<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:saxon="http://saxon.sf.net/"  extension-element-prefixes="saxon"  xmlns:filtre="apostal.toma.external.Publication" xmlns:integer="java.lang.Integer" xmlns:string="java.lang.String">
<!-- media-type defines the suffix .html for saxon -->
<xsl:output encoding='ISO-8859-1' method='html' media-type='text/html'/>


<!-- ********************* -->
<!-- Variables globales -->
<!-- ********************* -->
<!-- Parameters -->
<xsl:param name="dir"/>
<xsl:param name="lang"/>
<xsl:param name="properties"/>	
<xsl:param name="publish_org"/>
<xsl:param name="filename_default"/>
<xsl:param name="catTemp"/>
<xsl:param name="tedTemp"/>

	
<xsl:variable name="tempPath"><xsl:value-of select="$properties"/></xsl:variable>
<xsl:variable name="labels" select="document($tempPath)/DATA"/>
<xsl:variable name="listeCat" select="document($catTemp)"/>
	


<!-- Saisie	des	labels -->
	
	<!-- declaration des variables -->
	<xsl:variable name="css" saxon:assignable="yes" select="$labels/CSS"/>
	<xsl:variable name="mail" saxon:assignable="yes" select="$labels/MAIL"/>
	<xsl:variable name="title_trainings" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_trainings']/language[@code=$lang]"/>
	<xsl:variable name="title_slots" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_slots']/language[@code=$lang]"/>
	<xsl:variable name="title_slots_programme" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_slots_programme']/language[@code=$lang]"/>
	<xsl:variable name="title_slots_unit" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_slots_unit']/language[@code=$lang]"/>

	<xsl:variable name="title_level" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_level']/language[@code=$lang]"/>
	<xsl:variable name="end_interval" saxon:assignable="yes" select="$labels/LABEL[@NAME='end_interval']/language[@code=$lang]"/>
	<xsl:variable name="begin_interval" saxon:assignable="yes" select="$labels/LABEL[@NAME='begin_interval']/language[@code=$lang]"/>


	<xsl:variable name="duration_session" saxon:assignable="yes" select="$labels/LABEL[@NAME='duration_session']/language[@code=$lang]"/>
	<xsl:variable name="title_description" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_description']/language[@code=$lang]"/>
	<xsl:variable name="title_audience" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_audience']/language[@code=$lang]"/>
	<xsl:variable name="title_evaluation" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_evaluation']/language[@code=$lang]"/>
	<xsl:variable name="title_partnerShip" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_partnerShip']/language[@code=$lang]"/>
	<xsl:variable name="title_pedagogicalMethod" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_pedagogicalMethod']/language[@code=$lang]"/>
	<xsl:variable name="title_catalogues" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_catalogues']/language[@code=$lang]"/>
	<xsl:variable name="title_catalogue" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_catalogue']/language[@code=$lang]"/>

	<xsl:variable name="title_pointsDealtWith" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_pointsDealtWith']/language[@code=$lang]"/>
	<xsl:variable name="title_unit" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_unit']/language[@code=$lang]"/>
	<xsl:variable name="begin_validity" saxon:assignable="yes" select="$labels/LABEL[@NAME='begin_validity']/language[@code=$lang]"/>
	<xsl:variable name="end_validity" saxon:assignable="yes" select="$labels/LABEL[@NAME='end_validity']/language[@code=$lang]"/>
	<xsl:variable name="begin_validity_seance" saxon:assignable="yes" select="$labels/LABEL[@NAME='begin_validity_seance']/language[@code=$lang]"/>
	<xsl:variable name="end_validity_seance" saxon:assignable="yes" select="$labels/LABEL[@NAME='end_validity_seance']/language[@code=$lang]"/>
	<xsl:variable name="title_training" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_training']/language[@code=$lang]"/>
	<xsl:variable name="title_organism" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_organism']/language[@code=$lang]"/>
	<xsl:variable name="title_content" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_content']/language[@code=$lang]"/>
	<xsl:variable name="title_objectives" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_objectives']/language[@code=$lang]"/>
	<xsl:variable name="title_keywords" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_keywords']/language[@code=$lang]"/>
	<xsl:variable name="title_validity" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_validity']/language[@code=$lang]"/>
	<xsl:variable name="title_modeoforganization" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_modeoforganization']/language[@code=$lang]"/>
	<xsl:variable name="title_coursemedia" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_coursemedia']/language[@code=$lang]"/>
	<xsl:variable name="title_languages" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_languages']/language[@code=$lang]"/>
	<xsl:variable name="title_duration" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_duration']/language[@code=$lang]"/>
	<xsl:variable name="title_certificates" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_certificates']/language[@code=$lang]"/>
	<xsl:variable name="title_slot" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_slot']/language[@code=$lang]"/>
	<xsl:variable name="title_price" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_price']/language[@code=$lang]"/>
	<xsl:variable name="title_pricecomment" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_pricecomment']/language[@code=$lang]"/>
	<xsl:variable name="title_payment" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_payment']/language[@code=$lang]"/>
	<xsl:variable name="title_inscriptionconditions" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_inscriptionconditions']/language[@code=$lang]"/>
	<xsl:variable name="title_locations" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_locations']/language[@code=$lang]"/>
	<xsl:variable name="title_contactsteachers" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_contactsteachers']/language[@code=$lang]"/>
	<xsl:variable name="title_teacher" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_teacher']/language[@code=$lang]"/>
	<xsl:variable name="title_trainingcontact" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_trainingcontact']/language[@code=$lang]"/>
	<xsl:variable name="title_inscriptioncontact" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_inscriptioncontact']/language[@code=$lang]"/>
	<xsl:variable name="title_sessions" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_sessions']/language[@code=$lang]"/>
	<xsl:variable name="title_sessioninfo" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_sessioninfo']/language[@code=$lang]"/>
	<xsl:variable name="title_seancedate" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_seancedate']/language[@code=$lang]"/>
	<xsl:variable name="title_seance" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_seance']/language[@code=$lang]"/>
	<xsl:variable name="title_unitSession" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_unitSession']/language[@code=$lang]"/>

	<xsl:variable name="title_seancebegin" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_seancebegin']/language[@code=$lang]"/>
	<xsl:variable name="title_seanceend" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_seanceend']/language[@code=$lang]"/>
	<xsl:variable name="title_textualcalendar" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_textualcalendar']/language[@code=$lang]"/>
	<xsl:variable name="title_language" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_language']/language[@code=$lang]"/>
	<xsl:variable name="title_language_seance" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_language_seance']/language[@code=$lang]"/>
	<xsl:variable name="title_teacher_seance" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_teacher_seance']/language[@code=$lang]"/>


	<xsl:variable name="title_intervaldate" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_intervaldate']/language[@code=$lang]"/>
	<xsl:variable name="title_location" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_location']/language[@code=$lang]"/>
	<xsl:variable name="title_validitydate" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_validitydate']/language[@code=$lang]"/>
	<xsl:variable name="title_denomination" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_denomination']/language[@code=$lang]"/>
	<xsl:variable name="title_completename" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_completename']/language[@code=$lang]"/>
	<xsl:variable name="title_name" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_name']/language[@code=$lang]"/>
	<xsl:variable name="title_tel" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_tel']/language[@code=$lang]"/>
	<xsl:variable name="title_fax" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_fax']/language[@code=$lang]"/>
	<xsl:variable name="title_email" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_email']/language[@code=$lang]"/>
	<xsl:variable name="title_adresse" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_adresse']/language[@code=$lang]"/>
	<xsl:variable name="title_info" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_info']/language[@code=$lang]"/>
	<xsl:variable name="title_frage" saxon:assignable="yes" select="$labels/LABEL[@NAME='title_frage']/language[@code=$lang]"/>
	<xsl:variable name="text_info_mail_debut" saxon:assignable="yes" select="$labels/LABEL[@NAME='text_info_mail_debut']/language[@code=$lang]"/>
	<xsl:variable name="text_info_mail_session" saxon:assignable="yes" select="$labels/LABEL[@NAME='text_info_mail_session']/language[@code=$lang]"/>
	<xsl:variable name="text_info_mail_end" saxon:assignable="yes" select="$labels/LABEL[@NAME='text_info_mail_end']/language[@code=$lang]"/>


	
	
	<xsl:variable name="url_image" saxon:assignable="yes" select="$labels/IMAGE/URL"/>
	<xsl:variable name="taille_image" saxon:assignable="yes" select="$labels/IMAGE/TAILLE"/>	
	
	<xsl:variable name="catalogueFormation" saxon:assignable="yes">Titel_tochange</xsl:variable>

	<xsl:variable name="catcounter" saxon:assignable="yes">1</xsl:variable>
	<xsl:variable name="niveau" saxon:assignable="yes">0</xsl:variable>
	<xsl:variable name="space">&#160;&#160;&#160;&#160;&#160;&#160;</xsl:variable>
	<xsl:variable name="counter" saxon:assignable="yes">0</xsl:variable>
	<xsl:variable name="parentspace" saxon:assignable="yes">1</xsl:variable>
	<xsl:variable name="catalogue" saxon:assignable="yes">Titel_tochange</xsl:variable>
	<xsl:variable name="filename" saxon:assignable="yes">filename</xsl:variable>
	<xsl:variable name="titreTemp" saxon:assignable="yes">filename</xsl:variable>
	<xsl:variable name="catalogueFilename" saxon:assignable="yes">filename</xsl:variable>
	<xsl:variable name="compteur" saxon:assignable="yes">1</xsl:variable>
	<xsl:variable name="code" saxon:assignable="yes">code</xsl:variable>
	<xsl:variable name="filenameParent" saxon:assignable="yes">filename</xsl:variable>
	<xsl:variable name="idTraining" saxon:assignable="yes">filename</xsl:variable>
	<xsl:variable name="idCatalogue" saxon:assignable="yes">filename</xsl:variable>
	
	<xsl:variable name="uppercase">ABCDEFGHIJKLMNOPQRSTUVWXYZ</xsl:variable>
	<xsl:variable name="lowercase">abcdefghijklmnopqrstuvwxyz</xsl:variable>
	<xsl:variable name="pres_cat" saxon:assignable="yes">yes</xsl:variable>
	<xsl:variable name="message_mail" saxon:assignable="yes">message</xsl:variable>
	<!-- varibles concernant la taille des diffrents lmens -->
	
	<xsl:variable name="taille_texte_normal" saxon:assignable="yes">11pt</xsl:variable>
	<xsl:variable name="second_title_size" saxon:assignable="yes">14pt</xsl:variable>
	<xsl:variable name="first_title_size" saxon:assignable="yes">16pt</xsl:variable>	
	<xsl:variable name="taille_indent_liste" saxon:assignable="yes">0.3cm</xsl:variable>

	




<xsl:template match="/">
	<!--      
      <xsl:if test="$publish_org='true'">
      	<xsl:result-document href="file://{$dir}/{$filename}_T{../@key}.html" method="html" encoding="ISO-8859-1">
        <html>
          <head>
            <link rel="stylesheet" href="{$css}" type="text/css"/>
            <title>
              <xsl:value-of select="$title_training"/>
            </title>
          </head>
          <body class="bodycourses">

      
      </xsl:if>
     --> 

  <xsl:for-each select="ted/trainingCourse">
    <xsl:if test="catalogue">
    <xsl:for-each select="catalogue">
     <!--test de code-->
      <saxon:assign name="filename"><xsl:text>index</xsl:text></saxon:assign>
      <xsl:call-template name="getFileName">
        <xsl:with-param name="titre">
          <xsl:value-of select="$filename"/>
        </xsl:with-param>
      </xsl:call-template>
      <!--  method="html" encoding="ISO-8859-1" -->
      <xsl:result-document href="file://{$dir}/{$filename}_T{../@key}.html">
        <html>
          <head>
            <link rel="stylesheet" href="{$css}" type="text/css"/>
            <title>
              <xsl:value-of select="$title_training"/>
            </title>
          </head>
          <body class="bodycourses">
            <saxon:assign name="parentspace">0</saxon:assign>
            <saxon:assign name="counter">0</saxon:assign>
            <saxon:assign name="catalogueFilename"><xsl:text>index</xsl:text></saxon:assign>
            <a class="linkDEUmes" href="{$catalogueFilename}.html"><xsl:value-of select="title"/></a>
            <br/>
            <saxon:assign name="parentspace"><xsl:value-of select="number($parentspace)+1"/></saxon:assign> 
            <xsl:for-each select=".//catalogue">
              <saxon:assign name="catalogueFilename"><xsl:value-of select="$catalogueFilename"/>_<xsl:value-of select="@key"/></saxon:assign>
              <xsl:text>|_____</xsl:text>
              <a class="linkDEUmes" href="{$catalogueFilename}.html"> <xsl:value-of select="title"/></a><br/>
              <saxon:assign name="counter">0</saxon:assign>
              <xsl:call-template name="countespace"/>
              <saxon:assign name="parentspace"><xsl:value-of select="number($parentspace)+1"/></saxon:assign> 
	          </xsl:for-each>   
            <br/>
            <xsl:apply-templates select=".."/>
          </body>
        </html>
      </xsl:result-document>
    </xsl:for-each>
    </xsl:if>
    <xsl:if test="not(catalogue)">
    	<saxon:assign name="pres_cat">no</saxon:assign>
    	 <xsl:result-document href="file://{$dir}/{$filename_default}.html">
    	 <html>
          <head>
            <link rel="stylesheet" href="{$css}" type="text/css"/>
            <title>
              <xsl:value-of select="$title_training"/>
            </title>
          </head>
          <body class="bodycourses">
          <xsl:apply-templates select=".."/>
          </body>
        </html>
      </xsl:result-document>


    </xsl:if> 

  </xsl:for-each>
  
  <xsl:for-each select="ted/trainingProgramme">
    <xsl:if test="catalogue">
    	<xsl:for-each select="catalogue">
     		<saxon:assign name="filename"><xsl:text>index</xsl:text></saxon:assign>
      <xsl:call-template name="getFileName">
        <xsl:with-param name="titre">
          <xsl:value-of select="$filename"/>
        </xsl:with-param>
      </xsl:call-template>
      <xsl:result-document href="file://{$dir}/{$filename}_T{../@key}.html">
        <html>
          <head>
            <link rel="stylesheet" href="{$css}" type="text/css"/>
            <title>
              <xsl:value-of select="$title_training"/>
            </title>
          </head>
          <body class="bodycourses">
            <saxon:assign name="parentspace">0</saxon:assign>
            <saxon:assign name="counter">0</saxon:assign>
             <saxon:assign name="catalogueFilename"><xsl:text>index</xsl:text></saxon:assign>
            <a class="linkDEUmes" href="{$catalogueFilename}.html"><xsl:value-of select="title"/></a>
            <br/>
            <saxon:assign name="parentspace"><xsl:value-of select="number($parentspace)+1"/></saxon:assign> 
            <xsl:for-each select=".//catalogue">
              <saxon:assign name="catalogueFilename"><xsl:value-of select="$catalogueFilename"/>_<xsl:value-of select="@key"/></saxon:assign>
              <xsl:text>|____</xsl:text>
              <a class="linkDEUmes" href="{$catalogueFilename}.html"> <xsl:value-of select="title"/></a><br/>
              <saxon:assign name="counter">0</saxon:assign>
              <xsl:call-template name="countespace"/>
              <saxon:assign name="parentspace"><xsl:value-of select="number($parentspace)+1"/></saxon:assign> 
	          </xsl:for-each>   
            <br/>
            <xsl:apply-templates select=".."/>
          </body>
        </html>
      </xsl:result-document>
    </xsl:for-each>              
    </xsl:if>
    <xsl:if test="not(catalogue)">
    	<saxon:assign name="pres_cat">no</saxon:assign>
    	 <xsl:result-document href="file://{$dir}/{$filename_default}.html">
    	 <html>
          <head>
            <link rel="stylesheet" href="{$css}" type="text/css"/>
            <title>
              <xsl:value-of select="$title_training"/>
            </title>
          </head>
          <body class="bodycourses">
          <xsl:apply-templates select=".."/>
          </body>
        </html>
      </xsl:result-document>


    </xsl:if> 
  </xsl:for-each>  
  <xsl:apply-templates select="$listeCat/catalogues"/>  
</xsl:template>        

<xsl:template match="catalogues">
  	<xsl:call-template name="cataloguehtml"/>
	<xsl:apply-templates select="formation"/><br/>
</xsl:template>


<xsl:template match="formation">
  	<xsl:if test="(title) or title!=''">
    		<xsl:if test="position()=1">
    			<p class="header2"><xsl:value-of select="$title_trainings"/></p>
    		</xsl:if>
    		<table border="0" width="80%"> 
      			<tr>
        			<td width="80%">
         				 <a class="linkform" href="{$filename}_T{code}.html"><xsl:value-of select="title"/></a>
        			</td>
       		</tr>
       		<xsl:if test="normalize-space(duree) and duree!='0'">
             			<tr>
             				<td>
             					<xsl:value-of select="$duration_session"/><xsl:text> </xsl:text>
          					<xsl:value-of select="duree"/>
        				</td>
      				</tr>
      			</xsl:if>
           		<xsl:if test="beginDate!=0">
      				<tr>
       		 		<td>
         					<xsl:value-of select="$begin_validity_seance"/>
						<xsl:text> </xsl:text>
						<xsl:apply-templates select="beginDate" mode="toc"/>									
					 </td>
      				</tr>
      			</xsl:if>
    		</table>                        
	</xsl:if>
</xsl:template>

<xsl:template match="beginDate" mode="toc">
		<xsl:text> </xsl:text><xsl:value-of select="translate(.,'-','/')"/>
		<xsl:if test="position()!=last()">
			<xsl:text>,</xsl:text>
		</xsl:if>
	</xsl:template>

<xsl:template name="cataloguehtml">
	<xsl:for-each select="catalogueToPublish">
    		<saxon:assign name="filename"><xsl:text>index</xsl:text></saxon:assign>
	  	<xsl:result-document href="file://{$dir}/{$filename}.html">                        
		 	<html>
		    		<head>
		   	  		<link rel="stylesheet" href="{$css}" type="text/css"/> 
		   	  		<title><xsl:value-of select="$title_catalogue"/></title>
		   		</head>
		   		<body class="bodyframes">
          				<a class="textframes"><xsl:value-of select="title"/></a><br/>
			    		<hr/>
          				<saxon:assign name="parentspace"><xsl:value-of select="number($parentspace)+1"/></saxon:assign>
			    		<xsl:call-template name="printChildren"/>
          				<xsl:apply-templates select="formation"/>  	
		     			<saxon:assign name="parentspace">0</saxon:assign>
				</body>
			</html>
    		</xsl:result-document>
    		
    		 <xsl:call-template name="cataloguesToPublish">
        		<xsl:with-param name="titre">
          			<xsl:value-of select="$filename"/>
       		 </xsl:with-param>
      		</xsl:call-template>
  	</xsl:for-each>
</xsl:template>

<xsl:template name="cataloguesToPublish">
 	<xsl:param name="titre"/>
	<xsl:for-each select="catalogueToPublish">
  		<saxon:assign name="catcounter"><xsl:value-of select="number($catcounter)+1"/></saxon:assign>
  		<saxon:assign name="filename"><xsl:value-of select="$titre"/>_<xsl:value-of select="code"/></saxon:assign>
  		<xsl:result-document href="file://{$dir}/{$filename}.html">	
    			<html>
	    			<head>
	      				<link rel="stylesheet" href="{$css}" type="text/css"/>
	      				<title><xsl:value-of select="$title_catalogue"/></title>
	    			</head>
  	 		 	<body class="bodyframes">
        				<xsl:call-template name="printParents"/>
	    				<saxon:assign name="counter">0</saxon:assign>
	      				<xsl:call-template name="countespace"/>	
        				<a class="textframes"><xsl:value-of select="title"/></a>        	
	      				<hr/>
        				<xsl:if test="normalize-space(description)">
          					<p class="header2"><xsl:value-of select="$title_description"/></p>
          					<p><xsl:value-of select="description"/></p>
          					<hr/>
        				</xsl:if>
       				 <xsl:call-template name="printChildren"/>                              
        				<xsl:apply-templates select="formation"/>
	   			</body>
	  		</html>
		</xsl:result-document>
		<saxon:assign name="niveau"><xsl:value-of select="number($niveau)+1"/></saxon:assign>
  		<saxon:assign name="parentspace">0</saxon:assign>		
		<xsl:call-template name="cataloguesToPublish">
        		<xsl:with-param name="titre">
          			<xsl:value-of select="$filename"/>
       		 </xsl:with-param>
      		</xsl:call-template>
		<saxon:assign name="niveau"><xsl:value-of select="number($niveau)-1"/></saxon:assign>
		<saxon:assign name="filename"><xsl:value-of select="$catalogue"/></saxon:assign>
	</xsl:for-each>
</xsl:template>

<xsl:template name="printParents">
  <xsl:for-each select="ancestor::*">
    <saxon:assign name="counter">0</saxon:assign>
    <!--Space if title exists-->
    <xsl:if test="(title) or title!=''">
      <xsl:call-template name="countespace"/>
      <xsl:choose>
        <xsl:when test="$filenameParent='filename'">
          <!--<saxon:assign name="filenameParent"><xsl:value-of select="code"/></saxon:assign>-->
          <saxon:assign name="filenameParent"><xsl:text>index</xsl:text></saxon:assign>
        </xsl:when>    
        <xsl:otherwise>
          <saxon:assign name="filenameParent"><xsl:value-of select="$filenameParent"/>_<xsl:value-of select="code"/></saxon:assign>
        </xsl:otherwise>
      </xsl:choose>                
		  <saxon:assign name="parentspace"><xsl:value-of select="number($parentspace)+1"/></saxon:assign>
   	 	    <a class="linkframes" href="{$filenameParent}.html"><xsl:value-of select="title"/></a><br/>
	  </xsl:if>
  </xsl:for-each>
  <saxon:assign name="filenameParent">filename</saxon:assign>		
</xsl:template>
   
<xsl:template name="printChildren">
  <xsl:for-each select="catalogueToPublish">
    <xsl:if test="position()=1">
      <p  class="header2"><xsl:value-of select="$title_catalogues"/></p>
    </xsl:if>
    <saxon:assign name="catalogueFormation"><xsl:value-of select="code"/></saxon:assign>
    <a class="linkframes" href="{$filename}_{$catalogueFormation}.html"><xsl:value-of select="title"/></a><br/>
  </xsl:for-each>		
</xsl:template>


<xsl:template name="getFileName">
  <xsl:param name="titre"/>
  <xsl:if test="catalogue">
    <xsl:for-each select="catalogue">
      <saxon:assign name="filename" select="concat($titre,'_',@key)"/>
      <xsl:call-template name="getFileName">
        <xsl:with-param name="titre">
          <xsl:value-of select="$filename"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:for-each>
  </xsl:if>
</xsl:template>

<xsl:template match="trainingCourse">
  <hr/>
  <p class="header1"><b><xsl:apply-templates select="title"/></b></p>
  <hr/>
  <xsl:apply-templates select="contentDescription"/>
    <xsl:apply-templates select="level"/>
  <xsl:apply-templates select="objectives"/>                	        
  <xsl:apply-templates select="keyword"/>
  <xsl:apply-templates select="pointsDealtWith"/>
  <xsl:apply-templates select="modeOfOrganization"/>
  <xsl:apply-templates select="courseMedia"/>
  <xsl:apply-templates select="language"/>
	<xsl:apply-templates select="duration"/>
 	<xsl:apply-templates select="certificatesOrDiplomas"/>
	<xsl:apply-templates select="slot"/>
  <xsl:apply-templates select="price"/>
	<xsl:apply-templates select="priceComment"/>
  <xsl:apply-templates select="paymentFacilities"/>
	<xsl:apply-templates select="inscriptionConditions"/>
	<xsl:apply-templates select="teacher"/>
  <xsl:apply-templates select="trainingContact"/>                    
  <xsl:apply-templates select="inscriptionContact"/>
  <xsl:apply-templates select="courseSession"/>                  
</xsl:template>

<xsl:template match="trainingProgramme">
  <hr/>
  <p class="header1"><b><xsl:apply-templates select="title"/></b></p>
  <hr/>
  <xsl:apply-templates select="contentDescription"/>
  <xsl:apply-templates select="level"/>
  <xsl:apply-templates select="objectives"/>                	        
  <xsl:apply-templates select="keyword"/>
  <xsl:apply-templates select="pointsDealtWith"/>
   <xsl:apply-templates select="unit"/>
  <xsl:apply-templates select="modeOfOrganization"/>
  <xsl:apply-templates select="courseMedia"/>
  <xsl:apply-templates select="language"/>
	<xsl:apply-templates select="duration"/>
 	<xsl:apply-templates select="certificatesOrDiplomas"/>
	<xsl:apply-templates select="slot"/>
  <xsl:apply-templates select="price"/>
	<xsl:apply-templates select="priceComment"/>
  <xsl:apply-templates select="paymentFacilities"/>
	<xsl:apply-templates select="inscriptionConditions"/>
	<xsl:apply-templates select="teacher"/>
  <xsl:apply-templates select="trainingContact"/>                    
  <xsl:apply-templates select="inscriptionContact"/>
  <xsl:apply-templates select="programmeSession"/>                             
</xsl:template>

<xsl:template match="level">
		<xsl:if test="normalize-space(@value)">
		<p class="header2"><xsl:value-of select="$title_level"/></p>
		<p><xsl:value-of select="filtre:getLevelNameByValue($lang,@value)"/></p>
		</xsl:if>		
	</xsl:template>

   
<xsl:template match="title">
  <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="code">
  <xsl:value-of select="."/>
</xsl:template>

<!-- Description du contenu -->
   
<xsl:template match="contentDescription">
  <xsl:if test="normalize-space(.)">
    <p class="header2"><xsl:value-of select="$title_content"/></p>
	</xsl:if>  
  <p><xsl:value-of select="introduction"/></p>
	<xsl:for-each select="subDescription">
    <p><xsl:value-of select="."/></p>
	</xsl:for-each>
	<p><xsl:value-of select="conclusion"/></p>        
</xsl:template>

<!-- publication des objectifs -->
   
<xsl:template match="objectives">
  <xsl:if test="normalize-space(.)">		    	
    <p class="header2"><xsl:value-of select="$title_objectives"/></p>
  </xsl:if>
  <p><xsl:value-of select="introduction"/></p>
  <xsl:for-each select="objective">
    <p><xsl:value-of select="."/></p>
	</xsl:for-each>
	<p><xsl:value-of select="conclusion"/></p>
</xsl:template>
   
<!-- publication des mots cls -->
   
<xsl:template match="keyword">
  <xsl:if test="normalize-space(.)">
    <xsl:if test="position()=1">
      <p class="header2"><xsl:value-of select="$title_keywords"/></p>
    </xsl:if>
    <li><xsl:value-of select="."/></li>
	</xsl:if>
</xsl:template>
   
<!-- publication des points abords -->
   
<xsl:template match="pointsDealtWith">
  <xsl:if test="normalize-space(.)">
  	<p  class="header2"><xsl:value-of select="$title_pointsDealtWith"/></p>
  	<xsl:if test="normalize-space(introduction)">
    		<xsl:value-of select="introduction"/>                
 	 </xsl:if>
  	<xsl:apply-templates select="pointDealtWith"/>
 	 <p><xsl:value-of select="conclusion"/></p>
  	</xsl:if>
</xsl:template>
   
<xsl:template match="pointDealtWith">
  <br/><xsl:value-of select="introduction"/>
  <ul>
    <xsl:apply-templates select="subPointDealtWith"/>
  </ul>
  <br/><xsl:value-of select="conclusion"/>
</xsl:template>
      
<xsl:template match="subPointDealtWith">
  <xsl:if test="normalize-space(.)">
    <li><xsl:value-of select="."/></li>
  </xsl:if>
</xsl:template>
   
<!-- publication des dates de validit -->        
      
<xsl:template match="beginValidityDate">
  <xsl:call-template name="date"/>
</xsl:template>
   
<xsl:template match="endValidityDate">
	<xsl:call-template name="date"/>
</xsl:template>
   
<!-- publication du type de formation -->
   
<xsl:template match="modeOfOrganization">
  <p class="header2"><xsl:value-of select="$title_modeoforganization"/></p>
  <xsl:value-of select="filtre:getModeOfOrganizationNameByValue($lang,@value)"/>
</xsl:template>
   
<!-- publication de course media -->
   
<xsl:template match="courseMedia">
  <xsl:if test="normalize-space(.)"> 
    <p class="header2"><xsl:value-of select="$title_coursemedia"/></p>
    <xsl:value-of select="."/>
  </xsl:if>
</xsl:template>
   
<!-- publication des langues -->
   
<xsl:template match="language">
  <xsl:if test="position()=1">
    <p class="header2"><xsl:value-of select="$title_languages"/></p>
  </xsl:if>
  <li>
    <xsl:value-of select="languageName"/>
	</li>	
</xsl:template>
   
<!-- publication de la dure -->
        
<xsl:template match="duration">
  <xsl:if test="normalize-space(.)">
    <p class="header2"><xsl:value-of select="$title_duration"/></p>
    <xsl:value-of select="."/>
  </xsl:if>                   
</xsl:template>
   
<!-- publication du cerificat ou diplme dcern -->
   
<xsl:template match="certificatesOrDiplomas">
  <xsl:if test="normalize-space(.)">
    <p class="header2"><xsl:value-of select="$title_certificates"/></p>
    <xsl:value-of select="."/>
  </xsl:if>                      
</xsl:template>
   
<!-- publication de la tranche horaire  -->   
   
<xsl:template match="slot">
  <xsl:if test="normalize-space(@value)">
    <xsl:if test="position()=1">
      <p class="header2"><xsl:value-of select="$title_slot"/></p>
    </xsl:if>
    <li><xsl:value-of select="translate(filtre:getSlotNameByValue($lang,@value),$uppercase, $lowercase)"/></li>
  </xsl:if>
</xsl:template>
   
<!-- publication du prix -->
   
<xsl:template match="price">
  <xsl:if test="normalize-space(.)"> 
    <p class="header2"><xsl:value-of select="$title_price"/></p>
    <xsl:value-of select="."/>
  </xsl:if>
</xsl:template>
   
<!-- publication du commentaire sur le prix -->
   
<xsl:template match="priceComment">
  <xsl:if test="normalize-space(.)">
    <p class="header2"><xsl:value-of select="$title_pricecomment"/></p>
    <xsl:value-of select="."/>
  </xsl:if>                     
</xsl:template>   
   
<!-- publication des facilits de paiemment -->
   
<xsl:template match="paymentFacilities">
  <xsl:if test="normalize-space(.)">
    <p class="header2"><xsl:value-of select="$title_payment"/></p>
    <xsl:value-of select="."/>
  </xsl:if>               
</xsl:template>
   
<!-- publication des conditions d'inscription -->
   
<xsl:template match="inscriptionConditions">
  <xsl:if test="normalize-space(.)">
    <p class="header2"><xsl:value-of select="$title_inscriptionconditions"/></p>
    <xsl:value-of select="."/>
  </xsl:if>                      
</xsl:template>
   
 

<!--  publication des teachers -->
   
<xsl:template match="teacher">
  <xsl:if test="normalize-space(.)">
    <xsl:if test="position()=1">
      <p class="header2"><xsl:value-of select="$title_teacher"/></p>
    </xsl:if>
  </xsl:if>      
  <xsl:if test="normalize-space(lastname)">  
    <p><xsl:value-of select="firstname"/><xsl:text> </xsl:text><xsl:value-of select="lastname"/><br/>
    <xsl:value-of select="competence"/></p>
  </xsl:if>
</xsl:template>

<!--  publication des contacts pour l'inscription -->
   
<xsl:template match="trainingContact">
  <xsl:if test="normalize-space(.)">
    <xsl:if test="position()=1">
      <p class="header2"><xsl:value-of select="$title_trainingcontact"/></p>
    </xsl:if>               
  </xsl:if>        
  <xsl:if test="normalize-space(lastname)">  
    <xsl:call-template name="contact"/>
  </xsl:if>
</xsl:template>
   
<!--  publication des contacts pour l'inscription -->
  
<xsl:template match="inscriptionContact">
  <xsl:if test="normalize-space(.)">
    <xsl:if test="position()=1">
      <p class="header2"><xsl:value-of select="$title_inscriptioncontact"/></p>
    </xsl:if>               
	</xsl:if>        
  <xsl:if test="normalize-space(lastname)">  
    <xsl:call-template name="contact"/>
  </xsl:if>
</xsl:template>
   
<!-- publication des modules -->
   
<xsl:template match="unit">
  <xsl:if test="normalize-space(title)">
    <xsl:if test="position()=1">
      <p class="header2"><xsl:value-of select="$title_unit"/></p>
    </xsl:if>
	    <li><a href="{$filename}_T{../@key}_{@key}.html"><xsl:value-of select="title"/></a></li>
		<xsl:result-document href="file://{$dir}/{$filename}_T{../@key}_{@key}.html">		
      <html>
        <head>
          <link rel="stylesheet" href="{$css}" type="text/css"/>
          <title><xsl:value-of select="$title_unit"/><xsl:text> </xsl:text><xsl:value-of select="title"/></title>
        </head>
        <body>
        	<xsl:choose>
			<xsl:when test="$pres_cat='no'">
				<p><a href="{$filename_default}.html"> <xsl:value-of select="../title"/></a></p>		
			</xsl:when>
			<xsl:otherwise>
				<p><a href="{$filename}_T{../@key}.html"> <xsl:value-of select="../title"/></a></p>
			</xsl:otherwise>
		</xsl:choose>
          
          <hr/>
          <p class="header1"><b><xsl:apply-templates select="title"/></b></p>
          <hr/>
          <xsl:apply-templates select="contentDescription"/>
            <xsl:apply-templates select="level"/>
          <xsl:apply-templates select="objectives"/>                	        
          <xsl:apply-templates select="keyword"/>
          <xsl:apply-templates select="pointsDealtWith"/>
           <xsl:apply-templates select="modeOfOrganization"/>
          <xsl:apply-templates select="courseMedia"/>
          <xsl:apply-templates select="language"/>
		      <xsl:apply-templates select="duration"/>
 		      <xsl:apply-templates select="slot"/>
          <xsl:apply-templates select="teacher"/>
          <xsl:apply-templates select="trainingContact"/>                    
          <xsl:apply-templates select="inscriptionContact"/>
          <xsl:apply-templates select="unitSession"/>
        </body>
      </html>                       
    </xsl:result-document>
  </xsl:if>
</xsl:template>
   
<xsl:template match="unitSession">
	<xsl:if test="sessionName">
    <xsl:if test="position()=1">
      <p class="header2"><xsl:value-of select="$title_sessions"/></p>
    </xsl:if>
   <xsl:if test="normalize-space(../trainingContact/email)">
   	      		 <saxon:assign name="mail" select="../trainingContact/email"/>
   	       </xsl:if>
   	       <xsl:choose>
			<xsl:when test="normalize-space($mail)">
				<saxon:assign name="message_mail"><xsl:value-of select="$text_info_mail_debut"/><xsl:text> </xsl:text><xsl:value-of select="../title"/><xsl:value-of select="$text_info_mail_session"/>				<xsl:text> </xsl:text><xsl:value-of select="sessionName"/><xsl:text>.</xsl:text><xsl:value-of select="$text_info_mail_end"/></saxon:assign>
   	       		<p><a href="mailto:{$mail}?subject={../title}&amp;body={$message_mail}"><xsl:value-of select="sessionName"/></a></p>
			</xsl:when>
			<xsl:otherwise>
				<p><xsl:value-of select="sessionName"/></p>
			</xsl:otherwise>
	</xsl:choose>
    <table  class="table2">
      <xsl:if test="seance/dateSeance">
	   	  <tr>
          <td  colspan="2" class="td1"><xsl:value-of select="$title_seancedate"/></td>
	   		  <td class="td1"><xsl:value-of select="$title_seancebegin"/></td>
	   		  <td class="td1"><xsl:value-of select="$title_seanceend"/></td>
	      </tr>
	   	</xsl:if>
	   	<xsl:for-each select="seance">
	   		<tr>
	   			<td colspan="2" class="td2"><xsl:apply-templates select="dateSeance"/></td>
	   			<xsl:apply-templates select="timeInterval"/>
	   		</tr>
	   	</xsl:for-each>
		  <tr>
		    <td class="td1"><xsl:value-of select="$title_textualcalendar"/></td>
		   	<td class="td1"><xsl:value-of select="$title_language"/></td>
		   	<td class="td1"><xsl:value-of select="$title_price"/></td>
		   	<td class="td1"><xsl:value-of select="$title_pricecomment"/></td>
		  </tr>
		  <tr>
		    <td class="td2">
		   	  <xsl:if test="not(textualCalendar) or textualCalendar=''">
            &#160;
          </xsl:if>
          <xsl:value-of select="textualCalendar"/>
        </td>
		   	<td class="td2">
		   	  <xsl:if test="not(language) or language=''">
            &#160;
          </xsl:if>
		   		<xsl:value-of select="language/languageName"/>
        </td>
		   	<td class="td2">
		   	  <xsl:if test="not(price) or price=''">
            &#160;
          </xsl:if>
		   		<xsl:value-of select="price"/>
        </td>
		   	<td class="td2">
		   	  <xsl:if test="not(priceComment) or priceComment=''">
            &#160;
          </xsl:if>
		   		<xsl:value-of select="priceComment"/>
        </td>
		  </tr>
		  <tr>
		    <td class="td1"><xsl:value-of select="$title_intervaldate"/></td>
		   	<td class="td1"><xsl:value-of select="$title_teacher"/></td>
		   	<td class="td1"><xsl:value-of select="$title_location"/></td>
		   	<td class="td1"><xsl:value-of select="$title_validitydate"/></td>
		  </tr>
		  <tr>
		    <td class="td2">
		      <xsl:if test="not(dateInterval) or dateInterval=''">
            &#160;
          </xsl:if>
		   		<xsl:apply-templates select="dateInterval"/>
        </td>
		   	<td class="td2">
		   	  <xsl:if test="not(teacher/lastname) or teacher/lastname=''">
            &#160;
          </xsl:if>
		   		<xsl:value-of select="teacher/lastname"/><xsl:text> </xsl:text><xsl:value-of select="teacher/firstname"/>
        </td>
		   	<td class="td2">
		   	  <xsl:if test="not(location/denomination) or location/denomination=''">
            &#160;
          </xsl:if>
		   		<xsl:value-of select="location/denomination"/>
        </td>
		   	<td class="td2">
		   	  <xsl:if test="not(beginValidityDate) or beginValidityDate=''">
            &#160;
          </xsl:if>		   		
          <xsl:apply-templates select="beginValidityDate"/> - <xsl:apply-templates select="endValidityDate"/>
        </td>
		  </tr>
	  </table>
  </xsl:if>	   	
</xsl:template>
   
<xsl:template match="courseSession">
	<xsl:if test="sessionName">
               <xsl:if test="position()=1">
                <p class="header2"><xsl:value-of select="$title_sessions"/></p>
                </xsl:if>
               <!--<p class="header3"><xsl:value-of select="sessionName"/></p>-->
   	       <xsl:if test="normalize-space(../trainingContact/email)">
   	      		 <saxon:assign name="mail" select="../trainingContact/email"/>
   	       </xsl:if>
   	       <xsl:choose>
			<xsl:when test="normalize-space($mail)">
				<saxon:assign name="message_mail"><xsl:value-of select="$text_info_mail_debut"/><xsl:text> </xsl:text><xsl:value-of select="../title"/><xsl:value-of select="$text_info_mail_session"/>				<xsl:text> </xsl:text><xsl:value-of select="sessionName"/><xsl:text>.</xsl:text><xsl:value-of select="$text_info_mail_end"/></saxon:assign>
   	       		<p><a href="mailto:{$mail}?subject={../title}&amp;body={$message_mail}"><xsl:value-of select="sessionName"/></a></p>
			</xsl:when>
			<xsl:otherwise>
				<p><xsl:value-of select="sessionName"/></p>
			</xsl:otherwise>
		</xsl:choose>
   	       <table  class="table2">
	   	  <xsl:if test="seance/dateSeance">
	   	      <tr>
                                <td  colspan="2" class="td1"><xsl:value-of select="$title_seancedate"/></td>
	   		        <td class="td1"><xsl:value-of select="$title_seancebegin"/></td>
	   		      <td class="td1"><xsl:value-of select="$title_seanceend"/></td>
	               </tr>
	   	   </xsl:if>
	   	   <xsl:for-each select="seance">
	   		<tr>
	   			<td colspan="2" class="td2"><xsl:apply-templates select="dateSeance"/></td>
	   			<xsl:apply-templates select="timeInterval"/>
	   		</tr>
	   	   </xsl:for-each>
		   <tr>
		   	    <td class="td1"><xsl:value-of select="$title_textualcalendar"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_language"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_price"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_pricecomment"/></td>
		   </tr>
		   <tr>
		   	    <td class="td2">
		   	    	<xsl:if test="not(textualCalendar) or textualCalendar=''">
                		        &#160;
                		</xsl:if>
                		<xsl:value-of select="textualCalendar"/></td>
		   	    <td class="td2">
		   	    	<xsl:if test="not(language) or language=''">
                		        &#160;
                		</xsl:if>
		   		    	<xsl:value-of select="language/languageName"/></td>
		   		    <td class="td2">
		   		    	<xsl:if test="not(price) or price=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:value-of select="price"/></td>
		   		    <td class="td2">
		   		    	<xsl:if test="not(priceComment) or priceComment=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:value-of select="priceComment"/></td>
		   </tr>
		   <tr>
		   	    <td class="td1"><xsl:value-of select="$title_intervaldate"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_teacher"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_location"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_validitydate"/></td>
		   </tr>
		   <tr>
		   	    <td class="td2">
		        	<xsl:if test="not(dateInterval) or dateInterval=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:apply-templates select="dateInterval"/></td>
		   		    <td class="td2">
		   		    	<xsl:if test="not(teacher/lastname) or teacher/lastname=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:value-of select="teacher/lastname"/><xsl:text> </xsl:text><xsl:value-of select="teacher/firstname"/></td>
		   		    <td class="td2">
		   		    	<xsl:if test="not(location/denomination) or location/denomination=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:value-of select="location/denomination"/></td>
		   		    <td class="td2">
		   		    	<xsl:if test="not(beginValidityDate) or beginValidityDate=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:apply-templates select="beginValidityDate"/> - <xsl:apply-templates select="endValidityDate"/></td>
		   </tr>
	 </table>
	</xsl:if>	
   	
   </xsl:template>
   
   
   <xsl:template match="programmeSession">
	<xsl:if test="sessionName">
               <xsl:if test="position()=1">
                <p class="header2"><xsl:value-of select="$title_sessions"/></p>
                </xsl:if>
                    
               <xsl:if test="normalize-space(../trainingContact/email)">
   	      		 <saxon:assign name="mail" select="../trainingContact/email"/>
   	       </xsl:if>
   	       <xsl:choose>
			<xsl:when test="normalize-space($mail)">
				<saxon:assign name="message_mail"><xsl:value-of select="$text_info_mail_debut"/><xsl:text> </xsl:text><xsl:value-of select="../title"/><xsl:value-of select="$text_info_mail_session"/>				<xsl:text> </xsl:text><xsl:value-of select="sessionName"/><xsl:text>.</xsl:text><xsl:value-of select="$text_info_mail_end"/></saxon:assign>
   	       		<p><a href="mailto:{$mail}?subject={../title}&amp;body={$message_mail}"><xsl:value-of select="sessionName"/></a></p>
			</xsl:when>
			<xsl:otherwise>
				<p><xsl:value-of select="sessionName"/></p>
			</xsl:otherwise>
		</xsl:choose>

   	       <table  class="table2">
	   	  <xsl:if test="seance/dateSeance">
	   	      <tr>
                                <td  colspan="2" class="td1"><xsl:value-of select="$title_seancedate"/></td>
	   		        <td class="td1"><xsl:value-of select="$title_seancebegin"/></td>
	   		      <td class="td1"><xsl:value-of select="$title_seanceend"/></td>
	               </tr>
	   	   </xsl:if>
	   	   <xsl:for-each select="seance">
	   		<tr>
	   			<td colspan="2" class="td2"><xsl:apply-templates select="dateSeance"/></td>
	   			<xsl:apply-templates select="timeInterval"/>
	   		</tr>
	   	   </xsl:for-each>
		   <tr>
		   	    <td class="td1"><xsl:value-of select="$title_textualcalendar"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_language"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_price"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_pricecomment"/></td>
		   </tr>
		   <tr>
		   	    <td class="td2">
		   	    	<xsl:if test="not(textualCalendar) or textualCalendar=''">
                		        &#160;
                		</xsl:if>
                		<xsl:value-of select="textualCalendar"/></td>
		   	    <td class="td2">
		   	    	<xsl:if test="not(language) or language=''">
                		        &#160;
                		</xsl:if>
		   		    	<xsl:value-of select="language/languageName"/></td>
		   		    <td class="td2">
		   		    	<xsl:if test="not(price) or price=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:value-of select="price"/></td>
		   		    <td class="td2">
		   		    	<xsl:if test="not(priceComment) or priceComment=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:value-of select="priceComment"/></td>
		   </tr>
		   <tr>
		   	    <td class="td1"><xsl:value-of select="$title_intervaldate"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_teacher"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_location"/></td>
		   	    <td class="td1"><xsl:value-of select="$title_validitydate"/></td>
		   </tr>
		   <tr>
		   	    <td class="td2">
		        	<xsl:if test="not(dateInterval) or dateInterval=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:apply-templates select="dateInterval"/></td>
		   		    <td class="td2">
		   		    	<xsl:if test="not(teacher/lastname) or teacher/lastname=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:value-of select="teacher/lastname"/><xsl:text> </xsl:text><xsl:value-of select="teacher/firstname"/></td>
		   		    <td class="td2">
		   		    	<xsl:if test="not(location/denomination) or location/denomination=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:value-of select="location/denomination"/></td>
		   		    <td class="td2">
		   		    	<xsl:if test="not(beginValidityDate) or beginValidityDate=''">
                			        &#160;
                			</xsl:if>
		   		    	<xsl:apply-templates select="beginValidityDate"/> - <xsl:apply-templates select="endValidityDate"/></td>
		   </tr>
	 </table>
	</xsl:if>	
   	
   </xsl:template>
   

   
<xsl:template match="dateSeance">
  <xsl:call-template name="date"/>
</xsl:template>
   
<xsl:template match="timeInterval">
  <td class="td2"><xsl:apply-templates select="beginTime"/></td>
  <td class="td2"><xsl:apply-templates select="endTime"/></td>
</xsl:template>
   
<xsl:template match="beginTime">
  <xsl:call-template name="time"/>
</xsl:template>

<xsl:template match="endTime">
  <xsl:call-template name="time"/>
</xsl:template>
   
<xsl:template match="dateInterval">
  <xsl:apply-templates select="beginDate"/> - 
  <xsl:apply-templates select="endDate"/>
</xsl:template>
   
<xsl:template match="beginDate">
  <xsl:call-template name="date"/>
</xsl:template>
   
<xsl:template match="endDate">
  <xsl:call-template name="date"/>
</xsl:template> 
   
<xsl:template name="date">
  <xsl:value-of select="day"/>.<xsl:value-of select="month"/>.<xsl:value-of select="year"/>
</xsl:template>
   
<xsl:template name="time">
  <xsl:value-of select="hour"/>:<xsl:value-of select="minute"/>
</xsl:template>
   
<xsl:template name="contact">
  <p>
    <xsl:value-of select="title"/><xsl:text> </xsl:text>
	  <xsl:value-of select="firstname"/><xsl:text> </xsl:text>
	  <xsl:value-of select="lastname"/>
    <xsl:if test="normalize-space(tel)">
	    <br/><xsl:value-of select="$title_tel"/> :  <xsl:value-of select="tel"/>
    </xsl:if>
    <xsl:if test="normalize-space(fax)">
	    <br/><xsl:value-of select="$title_fax"/> : <xsl:value-of select="fax"/>
    </xsl:if>
    <xsl:if test="normalize-space(email)">
	    <br/><xsl:value-of select="$title_email"/> : <xsl:value-of select="email"/>
    </xsl:if>
  </p>
</xsl:template>
   
<xsl:template name="countespace">
  <xsl:if test="$counter!=$parentspace">
    <xsl:value-of select="$space"/>&#160;  
    <saxon:assign name="counter"><xsl:value-of select="number($counter)+1"/></saxon:assign>
    <xsl:call-template name="countespace"/>&#160;           
  </xsl:if>
</xsl:template>


</xsl:stylesheet>
