// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/*
 * TOMACommandLineServer.java
 *
 * Server TOMA sur ligne de commande (pas d'interface graphique). 
 * Attention, ne pas le lancer pour la 1re fois, lancer TOMAServer
 */

package apostal.toma;

import apostal.toma.database.TOMADatabase;
import apostal.toma.database.DatabaseFacilities;
import apostal.toma.data.TOMAConstants;
import apostal.toma.view.TOMAUI;
import apostal.toma.view.TOMAFirstRun;

import java.util.Properties;
import java.io.FileInputStream;

/**
 *
 * @author  ramel
 */
public class TOMACommandLineServer {

  public static void main(String[] argv)
    {                  	
      //vrifier que ce n'est pas le "firstRun"
        boolean firstRun=false;
        
        try{
            Properties firstRunProps=new Properties();
            FileInputStream fin=new FileInputStream(TOMAConstants.parametersFile);        
            firstRunProps.load(fin);                
            
            String myType=(String) firstRunProps.get("firstRunType");        
            
            if(myType!=null && !myType.equals(""))
            {
                firstRun=true;
            }
	    fin.close();
            
        }catch(Exception ex)
        {
        }                      
        
        //first run -> graphical UI
        if(firstRun)
	{
		//UI
        	TOMAUI ui=new TOMAUI();
        	ui.setUI(); 
		
                //first run
                TOMAFirstRun f=new TOMAFirstRun();   		
        }        
    	else
    	{    
	        //lancement de TOMA Server sur commande line
			TOMACommandLineServer.runServer();
    	}    	
    }    
    
    public static void runServer()
    {
         String[] options={"-database", "toma"};
         org.hsqldb.Server.main(options);  	         
    }
}
