// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;

import java.util.Vector;
import java.util.Iterator;

/**

 * @(#) Address.java

 */



public class Address extends TOMAData

{

	private Vector addressLines;



	private String city;



	private Country country;



	private String postCode;



    public Address(Vector addressLines, String city, String postCode, Country country)

    {

	this.addressLines=addressLines;

	this.city=city;

	this.postCode=postCode;

	this.country=country;

    }



	public Vector getAddressLines( )

	{

		return addressLines;

	}



	public String getCity( )

	{

		return city;

	}



	public Country getCountry( )

	{

		return country;

	}



	public String getPostCode( )

	{

		return postCode;

	}



	public void setAddressLines(final Vector addresslines )

	{

		this.addressLines = addresslines;

	}



	public void setCity(final String city )

	{

		this.city = city;

	}



	public void setCountry(final Country country )

	{

		this.country = country;

	}



	public void setPostCode( final String postcode )

	{

		this.postCode = postcode;

	}


        public String toHTMLString()
        {
            String s="";
            if(addressLines!=null)
            {
                Iterator it=addressLines.iterator();
                while(it.hasNext())
                {
                    String line=(String) it.next();
                    s=s+"<P>"+line+"</P>";
                }
            }
            s=s+"<P>"+postCode+" "+city+"</P>";
            
            if(country!=null)
                s=s+"<P>"+country.getName()+"</P>";            
            
            return s;
        }
}

