// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;

import java.util.Vector;

/**
 * @(#) Catalogue.java
 */

public class Catalogue extends TOMAData {
    private int idCatalogue=-1;
    private String title;
    private String description;
    private int idSuperCatalogue;
    private int nborder;

    // linked id
    private Vector catalogues;
    private Vector trainings;

    private java.sql.Date dateCreation;
    private java.sql.Date dateMaj;

    public Catalogue(int idCatalogue)
    {
	this.idCatalogue=idCatalogue;
	idSuperCatalogue=-1;
    }

    public Catalogue()
    {
	idSuperCatalogue=-1;
    }

	public Vector getCatalogues( )
	{
		return catalogues;
	}

	public String getDescription( )
	{
		return description;
	}

	public int getIdCatalogue( )
	{
		return idCatalogue;
	}

    public int getIdSuperCatalogue()
    {
	return idSuperCatalogue;
    }

	public String getTitle( )
	{
		return title;
	}

	public Vector getTrainings( )
	{
		return trainings;
	}

    public int getNborder()
    { return nborder; }

	public java.sql.Date getDateCreation( )
	{
		return dateCreation;
	}

	public java.sql.Date getDateMaj( )
	{
		return dateMaj;
	}

	public void setCatalogues( final Vector catalogues )
	{
		this.catalogues = catalogues;
	}

	public void setDescription( final String description )
	{
		this.description = description;
	}

	public void setIdCatalogue( final int idcatalogue )
	{
		idCatalogue = idcatalogue;
	}

    public void setIdSuperCatalogue(final int idSuperCatalogue)
    {
	this.idSuperCatalogue=idSuperCatalogue;
    }

	public void setTitle( final String title )
	{
		this.title = title;
	}

	public void setTrainings( final Vector trainings )
	{
		this.trainings = trainings;
	}


    public void setNborder(int nborder)
    { this.nborder = nborder; }

	public void setDateCreation( final java.sql.Date datecreation )
	{
		dateCreation = datecreation;
	}

	public void setDateMaj( final java.sql.Date datemaj )
	{
		dateMaj = datemaj;
	}


	public String toString()
	{
	  return title;
	}

}
