// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;

import java.util.Vector;
import java.util.Hashtable;
import toolbox.util.HashtableSort;
/**
 * @(#) PublishedCatalogue.java
 */

public class CataloguePublished extends TOMAData 
{		
    private int idPublicationUnit;

    private int idCatalogue;
	
    private String title;

    private Vector trainings;    

    private Vector catalogues;	

    public CataloguePublished(){}

    public CataloguePublished(int idCatalogue, int idPublicationUnit)
    {
	this.idCatalogue=idCatalogue;
	this.idPublicationUnit=idPublicationUnit;
    }  

	public Vector getCatalogues( )
	{
		return catalogues;
	}	
	
	public int getIdCatalogue( )
	{
		return idCatalogue;
	}

    public int getIdPublicationUnit( )
    {
	return idPublicationUnit;
    }

	public String getTitle( )
	{
		return title;
	}
	
    public Vector getTrainings( )
    {
	return trainings;
    }
	
	public void setCatalogues( final Vector catalogues )
	{
		this.catalogues = catalogues;
	}
	
	public void setIdCatalogue( final int idcatalogue )
	{
		idCatalogue = idcatalogue;
	}
	
	public void setIdPublicationUnit( final int idpublicationUnit )
	{
		idPublicationUnit = idpublicationUnit;
	}

	public void setTitle( final String title )
	{
		this.title = title;
	}
	
    public void setTrainings( final Vector trainings )    
	{
		this.trainings = trainings;
	}
}
