// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;



import apostal.toma.datacontrol.TOMAParametersControl;



import java.util.Vector;

import java.sql.Date;

/**

 * @(#) Contact.java

 */



public class Contact extends TOMAData {

    private java.sql.Date dateCreation;



    private java.sql.Date dateMaj;



    private String email;



    private String fax;



    private String firstname;



    private String function;



    private int idContact=-1;



    private String lastname;



    private String tel;



    private String title;



    private Address address;



    public Contact()

    {



    }



    public Contact(final int idContact)

    {

	this.idContact=idContact;

    }



	public Address getAddress( )

	{

		return address;

	}



	public java.sql.Date getDateCreation( )

	{

		return dateCreation;

	}



	public java.sql.Date getDateMaj( )

	{

		return dateMaj;

	}



	public String getEmail( )

	{

		return email;

	}



	public String getFax( )

	{

		return fax;

	}



	public String getFirstname( )

	{

		return firstname;

	}



	public String getFunction( )

	{

		return function;

	}



	public int getIdContact( )

	{

		return idContact;

	}



	public String getLastname( )

	{

		return lastname;

	}



	public String getTel( )

	{

		return tel;

	}



	public String getTitle( )

	{

		return title;

	}



	public void setAddress( final Address address )

	{

		this.address = address;

	}



	public void setDateCreation( final java.sql.Date datecreation )

	{

		dateCreation = datecreation;

	}



	public void setDateMaj( final java.sql.Date datemaj )

	{

		dateMaj = datemaj;

	}



	public void setEmail( final String email )

	{

		this.email = email;

	}



	public void setFax( final String fax )

	{

		this.fax = fax;

	}



	public void setFirstname( final String firstname )

	{

		this.firstname = firstname;

	}



	public void setFunction( final String function )

	{

		this.function = function;

	}



	public void setIdContact( final int idContact )

	{

		this.idContact = idContact;

	}



	public void setLastname( final String lastname )

	{

		this.lastname = lastname;

	}



	public void setTel( final String tel )

	{

		this.tel = tel;

	}



	public void setTitle( final String title )

	{

		this.title = title;

	}





	public String toString()

	{

	  return lastname+" "+firstname+" ("+tel+", "+email+") ";

	}

}

