// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;

import java.util.Vector;
import java.util.Iterator;
import java.sql.Date;
import java.sql.Time;
/**
 * @(#) CourseSession.java
 */

public class CourseSession extends Session
{
	private Slot slot;
	private Location location;

	private String textualCalendar;

	private Vector seances;

	private Vector teachers;

    public CourseSession()
    {

    }
    public CourseSession(int idSession)
    {
	super(idSession);
    }

	public Vector getSeances( )
	{
		return seances;
	}

	public Vector getTeachers( )
	{
		return teachers;
	}

	public String getTextualCalendar( )
	{
		return textualCalendar;
	}

	public Slot getSlot()
	{
	  return slot;
	}

	public Location getLocation()
	{
	  return location;
	}

	public void setSlot(Slot slot)
	{
	  this.slot=slot;
	}

	public void setLocation(Location location)
	{
	  this.location=location;
	}

	public void setSeances( final Vector seances )
	{
		this.seances = seances;
	}

	public void setTeachers( final Vector teachers )
	{
		this.teachers = teachers;
	}

	public void setTextualCalendar( final String textualcalendar )
	{
		textualCalendar = textualcalendar;
	}
	public Date getFirstSeanceDate(){
		Vector tempSeances = new Vector();
		if (seances!=null) {
			Iterator it = seances.iterator();
			while (it.hasNext()){
				tempSeances.add((Seance)it.next());
			}
			boolean sorted;
    		do	{
      			sorted = true;
      			for (int i = 0; i < tempSeances.size () - 1; i++)
      			{
        			Seance seance1 = (Seance)tempSeances.elementAt(i);
        			Seance seance2 = (Seance)tempSeances.elementAt(i + 1);
        			java.sql.Date date1 = seance1.getSeanceDate();
        			java.sql.Date date2 = seance2.getSeanceDate();
        			if (date1.after(date2))
        			{
          				tempSeances.setElementAt(seance2,i);
          				tempSeances.setElementAt(seance1,i+1);          								
          				sorted = false;
        			}
      			}
    		}
    		while (!sorted);
    	}
    	Seance first = null;
    	if (tempSeances.size()!=0) {
    		first = (Seance)tempSeances.elementAt(0); 
    	}
    	if (first!=null){
    		return first.getSeanceDate();
    	} else {
    		return null;
    	}
	}
	
	public Date getLastSeanceDate(){
		Vector tempSeances = new Vector();
		if (seances!=null) {
			Iterator it = seances.iterator();
			while (it.hasNext()){
				tempSeances.add((Seance)it.next());
			}
			boolean sorted;
    		do	{
      			sorted = true;
      			for (int i = 0; i < tempSeances.size () - 1; i++)
      			{
        	   		Seance seance1 = (Seance)tempSeances.elementAt(i);
        			Seance seance2 = (Seance)tempSeances.elementAt(i + 1);
        			java.sql.Date date1 = seance1.getSeanceDate();
        			java.sql.Date date2 = seance2.getSeanceDate();
        			if (date1.after(date2))
        			{
          				tempSeances.setElementAt(seance2,i);
          				tempSeances.setElementAt(seance1,i+1);          								
          				sorted = false;
        			}
      			}
    		}
    		while (!sorted);
    	}
    	int size = tempSeances.size();
    	Seance last = null;
    	if (size!=0){
    		last = (Seance)tempSeances.elementAt(size-1); 
    	}
    	if (last!=null){
    		return last.getSeanceDate();
    	} else {
    		return null;
    	}
	}
	
}
