// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;

import java.util.Vector;
import java.util.Iterator;
/**
 * @(#) Location.java
 */

public class Location extends TOMAData {
	private String accessDescription;

	private String accessComment;

	private String accessFacilities;

	private Area area;

	private String completeName;

	private java.sql.Date dateCreation;

	private java.sql.Date dateMaj;

	private String denomination;

	private String email;

	private String fax;

	private int idLocation=-1;
	private Vector images;

	private String tel;

	private Address address;

    public Location(){}

    public Location(int idLocation)
    {
	this.idLocation=idLocation;
    }

	public String getAccessDescription( )
	{
		return accessDescription;
	}

	public String getAccessComment( )
	{
		return accessComment;
	}

	public String getAccessFacilities( )
	{
		return accessFacilities;
	}

	public Address getAddress( )
	{
		return address;
	}

	public Area getArea( )
	{
		return area;
	}

	public String getCompleteName( )
	{
		return completeName;
	}

	public java.sql.Date getDateCreation( )
	{
		return dateCreation;
	}

	public java.sql.Date getDateMaj( )
	{
		return dateMaj;
	}

	public String getDenomination( )
	{
		return denomination;
	}

	public String getEmail( )
	{
		return email;
	}

	public String getFax( )
	{
		return fax;
	}

	public int getIdLocation( )
	{
		return idLocation;
	}

	public Vector getImages( )
	{
		return images;
	}

	public String getTel( )
	{
		return tel;
	}

	public void setAccessDescription( final String accessdescription )
	{
		accessDescription = accessdescription;
	}

	public void setAccessComment( final String accesscomment )
	{
		accessComment = accesscomment;
	}

	public void setAccessFacilities( final String accessfacilities )
	{
		accessFacilities = accessfacilities;
	}

	public void setAddress( final Address address )
	{
		this.address = address;
	}

	public void setArea( final Area area )
	{
		this.area = area;
	}

	public void setCompleteName( final String completename )
	{
		completeName = completename;
	}

	public void setDateCreation( final java.sql.Date datecreation )
	{
		dateCreation = datecreation;
	}

	public void setDateMaj( final java.sql.Date datemaj )
	{
		dateMaj = datemaj;
	}

	public void setDenomination( final String denomination )
	{
		this.denomination = denomination;
	}

	public void setEmail( final String email )
	{
		this.email = email;
	}

	public void setFax( final String fax )
	{
		this.fax = fax;
	}

	public void setIdLocation( final int idlocation )
	{
		idLocation = idlocation;
	}

	public void setImages( final Vector images )
	{
		this.images = images;
	}

	public void setTel( final String tel )
	{
		this.tel = tel;
	}


	public String toString()
	{
	  return denomination;
	}
}
