// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;

import java.util.Vector;

/**
 * @(#) Organism.java
 */

public class Organism extends TOMAData {
	private String completeName;

	private String denomination;

	private int idOrganism=-1;

	private String presentation;

	private String url;

	private Vector addresses=new Vector();

    public Organism(){}

    public Organism(int idOrganism)
    {
	this.idOrganism=idOrganism;
    }

	public Vector getAddresses( )
	{
		return addresses;
	}

	public String getCompleteName( )
	{
		return completeName;
	}

	public String getDenomination( )
	{
		return denomination;
	}

	public int getIdOrganism( )
	{
		return idOrganism;
	}

	public String getPresentation( )
	{
		return presentation;
	}

	public String getUrl( )
	{
		return url;
	}

	public void setAddresses( final Vector addresses )
	{
		this.addresses = addresses;
	}

	public void setCompleteName( final String completename )
	{
		completeName = completename;
	}

	public void setDenomination( final String denomination )
	{
		this.denomination = denomination;
	}

	public void setIdOrganism( final int idorganism )
	{
		idOrganism = idorganism;
	}

	public void setPresentation( final String presentation )
	{
		this.presentation = presentation;
	}

	public void setUrl( final String url )
	{
		this.url = url;
	}


	public String toString()
	{
	  return denomination;
	}
}
