// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;


import java.util.Calendar;
import java.util.GregorianCalendar;
import java.sql.Date;
/**
 * @(#) Seance.java
 */

public class Seance extends TOMAData
{

    private int beginHour;
    private int beginMinute;
    private int endHour;
    private int endMinute;
    private Date seanceDate;

    public Seance(){}

	public int getBeginHour( )
	{
		return beginHour;
	}
	public int getBeginMinute( )
	{
		return beginMinute;
	}

	public int getEndHour( )
	{
		return endHour;
	}
	public int getEndMinute( )
	{
		return endMinute;
	}

	public Date getSeanceDate( )
	{
		return seanceDate;
	}

	public void setBeginHour( final int beginhour )
	{
	    beginHour=beginhour;
	}
	public void setBeginMinute( final int beginminute )
	{
	    beginMinute=beginminute;
	}

	public void setEndHour( final int endhour )
	{
	    endHour=endhour;
	}
	public void setEndMinute( final int endminute )
	{
	    endMinute=endminute;
	}

	public void setSeanceDate( final Date seancedate )
	{
		seanceDate = seancedate;
	}

      public String toString()
      {
	  GregorianCalendar cal=new GregorianCalendar();
	  cal.setTime(seanceDate);
	  String date=new Integer(cal.get(Calendar.DAY_OF_MONTH))+"/"+new Integer(cal.get(Calendar.MONTH)+1)+"/"+new Integer(cal.get(Calendar.YEAR));

	  return date+" ("+new Integer(beginHour)+":"+new Integer(beginMinute)+" - "+new Integer(endHour)+":"+new Integer(endMinute)+")";
      }

    public boolean equals(Object o)
    {
      try{
      Seance s=(Seance) o;

      if(beginHour==s.getBeginHour()
	&& beginMinute==s.getBeginMinute()
	&& endHour==s.getEndHour()
	&& endMinute==s.getEndMinute()
	&& (
	      (seanceDate==null && s.getSeanceDate()==null)
	      || (seanceDate.equals(s.getSeanceDate()))
	      )
      )
	return true;
      else
	return false;

      }catch(java.lang.ClassCastException ex)
      {
        return false;
      }
    }
}
