// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;

import java.sql.Date;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.util.Vector;
import java.util.Iterator;
/**
 * @(#) Session.java
 */

public abstract class Session extends TOMAData {
    private int idSession=-1;
    private String sessionName;
    private java.sql.Date beginDate;
    private java.sql.Date endDate;
    private Language language;
    private String price;
    private String priceComment;
    private java.sql.Date beginValidityDate;
    private java.sql.Date endValidityDate;
    private String comment;
    private int idTraining;
    private java.sql.Date dateCreation;
    private java.sql.Date dateMaj;

    public Session()
    {
	java.util.Date d=new java.util.Date();
	long millis=d.getTime();
	beginValidityDate=new Date(millis);

	GregorianCalendar cal=new GregorianCalendar();
	cal.roll(Calendar.YEAR, true);
	endValidityDate=new Date(cal.getTime().getTime());
    }

    public Session(int idSession)
    {
	this.idSession=idSession;
    }

	public java.sql.Date getBeginDate( )
	{
		return beginDate;
	}

	public java.sql.Date getBeginValidityDate( )
	{
		return beginValidityDate;
	}

	public String getComment( )
	{
		return comment;
	}

	public java.sql.Date getDateCreation( )
	{
		return dateCreation;
	}

	public java.sql.Date getDateMaj( )
	{
		return dateMaj;
	}

	public java.sql.Date getEndDate( )
	{
		return endDate;
	}

	public java.sql.Date getEndValidityDate( )
	{
		return endValidityDate;
	}

	public int getIdSession( )
	{
		return idSession;
	}

	public int getIdTraining( )
	{
		return idTraining;
	}

	public Language getLanguage( )
	{
		return language;
	}

	

	public String getPrice( )
	{
		return price;
	}

	public String getPriceComment( )
	{
		return priceComment;
	}

	public String getSessionName( )
	{
		return sessionName;
	}

	
	public void setBeginDate( final java.sql.Date begindate )
	{
		beginDate = begindate;
	}

	public void setBeginValidityDate( final java.sql.Date beginvaliditydate )
	{
		beginValidityDate = beginvaliditydate;
	}

	public void setComment( final String comment )
	{
		this.comment = comment;
	}

	public void setDateCreation( final java.sql.Date datecreation )
	{
		dateCreation = datecreation;
	}

	public void setDateMaj( final java.sql.Date datemaj )
	{
		dateMaj = datemaj;
	}

	public void setEndDate( final java.sql.Date enddate )
	{
		endDate = enddate;
	}

	public void setEndValidityDate( final java.sql.Date endvaliditydate )
	{
		endValidityDate = endvaliditydate;
	}

	public void setIdSession( final int idsession )
	{
		idSession = idsession;
	}

	public void setIdTraining( final int idtraining )
	{
		idTraining = idtraining;
	}

	public void setLanguage( final Language language )
	{
		this.language = language;
	}

	

	public void setPrice( final String price )
	{
		this.price = price;
	}

	public void setPriceComment( final String pricecomment )
	{
		priceComment = pricecomment;
	}

	public void setSessionName( final String sessionname )
	{
		sessionName = sessionname;
	}

	


	public String toString()
	{
	  return sessionName;
	}
}
