// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;

import java.util.Vector;

/**
 * @(#) StandaloneTraining.java
 */

public abstract class StandaloneTraining extends Training
{
    private String certificatesOrDiplomas;
    private String price;
    private String priceComment;
    private String paymentFacilities;
    private String inscriptionConditions;

    private Vector audiences;
    private Vector domains;
    private Vector catalogues;
    private Vector catOrders;

    private Vector inscriptionContacts;

    public StandaloneTraining(){}

    public StandaloneTraining(int idTraining)
    {
	super(idTraining);
    }

	public Vector getAudiences( )
	{
		return audiences;
	}

	public Vector getCatalogues( )
	{
		return catalogues;
	}

	public Vector getCatOrders()
	{
	      return catOrders;
	}


	public String getCertificatesOrDiplomas( )
	{
		return certificatesOrDiplomas;
	}

	public Vector getDomains( )
	{
		return domains;
	}

	public String getInscriptionConditions( )
	{
		return inscriptionConditions;
	}

	public Vector getInscriptionContacts( )
	{
		return inscriptionContacts;
	}

	public String getPaymentFacilities( )
	{
		return paymentFacilities;
	}

	public String getPrice( )
	{
		return price;
	}

	public String getPriceComment( )
	{
		return priceComment;
	}

	public void setAudiences( final Vector audiences )
	{
		this.audiences = audiences;
	}

	public void setCatalogues( final Vector catalogues )
	{
		this.catalogues = catalogues;
	}
	public void setCatOrders( final Vector catOrders )
	{
		this.catOrders = catOrders;
	}
	public void setCertificatesOrDiplomas( final String certificatesordiplomas )
	{
		certificatesOrDiplomas = certificatesordiplomas;
	}

	public void setDomains( final Vector domains )
	{
		this.domains = domains;
	}

	public void setInscriptionConditions( final String inscriptionconditions )
	{
		inscriptionConditions = inscriptionconditions;
	}

	public void setInscriptionContacts( final Vector inscriptioncontacts )
	{
		inscriptionContacts = inscriptioncontacts;
	}

	public void setPaymentFacilities( final String paymentfacilities )
	{
		paymentFacilities = paymentfacilities;
	}

	public void setPrice( final String price )
	{
		this.price = price;
	}

	public void setPriceComment( final String pricecomment )
	{
		priceComment = pricecomment;
	}
}
