// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/**
 * TOMAConstants.java
 *
 * @author Created by Omnicore CodeGuide
 */

package apostal.toma.data;

import java.lang.System;

public class TOMAConstants
{
      /********* Images *********/
	private final static String imagesPath="Images"+System.getProperty("file.separator");

    //icones pour les trainings
	public final static String saveImagePath=imagesPath+"save.gif";
	public final static String deleteImagePath=imagesPath+"trash.gif";
	public final static String sessionsImagePath=imagesPath+"calendar.gif";

	public final static String savePressedImagePath=imagesPath+"save_pressed.gif";
	public final static String deletePressedImagePath=imagesPath+"trash_pressed.gif";
	public final static String sessionsPressedImagePath=imagesPath+"calendar_pressed.gif";

	public final static String addIconPath=imagesPath+"add.gif";
	public final static String removeIconPath=imagesPath+"remove.gif";

	public final static String addPressedIconPath=imagesPath+"add_pressed.gif";
	public final static String removePressedIconPath=imagesPath+"remove_pressed.gif";

	public final static String addPointIconPath=imagesPath+"add_point.gif";
	public final static String removePointIconPath=imagesPath+"remove_point.gif";

	public final static String addPointPressedIconPath=imagesPath+"add_point_pressed.gif";
	public final static String removePointPressedIconPath=imagesPath+"remove_point_pressed.gif";
    //icones pour l'arbre
	public final static String catalogueOpenedIconPath=imagesPath+"folder_open.gif";
	public final static String catalogueClosedIconPath=imagesPath+"folder_closed.gif";

	public final static String trainingCourseIconPath=imagesPath+"tr_course.gif";
	public final static String trainingProgrammeIconPath=imagesPath+"tr_programme.gif";

	public final static String treeOpenedIconPath=imagesPath+"minus.gif";
	public final static String treeClosedIconPath=imagesPath+"plus.gif";

    //icones pour les dialogues
	public final static String questionIconPath=imagesPath+"question.gif";
	public final static String errorIconPath=imagesPath+"error.gif";
	public final static String okIconPath=imagesPath+"ok.gif";


    /********** divers ****************/
    public final static String temporaryXMLFile="TOMATemporaryFile.xml";
    public final static String helpPath="Help" +  System.getProperty("file.separator") + "TOMA_ModeEmploi.html";

    public final static String parametersFile="TOMA.parameters";

    public final static String tedFilename="ted.xsd";
    public final static String tedTemplateSchemaFilename="tedTemplate.xsd";
    public final static String templateTemporaryFile="template.xml";

    /********** publication ************/

	public final static String stylesPath="External"+System.getProperty("file.separator");

    public final static String defaultHTMLStylesheet=stylesPath + "generationHTML.xsl";
    public final static String defaultPDFStylesheet=stylesPath + "generationPDF.xsl.fo";
    public final static String defaultRTFStylesheet=stylesPath + "generationRTF.xsl.fo";
    public final static String defaultPropertiesFile=stylesPath + "properties.xml";
    public final static String propertiesFilePDF = stylesPath + "propertiesPDF.xml";
    public final static String propertiesFileRTF = stylesPath + "propertiesRTF.xml";
    public final static String propertiesFileHTML = stylesPath + "propertiesHTML.xml";
	public final static String propertiesFileSOAP = stylesPath + "propertiesSOAP.xml";
    public final static String propertiesFileXSL = stylesPath + "propertiesXSL.xml";

    public final static String syrecosURL="http://binux.crpht.lu:8085/soap/servlet/rpcrouter";
    public final static String syrecosEncodingTarget="urn:apostal.SyrecosEncoding";
    public final static String syrecosEncodingTestMethod="testDeleteAndTestAttributes";
    public final static String syrecosEncodingMethod="deleteAndEncode";
    public final static String syrecosExtractionTarget="urn:apostal.SyrecosExtraction";
    public final static String syrecosExtractionMethod="extract";    
}

