// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.data;

import apostal.toma.TOMA;
import apostal.toma.data.TOMATemplateResult;

import java.util.Hashtable;
import java.util.Vector;


import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import java.io.IOException;
import java.io.File;
import java.io.FileInputStream;
import org.w3c.dom.*;
import org.xml.sax.ErrorHandler;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.transform.*;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.apache.xerces.parsers.*;


public class TOMATemplate {

    private String filename;
    
    private Document doc;
    private Vector validationMessages;

    public TOMATemplate()
    {
      this.filename=TOMA.getInstance().getTomaParameters().getTemplateFile();

      trainingCourseResults=new Hashtable();
      trainingProgrammeResults=new Hashtable();
      unitResults=new Hashtable();
      courseSessionResults=new Hashtable();
      programmeSessionResults=new Hashtable();
      unitSessionResults=new Hashtable();
      locationResults=new Hashtable();
      contactResults=new Hashtable();
      teacherResults=new Hashtable();
      organismResults=new Hashtable();
      
      validationMessages=new Vector();
    }

    private Hashtable unitResults;
    private Hashtable trainingProgrammeResults;
    private Hashtable trainingCourseResults;
    private Hashtable courseSessionResults;
    private Hashtable programmeSessionResults;
    private Hashtable unitSessionResults;
    private Hashtable locationResults;
    private Hashtable contactResults;
    private Hashtable teacherResults;
    private Hashtable organismResults;

    public apostal.toma.data.TOMATemplateResult getTrainingProgrammeResult(String val) {
	TOMATemplateResult result=(TOMATemplateResult) trainingProgrammeResults.get(val);

	if(result==null)
	  result=new TOMATemplateResult(false, false, -1, new Vector());

	return  result;
    }

    public apostal.toma.data.TOMATemplateResult getTrainingCourseResult(String val) {
	TOMATemplateResult result= (TOMATemplateResult) trainingCourseResults.get(val);

	if(result==null)
	  result=new TOMATemplateResult(false, false, -1, new Vector());

	return result;
    }

    public apostal.toma.data.TOMATemplateResult getUnitResult(String val) {
	TOMATemplateResult result= (TOMATemplateResult) unitResults.get(val);

	if(result==null)
	  result=new TOMATemplateResult(false, false, -1, new Vector());

	return result;
    }

    public apostal.toma.data.TOMATemplateResult getCourseSessionResult(String val) {
	TOMATemplateResult result= (TOMATemplateResult) courseSessionResults.get(val);

	if(result==null)
	  result=new TOMATemplateResult(false, false, -1, new Vector());

	return result;
    }

    public apostal.toma.data.TOMATemplateResult getProgrammeSessionResult(String val) {
	TOMATemplateResult result= (TOMATemplateResult) programmeSessionResults.get(val);

	if(result==null)
	  result=new TOMATemplateResult(false, false, -1, new Vector());

	return result;
    }

    public apostal.toma.data.TOMATemplateResult getUnitSessionResult(String val) {
	TOMATemplateResult result= (TOMATemplateResult) unitSessionResults.get(val);

	if(result==null)
	  result=new TOMATemplateResult(false, false, -1, new Vector());

	return result;
    }
    public apostal.toma.data.TOMATemplateResult getLocationResult(String val) {
	TOMATemplateResult result= (TOMATemplateResult) locationResults.get(val);

	if(result==null)
	  result=new TOMATemplateResult(false, false, -1, new Vector());

	return result;
    }    
    public apostal.toma.data.TOMATemplateResult getContactResult(String val) {
	TOMATemplateResult result= (TOMATemplateResult) contactResults.get(val);

	if(result==null)
	  result=new TOMATemplateResult(false, false, -1, new Vector());

	return result;
    }
    public apostal.toma.data.TOMATemplateResult getTeacherResult(String val) {
	TOMATemplateResult result= (TOMATemplateResult) teacherResults.get(val);

	if(result==null)
	  result=new TOMATemplateResult(false, false, -1, new Vector());

	return result;
    }         
    public apostal.toma.data.TOMATemplateResult getOrganismResult(String val) {
	TOMATemplateResult result= (TOMATemplateResult) organismResults.get(val);

	if(result==null)
	  result=new TOMATemplateResult(false, false, -1, new Vector());

	return result;
    }
    /**
     * methods to load the template file into the data sets
     */    

    public boolean aTemplateFileIsGiven()
    {
        boolean ok=true;
        if(filename==null || filename.equals(""))
	  ok=false;
        
        return ok;
    }
    

   public boolean openTemplateDocument()
   {
        boolean ok=true;

	if(filename==null || filename.equals(""))
	{
	  ok=false;
	}
	else{

	DocumentBuilder docBuilder = null;
	try {
	    DocumentBuilderFactory docBuilderFactory=DocumentBuilderFactory.newInstance();
            docBuilderFactory.setNamespaceAware(true);
	    docBuilder = docBuilderFactory.newDocumentBuilder();
            File f=new File(filename);
	    doc = docBuilder.parse(f);
	    Element root=doc.getDocumentElement();
            root.normalize();
            
            //put the right schema file
            //warning, the schema instance namespace must have been declared as xsi!
            root.setAttributeNS("http://www.w3.org/2001/XMLSchema-instance", "xsi:noNamespaceSchemaLocation", TOMAConstants.tedTemplateSchemaFilename);
            
            //save the file in the template file
            TransformerFactory factory=TransformerFactory.newInstance();
            Transformer transformer=factory.newTransformer();
            DOMSource source=new DOMSource(doc);
            StreamResult result=new StreamResult(new File(TOMAConstants.templateTemporaryFile));
            transformer.transform(source, result);            
            this.filename=TOMAConstants.templateTemporaryFile;
	}
	catch (IOException ioe){
	    doc = docBuilder.newDocument();
	    ok=false;
	}
	catch (Exception ex)
	    {
		TOMA.log(TOMA.SEVERE, ex.toString()+"\n"+ex.getMessage());
		ok=false;
	    }
        }
        
        return ok;        
   }
        
   public boolean isTemplateValid()
   {
       boolean ok=true;
	//validation
	MyHandler handler=new MyHandler();

	SAXParser parser=new SAXParser();
	parser.setErrorHandler(handler);
	try {
	    parser.setFeature("http://xml.org/sax/features/validation", true);
            parser.setFeature("http://apache.org/xml/features/validation/schema", true); 
            parser.setFeature("http://apache.org/xml/features/validation/schema-full-checking", true);            
	} catch (Exception e) {
	    TOMA.log(TOMA.SEVERE, "error in setting up parser feature");
	    ok=false;
	}

	try{
	parser.parse(filename);
	} catch(java.lang.Exception ex)
	    {
		TOMA.log(TOMA.SEVERE, "problem while parsing the file");
		ok=false;
	    }
	ok=handler.getValide();
       
        if(!ok)
            validationMessages=handler.getMessages();
        
        return ok;
   }

   public Vector getValidationMessages()
   {
        return validationMessages;
   }
   
   public boolean load()
   {
       boolean ok=true;
        //continue only if all is ok
        if(doc!=null)
	{
	  Element ted=doc.getDocumentElement();
          
	  //training Courses
	  NodeList tcs=ted.getElementsByTagName("trainingCourse");
	  if(tcs.getLength()>0)
	  {
	    Node tc=tcs.item(0);

	    NodeList children=tc.getChildNodes();
	    int nbChildren=children.getLength();
	    for(int i=0;i<nbChildren;i++)
	    {
	      Node child=children.item(i);
	      String name=child.getNodeName();
	      if(name!=null && !name.equals("courseSession"))
	      {
                TOMATemplateResult result=this.getResult(child);
                trainingCourseResults.put(name, result);
              
                this.addParticularCasesResults(child, trainingCourseResults);
	      }
	      else if(name!=null)
	      {
	      	    NodeList sessionChildren=child.getChildNodes();
		    int nbSessionChildren=sessionChildren.getLength();
		    for(int j=0;j<nbSessionChildren;j++)
		    {
		      Node sessionChild=sessionChildren.item(j);
		      String sessionName=sessionChild.getNodeName();
		      TOMATemplateResult result=this.getResult(sessionChild);
		      courseSessionResults.put(sessionName, result);
		    }
	      }
	    }
	  }

	  //training Programmes
	  NodeList tps=ted.getElementsByTagName("trainingProgramme");
	  if(tps.getLength()>0)
	  {
	    Node tp=tps.item(0);

	    NodeList children=tp.getChildNodes();
	    int nbChildren=children.getLength();
	    for(int i=0;i<nbChildren;i++)
	    {
	      Node child=children.item(i);
	      String name=child.getNodeName();
	      if(name!=null && !name.equals("unit") && !name.equals("programmeSession"))
	      {
		TOMATemplateResult result=this.getResult(child);
		trainingProgrammeResults.put(name, result);
                
                this.addParticularCasesResults(child, trainingProgrammeResults);
	      }
	      else if(name!=null && name.equals("unit"))
	      {
	      	    NodeList unitChildren=child.getChildNodes();
		    int nbUnitChildren=unitChildren.getLength();
		    for(int j=0;j<nbUnitChildren;j++)
		    {
		      Node unitChild=unitChildren.item(j);
		      String unitName=unitChild.getNodeName();
		      if(unitName!=null && !unitName.equals("unitSession"))
		      {
		        TOMATemplateResult result=this.getResult(unitChild);
		        unitResults.put(unitName, result);
                        
                        this.addParticularCasesResults(unitChild, unitResults);
		      }
		      else if(unitName!=null)
		      {
			NodeList sessionChildren=unitChild.getChildNodes();
			int nbSessionChildren=sessionChildren.getLength();
			for(int k=0;k<nbSessionChildren;k++)
			{
			  Node sessionChild=sessionChildren.item(k);
			  String sessionName=sessionChild.getNodeName();
			  TOMATemplateResult result=this.getResult(sessionChild);
			  unitSessionResults.put(sessionName, result);
			}
		      }
		    }
	      }
	      else if(name!=null && name.equals("programmeSession"))
	      {
	      	    NodeList sessionChildren=child.getChildNodes();
		    int nbSessionChildren=sessionChildren.getLength();
		    for(int j=0;j<nbSessionChildren;j++)
		    {
		      Node sessionChild=sessionChildren.item(j);
		      String sessionName=sessionChild.getNodeName();
		      TOMATemplateResult result=this.getResult(sessionChild);
		      programmeSessionResults.put(sessionName, result);
		    }
	      }
	    }
	  }
          
          //organism
	  NodeList orgs=ted.getElementsByTagName("aux_organism");
	  if(orgs.getLength()>0)
	  {
	    Node org=orgs.item(0);

	    NodeList children=org.getChildNodes();
	    int nbChildren=children.getLength();
	    for(int i=0;i<nbChildren;i++)
	    {
	      Node child=children.item(i);
	      String name=child.getNodeName();
	      if(name!=null)
	      {
                TOMATemplateResult result=this.getResult(child);
                organismResults.put(name, result);
              
                this.addParticularCasesResults(child, organismResults);
	      }
	    }
	  }          
          
          //locations
	  NodeList locs=ted.getElementsByTagName("aux_location");
	  if(locs.getLength()>0)
	  {
	    Node loc=locs.item(0);

	    NodeList children=loc.getChildNodes();
	    int nbChildren=children.getLength();
	    for(int i=0;i<nbChildren;i++)
	    {
	      Node child=children.item(i);
	      String name=child.getNodeName();
	      if(name!=null)
	      {
                TOMATemplateResult result=this.getResult(child);
                locationResults.put(name, result);
              
                this.addParticularCasesResults(child, locationResults);
	      }
	    }
	  }
          
          //contacts
	  NodeList contacts=ted.getElementsByTagName("aux_contact");
	  if(contacts.getLength()>0)
	  {
	    Node c=contacts.item(0);

	    NodeList children=c.getChildNodes();
	    int nbChildren=children.getLength();
	    for(int i=0;i<nbChildren;i++)
	    {
	      Node child=children.item(i);
	      String name=child.getNodeName();
	      if(name!=null)
	      {
                TOMATemplateResult result=this.getResult(child);
                contactResults.put(name, result);
              
                this.addParticularCasesResults(child, contactResults);
	      }
	    }
	  }  
          
          //teachers
	  NodeList tes=ted.getElementsByTagName("aux_teacher");
	  if(tes.getLength()>0)
	  {
	    Node te=tes.item(0);

	    NodeList children=te.getChildNodes();
	    int nbChildren=children.getLength();
	    for(int i=0;i<nbChildren;i++)
	    {
	      Node child=children.item(i);
	      String name=child.getNodeName();
	      if(name!=null)
	      {
                TOMATemplateResult result=this.getResult(child);
                teacherResults.put(name, result);
              
                this.addParticularCasesResults(child, teacherResults);
	      }
	    }
	  }           
	}	

    return ok;
  }

   /*
    * do particular treatments when loading the template
    * at the moment, only for objectives, pointDealtWiths and contentDescriptions
    */
   private void addParticularCasesResults(Node child, Hashtable table)
   {
       String name=child.getNodeName();
       
                //objectives
                if(name.equals("objectives"))
                {
                    NodeList obj_children=child.getChildNodes();
                    int nb2=obj_children.getLength();
                    for(int j=0;j<nb2;j++)
                    {
                        Node child2=obj_children.item(j);
                        TOMATemplateResult result2=this.getResult(child2);
                        if(child2.getNodeName().equals("introduction"))
                            table.put("objectivesIntroduction", result2);
                        else if(child2.getNodeName().equals("objective"))
                            table.put("objectivesPoint", result2);
                        else if(child2.getNodeName().equals("conclusion"))
                            table.put("objectivesConclusion", result2);
                    }
                }
                //content
                else if(name.equals("contentDescription"))
                {
                    NodeList obj_children=child.getChildNodes();
                    int nb2=obj_children.getLength();
                    for(int j=0;j<nb2;j++)
                    {
                        Node child2=obj_children.item(j);
                        TOMATemplateResult result2=this.getResult(child2);
                        if(child2.getNodeName().equals("introduction"))
                            table.put("contentIntroduction", result2);
                        else if(child2.getNodeName().equals("subDescription"))
                            table.put("contentPoint", result2);
                        else if(child2.getNodeName().equals("conclusion"))
                            table.put("contentConclusion", result2);
                    }
                }
                //point
                else if(name.equals("pointsDealtWith"))
                {
                    TOMA.log(TOMA.WARNING, "TOMATemplate, loading for pointsDealtWith");
                    
                    NodeList obj_children=child.getChildNodes();
                    int nb2=obj_children.getLength();
                    for(int j=0;j<nb2;j++)
                    {
                        Node child2=obj_children.item(j);
                        TOMATemplateResult result2=this.getResult(child2);
                        if(child2.getNodeName().equals("introduction"))
                            table.put("pdwIntroduction", result2);
                        else if(child2.getNodeName().equals("pointDealtWith"))
                        {
                            TOMA.log(TOMA.WARNING, "TOMATemplate, loading for pointsDealtWith.pointDealtWith");
                         
                            table.put("pointDealtWith", result2);
                            
                            NodeList obj_children2=child2.getChildNodes();
                            int nb3=obj_children2.getLength();
                            for(int k=0;k<nb3;k++)
                            {
                                Node child3=obj_children2.item(k);
                                TOMATemplateResult result3=this.getResult(child3);
                                if(child3.getNodeName().equals("introduction"))
                                {
                                    table.put("subPwdIntroduction", result3);
                                    TOMA.log(TOMA.WARNING, "TOMATemplate, loading for pointsDealtWith.pointDealtWith.introduction");
                                }
                                else if(child3.getNodeName().equals("subPointDealtWith"))
                                {
                                    table.put("subPwdPoint", result3);
                                    TOMA.log(TOMA.WARNING, "TOMATemplate, loading for pointsDealtWith.pointDealtWith.subPointDealtWith");
                                }
                                else if(child3.getNodeName().equals("conclusion"))
                                {
                                    table.put("subPwdConclusion", result3);
                                    TOMA.log(TOMA.WARNING, "TOMATemplate, loading for pointsDealtWith.pointDealtWith.conclusion");
                                }
                            }                            
                        }
                        else if(child2.getNodeName().equals("conclusion"))
                            table.put("pdwConclusion", result2);
                    }
                }         
   }
   
  public TOMATemplateResult getResult(Node child)
  {
	      boolean forbidden=false;
	      boolean mandatory=false;
	      int maximum=-1;
	      Vector v_values=new Vector();

	      NamedNodeMap attributes=child.getAttributes();
	      if(attributes!=null)
	      {
	      //forbidden
	      Attr attr_forbidden=(Attr) attributes.getNamedItem("forbidden");
	      if(attr_forbidden!=null)
	      {
	      String forbidden_value=attr_forbidden.getValue();
	      if(forbidden_value!=null && forbidden_value.equals("1"))
		forbidden=true;
	      }

	      //mandatory
	      Attr attr_mandatory=(Attr) attributes.getNamedItem("mandatory");
	      if(attr_mandatory!=null)
	      {
	      String mandatory_value=attr_mandatory.getValue();
	      if(mandatory_value!=null && mandatory_value.equals("1"))
		mandatory=true;
	      }

	      //maximum
	      Attr attr_maximum=(Attr) attributes.getNamedItem("maximum");
	      if(attr_maximum!=null)
	      {
	        String maximum_value=attr_maximum.getValue();
	        if(maximum_value!=null && !maximum_value.equals(""))
	        {
		  try{
		  maximum=Integer.parseInt(maximum_value);
		  }catch(java.lang.NumberFormatException ex)
		  {}
	        }
	      }

	      }

	      //values
	      Element el=null;
	      try{
	      el=(Element) child;
	      } catch(java.lang.ClassCastException ex)
	      {}
	      if(el!=null)
	      {
	        NodeList list=el.getElementsByTagName("values");
		//list=lists of "values"
		if(list!=null && list.getLength()>0)
		{
		  //only the first "values"
		  Node node_values=list.item(0);
		  if(node_values!=null)
		  {
		  Element values=null;
		  try{
		    values=(Element) node_values;
		  } catch(java.lang.ClassCastException ex)
		  {}
		  if(values!=null)
		  {
		    //values=Element of "values"

		    NodeList value_values=values.getElementsByTagName("value");
		    if(value_values!=null)
		    {
		    //value_values=NodeList of the elements "value" of "values"

		    int nbValues=value_values.getLength();
		    for(int i=0;i<nbValues;i++)
		    {
		      Node value=value_values.item(i);
		      //value=node of "value" type 
		      if(value!=null)
		      {
			//value ofthe node
			NodeList contenu=value.getChildNodes();
			int nbContenu=contenu.getLength();
			int l=0;
			boolean found=false;
			while(l<nbContenu && !found)
			{
			  Node node=contenu.item(l);
			  if(node.getNodeType()==Node.TEXT_NODE)
			    {
			      found=true;
			      v_values.add(node.getNodeValue());
			    }
			  l++;
			}

		      }
		    }
		    }
		  }
		  }
		}
	      }

	      TOMATemplateResult result=new TOMATemplateResult(forbidden, mandatory, maximum, v_values);
      return result;
  }

}


class MyHandler extends DefaultHandler
{
    private boolean valide;
    private Vector messages;

    public MyHandler()
    {
	valide=true;
	messages=new Vector();
    }

    public void error(SAXParseException exception) throws SAXException
    {
	allErrors(exception);
    }

    public void fatalError(SAXParseException exception) throws SAXException
    {
	allErrors(exception);
    }

    public void warning(SAXParseException exception) throws SAXException
    {
	allErrors(exception);
    }

    public void allErrors(SAXParseException exception) throws SAXException
    {
	valide=false;
	
        messages.add(exception.getMessage());

	TOMA.log(TOMA.SEVERE, "validation error: "+exception.getMessage());
    }

    public boolean getValide()
    {
	return valide;
    }

    public Vector getMessages()
    {
	return messages;
    }

}

