// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.data;

import java.util.Vector;

public class TOMATemplateResult {
    public final static int MANDATORY_PROBLEM=0;
    public final static int MAXIMUM_PROBLEM=1;

    private Vector values;
    private int maximum=-1;
    private boolean forbidden;
    private boolean mandatory;

    public TOMATemplateResult(boolean forbidden, boolean mandatory, int maximum, Vector values)
    {
      this.forbidden=forbidden;
      this.mandatory=mandatory;
      this.values=values;
      this.maximum=maximum;
    }

    public boolean isForbidden()
    {
      return forbidden;
    }

    public boolean isMandatory()
    {
      return mandatory;
    }

    public int getMaximum()
    {
      return maximum;
    }

    public Vector getValues()
    {
      return new Vector(values);
    }

    public int testCorrectness(String field)
    {
      int result=-1;

      if(mandatory && (field==null || field.equals("")))
	result=this.MANDATORY_PROBLEM;
      else if(maximum>0 && (field!=null && field.length()>maximum))
        result=this.MAXIMUM_PROBLEM;

      return result;
    }

}
