// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;

import java.util.Vector;
import java.util.Iterator;
import java.sql.Date;
import apostal.toma.database.CourseSessionDB;
import apostal.toma.data.Language;
/**
 * @(#) TrainingCourse.java
 */

public class TrainingCourse extends StandaloneTraining
{
	private Vector courseSessions;

    public TrainingCourse(){}

    public TrainingCourse(int idTraining)
    {
	super(idTraining);
    }

    public void setCourseSessions(Vector courseSessions)
    {
	this.courseSessions=courseSessions;
    }

    public Vector getCourseSessions()
    {
	return courseSessions;
    }
    
    public Date getFirstSeanceDate(){
    	Date returnDate = null;
    	Iterator it = courseSessions.iterator();
    	Vector dateSeances = new Vector();
    	while(it.hasNext()){
    		CourseSession cs = (CourseSession)it.next();
    		CourseSessionDB csDB = new CourseSessionDB(cs);
    		csDB.loadById(new Language("fra"),true);
    		Date beginDate = cs.getBeginDate();
    		if (beginDate==null){
    			beginDate = cs.getFirstSeanceDate();    			
    		}
    		dateSeances.add(beginDate);
    	}
    	boolean sorted;
    	do	{
      		sorted = true;
      		for (int i = 0; i < dateSeances.size () - 1; i++)
      		{
        		java.sql.Date date1 = (java.sql.Date)dateSeances.elementAt (i);
        		java.sql.Date date2 = (java.sql.Date)dateSeances.elementAt (i + 1);
        		if (date1!=null && date2!=null) {
        			if (date1.after(date2))
        			{
          				dateSeances.setElementAt(date2,i);
          				dateSeances.setElementAt(date1,i+1);          								
          				sorted = false;
        			}
        		}
      		}
    	}
    	while (!sorted);
    	if (dateSeances.size()!=0){
    		return (Date)dateSeances.elementAt(0);    	
    	} else {
    		return null;
    	}
    	
    }
    public Date getEndSeanceDate(){
    	Date returnDate = null;
    	Iterator it = courseSessions.iterator();
    	Vector dateSeances = new Vector();
    	while(it.hasNext()){
    		CourseSession cs = (CourseSession)it.next();
    		CourseSessionDB csDB = new CourseSessionDB(cs);
    		csDB.loadById(new Language("fra"),true);
    		Date endDate = cs.getEndDate();
    		if (endDate==null){
    			endDate = cs.getLastSeanceDate();
    		}
    		dateSeances.add(endDate);
    	}
    	boolean sorted;
    	do	{
      		sorted = true;
      		for (int i = 0; i < dateSeances.size () - 1; i++)
      		{
        		java.sql.Date date1 = (java.sql.Date)dateSeances.elementAt (i);
        		java.sql.Date date2 = (java.sql.Date)dateSeances.elementAt (i + 1);
        		if (date1!=null && date2!=null) {
        			if (date1.after(date2))
        			{
          				dateSeances.setElementAt(date2,i);
          				dateSeances.setElementAt(date1,i+1);          								
          				sorted = false;
        			}
        		}
      		}
    	}
    	while (!sorted);
    	int size = dateSeances.size(); 
    	if (size!=0) {
    		return (Date)dateSeances.elementAt(size-1);    	
    	}
    	else {
    		return null;
    	}
    	
    }

}
