// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;

/**
 * @(#) PublishedTraining.java
 */
public class TrainingPublished extends TOMAData
{
    private int idTraining;
    private int idPublicationUnit;
    private int idCatalogue=-1;
    private boolean publishWithoutCatalogue=false;
    private int nborder;

    private String title;

    public TrainingPublished(int idPublicationUnit, int idCatalogue, int idTraining, int nborder)
    {
	this.idPublicationUnit=idPublicationUnit;
	this.idCatalogue=idCatalogue;
	this.idTraining=idTraining;
	this.nborder=nborder;
    }
    public TrainingPublished(int idPublicationUnit, int idCatalogue, int idTraining, int nborder, boolean publishWithoutCatalogue)
    {
	this.idPublicationUnit=idPublicationUnit;
	this.idCatalogue=idCatalogue;
        this.idTraining=idTraining;
	this.nborder=nborder;
        this.publishWithoutCatalogue=publishWithoutCatalogue;
    }

    public TrainingPublished(){}

	public int getIdTraining( )
	{
		return idTraining;
	}

    public int getIdCatalogue()
    {
	return idCatalogue;
    }

    public int getIdPublicationUnit()
    {
	return idPublicationUnit;
    }

	public String getTitle( )
	{
		return title;
	}

    public int getNborder()
    {
      return nborder;
    }

    public boolean getPublishWithoutCatalogue()
    {
        return publishWithoutCatalogue;
    }
    
	public void setIdTraining( final int idtraining )
	{
		idTraining = idtraining;
	}

    public void setIdPublicationUnit(final int idPublicationUnit)
    {
	this.idPublicationUnit=idPublicationUnit;
    }

   public void setIdCatalogue(final int idCatalogue)
    {
	this.idCatalogue=idCatalogue;
    }

	public void setTitle( final String title )
	{
		this.title = title;
	}

	public void setNborder(int nborder)
	  {
	    this.nborder=nborder;
	  }
        public void setPublishWithoutCatalogue(boolean pwc)
        {
            this.publishWithoutCatalogue=pwc;
            
        }
        
    public boolean equals(Object o){
    	boolean equal = true;
    	if (o==null){
    		equal=false;
    	} else {
    		String classname = o.getClass().getName();
    	   	if (classname.equals("apostal.toma.data.TrainingPublished")){
    	   		TrainingPublished trPub = (TrainingPublished)o;
    	   		if (!(this.idTraining==trPub.getIdTraining()) || !(this.idCatalogue==trPub.getIdCatalogue())){
    	   			equal=false;
    	   		}
    		} else {
    			equal=false;	
    		}
    	}
    	return equal;
    }
}

