// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.data;

import apostal.toma.database.UnitSessionDB;
import apostal.toma.data.Language;

import java.util.Vector;
import java.util.Iterator;

import java.sql.Date;
/**
 * @(#) Unit.java
 */

public class Unit extends Training
{
	private Vector unitSessions;

    private int nborder;
    private int idProgramme;
    private int idTrainingCopied;

    public Unit()
    {
      this.idProgramme=-1;
      this.idTrainingCopied=-1;
      this.nborder=-1;
    }

    public Unit(int idTraining)
    {
	super(idTraining);
        this.idProgramme=-1;
        this.idTrainingCopied=-1;
        this.nborder=-1;
    }

    public int getNborder()
    { return nborder; }

    public int getIdProgramme()
    {
	return idProgramme;
    }
    public int getIdTrainingCopied()
    {
	return idTrainingCopied;
    }

    public Vector getUnitSessions()
    {
	return unitSessions;
    }

    public void setNborder(int nborder)
    { this.nborder = nborder; }

    public void setIdProgramme(int idProgramme)
    {
	this.idProgramme= idProgramme;
    }
    public void setIdTrainingCopied(int idTrainingCopied)
    {
	this.idTrainingCopied= idTrainingCopied;
    }

    public void setUnitSessions(Vector unitSessions)
    {
	this.unitSessions=unitSessions;
    }
    
    
    public Date getFirstSeanceDate(){
    	Date returnDate = null;
    	Iterator it = unitSessions.iterator();
    	Vector dateSeances = new Vector();
    	while(it.hasNext()){
    		UnitSession us = (UnitSession)it.next();
    		UnitSessionDB usDB = new UnitSessionDB(us);
    		usDB.loadById(new Language("fra"),true);
    		Date beginDate = us.getBeginDate();
    		if (beginDate==null){
    			beginDate = us.getFirstSeanceDate();    			
    		}
    		dateSeances.add(beginDate);
    	}
    	boolean sorted;
    	do	{
      		sorted = true;
      		for (int i = 0; i < dateSeances.size () - 1; i++)
      		{
        		java.sql.Date date1 = (java.sql.Date)dateSeances.elementAt (i);
        		java.sql.Date date2 = (java.sql.Date)dateSeances.elementAt (i + 1);
        		if (date1!=null && date2!=null){
        			if (date1.after(date2))
        			{
          				dateSeances.setElementAt(date2,i);
          				dateSeances.setElementAt(date1,i+1);          								
          				sorted = false;
        			}
        		}
      		}
    	}
    	while (!sorted);
    	return (Date)dateSeances.elementAt(0);    	
    }
    public Date getEndSeanceDate(){
    	Date returnDate = null;
    	Iterator it = unitSessions.iterator();
    	Vector dateSeances = new Vector();
    	while(it.hasNext()){
    		UnitSession us = (UnitSession)it.next();
    		UnitSessionDB usDB = new UnitSessionDB(us);
    		usDB.loadById(new Language("fra"),true);
    		Date endDate = us.getEndDate();
    		if (endDate==null){
    			endDate = us.getLastSeanceDate();
    		}
    		dateSeances.add(endDate);
    	}
    	boolean sorted;
    	do	{
      		sorted = true;
      		for (int i = 0; i < dateSeances.size () - 1; i++)
      		{
        		java.sql.Date date1 = (java.sql.Date)dateSeances.elementAt (i);
        		java.sql.Date date2 = (java.sql.Date)dateSeances.elementAt (i + 1);
        		if (date1!=null && date2!=null){
        			if (date1.after(date2))
        			{
          				dateSeances.setElementAt(date2,i);
          				dateSeances.setElementAt(date1,i+1);          								
          				sorted = false;
        			}
        		}
      		}
    	}
    	while (!sorted);
    	int size = dateSeances.size(); 
    	return (Date)dateSeances.elementAt(size-1);    	
    }

}
