// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.database;


import apostal.toma.data.ModeOfOrganization;


import java.util.Vector;

import apostal.toma.data.Language;

/**

 * @(#) ModeOfOrganization.java

 */


public class ModeOfOrganizationDB {

    private ModeOfOrganization moo;


    public ModeOfOrganizationDB(ModeOfOrganization moo) {

        this.moo = moo;

    }


    /********************************** database **************************/

    public void loadByValue(final Language language) {

        if (language != null) {

            TOMADatabase db = TOMADatabase.getInstance();

            String[][] where = new String[2][3];


            where[0][0] = moo.getValue();

            where[0][1] = "String";

            where[0][2] = "modeOfOrganizationValue";


            where[1][0] = language.getCode();

            where[1][1] = "String";

            where[1][2] = "languageCode";


            RequeteSelectWhere rs = new RequeteSelectWhere(db, "modeOfOrganizationName", where);

            if (rs.next()) {

                moo.setName(rs.getString("name"));

            }

            rs.close();


        }

    }


    public static Vector load(final Language language) {

        TOMADatabase db = TOMADatabase.getInstance();

        Vector v = new Vector();

        String[][] where = new String[0][3];


        RequeteSelectWhere rs = new RequeteSelectWhere(db, "modeOfOrganization", where);

        while (rs.next()) {

            String value = rs.getString("modeOfOrganizationValue");

            String name = null;


            if (language != null) {


                String[][] where2 = new String[2][3];

                where2[0][0] = value;

                where2[0][1] = "String";

                where2[0][2] = "modeOfOrganizationValue";

                where2[1][0] = language.getCode();

                where2[1][1] = "String";

                where2[1][2] = "languageCode";


                RequeteSelectWhere rs2 = new RequeteSelectWhere(db, "modeOfOrganizationName", where2);

                if (rs2.next()) {

                    name = rs2.getString("name");

                }

                rs2.close();

            }

            ModeOfOrganization m = new ModeOfOrganization(value);

            m.setName(name);


            v.add(m);

        }

        rs.close();


        return v;

    }

}

