// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.database;


import apostal.toma.TOMA;

import toolbox.sql.SQLTools;


import java.sql.*;

import java.io.*;

import java.lang.String;


public class RequeteDelete {


    private apostal.toma.database.TOMADatabase db;

    private int result;

    private Statement stmt;


    public RequeteDelete(apostal.toma.database.TOMADatabase db, String Table, String AttributeName, Object AttributeValue) {

        this.db = db;


        String requete = "DELETE FROM " + Table + " WHERE " + AttributeName;


        String cl = AttributeValue.getClass().getName();

        if (cl.equals("java.lang.String")) {

            //filtrer les caractres interdits

            String value = SQLTools.escape((String) AttributeValue);


            requete = requete + " LIKE '" + value + "'";

        } else

            requete = requete + " = '" + AttributeValue + "'";


        try {

            stmt = db.getStatement();

            //stmt = (TOMADatabase.connection).createStatement();

        } catch (SQLException sqle) {

            TOMA.log(TOMA.SEVERE, "SQLException while opening statement: " + SQLTools.printSQLException(sqle));

        }


        TOMA.log(TOMA.INFO, "Requete: " + requete);


        try {

            result = stmt.executeUpdate(requete);


        } catch (SQLException sqle) {

            TOMA.log(TOMA.SEVERE, "SQLException while executing delete: " + SQLTools.printSQLException(sqle, requete));

            db.setRollbackTrue();

        } catch (java.lang.NullPointerException ex) {

            //ressayer

            try {

                stmt = db.getStatement();

                result = stmt.executeUpdate(requete);

            } catch (SQLException sqle2) {

                TOMA.log(TOMA.SEVERE, "SQLException while executing query: " + SQLTools.printSQLException(sqle2, requete));

            }

        }

    }


    public int getResult() {

        return result;

    }


    public void close() {
        try {

            stmt.close();

        } catch (SQLException sqle) {

            TOMA.log(TOMA.SEVERE, "SQLException while closing: " + SQLTools.printSQLException(sqle));

        }


    }


}

