// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.database;


import apostal.toma.TOMA;

import toolbox.sql.SQLTools;


import java.sql.*;

import java.io.*;

import java.lang.String;


public class RequeteInsert {


    private apostal.toma.database.TOMADatabase db;

    private int result;

    private PreparedStatement pStmt;


    public RequeteInsert(apostal.toma.database.TOMADatabase db, String Table, Object[][] ListOfValues) {

        this.db = db;

        String requete = new String("INSERT INTO ");


        requete = requete + Table;


        int NbValues = ListOfValues.length;


        for (int i = 0; i < NbValues; i++) {

            if (i == 0)

                requete = requete + " (";


            if (ListOfValues[i][1] != null) {

                //rajouter la valeur

                requete = requete + ListOfValues[i][0] + ",";

            }

        }

        requete = requete.substring(0, requete.length() - 1); // Suppression de la ',' de fin de select

        requete = requete + ") VALUES (";


        for (int i = 0; i < NbValues; i++) {

            if (ListOfValues[i][1] != null)

                requete = requete + "?,";

        }

        requete = requete.substring(0, requete.length() - 1) + ")";

        //requete=requete + "?)";



        TOMA.log(TOMA.INFO, "Requete : " + requete);


        try {

            pStmt = db.getPreparedStatement(requete);

            //pStmt =(TOMADatabase.connection).prepareStatement(requete);

            //compteur c: si jamais des lments sont nuls, i+1 n'est plus le numro de colonne

            int c = 0;

            for (int i = 0; i < NbValues; i++) {

                Object o = ListOfValues[i][1];

                if (o == null) {

                    //quand insertion, ne pas mettre les lments nulls

                    TOMA.log(TOMA.INFO, ListOfValues[i][0] + " est null");

                } else {

                    c++;

                    String cl = o.getClass().getName();

                    if (cl.equals("java.lang.String")) {

                        //filtrer les caractres interdits

                        //String value=SQLTools.escape((String) o);

                        //pas de escape dans ces cas la

                        String value = (String) o;


                        pStmt.setString(c, value);

                    } else if (cl.equals("java.sql.Date"))

                        pStmt.setDate(c, (java.sql.Date) o);

                    else if (cl.equals("java.lang.Integer"))

                        pStmt.setInt(c, ((Integer) o).intValue());

                    else if (cl.equals("java.lang.Boolean"))

                        pStmt.setBoolean(c, ((Boolean) o).booleanValue());


                    TOMA.log(TOMA.INFO, ListOfValues[i][0] + "=" + o);

                }

            }


            result = pStmt.executeUpdate();


        } catch (SQLException sqle) {

            TOMA.log(TOMA.SEVERE, SQLTools.printSQLException(sqle, requete));

            db.setRollbackTrue();

            //System.exit(1);

        } catch (java.lang.NullPointerException ex) {

            //ressayer

            try {

                pStmt = db.getPreparedStatement(requete);

                result = pStmt.executeUpdate();

            } catch (SQLException sqle2) {

                TOMA.log(TOMA.SEVERE, "SQLException while executing query: " + SQLTools.printSQLException(sqle2, requete));

            }

        }


    }


    public int getResult() {

        return result;

    }


    public void close() {
        try {

            pStmt.close();

        } catch (SQLException sqle) {

            TOMA.log(TOMA.SEVERE, "SQLException while closing: " + SQLTools.printSQLException(sqle));

        }


    }


}

