// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.datacontrol;


import apostal.toma.database.ContactDB;
import apostal.toma.data.Contact;
import apostal.toma.data.Language;
import apostal.toma.TOMA;
import java.util.Vector;

import toolbox.util.*;

public class ContactsControl {
    private ContactDB contactDB;

    //Load de toutes les contacts
    public Vector loadContacts(boolean all) {
      Vector vcontacts = new Vector();
      vcontacts = ContactDB.load(TOMA.getInstance().getTomaParameters().getLanguage(),all);
      
      ToStringComparator comp=new ToStringComparator();
      QuickSort sort=new QuickSort(comp);
      vcontacts=sort.qsort(vcontacts);      
      
      return vcontacts;
    }

    // Creation d'un lieu dans la base de donnes
    public boolean createContact(Contact c) {
      contactDB = new ContactDB(c);
      contactDB.create();
      return true;
    }



    public void deleteContact(Contact c) {
      contactDB = new ContactDB(c);
      contactDB.delete();
    }

    public void saveContact(Contact c) {
      contactDB = new ContactDB(c);
      contactDB.update();
    }

   public void loadContact(Contact c, boolean all)
    {
        Language lng=TOMA.getInstance().getTomaParameters().getLanguage();
        contactDB=new ContactDB(c);
        contactDB.loadById(lng, all);
    }    
    
    public void lockContact(Contact c)
    {
      contactDB = new ContactDB(c);
      contactDB.lock();
    }

    public void unlockContact(Contact c)
    {
      contactDB = new ContactDB(c);
      contactDB.unlock();
    }

    public boolean getLock(Contact c)
    {
      boolean lock = true;
      contactDB = new ContactDB(c);
      lock = contactDB.isLocked();
      return lock;
    }
    
    public boolean isUsedInTraining(int id)
    {
        Contact t=new Contact(id);
        ContactDB tdb=new ContactDB(t);
        return tdb.isUsedInTraining();
    }    
}

