// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.datacontrol;

import apostal.toma.data.Organism;
import apostal.toma.database.*;
import apostal.toma.TOMA;

public class OrganismControl
{
    private OrganismDB organismDB;

    public Organism loadOrganism()
    {
      /*Organism org = new Organism();
      organismDB = new OrganismDB(org);
      organismDB.loadById(TOMA.getInstance().getTomaParameters().getLanguage(), true);*/
      Organism org=OrganismDB.getOrganism(TOMA.getInstance().getTomaParameters().getLanguage(), true);
      
      if(org==null) //crer le premier organism
      {
        org=new Organism();
        org.setDenomination("organism");
        OrganismDB odb=new OrganismDB(org);
        if(odb.testCreate())
            odb.create();
      }
      
      return org;
    }


    //Sauvegarde de l'organisme dans la base de donnes
    public void saveOrganism(Organism org) {
      organismDB = new OrganismDB(org);
      if (organismDB.isLocked())
      {
        TOMA.log(TOMA.WARNING, "Organism Locked");
        // WARNING
        organismDB.unlock();
      }
      else
      {       
        if(org.getIdOrganism()>-1)
        {
            organismDB.lock();
            organismDB.update();
            organismDB.unlock();
        }
        else
        {
            //charger l'organism existant
            Organism org2=organismDB.getOrganism(TOMA.getInstance().getTomaParameters().getLanguage(), false); 
            if(org2==null && organismDB.testCreate()) //premier organisme
            {
                    organismDB.create();
            }
            else //il existait dj un organism
            {
                org.setIdOrganism(org2.getIdOrganism());
                if(organismDB.testUpdate())
                {
                    organismDB.lock();
                    organismDB.update();
                    organismDB.unlock();            
                }
            }
        }
      }
    }
}

