// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */



package apostal.toma.datacontrol;

import apostal.toma.TOMA;
import apostal.toma.viewcontrol.TOMAEventHandler;
import apostal.toma.data.TOMAParameters;
import apostal.toma.TOMA;
import apostal.toma.data.Language;
import apostal.toma.database.LanguageDB;


import java.util.Vector;
import java.util.Iterator;

/**

 * Mthodes:

 * - les mthodes "open" correspondent  l'ouverture de fentres

 * - les mthodes "load" correspondent  un chargement, en gnral depuis un fichier

 */

public class TOMAParametersControl {



    /**

     * @link

     * @shapeType PatternLink

     * @pattern Singleton

     * @supplierRole Singleton factory

     */

    /*# private TOMAEventHandler _tomaEventHandler; */



    public static Language getLanguageByCode(String code)

    {

        TOMAParameters params=TOMA.getInstance().getTomaParameters();

        Language actualLanguage=params.getLanguage();



        Language language=new Language(code);

	LanguageDB ldb=new LanguageDB(language);

	ldb.loadByCode(actualLanguage);



        return language;

    }



    public static Vector getInterfaceLanguages()
    {
        TOMAParameters params=TOMA.getInstance().getTomaParameters();
        Language actualLanguage=params.getLanguage();
		Vector lngs=LanguageDB.loadSomeLanguages(actualLanguage, false, true, false);
	
		TOMA.log(TOMA.WARNING, "TOMAParametersControl.interfaceLanguages: ");
		if(lngs!=null)
		{
			Iterator it=lngs.iterator();
			while(it.hasNext())
			{
				Language lng=(Language) it.next();
				TOMA.log(TOMA.WARNING, "   lng="+lng.getCode());
			}
		}
		
		return lngs;
    }



    public static Vector getExportLanguages()
    {
        TOMAParameters params=TOMA.getInstance().getTomaParameters();
        Language actualLanguage=params.getLanguage();
		Vector lngs=LanguageDB.loadSomeLanguages(actualLanguage, false, false, true);

		TOMA.log(TOMA.WARNING, "TOMAParametersControl.exportLanguages: ");
		if(lngs!=null)
		{
			Iterator it=lngs.iterator();
			while(it.hasNext())
			{
				Language lng=(Language) it.next();
				TOMA.log(TOMA.WARNING, "   lng="+lng.getCode());
			}
		}

		return lngs;
    }

    public static void saveParameters(TOMAParameters params)
    {
	params.save();
	//changements immdiats

	TOMAParameters actualParams=TOMA.getInstance().getTomaParameters();

	actualParams.setExportationLanguage(params.getExportationLanguage());

	//actualParams.setLookAndFeel(params.getLookAndFeel());
	//TOMA.getInstance().setLookAndFeel();

    }

}
