// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.datacontrol;


import apostal.toma.database.TeacherDB;
import apostal.toma.data.Teacher;
import apostal.toma.data.Language;
import java.util.Vector;
import apostal.toma.TOMA;

import toolbox.util.*;

public class TeachersControl {
    private TeacherDB teacherDB;

    //Load de toutes les teachers
    public Vector loadTeachers(boolean all) {
      Vector vteachers = new Vector();
      vteachers = teacherDB.load(TOMA.getInstance().getTomaParameters().getLanguage(),all);
      
      ToStringComparator comp=new ToStringComparator();
      QuickSort sort=new QuickSort(comp);
      vteachers=sort.qsort(vteachers);
      
      return vteachers;
    }

    // Creation d'un lieu dans la base de donnes
    public boolean createTeacher(Teacher t) {
      teacherDB = new TeacherDB(t);
      teacherDB.create();
      return true;
    }



    public void deleteTeacher(Teacher t) {
      teacherDB = new TeacherDB(t);
      teacherDB.delete();
    }

    public void saveTeacher(Teacher l) {
      teacherDB = new TeacherDB(l);
      teacherDB.update();
    }

   public void loadTeacher(Teacher t, boolean all)
    {
      Language lng=TOMA.getInstance().getTomaParameters().getLanguage();
      teacherDB = new TeacherDB(t);    
      teacherDB.loadById(lng, all);
    }    
    
    public void lockTeacher(Teacher t)
    {
      teacherDB = new TeacherDB(t);
      teacherDB.lock();
    }

    public void unlockTeacher(Teacher t)
    {
      teacherDB = new TeacherDB(t);
      teacherDB.unlock();
    }

    public boolean getLock(Teacher t)
    {
      boolean lock = true;
      teacherDB = new TeacherDB(t);
      lock = teacherDB.isLocked();
      return lock;
    }
    
    public boolean isUsedInTraining(int idteacher)
    {
        Teacher t=new Teacher(idteacher);
        TeacherDB tdb=new TeacherDB(t);
        return tdb.isUsedInTraining();
    }
}

