// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.datacontrol;

import apostal.toma.TOMA;
import apostal.toma.data.Unit;
import apostal.toma.data.Language;
import apostal.toma.data.UnitSession;
import apostal.toma.data.TrainingProgramme;
import apostal.toma.database.TrainingProgrammeDB;
import apostal.toma.database.UnitDB;

import java.util.Vector;
import java.util.Iterator;

public class UnitControl {
    public Unit loadUnit(int idUnit)
    {
      Unit u=new Unit(idUnit);
      UnitDB udb=new UnitDB(u);
      udb.loadById(TOMA.getInstance().getTomaParameters().getLanguage(), true);
      return u;
    }

    public void loadUnitWithSessions(Unit t)
    {
      Language ln=TOMA.getInstance().getTomaParameters().getLanguage();
      UnitDB tdb=new UnitDB(t);
      tdb.loadById(ln, true);

      if(t.getUnitSessions()!=null)
      {
	UnitSessionControl control=new UnitSessionControl();
        Iterator iter = t.getUnitSessions().iterator();
	while (iter.hasNext())
	{
	  UnitSession s = (UnitSession) iter.next();
	  control.loadSession(s);
	}
      }
    }

  public void lock(Unit t)
  {
    UnitDB tdb=new UnitDB(t);
    tdb.lock();
  }

  public void unlock(Unit t)
  {
    UnitDB tdb=new UnitDB(t);
    tdb.unlock();
  }

    public void delete(TrainingProgramme tp, Unit unit) {
    	  UnitDB udb=new UnitDB(unit);
	  udb.delete();

	  //maj de l'ordre
	  Vector units=tp.getUnits();
	  int index=units.indexOf(unit);
	  int size=units.size();
	  for(int i=index+1;i<size;i++)
	  {
	    Unit u=(Unit) units.elementAt(i);
	    u.setNborder(i-1);

	    //mettre juste a  jour dans la BD
	    UnitDB auxdb=new UnitDB(u);
	    auxdb.updateOrder();
	  }
	  units.remove(unit);
    }

    public boolean testSave(Unit unit)
    {
      UnitDB tdb=new UnitDB(unit);

      boolean ok=true;

      ok=tdb.testUpdate();
      /*//todo: vrifier le code
      Unit t2=new Unit(unit.getIdTraining());
      UnitDB t2db=new UnitDB(t2);
      t2db.loadById(TOMA.getInstance().getTomaParameters().getLanguage(), false);
      if(!t2.getCode().equals(unit.getCode()))
      //le code a chang -> vrifier
      {
	  String code=unit.getCode();
	  if(code==null || code.equals("") || !tdb.testUpdate())
	  {
	    ok=false;
	  }
      }*/

      return ok;
    }

    public void save(Unit unit)
    {
       UnitDB tdb=new UnitDB(unit);
       tdb.update();
    }


    public TrainingProgramme getTrainingProgramme(Unit u)
    {
      int idp=u.getIdProgramme();
      TrainingProgramme tp=new TrainingProgramme(idp);
      TrainingProgrammeDB tpbd=new TrainingProgrammeDB(tp);
      tpbd.loadById(TOMA.getInstance().getTomaParameters().getLanguage(), true);

      return tp;
    }
    
    public TrainingProgramme getTrainingProgramme(Unit u, boolean all)
    {
      int idp=u.getIdProgramme();
      TrainingProgramme tp=new TrainingProgramme(idp);
      TrainingProgrammeDB tpbd=new TrainingProgrammeDB(tp);
      tpbd.loadById(TOMA.getInstance().getTomaParameters().getLanguage(), all);

      return tp;
    }    
}
