// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.datacontrol;

/**
 * Title:        TOMA
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      CRP Henri Tudor
 * @author
 * @version 1.0
 */

import apostal.toma.TOMA;
import apostal.toma.data.UnitSession;
import apostal.toma.database.UnitSessionDB;

public class UnitSessionControl extends SessionControl
{

  public UnitSessionControl()
  {
  }

    public void loadSession(UnitSession cs)
    {
	  UnitSessionDB csdb=new UnitSessionDB(cs);
	  csdb.loadById(TOMA.getInstance().getTomaParameters().getLanguage(), true);
    }

    public void deleteSession(UnitSession s)
    {
      UnitSessionDB sdb=new UnitSessionDB(s);
      sdb.delete();
    }

    public boolean testSave(UnitSession s)
    {
      UnitSessionDB csdb=new UnitSessionDB(s);
      if(csdb.testUpdate())
	return true;
      else
	return false;
    }

    public void saveSession(UnitSession s)
    {
      UnitSessionDB csdb=new UnitSessionDB(s);
      csdb.update();
    }

    public boolean testCreate(UnitSession s)
    {
      UnitSessionDB csdb=new UnitSessionDB(s);
      if(csdb.testCreate())
	return true;
      else
	return false;
    }

    public void create(UnitSession s)
    {
          UnitSessionDB csdb=new UnitSessionDB(s);
	  csdb.create();
    }

}