// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.external;


import java.util.Hashtable;
import java.util.Vector;



public class CatalogueToPublish{

  Hashtable valeurs;
    public CatalogueToPublish(){
      	valeurs = new Hashtable();
    }

    public CatalogueToPublish(String title)
    {
       valeurs.put("title",title);
    }

    public CatalogueToPublish(String title, String description)
    {
       valeurs.put("title",title);
       valeurs.put("description",description);
    }

    public void setTitle(String title)
    {
	valeurs.put("title", title);
    }

    public void setCode(int title){
        valeurs.put("code",new Integer(title));
    }

    public void setDescription(String description)
    {
        try{
          valeurs.put("description",description);
        }catch(NullPointerException np){valeurs.put("description","");}
    }

    public void setFormations(Vector formations){
        valeurs.put("formations", formations);
    }
    
    public void setOrder(String order){
    	if (order==null) 
    		order = "0";
		valeurs.put("order", order);
    }
    public void setCatalogues(Vector catalogues){
        valeurs.put("catalogues", catalogues);
    }

    public void setFormation(Formation f){
        Vector v = new Vector();
        try{
          v = (Vector)valeurs.get("formations");
        }catch(NullPointerException np){}
        if (v==null)
          v = new Vector();
        v.addElement(f);
        valeurs.put("formations",v);
    }

   public void setCatalogue(CatalogueToPublish c){
        Vector v = new Vector();
        try{
          v = (Vector)valeurs.get("catalogues");
        }catch(NullPointerException np){}
        if (v==null)
          v = new Vector();
        v.addElement(c);
        valeurs.put("catalogues",v);
    }

   public void removeCatalogues(){
        valeurs.remove("catalogues");
    }

    public void setFormation(String filename, String title, String organisme,String code,Vector beginDate,String endDate,String duree){
        Vector v = new Vector();
        Formation f = new Formation(filename, title, organisme);
        f.setCode(code);
        f.setBeginValidityDate(beginDate);
        f.setEndValidityDate(endDate);
        f.setDuration(duree);
        try{
          v = (Vector)valeurs.get("formations");
        }catch(NullPointerException np){}
        if (v==null)
          v = new Vector();
        v.addElement(f);
        valeurs.put("formations",v);
    }

    public void setCatalogue(String title, String description){
        Vector v = new Vector();
        CatalogueToPublish c = new CatalogueToPublish(title,description);
        try{
          v = (Vector)valeurs.get("catalogues");
        }catch(NullPointerException np){}
        if (v==null)
          v = new Vector();
        v.addElement(c);
        valeurs.put("catalogues",v);
    }



	/* get */
    public String getTitle()
    {
       return (String) valeurs.get("title");
    }
    
    public String getOrder()
    {
       return (String) valeurs.get("order");
    }


    public int getCode(){
        Integer code = (Integer)valeurs.get("code");
        return code.intValue();
    }

    public String getDescription()
    {
       return (String) valeurs.get("description");
    }

    public Vector getFormations(){
       Vector formations = new Vector();
       formations = (Vector)valeurs.get("formations");
       return formations;
    }

    public Vector getCatalogues(){
       Vector catalogues = new Vector();
       catalogues = (Vector)valeurs.get("catalogues");
       return catalogues;
    }

}
