// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.external;

import java.util.Hashtable;
import java.util.Vector;

public class Formation{

  Hashtable valeurs;
    public Formation(){
      	valeurs = new Hashtable();
    }

    public Formation(String filename, String title, String organisme){
      	valeurs = new Hashtable();
        valeurs.put("filename", filename);
        valeurs.put("title", title);
        organisme = organisme.toUpperCase();
        valeurs.put("organisme", organisme);
    }

    public void setTitle(String title)
    {
	valeurs.put("title", title);
    }
    
    public void setCode(String code)
    {
	valeurs.put("code", code);
    }
    
    public void setDuration(String duration)
    {
	valeurs.put("duration", duration);
    }
    
    public void setBeginValidityDate(Vector beginDate)
    {
	valeurs.put("beginDate", beginDate);
    }
    
    public void setEndValidityDate(String endDate)
    {
	valeurs.put("endDate", endDate);
    }

    public void setOrganisme(String organisme){
        organisme = organisme.toUpperCase();
        valeurs.put("organisme", organisme);
    }


    public void setFilename(String filename)
    {
        valeurs.put("filename",filename);
    }




	/* Get */
    public String getTitle()
    {
       return (String) valeurs.get("title");
    }

    public String getOrganisme(){
      return (String) valeurs.get("organisme");
    }

    public String getFilename()
    {
       return (String) valeurs.get("filename");
    }
	public String getCode()
    {
       return (String) valeurs.get("code");
    }

	public String getDuration()
    {
    	return (String) valeurs.get("duration");
	}
    
    public Vector getBeginValidityDate()
    {
    	return (Vector) valeurs.get("beginDate");
	}
    
    public String getEndValidityDate()
    {
    	return (String) valeurs.get("endDate");
	}
	

}
