// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.external;

import apostal.ted.ContactXML;
import apostal.ted.LocationXML;
import apostal.ted.TeacherXML;
import apostal.toma.TOMA;

public class ObjecttoImport{



    private boolean importer;
    private int creator;
    //Objet qui n'est pas chang pour le retrouver dans TrainingXML
    private Object fobj=null;
    //Object qui est chang par l'utilisateur
    private Object obj;
    private String name;

    public void setName(String name)
    {
      this.name = name;
    }

    public void setImporter(boolean importer)
    {
      this.importer = importer;
    }

    public void setCreator(int creator)
    {
      this.creator = creator;
    }

    public void setObject(Object obj)
    {
       this.obj = obj;
    }

    public void setFixedObject(Object fobj)
    {
      this.fobj = fobj;
    }


/* Mthodes get */
    public Object getFixedObject()
    {
      if(this.fobj==null)
        return this.obj;
      else
        return this.fobj;
    }

    public boolean getImporter()
    {
       return this.importer;
    }

    public int getCreator(){
        return this.creator;
    }

    public Object getObject()
    {
       return this.obj;
    }

//---------Debug
    public String toString()
    {
      return "ObjectToImport: " +obj +" Importer :" +importer +" Creer: " +creator +"";
    }

 public TeacherXML compareTeachers(TeacherXML t, boolean alreadyWritten)
 {
          TeacherXML result=t;
          if(t!=null && t.equals(this.getObject()))
          //c'est le bon objet
          {
            if(!this.getImporter())
              result=null;
            else
            {
              int creator=this.getCreator();

              //result=(TeacherXML) this.getObject();
              TeacherXML fixedTeacher=(TeacherXML) this.getFixedObject();
              if(fixedTeacher!=null) //en principe jamais null...
                result=(TeacherXML) fixedTeacher.clone();

              if(creator==-1) //creation
              {
                if(!alreadyWritten)
                  result.setKey("");
                else
                  result.setKey("-1");
              }
              else //maj
              {
                result.setKey(String.valueOf(creator));
              }
            }
          }
   return result;
 }

  public LocationXML compareLocations(LocationXML t, boolean alreadyWritten)
 {
    LocationXML result=t;
          if(t!=null && t.equals(this.getObject()))
          //c'est le bon objet
          {
            if(!this.getImporter())
              result=null;
            else
            {
              int creator=this.getCreator();
              //result=(LocationXML) this.getObject();

              LocationXML fixedLocation=(LocationXML) this.getFixedObject();
              if(fixedLocation!=null) 
                result=(LocationXML) fixedLocation.clone();

              if(creator==-1) //creation
              {
                if(!alreadyWritten)
                  result.setKey("");
                else
                  result.setKey("-1");
              }
              else //maj
              {
                result.setKey(String.valueOf(creator));
              }
            }
          }
   return result;
 }

  public ContactXML compareContacts(ContactXML t, boolean alreadyWritten)
 {
    ContactXML result=t;
          if(t!=null && t.equals(this.getObject()))
          //c'est le bon objet
          {

            TOMA.log(TOMA.WARNING, " --- equals --- ");
            if(!this.getImporter())
              result=null;
            else
            {
              int creator=this.getCreator();
              //result=(ContactXML) this.getObject();

              ContactXML fixedContact=(ContactXML) this.getFixedObject();
              if(fixedContact!=null) //en principe jamais null...
                result=(ContactXML) fixedContact.clone();

              if(creator==-1) //creation
              {
                if(!alreadyWritten)
                  result.setKey("");
                else
                  result.setKey("-1");
              }
              else //maj
              {
                result.setKey(String.valueOf(creator));
              }
            }
          }
   return result;
 }

}
