// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.external;

import apostal.ted.*;
import apostal.toma.TOMA;
import apostal.toma.data.*;
import apostal.toma.database.*;
import apostal.toma.external.tedtoma.DateConversion;
import apostal.toma.external.tedtoma.TedTomaConversion;
import apostal.toma.view.CatalogueTreeNode;
import apostal.toma.view.TOMATree;
import apostal.toma.view.TOMATreeCellRenderer;
import apostal.toma.view.TrainingTreeNode;
import toolbox.text.StringEncoder;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.*;

public class Publication {

    protected PublicationUnit publicationUnit;
    protected TedTomaConversion tedTomaConversion;
    public Vector trainingCourses;
    public Vector trainingProgrammes;
    public Vector trainingsToPublish;
    public Vector trainingCoursesToView;
    public Vector trainingProgrammesToView;
    public Vector trainingsToView;
    public Vector vectorTemp = new Vector();
    int lastplace = 0;
    boolean trouve = false;
    boolean filscattoadd = true;
    Formation formation = new Formation();
    Vector orga = new Vector();
    String tempcatxml = "";
    int counter = 0;
    String filename = null;
    public static int[] tabCatalogueSelected;

    public Publication(PublicationUnit publicationUnit) {
        tedTomaConversion = new TedTomaConversion();
        this.publicationUnit = publicationUnit;
    }

    public void publish() {
    }

    public Vector getTrainingToPublish(PublicationUnit publicationUnit) {
        Vector trainingToPublish = new Vector();
        Vector trainings = (Vector) publicationUnit.getTrainings().clone();
        Vector cataloguePublished = publicationUnit.getCatalogues();
        tabCatalogueSelected = new int[cataloguePublished.size()];
        for (int it = 0; it < cataloguePublished.size(); it++) {
            CataloguePublished catP = (CataloguePublished) cataloguePublished.elementAt(it);
            tabCatalogueSelected[it] = catP.getIdCatalogue();
        }
        if (trainings != null) {
            int i = 0;

            TrainingPublished tPublish;
            while (i < trainings.size()) {
                Vector catalogues = new Vector();
                tPublish = (TrainingPublished) trainings.elementAt(i);
                int idTraining = tPublish.getIdTraining();
                Training t = TrainingDB.getInstanceForPublication(publicationUnit.getLanguage(), true, idTraining);
                Catalogue cat = new Catalogue(tPublish.getIdCatalogue());
                CatalogueDB catDB = new CatalogueDB(cat);
                catDB.loadById(publicationUnit.getLanguage(), true);
                cat.setNborder(tPublish.getNborder());
                catalogues.add(cat);
                int j = i + 1;
                while (j < trainings.size()) {
                    TrainingPublished tPublishTemp = (TrainingPublished) trainings.elementAt(j);
                    int idTrainingTemp = tPublishTemp.getIdTraining();
                    if (idTraining == idTrainingTemp) {
                        Catalogue catTemp = new Catalogue(tPublishTemp.getIdCatalogue());
                        catDB = new CatalogueDB(catTemp);
                        catDB.loadById(publicationUnit.getLanguage(), true);
                        cat.setNborder(tPublishTemp.getNborder());
                        catalogues.add(catTemp);
                        trainings.remove(j);
                        j--;
                    }
                    j++;
                }
                i++;
                if (t instanceof TrainingProgramme) {
                    TrainingProgramme training = (TrainingProgramme) t;
                    training.setCatalogues(catalogues);
                    trainingToPublish.add(t);
                }
                if (t instanceof TrainingCourse) {
                    TrainingCourse training = (TrainingCourse) t;
                    training.setCatalogues(catalogues);
                    trainingToPublish.add(t);
                }
            }
        }
        return trainingToPublish;
    }

    public void checkCompliance(PublicationUnit pub) {
        trainingsToPublish = this.getTrainingToPublish(pub);
        TedTomaConversion conversion = new TedTomaConversion();
        conversion.checkTedCompliance(trainingsToPublish, publicationUnit.getLanguage());
    }

    public void checkCompliance() {
        trainingsToPublish = this.getTrainingToPublish(this.publicationUnit);
        TedTomaConversion conversion = new TedTomaConversion();
        conversion.checkTedCompliance(trainingsToPublish, publicationUnit.getLanguage());
    }

    public void generateTedXML(Vector trainings, String filename, boolean addFirstCat, boolean addNamespaces) {

        boolean syrecos = false;
        ///if (publicationUnit.getType()==PublicationUnit.PUBLICATION_SYRECOS){
        if (publicationUnit.getType() == PublicationUnit.PUBLICATION_SOAP) {
            syrecos = true;
        }
        TedTomaConversion conversion = new TedTomaConversion();
        TedXML ted = conversion.tomaToTed(trainings, publicationUnit.getLanguage(), publicationUnit.getPublishOrganismData(), publicationUnit.getFirstCatalogueTitle(), publicationUnit.getConsiderValidityDates(), syrecos, addFirstCat, addNamespaces);
        trainingCourses = ted.getTrainingCourses();
        trainingProgrammes = ted.getTrainingProgrammes();
        SaveXML save = new SaveXML(filename);
        save.save(ted);
    }

    public void generateTedXML(String filename, boolean addFirstCat, boolean addNamespaces) {
        trainingCourses = new Vector();
        trainingProgrammes = new Vector();
        boolean syrecos = false;
        if (publicationUnit.getType() == PublicationUnit.PUBLICATION_SOAP) {
            syrecos = true;
        }
        
        //DEBUG
        TOMA.log(TOMA.ALL, "Publication.generateTedXML called. filename="+filename+", addirstCat="+addFirstCat+", addNamespaces="+addNamespaces);
        TOMA.log(TOMA.ALL, "Publication.generateTedXML,language="+publicationUnit.getLanguage()+", publish organism data="+publicationUnit.getPublishOrganismData()+", first catalogue title="+publicationUnit.getFirstCatalogueTitle()+", consider validity dates="+publicationUnit.getConsiderValidityDates()+", syrecos?="+syrecos);
        TOMA.log(TOMA.ALL, "Publication.generateTedXML, trainingsToPublish:");
        Iterator it=trainingsToPublish.iterator();
        while(it.hasNext()){
            Training t=(Training) it.next();
            TOMA.log(TOMA.ALL, "Publication.generateTedXML, training "+t.getCode());
        }
        
        TedTomaConversion conversion = new TedTomaConversion();
        TedXML ted = conversion.tomaToTed(this.trainingsToPublish, publicationUnit.getLanguage(), publicationUnit.getPublishOrganismData(), publicationUnit.getFirstCatalogueTitle(), publicationUnit.getConsiderValidityDates(), syrecos, addFirstCat, addNamespaces);
        try {
            trainingCourses = ted.getTrainingCourses();
            trainingProgrammes = ted.getTrainingProgrammes();
            SaveXML save = new SaveXML(filename);
            save.save(ted);
        } catch(Exception e) {
            TOMA.log(TOMA.WARNING,e.getMessage());
        }
    }

    public TOMATree generateTreeForView(PublicationUnit pub, boolean addFirstCat) {
        boolean syrecos = false;
        //if (pub.getType()==PublicationUnit.PUBLICATION_SYRECOS){
        if (pub.getType() == PublicationUnit.PUBLICATION_SOAP) {
            syrecos = true;
        }
        trainingsToView = this.getTrainingToPublish(pub);
        TedTomaConversion tedConversion = new TedTomaConversion();
        TedXML ted = tedConversion.tomaToTedToView(trainingsToView, pub.getLanguage(), pub.getFirstCatalogueTitle(), pub.getConsiderValidityDates(), syrecos, addFirstCat);
        trainingCoursesToView = ted.getTrainingCourses();
        trainingProgrammesToView = ted.getTrainingProgrammes();
        Hashtable hashToView = this.processCataloguesToView();
        return this.getTreeToView(hashToView);
    }

    public CatalogueTreeNode createTreeNode(CatalogueToPublish catalogue, CatalogueTreeNode parent, boolean seeCourses, boolean seeProgrammes) {
        CatalogueTreeNode node = null;
        if (parent != null)
            node = new CatalogueTreeNode(parent, catalogue.getCode(), catalogue.getTitle(), seeCourses, seeProgrammes);
        else
            node = new CatalogueTreeNode(catalogue.getCode(), catalogue.getTitle(), seeCourses, seeProgrammes);
        Vector data = new Vector();
        //catalogues
        Vector cats = catalogue.getCatalogues();
        int nbCatalogues = 0;
        if (cats != null) {
            nbCatalogues = cats.size();
            Iterator it = cats.iterator();
            while (it.hasNext()) {
                CatalogueToPublish c = (CatalogueToPublish) it.next();
                CatalogueTreeNode subnode = this.createTreeNode(c, node, seeCourses, seeProgrammes);
                data.add(subnode);
            }
        }
        //trainings
        Vector trainings = catalogue.getFormations();

        if (trainings != null) {
            Iterator it = trainings.iterator();
            while (it.hasNext()) {
                Formation t = (Formation) it.next();
                int type = TrainingTreeNode.TRAININGCOURSE;
                if (Integer.parseInt(t.getDuration()) == 0) {
                    type = TrainingTreeNode.TRAININGPROGRAMME;
                }
                TrainingTreeNode tr = new TrainingTreeNode(node, 1, t.getTitle(), t.getCode(), catalogue.getCode(), type);
                data.add(tr);
            }
        }
        node.setData(data, nbCatalogues);
        return node;
    }

    private TOMATree getTreeToView(Hashtable h) {
        CatalogueTreeNode root = null;
        TOMATree tree = null;
        int formsize = 0;
        for (int i = 0; i < h.size(); i++) {
            try {
                CatalogueToPublish c = (CatalogueToPublish) h.get("" + i);
                root = this.createTreeNode(c, null, true, true);
                tree = new TOMATree(true, true, true, root);

            } catch (NullPointerException np) {
            }

        }
        Vector formation = (Vector) h.get("formation");
        try {
            formsize = formation.size();
        } catch (NullPointerException np) {
        }
        int type = TrainingTreeNode.TRAININGCOURSE;
        if (formsize > 0) {
            for (int i = 0; i < formsize; i++) {
                Formation format = (Formation) formation.elementAt(i);
                if (Integer.parseInt(format.getDuration()) == 0) {
                    type = TrainingTreeNode.TRAININGPROGRAMME;
                }
                CatalogueToPublish cat = new CatalogueToPublish();
                cat.setTitle(format.getTitle());
                cat.setCode(1);
                root = this.createTreeNode(cat, null, true, true);
            }
            tree = new TOMATree(true, true, true, root);
            TOMATreeCellRenderer render = new TOMATreeCellRenderer(type);
            tree.getTree().setCellRenderer(render);
        }

        return tree;
    }

    public Hashtable addFormation(Hashtable h, String filename, String title, String organism, String code, Vector beginDate, String endDate, String duree) {
        Vector form = new Vector();
        Formation formation = new Formation(filename, title, organism);
        formation.setCode(code);
        formation.setBeginValidityDate(beginDate);
        formation.setEndValidityDate(endDate);
        formation.setDuration(duree);
        try {
            form = (Vector) h.get("formation");
        } catch (NullPointerException np) {
        }
        if (form == null)
            form = new Vector();
        form.addElement(formation);
        h.put("formation", form);
        return h;
    }

    public Hashtable addLevels(CatalogueXML catxml, Hashtable h, String filename, String title, String organism, String code, Vector beginDate, String endDate, String duree) {
        CatalogueToPublish cat = new CatalogueToPublish();
        //Vector catordered = new Vector();
        //Vector with data in reversed order
        toCat(catxml, cat, filename, title, organism, code, beginDate, endDate, duree);
        //index = place to add catalogue in hashtable
        int index = compare(cat, h);
        h = add(cat, h, index);
        return h;
    }

    //Transform object CatalogueXML to object catalogue
    public void toCat(CatalogueXML c, CatalogueToPublish cat, String filename, String title, String organism, String code, Vector beginDate, String endDate, String duree) {
        CatalogueXML c2 = new CatalogueXML();
        CatalogueToPublish catinc = new CatalogueToPublish();
        //if (c!=null)
        cat.setDescription(c.getDescription());
        //  if (c!=null)
        cat.setCode(Integer.parseInt(c.getKey()));
        // if (c!=null)
        cat.setTitle(c.getTitle());
        try {
            c2 = c.getCatalogue();
            toCat(c2, catinc, filename, title, organism, code, beginDate, endDate, duree);
            cat.setCatalogue(catinc);
        } catch (NullPointerException np) {
            cat.removeCatalogues();
            cat.setFormation(filename, title, organism, code, beginDate, endDate, duree);
        }
    }

    public int compare(CatalogueToPublish c1, Hashtable h) {
        int index = -1;
        String title = c1.getTitle();
        String comparer = "";
        if (lastplace > 0)
            index = -2;
        for (int i = 0; i < lastplace; i++) {
            try {
                comparer = ((CatalogueToPublish) h.get(i + "")).getTitle();
                if (comparer.compareTo(title) == 0) {
                    index = i;
                }
            } catch (NullPointerException np) {
            }
        }
        return index; //index=-1 -> h=0; index=-2 ->not found
    }

    public Hashtable add(CatalogueToPublish cat, Hashtable h, int index) {


        //Hashtable = null, to first place in h
        if (index == -1) {
            printCatalogue(cat);
            h.put(0 + "", cat);
            lastplace++;
        }
        //cat not found, too last place in h
        else if (index == -2) {
            printCatalogue(cat);
            h.put(lastplace + "", cat);
            lastplace++;
        } else {
            CatalogueToPublish c = (CatalogueToPublish) h.get("" + index);
            printCatalogue(cat);
            printCatalogue(c);
            trouve = false;
            filscattoadd = true;
            addCatalogue(cat, c);
        }

        return h;
    }

    public boolean addCatalogue(CatalogueToPublish cattoadd, CatalogueToPublish cat) {
        printCatalogue(cattoadd);
        boolean filscat = true;
        String cattoaddtitle = cattoadd.getTitle();
        String cattitle = cat.getTitle();
        CatalogueToPublish cattoaddinc = null;
        Vector catinc = cat.getCatalogues();
        int catincsize = 0;

        //test if there some children
        if (cattoadd != null) {
            try {
                catincsize = catinc.size();
            } catch (NullPointerException np) {
                filscat = false;
            }
            try {
                cattoaddinc = (CatalogueToPublish) cattoadd.getCatalogues().elementAt(0);
            } catch (NullPointerException np) {
                filscattoadd = false;
                if (cattoadd.getFormations() != null) {
                    formation = (Formation) cattoadd.getFormations().elementAt(0);
                }

            }
            if (cattitle != null && cattoaddtitle != null) {
                if ((cattitle.compareTo(cattoaddtitle) == 0) && (!trouve)) {
                    //cattoadd have no children
                    if ((!filscattoadd)) {
                        //Add the formation
                        cat.setFormation(formation);
                        trouve = true;
                    }
                    //cat have no children
                    else if ((!filscat) && (!trouve)) {
                        //Add the catalogue to the exesting tree
                        printCatalogue(cattoaddinc);
                        cat.setCatalogue(cattoaddinc);
                        trouve = true;
                    }
                    //cattadd et cat have one children
                    else {
                        //continue
                        for (int i = 0; i < catincsize; i++) {
                            if (!trouve) {
                                trouve = addCatalogue(cattoaddinc, (CatalogueToPublish) catinc.elementAt(i));
                            }
                        }
                        if (!trouve) {
                            cat.setCatalogue(cattoaddinc);
                            trouve = true;
                        }
                    }
                } else {
                    trouve = false;
                }
            } else {
                trouve = false;
            }
        }
        return trouve;
    }


    public void printCatalogue(Vector cat) {
        for (int i = 0; i < cat.size(); i++) {
            System.out.println(((CatalogueToPublish) cat.elementAt(i)).getTitle() + " ");
        }
    }

    public void printCatalogue(CatalogueToPublish cat) {
        try {
            Vector v = cat.getCatalogues();
            for (int i = 0; i < v.size(); i++) {
                printCatalogue((CatalogueToPublish) v.elementAt(i));
            }
        } catch (NullPointerException np) {
        }
    }

    public String printCatalogue(CatalogueToPublish cat, String catxml, String organ) {
        //org, test if all courses are printed or not
        int formsize = 0;
        int catincsize = 0;
        tempcatxml = tempcatxml + "<catalogueToPublish>" + "\n";
        tempcatxml = tempcatxml + "<title>";
        tempcatxml = tempcatxml + StringEncoder.escapeHTMLTags(cat.getTitle()) + "</title>" + "\n";
        tempcatxml = tempcatxml + "<code>";
        tempcatxml = tempcatxml + cat.getCode() + "</code>" + "\n";
        tempcatxml = tempcatxml + "<description>";
        tempcatxml = tempcatxml + StringEncoder.escapeHTMLTags(cat.getDescription()) + "</description>" + "\n";
        Vector formations = new Vector();
        formations = cat.getFormations();
        try {
            formsize = formations.size();
        } catch (NullPointerException np) {
        }
        for (int i = 0; i < formsize; i++) {
            if ((organ.compareTo(((Formation) formations.elementAt(i)).getOrganisme()) == 0) || (organ.compareTo("") == 0)) {
                catxml = catxml + tempcatxml;
                tempcatxml = "";

                catxml = catxml + "<formation>";
                catxml = catxml + "<filename>" + StringEncoder.escapeHTMLTags(((Formation) formations.elementAt(i)).getFilename()) + "</filename>" + "\n";
                catxml = catxml + "<title>" + StringEncoder.escapeHTMLTags(((Formation) formations.elementAt(i)).getTitle()) + "</title>" + "\n";
                catxml = catxml + "<code>" + ((Formation) formations.elementAt(i)).getCode() + "</code>" + "\n";
                Vector tempVector = new Vector();
                tempVector = ((Formation) formations.elementAt(i)).getBeginValidityDate();
                Iterator it = tempVector.iterator();
                while (it.hasNext()) {
                    catxml = catxml + "<beginDate>" + (String) it.next() + "</beginDate>" + "\n";
                }
                catxml = catxml + "<endDate>" + ((Formation) formations.elementAt(i)).getEndValidityDate() + "</endDate>" + "\n";
                catxml = catxml + "<duree>" + ((Formation) formations.elementAt(i)).getDuration() + "</duree>" + "\n";

                // add to organism list
                String organisme = ((Formation) formations.elementAt(i)).getOrganisme();
                if (!orga.contains(organisme)) {
                    orga.addElement(((Formation) formations.elementAt(i)).getOrganisme());
                }
                catxml = catxml + "</formation>" + "\n";
            } else {
                //counter = 0;
                //tempcatxml = "";
            }
        }

        Vector catinc = (Vector) cat.getCatalogues();
        try {
            catincsize = catinc.size();
        } catch (NullPointerException np) {
        }
        for (int j = 0; j < catincsize; j++) {
            catxml = printCatalogue((CatalogueToPublish) catinc.elementAt(j), catxml, organ);
        }
        catxml = catxml + "</catalogueToPublish>";
        return catxml;
    }

    public String printHashtable(Hashtable h) {
        String catxml = "";
        int catincluded = 0;
        int formsize = 0;
        counter = 0;
        catxml = "<?xml version='1.0' encoding='ISO-8859-1'?>";
        catxml = catxml + "\n" + "<catalogues>";
        for (int i = 0; i < h.size(); i++) {
            try {
                CatalogueToPublish c = (CatalogueToPublish) h.get("" + i);
                c.getTitle();
                catxml = printCatalogue(c, catxml, "");
            } catch (NullPointerException np) {
            }
        }

        //Courses not in a catalogue
        Vector formation = (Vector) h.get("formation");
        try {
            formsize = formation.size();
        } catch (NullPointerException np) {
        }
        //print courses not in catalogues
        for (int i = 0; i < formsize; i++) {
            catxml = catxml + "<formation>";
            catxml = catxml + "<filename>" + StringEncoder.escapeHTMLTags(((Formation) formation.elementAt(i)).getFilename()) + "</filename>" + "\n";
            catxml = catxml + "<title>" + StringEncoder.escapeHTMLTags(((Formation) formation.elementAt(i)).getTitle()) + "</title>" + "\n";
            catxml = catxml + "<code>" + ((Formation) formation.elementAt(i)).getCode() + "</code>" + "\n";
            Vector tempVector = new Vector();
            tempVector = ((Formation) formation.elementAt(i)).getBeginValidityDate();
            Iterator it = tempVector.iterator();
            while (it.hasNext()) {
                catxml = catxml + "<beginDate>" + (String) it.next() + "</beginDate>" + "\n";
            }
            catxml = catxml + "<endDate>" + ((Formation) formation.elementAt(i)).getEndValidityDate() + "</endDate>" + "\n";
            catxml = catxml + "<duree>" + ((Formation) formation.elementAt(i)).getDuration() + "</duree>" + "\n";
            // add to organism list
            String organisme = ((Formation) formation.elementAt(i)).getOrganisme();
            if (!orga.contains(organisme)) {
                orga.addElement(((Formation) formation.elementAt(i)).getOrganisme());
            }
            catxml = catxml + "</formation>" + "\n";
        }
        catxml = catxml + "\n" + "</catalogues>";

        return catxml;
    }


    public String processCatalogues() {
        //hashtable with all level 0 catalogues
        DateConversion dateConvert = new DateConversion();
        Hashtable allcat = new Hashtable();
        Vector cat = new Vector();
        String localName = "";
        String title = "";
        String organisme = "";
        Vector trainings = new Vector();
        Iterator it = trainingCourses.iterator();
        TrainingXML trcourses = null;
        Object t;
        while (it.hasNext()) {
            trainings.add(it.next());
        }
        it = trainingProgrammes.iterator();
        while (it.hasNext()) {
            trainings.add(it.next());
        }
        it = trainings.iterator();
        while (it.hasNext()) {
            t = it.next();
            if (t instanceof TrainingProgrammeXML) {
                TrainingProgrammeXML training = (TrainingProgrammeXML) t;
                //trcourses = training;
                Vector dates = new Vector();
                title = training.getTitle();
                localName = training.getTitle();
                organisme = "toto";
                BeginDateXML beginDate = null;
                EndDateXML endDate = null;
                String beginValDate = "0";
                String endValDate = "0";
                Vector sessions = training.getProgrammeSessions();
                if (sessions != null) {
                    Date toDay = new Date();
                    Iterator ses = sessions.iterator();
                    while (ses.hasNext()) {
                        ProgrammeSessionXML ps = (ProgrammeSessionXML) ses.next();
                        DateIntervalXML dateInterval = ps.getDateInterval();
                        beginDate = dateInterval.getBeginDate();
                        endDate = dateInterval.getEndDate();
                        java.sql.Date date = dateConvert.tedToToma(beginDate);
                        if (!toDay.after(date)) {
                            dates.add(date);
                        }
                    }
                    boolean sorted;
                    do {
                        sorted = true;
                        for (int i = 0; i < dates.size() - 1; i++) {
                            java.sql.Date date1 = (java.sql.Date) dates.elementAt(i);
                            java.sql.Date date2 = (java.sql.Date) dates.elementAt(i + 1);
                            if (date1.after(date2)) {
                                dates.setElementAt(date2, i);
                                dates.setElementAt(date1, i + 1);
                                sorted = false;
                            }
                        }
                    } while (!sorted);
                }
                Vector dateString = new Vector();
                if ((dates != null) && (dates.size() != 0)) {
                    Iterator itDates = dates.iterator();
                    while (itDates.hasNext()) {
                        java.sql.Date dateToma = (java.sql.Date) itDates.next();
                        DateXML dateTemp = dateConvert.tomaToTed(dateToma);
                        String d = dateTemp.getDay() + "-" + dateTemp.getMonth() + "-" + dateTemp.getYear();
                        dateString.add(d);
                    }
                } else {
                    dateString.add(new String("0"));
                }
                String code = training.getKey();

                String duree = training.getDuration();
                if (duree == null) duree = "0";
                // Vector with catalogues from this xml-file
                cat = training.getCatalogues();
                if (cat.size() == 0 || cat.elementAt(0) == null) {
                    allcat = addFormation(allcat, localName, title, organisme, code, dateString, endValDate, duree);

                } else {
                    // Add to level vectors
                    for (int i = 0; i < cat.size(); i++) {
                        allcat = addLevels((CatalogueXML) cat.elementAt(i), allcat, localName, title, organisme, code, dateString, endValDate, duree);
                    }
                }
            } else if (t instanceof TrainingCourseXML) {
                TrainingCourseXML training = (TrainingCourseXML) t;
                Vector dates = new Vector();
                title = training.getTitle();
                localName = training.getTitle();
                organisme = "toto";
                BeginDateXML beginDate = null;
                EndDateXML endDate = null;
                String beginValDate = "0";
                String endValDate = "0";
                Vector sessions = training.getCourseSessions();
                if (sessions != null) {
                    Date toDay = new Date();
                    Iterator ses = sessions.iterator();
                    while (ses.hasNext()) {
                        CourseSessionXML ps = (CourseSessionXML) ses.next();
                        DateIntervalXML dateInterval = ps.getDateInterval();
                        beginDate = dateInterval.getBeginDate();
                        endDate = dateInterval.getEndDate();
                        java.sql.Date date = dateConvert.tedToToma(beginDate);
                        if (!toDay.after(date)) {
                            dates.add(date);
                        }
                    }
                    boolean sorted;
                    do {
                        sorted = true;
                        for (int i = 0; i < dates.size() - 1; i++) {
                            java.sql.Date date1 = (java.sql.Date) dates.elementAt(i);
                            java.sql.Date date2 = (java.sql.Date) dates.elementAt(i + 1);
                            if (date1.after(date2)) {
                                dates.setElementAt(date2, i);
                                dates.setElementAt(date1, i + 1);
                                sorted = false;
                            }
                        }
                    } while (!sorted);

                }
                Vector dateString = new Vector();
                if ((dates != null) && (dates.size() != 0)) {
                    Iterator itDate = dates.iterator();
                    while (itDate.hasNext()) {
                        java.sql.Date dateToma = (java.sql.Date) itDate.next();
                        DateXML dateTemp = dateConvert.tomaToTed(dateToma);
                        String d = dateTemp.getDay() + "-" + dateTemp.getMonth() + "-" + dateTemp.getYear();
                        dateString.add(d);
                    }
                } else {
                    dateString.add(new String("0"));
                }
                String code = training.getKey();
                String duree = training.getDuration();
                if (duree == null) duree = "0";
                // Vector with catalogues from this xml-file
                cat = training.getCatalogues();
                if (cat.size() == 0 || cat.elementAt(0) == null) {
                    allcat = addFormation(allcat, localName, title, organisme, code, dateString, endValDate, duree);
                } else {
                    // Add to level vectors
                    for (int i = 0; i < cat.size(); i++) {
                        CatalogueXML catTest = (CatalogueXML) cat.elementAt(i);
                        allcat = addLevels((CatalogueXML) cat.elementAt(i), allcat, localName, title, organisme, code, dateString, endValDate, duree);
                    }
                }
            }


        }
        String catxml = printHashtable(allcat);
        return catxml;
    }


    private Hashtable processCataloguesToView() {
        //hashtable with all level 0 catalogues
        DateConversion dateConvert = new DateConversion();
        Hashtable allcat = new Hashtable();
        Vector cat = new Vector();
        String localName = "";
        String title = "";
        String organisme = "";
        Vector trainings = new Vector();
        Iterator it = trainingCoursesToView.iterator();
        TrainingXML trcourses = null;
        Object t;
        while (it.hasNext()) {
            trainings.add(it.next());
        }
        it = trainingProgrammesToView.iterator();
        while (it.hasNext()) {
            trainings.add(it.next());
        }
        it = trainings.iterator();
        while (it.hasNext()) {
            t = it.next();
            if (t instanceof TrainingProgrammeXML) {
                TrainingProgrammeXML training = (TrainingProgrammeXML) t;
                //trcourses = training;
                Vector dates = new Vector();
                title = training.getTitle();
                localName = training.getTitle();
                organisme = "";
                String beginValDate = "0";
                String endValDate = "0";
                Vector dateString = new Vector();
                dateString.add(new String("0"));
                String code = training.getCode();
                String duree = "0";
                cat = training.getCatalogues();
                if (cat.size() == 0 || cat.elementAt(0) == null) {
                    allcat = addFormation(allcat, localName, title, organisme, code, dateString, endValDate, duree);

                } else {
                    // Add to level vectors
                    for (int i = 0; i < cat.size(); i++) {
                        allcat = addLevels((CatalogueXML) cat.elementAt(i), allcat, localName, title, organisme, code, dateString, endValDate, duree);
                    }
                }
            }
            if (t instanceof TrainingCourseXML) {
                TrainingCourseXML training = (TrainingCourseXML) t;
                title = training.getTitle();
                localName = training.getTitle();
                organisme = "";

                String endValDate = "0";
                Vector dateString = new Vector();
                dateString.add(new String("0"));
                String code = training.getCode();
                String duree = "1";
                cat = training.getCatalogues();
                if (cat.size() == 0 || cat.elementAt(0) == null) {
                    allcat = addFormation(allcat, localName, title, organisme, code, dateString, endValDate, duree);
                } else {
                    // Add to level vectors
                    for (int i = 0; i < cat.size(); i++) {
                        CatalogueXML catTest = (CatalogueXML) cat.elementAt(i);
                        allcat = addLevels((CatalogueXML) cat.elementAt(i), allcat, localName, title, organisme, code, dateString, endValDate, duree);
                    }
                }
            }
        }
        return allcat;
    }

    public static String getModeOfOrganizationNameByValue(String languageCode, String value) {
        ModeOfOrganization moo = new ModeOfOrganization(value);
        ModeOfOrganizationDB moodb = new ModeOfOrganizationDB(moo);

        Language lng = new Language(languageCode);
        moodb.loadByValue(lng);

        return moo.getName();
    }

    public static String getLevelNameByValue(String languageCode, String value) {
        Level level = new Level(value);
        LevelDB leveldb = new LevelDB(level);

        Language lng = new Language(languageCode);
        leveldb.loadByValue(lng);

        return level.getName();
    }

    public static String getSlotNameByValue(String languageCode, String value) {
        Slot slot = new Slot(value);
        SlotDB slotdb = new SlotDB(slot);

        Language lng = new Language(languageCode);
        slotdb.loadByValue(lng);

        return slot.getName();
    }

    public static String isPassed(String day, String month, String year) {
        int dayInt = Integer.parseInt(day);
        int monthInt = Integer.parseInt(month) - 1;
        int yearInt = Integer.parseInt(year);
        GregorianCalendar gc = new GregorianCalendar(yearInt, monthInt, dayInt);
        GregorianCalendar today = new GregorianCalendar();
        if (today.before(gc)) {
            return "nok";
        } else {
            return "ok";
        }
    }

    public static String preserveSpace(String texte) {
        String resultat = String.valueOf(texte.charAt(0));
        for (int i = 1; i < texte.length(); i++) {
            char c = texte.charAt(i);
            if (c == '\n') {
                resultat = resultat.concat("%n");
            } else {
                resultat = resultat.concat(String.valueOf(c));
            }
        }
        return resultat;

    }

    public static String rajouterEspaces(String texte) {
        String resultat = String.valueOf(texte.charAt(0));
        for (int i = 1; i < texte.length(); i++) {
            char c = texte.charAt(i);
            resultat = resultat.concat(" ");
            resultat = resultat.concat(String.valueOf(c));
        }
        return resultat;
    }

    public static String getIdTrainingByCode(String code) {
        return code;
    }

    public static void copyFile(String in, String out) {
        try {
            File inputFile = new File(in);
            File outputFile = new File(out);
            FileInputStream input = new FileInputStream(inputFile);
            FileOutputStream output = new FileOutputStream(outputFile);
            int c;
            while ((c = input.read()) != -1)
                output.write(c);
            input.close();
            output.close();
        } catch (Exception e) {
        }

    }
}
