package apostal.toma.external;

/**
 * @author sof
 * date: Sep 20, 2002
 */

import apostal.toma.TOMA;
import apostal.toma.XMLHelper;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.encoding.XMLType;
import org.apache.axis.encoding.ser.JAFDataHandlerDeserializerFactory;
import org.apache.axis.encoding.ser.JAFDataHandlerSerializerFactory;

import javax.activation.DataHandler;
import javax.activation.FileDataSource;

import javax.xml.namespace.QName;
import javax.xml.rpc.ParameterMode;
import javax.xml.rpc.ServiceException;
import org.w3c.dom.Document;

import java.io.File;
import java.io.FileOutputStream;

import java.net.MalformedURLException;
import java.net.URL;

import java.util.Vector;
import java.util.Iterator;

public class SOAPClient {

	private String _url;
	private String _target;
	private String _method;
	private String _soapAction;

	public SOAPClient(String url, String target, String method)
	{
			this._url=url;
			this._target=target;
			this._method=method;
			this._soapAction=null;
	}
	
	public SOAPClient(String url, String target, String method, String soapAction)
	{
			this._url=url;
			this._target=target;
			this._method=method;
			this._soapAction=soapAction;
	}	

 /**
   * encodes the file "filename" into syrecos, for the user & pwd provided.
   * @returns the message if there was no error or a software error, null otherwise
   */
  public File deleteAndEncode(String user, String pwd, String filename, Vector parameters)
  {
   	File log;    	
    	
    Service service=new Service();
    Call call=null;
	try{
		call=(Call) service.createCall();	
	}catch(javax.xml.rpc.ServiceException ex)
	{
		TOMA.log(TOMA.SEVERE, "ServiceException: "+ex.getMessage());
		return null;
	}

    //url
    try{
	    call.setTargetEndpointAddress(new URL(_url));
    }catch(MalformedURLException ex)
    {
		TOMA.log(TOMA.SEVERE, "MalformedURLException for url="+_url+": "+ex.getMessage());
		return null;    
    }

    //method
    call.setOperationName(new QName(_target, _method));
    
    //set parameters
    Object[] args=this.setParameters(call, user, pwd, filename, null, parameters, false);
    
	TOMA.log(TOMA.INFO, "SOAPClient.deleteAndEncode for URL="+_url+", target="+_target+", method="+_method+", user="+user);

	//added by SRa 11/02/05
	//timeout set to 3600seconds = 1 hour
	call.setTimeout(new Integer(3600000));
	
	//set a special SOAP action (for .NET interoperability)
	if(_soapAction!=null && !_soapAction.equals("")){
		call.setProperty(Call.SOAPACTION_USE_PROPERTY, Boolean.TRUE);
		call.setProperty(Call.SOAPACTION_URI_PROPERTY, _soapAction);
	}
	
    //invocation
    Object o=null;
    try{
		o=call.invoke(args);
		TOMA.log(TOMA.WARNING, "invokation result="+o.getClass().getName()+", value="+o.toString());
    }catch(java.lang.Exception ex)
    {
    	TOMA.log(TOMA.SEVERE, "There was an error during soap extract invocation");
    	TOMA.log(TOMA.SEVERE, "exception: "+ex.getClass().getName()+", message="+ex.getMessage());
      	ex.printStackTrace();
    	log=null;
    }
	
	if(o!=null &&  o instanceof DataHandler)
	{
	    //r�cup�ration du r�sultat
		DataHandler d=(DataHandler) o;
		try{
			log=File.createTempFile("encode", ".log");
			FileOutputStream fout=new FileOutputStream(log);
			d.writeTo(fout);			
		}
		catch(java.io.FileNotFoundException ex)
		{
			TOMA.log(TOMA.SEVERE, "FileNotFoundException for temp file: "+ex.getMessage());
			return null;			
		}		
		catch(java.io.IOException ex)
		{
			TOMA.log(TOMA.SEVERE, "IOException with temp log file: "+ex.getMessage());
			return null;			
		}
	}
    else
    {
    	log=null;
    }
	return log;
  }     
  
  public boolean deleteAndEncodeBoolean(String user, String pwd, String filename, Vector parameters)
  {     
    Service service=new Service();
    Call call=null;
    try{
        call=(Call) service.createCall();   
    }catch(javax.xml.rpc.ServiceException ex)
    {
        TOMA.log(TOMA.SEVERE, "ServiceException: "+ex.getMessage());
        return false;
    }

    //url
    try{
        call.setTargetEndpointAddress(new URL(_url));
    }catch(MalformedURLException ex)
    {
        TOMA.log(TOMA.SEVERE, "MalformedURLException for url="+_url+": "+ex.getMessage());
        return false;    
    }

    //method
    call.setOperationName(new QName(_target, _method));
    
    //set parameters
    Object[] args=this.setParameters(call, user, pwd, filename, null, parameters, true);    
    
    TOMA.log(TOMA.INFO, "SOAPClient.deleteAndEncode for URL="+_url+", target="+_target+", method="+_method+", user="+user);

    //added by SRa 11/02/05
    //timeout set to 3600seconds = 1 hour
    call.setTimeout(new Integer(3600000));
    
	//set a special SOAP action (for .NET interoperability)
	if(_soapAction!=null && !_soapAction.equals("")){
		call.setProperty(Call.SOAPACTION_USE_PROPERTY, Boolean.TRUE);
		call.setProperty(Call.SOAPACTION_URI_PROPERTY, _soapAction);
	}
	
    //invocation
    Object o=null;
    try{
        o=call.invoke(args);
        TOMA.log(TOMA.WARNING, "invokation result="+o.getClass().getName()+", value="+o.toString());
    }catch(java.lang.Exception ex)
    {
        TOMA.log(TOMA.SEVERE, "There was an error during soap encode invocation");
        TOMA.log(TOMA.SEVERE, "exception: "+ex.getClass().getName()+", message="+ex.getMessage());
        ex.printStackTrace();
    }
    
    if(o!=null && o instanceof Boolean)
    {
        return ((Boolean) o).booleanValue();
    }
    else
        return false;
  }  
    
  public boolean deleteATraining(String user, String pwd, String code, Vector parameters)
  {     
    Service service=new Service();
    Call call=null;
    try{
        call=(Call) service.createCall();   
    }catch(javax.xml.rpc.ServiceException ex)
    {
        TOMA.log(TOMA.SEVERE, "ServiceException: "+ex.getMessage());
        return false;
    }

    //url
    try{
        call.setTargetEndpointAddress(new URL(_url));
    }catch(MalformedURLException ex)
    {
        TOMA.log(TOMA.SEVERE, "MalformedURLException for url="+_url+": "+ex.getMessage());
        return false;    
    }

    //method
    call.setOperationName(new QName(_target, _method));
    
    //set parameters
    Object[] args=this.setParameters(call, user, pwd, null,code, parameters, true);    
    
    TOMA.log(TOMA.INFO, "SOAPClient.deleteATraining for URL="+_url+", target="+_target+", method="+_method+", user="+user);

    //added by SRa 11/02/05
    //timeout set to 3600seconds = 1 hour
    call.setTimeout(new Integer(3600000));
    
	//set a special SOAP action (for .NET interoperability)
	if(_soapAction!=null && !_soapAction.equals("")){
		call.setProperty(Call.SOAPACTION_USE_PROPERTY, Boolean.TRUE);
		call.setProperty(Call.SOAPACTION_URI_PROPERTY, _soapAction);
	}
	
    //invocation
    Object o=null;
    try{
        o=call.invoke(args);
        TOMA.log(TOMA.WARNING, "invokation result="+o.getClass().getName()+", value="+o.toString());
    }catch(java.lang.Exception ex)
    {
        TOMA.log(TOMA.SEVERE, "There was an error during soap delete invocation");
        TOMA.log(TOMA.SEVERE, "exception: "+ex.getClass().getName()+", message="+ex.getMessage());
        ex.printStackTrace();
    }
    
    if(o!=null && o instanceof Boolean)
    {
        return ((Boolean) o).booleanValue();
    }
    else
        return false;
  }  
  
public boolean deleteAllTrainings(String user, String pwd, Vector parameters)
  {     
    Service service=new Service();
    Call call=null;
    try{
        call=(Call) service.createCall();   
    }catch(javax.xml.rpc.ServiceException ex)
    {
        TOMA.log(TOMA.SEVERE, "ServiceException: "+ex.getMessage());
        return false;
    }

    //url
    try{
        call.setTargetEndpointAddress(new URL(_url));
    }catch(MalformedURLException ex)
    {
        TOMA.log(TOMA.SEVERE, "MalformedURLException for url="+_url+": "+ex.getMessage());
        return false;    
    }

    //method
    call.setOperationName(new QName(_target, _method));
    
    //set parameters
    Object[] args=this.setParameters(call, user, pwd, null,null, parameters, true);    
    
    TOMA.log(TOMA.INFO, "SOAPClient.deleteAllTrainings for URL="+_url+", target="+_target+", method="+_method+", user="+user);

    //added by SRa 11/02/05
    //timeout set to 3600seconds = 1 hour
    call.setTimeout(new Integer(3600000));
    
	//set a special SOAP action (for .NET interoperability)
	if(_soapAction!=null && !_soapAction.equals("")){
		call.setProperty(Call.SOAPACTION_USE_PROPERTY, Boolean.TRUE);
		call.setProperty(Call.SOAPACTION_URI_PROPERTY, _soapAction);
	}
	
    //invocation
    Object o=null;
    try{
        o=call.invoke(args);
        TOMA.log(TOMA.WARNING, "invokation result="+o.getClass().getName()+", value="+o.toString());
    }catch(java.lang.Exception ex)
    {
        TOMA.log(TOMA.SEVERE, "There was an error during soap delete invocation");
        TOMA.log(TOMA.SEVERE, "exception: "+ex.getClass().getName()+", message="+ex.getMessage());
        ex.printStackTrace();
    }
    
    if(o!=null && o instanceof Boolean)
    {
        return ((Boolean) o).booleanValue();
    }
    else
        return false;
  }   
  
  /**
   * set the right parameters on the call object
   * + return an array containing the parameters in the right order
   * @param call
   * @param user
   * @param pwd
   * @param filename
   * @param parameters
   * @return
   */
  public Object[] setParameters(Call call, String user, String pwd, String filename, String code, Vector parameters, boolean BooleanReturnType){
      Object args[]=new Object[parameters.size()];
      
      //return type
      if(BooleanReturnType)
          call.setReturnType(XMLType.XSD_BOOLEAN);
      else{
          QName qnameAttachment=new QName(_target, "DataHandler");
          call.setReturnType(qnameAttachment);
      }
      
      if(parameters!=null){       
          Iterator it=parameters.iterator();
          int cpt=0;
          while(it.hasNext()){
              SOAPCallParameter param=(SOAPCallParameter) it.next();
              
              TOMA.log(TOMA.ALL, "SOAP: adding parameter "+param.toString());
              
              if(param.getParameterType()==SOAPCallParameter.USER_PARAM){
                  call.addParameter("ns1:"+param.getParameterName(), XMLType.XSD_STRING, ParameterMode.IN );
                  args[cpt]=user;
              }
              else if(param.getParameterType()==SOAPCallParameter.PASSWORD_PARAM){
                  call.addParameter("ns1:"+param.getParameterName(), XMLType.XSD_STRING, ParameterMode.IN );
                  args[cpt]=pwd;
              }
              else if(param.getParameterType()==SOAPCallParameter.STRINGDOCUMENT_PARAM){
                  call.addParameter("ns1:"+param.getParameterName(), XMLType.XSD_STRING, ParameterMode.IN );
                  Document doc=XMLHelper.readDocument(filename);
                  args[cpt]=XMLHelper.getDocumentAsString(doc);            
              }   		  			  
              else if(param.getParameterType()==SOAPCallParameter.DATAHANDLERDOCUMENT_PARAM){
                  DataHandler dhData=new DataHandler(new FileDataSource(filename));
                  QName qnameAttachment=new QName(_target, "DataHandler");
                  call.registerTypeMapping(dhData.getClass(), 
                                  qnameAttachment, 
                                  JAFDataHandlerSerializerFactory.class,
                                  JAFDataHandlerDeserializerFactory.class);
                  call.addParameter("ns1:"+param.getParameterName(), qnameAttachment, ParameterMode.IN );
                  
                  args[cpt]=dhData;
              }
              else if(param.getParameterType()==SOAPCallParameter.TRAININGCODE_PARAM){
                  call.addParameter("ns1:"+param.getParameterName(), XMLType.XSD_STRING, ParameterMode.IN );                  
                  args[cpt]=code;            
              }		
              else if(param.getParameterType()==SOAPCallParameter.CONSTANT_PARAM){
                  call.addParameter("ns1:"+param.getParameterName(), XMLType.XSD_STRING, ParameterMode.IN );                  
                  args[cpt]=param.getConstantValue();            
              }				  
              
              cpt++;
          }
      }
      else{                    
          //use default parameters order and names
          TOMA.log(TOMA.ALL, "SOAP: No CallParameters element, using default parameters");
          
          DataHandler dhData=new DataHandler(new FileDataSource(filename));
          QName qnameAttachment=new QName(_target, "DataHandler");
          call.registerTypeMapping(dhData.getClass(), 
                          qnameAttachment, 
                          JAFDataHandlerSerializerFactory.class,
                          JAFDataHandlerDeserializerFactory.class);
          call.addParameter( "user", XMLType.XSD_STRING, ParameterMode.IN );    
          call.addParameter( "pwd", XMLType.XSD_STRING, ParameterMode.IN );       
          call.addParameter("data", qnameAttachment, ParameterMode.IN);   

          args[0]=user;
          args[1]=pwd;
          args[2]=dhData;        
      }      
      return args;
  }  
  
  public boolean extract(String user, String pwd, String filename)
  {
  	boolean ok=false;
	Service service=new Service();
	Call call=null;
	try{
		call=(Call) service.createCall();	
	}catch(ServiceException ex)
	{
		TOMA.log(TOMA.SEVERE, "ServiceException: "+ex.getMessage());
		return false;
	}
	
	//url
	try{
		call.setTargetEndpointAddress(new URL(_url));
	}catch(MalformedURLException ex)
	{
		TOMA.log(TOMA.SEVERE, "MalformedURLException for url="+_url+": "+ex.getMessage());
		return false;
	}

	//method
   	call.setOperationName(new QName(_target, _method));

	//parameters
	Vector params=new Vector();
	QName qnameAttachment=new QName(_target, "DataHandler");
	call.registerTypeMapping(DataHandler.class, 
    				qnameAttachment, 
    				JAFDataHandlerSerializerFactory.class,
				JAFDataHandlerDeserializerFactory.class);
	call.setReturnType(qnameAttachment);					
	call.addParameter( "user", XMLType.XSD_STRING, ParameterMode.IN );    
	call.addParameter( "pwd", XMLType.XSD_STRING, ParameterMode.IN );    

	Object args[]=new Object[2];
	args[0]=user;
	args[1]=pwd;

	//invocation
	Object o=null;
	try{
		o=call.invoke(args );
	}catch(Exception ex)
	{
		TOMA.log(TOMA.SEVERE, "There was an error during soap extract invocation");
		TOMA.log(TOMA.SEVERE, "exception: "+ex.getClass().getName()+", message="+ex.getMessage());
		ex.printStackTrace();
	}

	//r�cup�ration du r�sultat
	if(o!=null &&  o instanceof DataHandler)
	{
		ok=true;
		DataHandler dh=(DataHandler) o;
		
		//r�cup�ration du r�sultat
		String name=dh.getName();    		
		TOMA.log(TOMA.WARNING, "echoFile, result="+name);
    		
		//test avec Reader
		/*try{
			java.io.InputStream in=dh.getInputStream();
			java.io.InputStreamReader reader= new java.io.InputStreamReader(in);
			java.io.BufferedReader breader=new java.io.BufferedReader(reader); 
			java.io.FileWriter writer=new java.io.FileWriter(filename); 
			java.io.BufferedWriter bwriter=new java.io.BufferedWriter(writer);
			String line=null;
			do{
				line=breader.readLine();
				if(line!=null){
					bwriter.write(line);
					TOMA.log(TOMA.WARNING, "copied line: "+line);
					//lines are read correctly ! 
				}
			}while(line!=null);
			in.close();
			reader.close();
			breader.close();
			writer.flush();
			bwriter.flush();
			writer.close();
			bwriter.close();
			TOMA.log(TOMA.WARNING, "-> result copied to file "+filename+" correctly");
		}catch(Exception ex)
		{
			TOMA.log(TOMA.WARNING, "Exception while writing to file: "+ex.getMessage());
			return false;    	
		}*/
		
		//test avec InputStream
		/*try{
			java.io.InputStream in=((DataHandler) o).getInputStream();
			FileOutputStream fout=new FileOutputStream(filename);
			int b;
			do{
				b=in.read();
				if(b!=-1){
					fout.write(b);
				}
			}while(b!=-1);
			in.close();			
			fout.flush();
			fout.close();
			TOMA.log(TOMA.WARNING, "-> result copied to file "+filename+" correctly");
		}catch(Exception ex)
		{
			TOMA.log(TOMA.WARNING, "Exception while writing to file: "+ex.getMessage());
			return false;    	
		}*/
		
		//debug
		/*TOMA.log(TOMA.WARNING, "DataHandler: contentType="+dh.getContentType());
		Object object=dh.getContent();
		if(object!=null)
			TOMA.log(TOMA.WARNING, "DataHandler object is not null. Class="+object.getClass().getName()+", toString="+object.toString());
		else
			TOMA.log(TOMA.WARNING, "DataHandler object is null");*/				
		
		//�criture dans un fichier
		try{			
			java.io.FileOutputStream fout=new java.io.FileOutputStream(filename);
			dh.writeTo(fout);
			fout.flush();
			fout.close();
			TOMA.log(TOMA.WARNING, "-> result copied to file "+filename+" correctly");
			
		}catch(Exception ex)
		{
			TOMA.log(TOMA.WARNING, "Exception while writing to file: "+ex.getMessage());
			return false;    	
		}
	}
	else
	{
		TOMA.log(TOMA.SEVERE, "extract, result null or not a DataHandler");
	}
	return ok;
  }  
  
}
