// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.external;

import apostal.toma.data.Language;
import apostal.toma.data.PublicationUnit;
import apostal.toma.data.TOMALabels;
import apostal.toma.data.Training;
import apostal.toma.external.tedtoma.TedTomaConversion;
import apostal.toma.view.TOMAFonts;

import java.io.File;
import java.io.IOException;
import java.util.Vector;

public class XMLPublication extends Publication
{
	public String filename;
	private String errorMessage;
	private int result;
	private TOMALabels labels;
    
    public XMLPublication(PublicationUnit publicationUnit)
    {
    	super(publicationUnit);  
    	result=0;   
    	labels = new TOMALabels(); 
    }
    
    public int getResult(){
		return result;
	}
	public String getErrorMessage(){
		return errorMessage;
	}
	
    public void publish(boolean addFirstCat){
    	errorMessage = TOMAFonts.htmlBegin;
    	Vector trainings = this.getTrainingToPublish(this.publicationUnit);
		String destinationFile =this.publicationUnit.getDestinationPath();
		File fileDestination = new File(destinationFile);
		if (!fileDestination.exists()){
			try {
				fileDestination.createNewFile();					
			}
			catch(IOException ioEx){
				result = 1;		
				errorMessage = errorMessage +"<P>"+ labels.get("apostal.toma.publication.publish.error.directory_not_exist") +"</P>";
			}				
		}
		errorMessage = errorMessage +TOMAFonts.htmlEnd;
		if (result==0){
			try{
				//this.generateTedXML(trainings,destinationFile,addFirstCat);
                this.generateTedXML(destinationFile,addFirstCat, true);
			}
			catch(Exception e){
				result =1;
        		errorMessage = e.getMessage();
			}
		}
	
    }

	public void checkSingleTraining(Training t,Language lang){
    	Vector trainings=new Vector();
        trainings.add(t);
    	TedTomaConversion conversion = new TedTomaConversion();
    	conversion.checkTedCompliance(trainings,lang);    	
    	
    }
    public void publishSingleTraining(Training t,boolean addFirstCat)
    {
        try{
        	Vector trainings=new Vector();
        	trainings.add(t);
        	this.generateTedXML(trainings,this.publicationUnit.getDestinationPath(),addFirstCat, true);
        }
        catch(Exception e){
        	result =1;
        	errorMessage = e.getMessage();
        	e.printStackTrace();
        }
        
    }  

    public Vector getErrors()
    {
      return this.tedTomaConversion.getErrors();
    }
}
