// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.external.tedtoma;

import apostal.ted.DateXML;

import java.util.Calendar;
import java.util.GregorianCalendar;

public class DateConversion {

    public DateConversion() {
    }


    public boolean checkTedCompliance(java.sql.Date d) {
        boolean compliance = true;
        if (d != null) {
        } else
            compliance = false;
        return compliance;
    }

    public java.sql.Date tedToToma(DateXML date) {
        GregorianCalendar cal = new GregorianCalendar();

        String year = date.getYear();
        String month = date.getMonth();
        String day = date.getDay();

        java.sql.Date dateSQL = null;

        if (year != null && month != null && day != null) {
            cal.set(Calendar.YEAR, (new Integer(year)).intValue());
            //!! les mois en Java commencent  0 ...
            cal.set(Calendar.MONTH, (new Integer(month)).intValue() - 1);
            cal.set(Calendar.DAY_OF_MONTH, (new Integer(day)).intValue());
        }
        java.util.Date dateUtil = cal.getTime();
        dateSQL = new java.sql.Date(dateUtil.getTime());
        return dateSQL;
    }

    public DateXML tomaToTed(java.sql.Date date) {
        DateXML datexml = null;
        Calendar cal = new GregorianCalendar();

        if (date != null) {
            cal.setTime(date);
            String day = String.valueOf(cal.get(Calendar.DAY_OF_MONTH));
            String month = String.valueOf(cal.get(Calendar.MONTH) + 1);
            String year = String.valueOf(cal.get(Calendar.YEAR));

            datexml = new DateXML(day, month, year);
        }
        return datexml;
    }
}
