// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.external.tedtoma;

import apostal.ted.DomainXML;
import apostal.toma.data.Domain;
import apostal.toma.data.Language;
import apostal.toma.data.TOMALabels;
import apostal.toma.database.DomainDB;

import java.util.Vector;

public class DomainConversion {
    TOMALabels labels;


    public DomainConversion() {
        labels = new TOMALabels();

    }

    public boolean checkTedCompliance(Domain d) {

        boolean compliance = true;
        if (d != null) {
            if (d.getName() == null) {
                compliance = false;
                TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.domain.name"));
            }
        } else
            compliance = false;
        return compliance;
    }

    public DomainXML tomaToTed(Domain d, DomainXML domXML, Language lang) {
        DomainDB dDB = new DomainDB(d);
        dDB.loadById(lang);
        String name = d.getName();
        int superDom = d.getIdSuperDomain();
        DomainXML domain = domXML;
        if (name != null) {
            DomainXML domainTemp = new DomainXML(name);
            if (domXML != null)
                domainTemp.setDomain(domXML);
            if (superDom != -1) {
                Domain superDomainToma = new Domain(superDom);
                dDB = new DomainDB(superDomainToma);
                dDB.loadById(lang);
                domain = this.tomaToTed(superDomainToma, domainTemp, lang);
            } else
                domain = domainTemp;
        }
        return domain;
    }

    /**
     * returns all the "TOMA" domains corresponding to this DomainXML
     */
    public Vector tedToToma(DomainXML d) {
        String name = d.getTitle();

        Vector domains = new Vector();

        Domain domain = new Domain();
        domain.setName(name);
        DomainDB ddb = new DomainDB(domain);
        if (ddb.loadByName()) {
            domains.add(domain);

            DomainXML dom = d.getDomain();
            if (dom != null) {
                domains.addAll(this.tedToToma(dom));
            }
        }

        return domains;

        /*DomainXML dom = d.getDomain();
            Domain domain = new Domain();
            domain.setName(name);
            Vector domains = new Vector();
            if (dom!=null){
                domains.add(this.tedToToma(dom));
            }
            domain.setDomains(domains);

            return domain;*/
    }
}
