// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.external.tedtoma;

import apostal.ted.LanguageXML;
import apostal.toma.data.Language;
import apostal.toma.data.TOMALabels;

public class LanguageConversion {

    TOMALabels labels;

    public LanguageConversion() {
        labels = new TOMALabels();
    }

    public boolean checkTedCompliance(Language l) {
        boolean compliance = true;
        if (l != null) {
            if (l.getCode() == null) {
                compliance = false;
            }
        } else
            compliance = false;
        return compliance;
    }

    public LanguageXML tomaToTed(Language l) {
        String code = l.getCode();
        String name = l.getName();
        LanguageXML language = null;
        if (code != null) {
            language = new LanguageXML();
            language.setLanguageCode(code);
            if (name != null)
                language.setLanguageName(name);
        }
        return language;

    }

    public Language tedToToma(LanguageXML l) {
        String code = l.getLanguageCode();
        String name = l.getLanguageName();
        Language language = null;
        if (code != null) {
            language = new Language(code);
            if (name != null)
                language.setName(name);
        }
        return language;
    }
}
