// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.external.tedtoma;

import apostal.ted.SlotXML;
import apostal.toma.data.Slot;

public class SlotConversion {
    public SlotConversion() {
    }

    public boolean checkTedCompliance(Slot s) {
        boolean compliance = true;
        if (s != null) {
            if (s.getValue() == null) compliance = false;
        } else
            compliance = false;
        return compliance;
    }

    public SlotXML tomaToTed(Slot s) {
        SlotXML slot = null;
        if (s == null) {
            slot = new SlotXML("day");
        } else {
            String value = s.getValue();
            if (value == null) {
                slot = new SlotXML("day");
            } else {
                slot = new SlotXML(s.getValue());
            }
        }
        return slot;
    }

    public Slot tedToToma(SlotXML s) {
        String value = s.getValue();
        Slot slot = null;
        if (value != null)
            slot = new Slot(value);
        return slot;
    }

}
