// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.external.tedtoma;

import apostal.ted.CatalogueXML;
import apostal.ted.TedXML;
import apostal.ted.TrainingCourseXML;
import apostal.ted.TrainingProgrammeXML;
import apostal.toma.data.*;
import apostal.toma.database.CatalogueDB;
import apostal.toma.database.OrganismDB;
import apostal.toma.database.TrainingCourseDB;
import apostal.toma.database.TrainingProgrammeDB;

import java.util.Date;
import java.util.Iterator;
import java.util.Vector;

public class TedTomaConversion {

    private static Vector errors = null;
//	TOMALabels labels = new TOMALabels();
    private TrainingCourseDB trCourseDB;
    private TrainingProgrammeDB trProgDB;
    private OrganismConversion orgConvert = new OrganismConversion();

    public TedTomaConversion() {
    }

    /*public void checkTedCompliance(Vector trainings,Language lang){
        this.emptyErrors();
        TrainingProgramme trProgramme;
        TrainingCourse trCourse;
        if(trainings!=null)
        {
              Organism organism=OrganismDB.getOrganism(lang, true);
            orgConvert.checkTedCompliance(organism,"");
              Iterator iter = trainings.iterator();
              while (iter.hasNext())
              {

                Training t = (Training) iter.next();
                if(t instanceof TrainingProgramme)
                {
                    TrainingProgrammeConversion mapping=new TrainingProgrammeConversion();
                    trProgramme = (TrainingProgramme)t;
                    trProgDB = new TrainingProgrammeDB(trProgramme);
                    trProgDB.loadById(lang,true);
                    mapping.checkTedCompliance(trProgramme,lang);
                }
                else
                {
                    TrainingCourseConversion mapping=new TrainingCourseConversion();
                    trCourse = (TrainingCourse)t;
                    trCourseDB = new TrainingCourseDB(trCourse);
                    trCourseDB.loadById(lang,true);
                    mapping.checkTedCompliance(trCourse,lang);
                }
              }
        }
    }      */

    public void checkTedCompliance(Vector trainings, Language lang) {
        this.emptyErrors();
        TrainingProgramme trProgramme;
        TrainingCourse trCourse;
        if (trainings != null) {
            Organism organism = OrganismDB.getOrganism(lang, true);
            orgConvert.checkTedCompliance(organism, "");
            Iterator iter = trainings.iterator();
            while (iter.hasNext()) {

                Training t = (Training) iter.next();
                if (t instanceof TrainingProgramme) {
                    TrainingProgrammeConversion mapping = new TrainingProgrammeConversion();
                    trProgramme = (TrainingProgramme) t;
                    mapping.checkTedCompliance(trProgramme, lang);
                } else {
                    TrainingCourseConversion mapping = new TrainingCourseConversion();
                    trCourse = (TrainingCourse) t;
                    mapping.checkTedCompliance(trCourse, lang);
                }
            }
        }
    }


    public Vector tedToToma(TedXML ted) {
        Vector formations = null;
        this.emptyErrors();
        if (ted != null) {
            formations = new Vector();

            Vector trainingCourses = ted.getTrainingCourses();
            Iterator it_courses = trainingCourses.iterator();
            while (it_courses.hasNext()) {
                TrainingCourseXML training = (TrainingCourseXML) it_courses.next();

                apostal.toma.TOMA.log(apostal.toma.TOMA.WARNING, "TedTomaConversion, tc.title=\"" + training.getTitle() + "\"");

                TrainingCourseConversion tctf = new TrainingCourseConversion();
                formations.add(tctf.tedToToma(training));
            }
            Vector trainingProgrammes = ted.getTrainingProgrammes();
            Iterator it_programmes = trainingProgrammes.iterator();
            while (it_programmes.hasNext()) {
                TrainingProgrammeXML training = (TrainingProgrammeXML) it_programmes.next();
                TrainingProgrammeConversion tptf = new TrainingProgrammeConversion();
                formations.add(tptf.tedToToma(training));
            }
        }


        return formations;

    }


    public TedXML tomaToTed(Training t, Language lang, boolean publishOrganismDetails, String catalogueFictif, boolean testDate, boolean syrecos, boolean addFirstCat, boolean addNamespaces) {
        TedXML ted = new TedXML();
        Date toDay = new Date();
        this.emptyErrors();
        TrainingProgramme trProgramme;
        TrainingCourse trCourse;
        if (t instanceof TrainingProgramme) {
            TrainingProgrammeConversion mapping = new TrainingProgrammeConversion();
            trProgramme = (TrainingProgramme) t;
            if ((testDate == false) || (!toDay.before(trProgramme.getBeginValidityDate()) && !toDay.after(trProgramme.getEndValidityDate()))) {
                TrainingProgrammeXML tp = mapping.tomaToTed(trProgramme, lang, publishOrganismDetails, catalogueFictif, testDate, syrecos, addFirstCat);
                ted.addTrainingProgramme(tp);
            }
        } else {
            TrainingCourseConversion mapping = new TrainingCourseConversion();
            trCourse = (TrainingCourse) t;
            if ((testDate == false) || (!toDay.before(trCourse.getBeginValidityDate()) && !toDay.after(trCourse.getEndValidityDate()))) {
                TrainingCourseXML tc = mapping.tomaToTed(trCourse, lang, publishOrganismDetails, catalogueFictif, testDate, syrecos, addFirstCat);
                ted.addTrainingCourse(tc);
            }
        }
        if(addNamespaces)
            ted.setDefaultNamespace();
        return ted;
    }


    public TedXML tomaToTed(Vector trainings, Language lang, boolean publishOrganismDetails, String catalogueFictif, boolean testDate, boolean syrecos, boolean addFirstCat, boolean addNamespaces) {
        this.emptyErrors();
        Date toDay = new Date();
        TedXML ted = new TedXML();
        TrainingProgramme trProgramme;
        TrainingCourse trCourse;
        if (trainings != null) {
            Iterator iter = trainings.iterator();
            while (iter.hasNext()) {
                Training t = (Training) iter.next();
                if (t instanceof TrainingProgramme) {
                    TrainingProgrammeConversion mapping = new TrainingProgrammeConversion();
                    trProgramme = (TrainingProgramme) t;
                    if ((testDate == false) || (!toDay.before(trProgramme.getBeginValidityDate()) && !toDay.after(trProgramme.getEndValidityDate()))) {
                        TrainingProgrammeXML tp = mapping.tomaToTed(trProgramme, lang, publishOrganismDetails, catalogueFictif, testDate, syrecos, addFirstCat);
                        ted.addTrainingProgramme(tp);
                    }
                } else {
                    TrainingCourseConversion mapping = new TrainingCourseConversion();
                    trCourse = (TrainingCourse) t;
                    if ((testDate == false) || (!toDay.before(trCourse.getBeginValidityDate()) && !toDay.after(trCourse.getEndValidityDate()))) {
                        TrainingCourseXML tc = mapping.tomaToTed(trCourse, lang, publishOrganismDetails, catalogueFictif, testDate, syrecos, addFirstCat);
                        ted.addTrainingCourse(tc);
                    }
                }
            }
        }
        if(addNamespaces)
            ted.setDefaultNamespace();
        return ted;
    }


    public TedXML tomaToTedToView(Vector trainings, Language lang, String catalogueFictif, boolean testDate, boolean syrecos, boolean addFirstCat) {
        Date toDay = new Date();
        TedXML ted = new TedXML();
        TrainingProgramme trProgramme;
        TrainingCourse trCourse;
        if (trainings != null) {
            Iterator iter = trainings.iterator();
            while (iter.hasNext()) {
                Training t = (Training) iter.next();
                if (t instanceof TrainingProgramme) {
                    TrainingProgrammeConversion mapping = new TrainingProgrammeConversion();
                    trProgramme = (TrainingProgramme) t;
                    if ((testDate == false) || (!toDay.before(trProgramme.getBeginValidityDate()) && !toDay.after(trProgramme.getEndValidityDate()))) {
                        TrainingProgrammeXML tp = new TrainingProgrammeXML();
                        tp.setTitle(trProgramme.getTitle());
                        tp.setCode(trProgramme.getCode());
                        Vector catalogues = trProgramme.getCatalogues();
                        if (catalogues != null) {
                            Iterator it = catalogues.iterator();
                            while (it.hasNext()) {
                                Catalogue cat = (Catalogue) it.next();
                                CatalogueDB catDB = new CatalogueDB(cat);
                                catDB.loadById(lang, true);
                                CatalogueConversion catConvert = new CatalogueConversion();
                                CatalogueXML catXML = catConvert.tomaToTed(cat, null, 0, catalogueFictif, lang, syrecos, addFirstCat);
                                tp.addCatalogue(catXML);
                            }

                        }
                        ted.addTrainingProgramme(tp);
                    }
                } else {
                    TrainingCourseConversion mapping = new TrainingCourseConversion();
                    trCourse = (TrainingCourse) t;
                    if ((testDate == false) || (!toDay.before(trCourse.getBeginValidityDate()) && !toDay.after(trCourse.getEndValidityDate()))) {
                        TrainingCourseXML tc = new TrainingCourseXML();
                        tc.setTitle(trCourse.getTitle());
                        tc.setCode(trCourse.getCode());
                        Vector catalogues = trCourse.getCatalogues();
                        if (catalogues != null) {
                            Iterator it = catalogues.iterator();
                            while (it.hasNext()) {
                                Catalogue cat = (Catalogue) it.next();
                                CatalogueDB catDB = new CatalogueDB(cat);
                                catDB.loadById(lang, true);
                                CatalogueConversion catConvert = new CatalogueConversion();
                                CatalogueXML catXML = catConvert.tomaToTed(cat, null, 0, catalogueFictif, lang, syrecos, addFirstCat);
                                tc.addCatalogue(catXML);
                            }

                        }
                        ted.addTrainingCourse(tc);
                    }
                }
            }
        }
        ted.setDefaultNamespace();
        return ted;
    }

    public static void addError(String error) {
        if (error != null)
            errors.add(error);
    }

    public static Vector getErrors() {
        return errors;
    }

    private static void emptyErrors() {
        errors = new Vector();
    }
}
