// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.external.tedtoma;

import apostal.ted.*;
import apostal.toma.TOMA;
import apostal.toma.data.*;
import apostal.toma.database.*;

import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.Vector;

public class TrainingCourseConversion extends StandAloneTrainingConversion {
    TeacherConversion teacherConvert = new TeacherConversion();
    ContactConversion contactConvert = new ContactConversion();
    CatalogueConversion catConvert = new CatalogueConversion();
    LocationConversion locConvert = new LocationConversion();
    ModeOfOrganizationConversion mooConvert = new ModeOfOrganizationConversion();
    LevelConversion levelConvert = new LevelConversion();
    CourseSessionConversion csConvert = new CourseSessionConversion();
    DateConversion dateConvert = new DateConversion();
    OrganismConversion orgConvert = new OrganismConversion();
    TOMALabels labels = new TOMALabels();
    private CourseSessionDB csDB;
    private LocationDB locDB;
    private TeacherDB teacherDB;
    private ContactDB contactDB;
    private CatalogueDB catalogueDB;

    public TrainingCourseConversion() {
    }

    /* public boolean checkTedCompliance(TrainingCourse t,Language lang) {
         boolean compliance = true;
         if (t!=null){
             if (t.getTitle()==null){
                 compliance = false;
                 TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.title") +" " + labels.get("apostal.toma.tomatoted.trainingCourse") + " " +  t.getCode());
             }
             if (t.getModeOfOrganization()!=null){
                 if (!mooConvert.checkTedCompliance(t.getModeOfOrganization())){
                     compliance = false;
                     TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.modeOfOrganization")+" " + labels.get("apostal.toma.tomatoted.trainingCourse") + " " +  t.getTitle());
                 }
             } else compliance = false;
             if (t.getLevel()!=null){
                 if (!levelConvert.checkTedCompliance(t.getLevel())){
                     compliance = false;
                     TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.level")+" " + labels.get("apostal.toma.tomatoted.trainingCourse") + " " +  t.getTitle());
                 }
             } else compliance = false;
             if (t.getBeginValidityDate()==null){
                 compliance = false;
                 TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.beginValidityDate")+" " + labels.get("apostal.toma.tomatoted.trainingCourse") + " " +  t.getTitle());
             }
             if (t.getEndValidityDate()==null){
                 compliance = false;
                 TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.endValidityDate")+" " + labels.get("apostal.toma.tomatoted.trainingCourse") + " " +  t.getTitle());
             }
             if (t.getCourseSessions() != null && !t.getCourseSessions().isEmpty()){
                 Iterator it = t.getCourseSessions().iterator();
                 CourseSession cs;
                 while (it.hasNext()){
                     cs = (CourseSession)it.next();
                     csDB = new CourseSessionDB(cs);
                     csDB.loadById(lang,true);
                     String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " +  t.getTitle());
                     csConvert.checkTedCompliance(cs,message,lang);
                 }
             }

             if (t.getLanguages()!=null && t.getLanguages().size()>0){
                 Iterator it = t.getLanguages().iterator();
                 Language language;
                 while (it.hasNext()){
                     language = (Language)it.next();
                     if (!langueConvert.checkTedCompliance(language)) compliance = false;
                 }
             } else {
                 TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.session.language") + " " + labels.get("apostal.toma.tomatoted.trainingCourse") +" " + t.getTitle());
                 compliance = false;
             }
             if (t.getTeachers() != null && !t.getTeachers().isEmpty()){
                 Iterator it = t.getTeachers().iterator();
                 Teacher tcs;
                 while (it.hasNext()){
                     tcs = (Teacher)it.next();
                     teacherDB = new TeacherDB(tcs);
                     teacherDB.loadById(lang,true);
                     String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " +  t.getTitle());
                     teacherConvert.checkTedCompliance(tcs,message);
                 }
             }
             if (t.getInscriptionContacts() != null && !t.getInscriptionContacts().isEmpty()){
                 Iterator it = t.getInscriptionContacts().iterator();
                 Contact contact;
                 while (it.hasNext()){
                     contact = (Contact)it.next();
                     contactDB = new ContactDB(contact);
                     contactDB.loadById(lang,true);
                     String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " +  t.getTitle());
                     contactConvert.checkTedCompliance(contact,message);
                 }
             }
             if (t.getTrainingContacts() != null && !t.getTrainingContacts().isEmpty()){
                 Iterator it = t.getTrainingContacts().iterator();
                 Contact contact;
                 while (it.hasNext()){
                     contact = (Contact)it.next();
                     contactDB = new ContactDB(contact);
                     contactDB.loadById(lang,true);
                     String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " +  t.getTitle());
                     contactConvert.checkTedCompliance(contact,message);
                 }
             }
             if (t.getCatalogues() != null && !t.getCatalogues().isEmpty()){
                 Iterator it = t.getCatalogues().iterator();
                 Catalogue cat;
                 while (it.hasNext()){
                     cat = (Catalogue)it.next();
                     catalogueDB = new CatalogueDB(cat);
                     catalogueDB.loadById(lang,true);
                     String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " +  t.getTitle());
                     catConvert.checkTedCompliance(cat,message);
                 }
             }
             if (t.getLocations() != null && !t.getLocations().isEmpty()){

                 Iterator it = t.getLocations().iterator();
                 Location loc;
                 while (it.hasNext()){
                     loc = (Location)it.next();
                     locDB = new LocationDB(loc);
                     locDB.loadById(lang,true);
                     String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " +  t.getTitle());
                     locConvert.checkTedCompliance(loc,message);
                 }
             }

         } else compliance = false;
         return compliance;
     }       */

    public boolean checkTedCompliance(TrainingCourse t, Language lang) {
        boolean compliance = true;
        if (t != null) {
            if (t.getTitle() == null) {
                compliance = false;
                TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.title") + " " + labels.get("apostal.toma.tomatoted.trainingCourse") + " " + t.getCode());
            }
            if (t.getModeOfOrganization() != null) {
                if (!mooConvert.checkTedCompliance(t.getModeOfOrganization())) {
                    compliance = false;
                    TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.modeOfOrganization") + " " + labels.get("apostal.toma.tomatoted.trainingCourse") + " " + t.getTitle());
                }
            } else
                compliance = false;
            if (t.getLevel() != null) {
                if (!levelConvert.checkTedCompliance(t.getLevel())) {
                    compliance = false;
                    TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.level") + " " + labels.get("apostal.toma.tomatoted.trainingCourse") + " " + t.getTitle());
                }
            } else
                compliance = false;
            if (t.getBeginValidityDate() == null) {
                compliance = false;
                TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.beginValidityDate") + " " + labels.get("apostal.toma.tomatoted.trainingCourse") + " " + t.getTitle());
            }
            if (t.getEndValidityDate() == null) {
                compliance = false;
                TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.endValidityDate") + " " + labels.get("apostal.toma.tomatoted.trainingCourse") + " " + t.getTitle());
            }
            if (t.getCourseSessions() != null && !t.getCourseSessions().isEmpty()) {
                Iterator it = t.getCourseSessions().iterator();
                CourseSession cs;
                while (it.hasNext()) {
                    cs = (CourseSession) it.next();
                    /*csDB = new CourseSessionDB(cs);
                    csDB.loadById(lang,true);    */
                    String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " + t.getTitle());
                    csConvert.checkTedCompliance(cs, message, lang);
                }
            }

            if (t.getLanguages() != null && t.getLanguages().size() > 0) {
                Iterator it = t.getLanguages().iterator();
                Language language;
                while (it.hasNext()) {
                    language = (Language) it.next();
                    if (!langueConvert.checkTedCompliance(language)) compliance = false;
                }
            } else {
                TedTomaConversion.addError(labels.get("apostal.toma.tomatoted.session.language") + " " + labels.get("apostal.toma.tomatoted.trainingCourse") + " " + t.getTitle());
                compliance = false;
            }
            if (t.getTeachers() != null && !t.getTeachers().isEmpty()) {
                Iterator it = t.getTeachers().iterator();
                Teacher tcs;
                while (it.hasNext()) {
                    tcs = (Teacher) it.next();
                    /*teacherDB = new TeacherDB(tcs);
                    teacherDB.loadById(lang,true); */
                    String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " + t.getTitle());
                    teacherConvert.checkTedCompliance(tcs, message);
                }
            }
            if (t.getInscriptionContacts() != null && !t.getInscriptionContacts().isEmpty()) {
                Iterator it = t.getInscriptionContacts().iterator();
                Contact contact;
                while (it.hasNext()) {
                    contact = (Contact) it.next();
                    /*contactDB = new ContactDB(contact);
                    contactDB.loadById(lang,true);  */
                    String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " + t.getTitle());
                    contactConvert.checkTedCompliance(contact, message);
                }
            }
            if (t.getTrainingContacts() != null && !t.getTrainingContacts().isEmpty()) {
                Iterator it = t.getTrainingContacts().iterator();
                Contact contact;
                while (it.hasNext()) {
                    contact = (Contact) it.next();
                    /*contactDB = new ContactDB(contact);
                    contactDB.loadById(lang,true);     */
                    String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " + t.getTitle());
                    contactConvert.checkTedCompliance(contact, message);
                }
            }
            if (t.getCatalogues() != null && !t.getCatalogues().isEmpty()) {
                Iterator it = t.getCatalogues().iterator();
                Catalogue cat;
                while (it.hasNext()) {
                    cat = (Catalogue) it.next();
                    /*catalogueDB = new CatalogueDB(cat);
                    catalogueDB.loadById(lang,true);*/
                    String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " + t.getTitle());
                    catConvert.checkTedCompliance(cat, message);
                }
            }
            if (t.getLocations() != null && !t.getLocations().isEmpty()) {

                Iterator it = t.getLocations().iterator();
                Location loc;
                while (it.hasNext()) {
                    loc = (Location) it.next();
                    /*locDB = new LocationDB(loc);
                    locDB.loadById(lang,true);    */
                    String message = new String(labels.get("apostal.toma.tomatoted.trainingCourse.courseSession") + " " + t.getTitle());
                    locConvert.checkTedCompliance(loc, message);
                }
            }

        } else
            compliance = false;
        return compliance;
    }

    public TrainingCourseXML tomaToTed(TrainingCourse t, Language lang, boolean publishOrganismDetails, String catalogueFictif, boolean testDate, boolean syrecos, boolean addFirstCat) {

        int id = t.getIdTraining();
        Date toDay = new Date();
        String code = t.getCode();
        String title = t.getTitle();
        String comment = t.getComment();
        String certificatesOrDiplomas = t.getCertificatesOrDiplomas();
        String commentNotPublished = t.getCommentNotPublished();
        String courseMedia = t.getCourseMedia();
        String duration = t.getDuration();
        String evaluation = t.getEvaluation();
        String inscriptionConditions = t.getInscriptionConditions();
        String partnerShip = t.getPartnership();
        String price = t.getPrice();
        String priceComment = t.getPriceComment();
        String pedagogicalMethods = t.getPedagogicalMethods();
        Vector courseSessions = t.getCourseSessions();
        String payementFacilities = t.getPaymentFacilities();


        java.sql.Date beginValidityDate = t.getBeginValidityDate();
        java.sql.Date endValidityDate = t.getEndValidityDate();
        Level level = t.getLevel();
        ModeOfOrganization moo = t.getModeOfOrganization();
        DateXML dateTemp = new DateXML();


        TrainingCourseXML training = new TrainingCourseXML();

        training.setKey(String.valueOf(id));

        Organism organism = OrganismDB.getOrganism(lang, true);

        if (organism != null) {
            OrganismXML orgXML = orgConvert.tomaToTed(organism, publishOrganismDetails);
            if (orgXML != null)
                training.setOrganism(orgXML);
        } else {
            organism = new Organism();
            OrganismXML orgXML = orgConvert.tomaToTed(organism, publishOrganismDetails);
            if (orgXML != null)
                training.setOrganism(orgXML);
        }
        training.setModeOfOrganization(mooConvert.tomaToTed(moo, lang));

        if (code != null)
            training.setCode(code);
        if (title != null)
            training.setTitle(title);
        if (comment != null)
            training.setComment(comment);
        if (certificatesOrDiplomas != null)
            training.setCertificatesOrDiplomas(certificatesOrDiplomas);
        if (courseMedia != null)
            training.setCourseMedia(courseMedia);
        if (duration != null)
            training.setDuration(duration);
        if (evaluation != null)
            training.setEvaluation(evaluation);
        if (inscriptionConditions != null)
            training.setInscriptionConditions(inscriptionConditions);
        if (partnerShip != null)
            training.setPartnership(partnerShip);
        if (price != null)
            training.setPrice(price);
        if (priceComment != null)
            training.setPriceComment(priceComment);
        if (pedagogicalMethods != null)
            training.setPedagogicalMethods(pedagogicalMethods);
        if (beginValidityDate != null) {
            dateTemp = dateConvert.tomaToTed(beginValidityDate);
        } else {
            java.sql.Date toDaySql = new java.sql.Date(toDay.getTime());
            dateTemp = dateConvert.tomaToTed(toDaySql);
            t.setBeginValidityDate(toDaySql);
        }
        training.setBeginValidityDate(new BeginValidityDateXML(dateTemp.getDay(), dateTemp.getMonth(), dateTemp.getYear()));
        if (endValidityDate != null) {
            dateTemp = dateConvert.tomaToTed(endValidityDate);
        } else {
            Calendar now = Calendar.getInstance();
            now.roll(Calendar.YEAR, 2);
            java.sql.Date endValSql = new java.sql.Date(now.getTime().getTime());
            dateTemp = dateConvert.tomaToTed(endValSql);
            t.setEndValidityDate(endValSql);
        }
        training.setEndValidityDate(new EndValidityDateXML(dateTemp.getDay(), dateTemp.getMonth(), dateTemp.getYear()));
        //levelConvert.checkTedCompliance(level);
        training.setLevel(levelConvert.tomaToTed(level));
        if (payementFacilities != null)
            training.setPaymentFacilities(payementFacilities);

        if (courseSessions != null) {
            Iterator it = courseSessions.iterator();
            while (it.hasNext()) {
                CourseSession courseSession = (CourseSession) it.next();
                /*	csDB = new CourseSessionDB(courseSession);
                    csDB.loadById(lang,true);  */
                if ((testDate == false) || (!toDay.before(courseSession.getBeginValidityDate()) && !toDay.after(courseSession.getEndValidityDate()))) {
                    //if (csConvert.checkTedCompliance(courseSession,""))
                    training.addCourseSession(csConvert.tomaToTed(courseSession, t, lang));
                }
            }

        }

        this.addTeachers(training, t, lang);
        this.addPointsDealtWith(training, t);
        this.addAllPrerequies(training, t);
        this.setObjectivesTed(training, t);
        this.setContentDesc(training, t);
        this.addInscriptionContacts(training, t, lang);
        this.addContacts(training, t, lang);
        this.addCatalogues(training, t, catalogueFictif, lang, syrecos, addFirstCat);
        this.addAudiences(training, t);
        this.addLocations(training, t, lang);
        this.addLanguages(training, t, lang);
        this.addKeywords(training, t);
        this.addSlots(training, t);
        this.addDomains(training, t, lang);

        return training;
    }



    /*  public TrainingCourseXML tomaToTed(TrainingCourse t,Language lang,boolean publishOrganismDetails,String catalogueFictif,boolean testDate,boolean syrecos,boolean addFirstCat) {

          int id = t.getIdTraining();
          Date toDay = new Date();
          String code = t.getCode();
          String title = t.getTitle();
          String comment = t.getComment();
          String certificatesOrDiplomas = t.getCertificatesOrDiplomas();
          String commentNotPublished = t.getCommentNotPublished();
          String courseMedia = t.getCourseMedia();
          String duration = t.getDuration();
          String evaluation = t.getEvaluation();
          String inscriptionConditions = t.getInscriptionConditions();
          String partnerShip = t.getPartnership();
          String price = t.getPrice();
          String priceComment = t.getPriceComment();
          String pedagogicalMethods = t.getPedagogicalMethods();
          Vector courseSessions = t.getCourseSessions();
          String payementFacilities = t.getPaymentFacilities();


          java.sql.Date beginValidityDate = t.getBeginValidityDate();
          java.sql.Date endValidityDate = t.getEndValidityDate();
          Level level = t.getLevel();
          ModeOfOrganization moo = t.getModeOfOrganization();
          DateXML dateTemp = new DateXML();



          TrainingCourseXML training = new TrainingCourseXML();

          training.setKey(String.valueOf(id));

          Organism organism=OrganismDB.getOrganism(lang, true);

          if (organism!=null){
              OrganismXML orgXML = orgConvert.tomaToTed(organism,publishOrganismDetails);
              if(orgXML!=null)
                  training.setOrganism(orgXML);
          } else {
              organism = new Organism();
              OrganismXML orgXML = orgConvert.tomaToTed(organism,publishOrganismDetails);
              if(orgXML!=null)
                  training.setOrganism(orgXML);
          }
          training.setModeOfOrganization(mooConvert.tomaToTed(moo,lang));

          if (code!=null)
              training.setCode(code);
          if (title!=null)
              training.setTitle(title);
          if (comment!=null)
              training.setComment(comment);
          if (certificatesOrDiplomas!=null)
              training.setCertificatesOrDiplomas(certificatesOrDiplomas);
          if (courseMedia!=null)
              training.setCourseMedia(courseMedia);
          if (duration!=null)
              training.setDuration(duration);
          if (evaluation!=null)
              training.setEvaluation(evaluation);
          if (inscriptionConditions!=null)
              training.setInscriptionConditions(inscriptionConditions);
          if (partnerShip!=null)
              training.setPartnership(partnerShip);
          if (price!=null)
              training.setPrice(price);
          if (priceComment!=null)
              training.setPriceComment(priceComment);
          if (pedagogicalMethods!=null)
              training.setPedagogicalMethods(pedagogicalMethods);
          if (beginValidityDate!=null){
              dateTemp=dateConvert.tomaToTed(beginValidityDate);
          } else{
              java.sql.Date toDaySql = new java.sql.Date(toDay.getTime());
              dateTemp=dateConvert.tomaToTed(toDaySql);
              t.setBeginValidityDate(toDaySql);
          }
          training.setBeginValidityDate(new BeginValidityDateXML(dateTemp.getDay(),dateTemp.getMonth(),dateTemp.getYear()));
          if (endValidityDate!=null){
              dateTemp=dateConvert.tomaToTed(endValidityDate);
          } else {
              Calendar now = Calendar.getInstance();
              now.roll(Calendar.YEAR,2);
              java.sql.Date endValSql = new java.sql.Date(now.getTime().getTime());
              dateTemp = dateConvert.tomaToTed(endValSql);
              t.setEndValidityDate(endValSql);
          }
             training.setEndValidityDate(new EndValidityDateXML(dateTemp.getDay(),dateTemp.getMonth(),dateTemp.getYear()));
            //levelConvert.checkTedCompliance(level);
             training.setLevel(levelConvert.tomaToTed(level));
          if (payementFacilities!=null)
              training.setPaymentFacilities(payementFacilities);

          if (courseSessions!=null){
              Iterator it = courseSessions.iterator();
              while (it.hasNext()){
                  CourseSession courseSession = (CourseSession)it.next();
                  csDB = new CourseSessionDB(courseSession);
                  csDB.loadById(lang,true);
                  if ((testDate==false) || (!toDay.before(courseSession.getBeginValidityDate()) && !toDay.after(courseSession.getEndValidityDate()))){
                      //if (csConvert.checkTedCompliance(courseSession,""))
                      training.addCourseSession(csConvert.tomaToTed(courseSession,t,lang));
                  }
              }

          }

          this.addTeachers(training,t,lang);
          this.addPointsDealtWith(training,t);
          this.addAllPrerequies(training,t);
          this.setObjectivesTed(training,t);
          this.setContentDesc(training,t);
          this.addInscriptionContacts(training,t,lang);
          this.addContacts(training,t,lang);
          this.addCatalogues(training,t,catalogueFictif,lang,syrecos,addFirstCat);
            this.addAudiences(training,t);
          this.addLocations(training,t,lang);
          this.addLanguages(training,t,lang);
          this.addKeywords(training,t);
          this.addSlots(training,t);
          this.addDomains(training,t,lang);

          return training;
      }*/

    public TrainingCourse tedToToma(TrainingCourseXML t) {

        String code = t.getCode();
        String title = t.getTitle();
        String comment = t.getComment();
        String certificatesOrDiplomas = t.getCertificatesOrDiplomas();
        String courseMedia = t.getCourseMedia();
        String duration = t.getDuration();
        String evaluation = t.getEvaluation();
        String inscriptionConditions = t.getInscriptionConditions();
        String partnerShip = t.getPartnership();
        String price = t.getPrice();
        String priceComment = t.getPriceComment();
        String paymentFacilities = t.getPaymentFacilities();
        String pedagogicalMethods = t.getPedagogicalMethods();
        Vector courseSessions = t.getCourseSessions();
        LevelXML level = t.getLevel();
        ModeOfOrganizationXML moo = t.getModeOfOrganization();
        DateXML beginValidityDate = t.getBeginValidityDate();
        DateXML endValidityDate = t.getEndValidityDate();

        TrainingCourse training = new TrainingCourse();

        String key = t.getKey();
        if (key != null && !key.equals("")) {
            try {
                int id = Integer.parseInt(key);
                training.setIdTraining(id);
            } catch (java.lang.NumberFormatException ex) {
                TOMA.log(TOMA.SEVERE, "TrainingCourseConversion, key not a number: " + key);
            }
        }

        if (courseSessions != null) {
            Iterator it = courseSessions.iterator();
            Vector coursesToma = new Vector();
            while (it.hasNext()) {
                CourseSessionXML courseSession = (CourseSessionXML) it.next();
                coursesToma.add(csConvert.tedToToma(courseSession));
            }
            training.setCourseSessions(coursesToma);
        }

        if (moo != null)
            training.setModeOfOrganization(mooConvert.tedToToma(moo));
        if (level != null)
            training.setLevel(levelConvert.tedToToma(level));
        if (code != null)
            training.setCode(code);
        if (title != null)
            training.setTitle(title);
        if (comment != null)
            training.setComment(comment);
        if (certificatesOrDiplomas != null)
            training.setCertificatesOrDiplomas(certificatesOrDiplomas);
        if (courseMedia != null)
            training.setCourseMedia(courseMedia);
        if (duration != null)
            training.setDuration(duration);
        if (evaluation != null)
            training.setEvaluation(evaluation);
        if (inscriptionConditions != null)
            training.setInscriptionConditions(inscriptionConditions);
        if (partnerShip != null)
            training.setPartnership(partnerShip);
        if (price != null)
            training.setPrice(price);
        if (priceComment != null)
            training.setPriceComment(priceComment);
        if (paymentFacilities != null)
            training.setPaymentFacilities(paymentFacilities);
        if (pedagogicalMethods != null)
            training.setPedagogicalMethods(pedagogicalMethods);
        if (beginValidityDate != null)
            training.setBeginValidityDate(dateConvert.tedToToma(beginValidityDate));
        if (endValidityDate != null)
            training.setEndValidityDate(dateConvert.tedToToma(endValidityDate));


        this.addTeachersToma(t, training);
        this.addPointsDealtWithToma(t, training);
        this.addAllPrerequiesToma(t, training);
        this.setObjectivesToma(t, training);
        this.setContentDescToma(t, training);
        this.addInscriptionContactsToma(t, training);
        this.addContactsToma(t, training);
        this.addCataloguesToma(t, training);
        this.addAudiencesToma(t, training);
        this.addLocationsToma(t, training);
        this.addLanguagesToma(t, training);
        this.addKeywordsToma(t, training);
        this.addSlotsToma(t, training);
        this.addDomainsToma(t, training);

        return training;

    }
}
