// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import apostal.toma.TOMA;
import apostal.toma.data.TOMALabels;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class AboutView extends JDialog implements ActionListener {

    private JPanel panel;

    private TOMAButton ok;
    private String label_ok;
    private TOMALabel infos;
    private TOMALabel applicationTitle;
    private TOMALabel version;
    private TOMALabels labels;


    public AboutView(String title) {
        //super(TOMA.getInstance().getTomaView(), labels.get("apostal.toma.aboutview.title"), true);
        super(TOMA.getInstance().getTomaView(), title, true);
        labels = new TOMALabels();

        infos = new TOMALabel();
        infos.setTextWithLowerCase(TOMAFonts.htmlBegin + labels.get("apostal.toma.aboutview.infos") + TOMAFonts.htmlEnd);
        applicationTitle = new TOMALabel();
        applicationTitle.setText(TOMAFonts.htmlBegin + labels.get("apostal.toma.aboutview.application_title") + TOMAFonts.htmlEnd);
        version = new TOMALabel();
        version.setText(TOMAFonts.htmlBegin + labels.get("apostal.toma.aboutview.application_version") + TOMAFonts.htmlEnd);

        label_ok = new String("ok");
        ok = new TOMAButton(label_ok);
        ok.setActionCommand("choose_ok");
        ok.addActionListener(this);

        panel = new JPanel();
        panel.setLayout(new GridBagLayout());


        panel.add(applicationTitle, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
        panel.add(version, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
        panel.add(infos, new GridBagConstraints(0, 3, 1, 1, 1.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));

        panel.add(ok, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        this.setBackground(TOMAColors.tomaBackgroundColor);
        panel.setBackground(TOMAColors.tomaBackgroundColor);

        this.getContentPane().add(panel);


    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        if (cmd.equals("choose_ok"))
            this.dispose();
    }


    public void center() {
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = this.getSize();
        this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    }
}
