// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.view;

/**
 * Training Course: duplicate
 */

import apostal.toma.data.TrainingCourse;
import apostal.toma.viewcontrol.TrainingEventHandler;

import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionListener;

public class CopyTrainingIntoUnit extends TOMACreate {

    private TrainingCourse tc;

    private JLabel label_code;
    private JLabel label_title;
    protected JTextField code;
    protected JTextField title;

    public CopyTrainingIntoUnit(ActionListener handler, TrainingCourse tc, TOMAFrame parent) {
        super(parent);
        this.setMessage(labels.get("apostal.toma.trainingview.duplicate.message"));
        this.setTitle(labels.get("apostal.toma.trainingview.duplicate.title"));

        this.tc = tc;

        //remplir questions
        questions.setLayout(new GridBagLayout());

        label_code = new JLabel(labels.get("apostal.toma.trainingview.duplicate.question.code"));
        questions.add(label_code, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        code = new JTextField();
        code.setColumns(20);
        questions.add(code, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        label_title = new JLabel(labels.get("apostal.toma.trainingview.duplicate.question.title"));
        questions.add(label_title, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        title = new JTextField();
        title.setColumns(20);
        title.setText(tc.getTitle());
        questions.add(title, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        ok.addActionListener(handler);
        ok.setActionCommand("copy_code_ok");
    }

    public Object getData() {
        TrainingCourse t = (TrainingCourse) tc.duplicate();
        t.setTitle(title.getText());
        t.setCode(code.getText());

        //pour pouvoir rcuprer l'id
        t.setIdTraining(tc.getIdTraining());

        return t;
    }

}
