// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */


package apostal.toma.view;


import toolbox.swing.LimitedNumericDocument;


import apostal.toma.TOMA;

import apostal.toma.data.*;

import apostal.toma.database.LanguageDB;

import apostal.toma.view.TOMAMultipleElementsList;

import apostal.toma.view.TOMAMultipleElements;

import apostal.toma.view.SeancePanel;

import apostal.toma.view.TrainingView;

import apostal.toma.viewcontrol.CourseSessionEventHandler;


import toolbox.swing.MultipleLinesLabel;


import java.lang.Class;

import java.awt.*;

import javax.swing.*;

import javax.swing.border.LineBorder;

import javax.swing.event.ListSelectionEvent;

import javax.swing.event.ListSelectionListener;


import java.lang.Integer;

import java.util.GregorianCalendar;

import java.util.Calendar;

import java.util.Vector;

import java.util.Iterator;

import java.sql.Date;


public class CourseSessionView extends CourseUnitSessionView {

    public CourseSessionView(CourseSessionEventHandler handler) {

        super(TOMATemplateView.COURSESESSIONVIEW, handler, handler);


        this.setTitle(labels.get("apostal.toma.coursesessionview.title"));


    }


    public void sessionSelected() {
        //mettre dans le tableau les anciennes valeurs
        session = this.getData();

        CourseSession s = (CourseSession) list_sessions.getSelectedValue();
        if (s != null) {
            this.setSessionData(s);
            deleteSession.setEnabled(true);
        }
    }


    /**

     * get the data of the current session

     */

    public CourseSession getData() {

        CourseSession s = (CourseSession) session;

        //CourseSession s=new CourseSession(idSession);

        if (s == null) {

            s = new CourseSession();

            TOMA.log(TOMA.INFO, "the course session wasn't chosen when there was a getData() operation");

        }


        if (!nameComponent.getClass().getName().equals("javax.swing.JComboBox"))

            s.setSessionName(name.getText());

        else {

            try {

                s.setSessionName((String) ((JComboBox) nameComponent).getSelectedItem());

            } catch (java.lang.ClassCastException exception) {
                s.setSessionName(null);
            }

        }


        if (!textualCalendarComponent.getClass().getName().equals("javax.swing.JComboBox"))

            s.setTextualCalendar(textualCalendar.getText());

        else {

            try {

                s.setTextualCalendar((String) ((JComboBox) textualCalendarComponent).getSelectedItem());

            } catch (java.lang.ClassCastException exception) {
                s.setTextualCalendar(null);
            }

        }


        if (!priceComponent.getClass().getName().equals("javax.swing.JComboBox"))

            s.setPrice(price.getText());

        else {

            try {

                s.setPrice((String) ((JComboBox) priceComponent).getSelectedItem());

            } catch (java.lang.ClassCastException exception) {
                s.setPrice(null);
            }

        }


        if (!priceCommentComponent.getClass().getName().equals("javax.swing.JComboBox"))

            s.setPriceComment(priceComment.getText());

        else {

            try {

                s.setPriceComment((String) ((JComboBox) priceCommentComponent).getSelectedItem());

            } catch (java.lang.ClassCastException exception) {
                s.setPriceComment(null);
            }

        }


        if (!commentComponent.getClass().getName().equals("javax.swing.JComboBox"))

            s.setComment(comment.getText());

        else {

            try {

                s.setComment((String) ((JComboBox) commentComponent).getSelectedItem());

            } catch (java.lang.ClassCastException exception) {
                s.setComment(null);
            }

        }


        try {

            Language l = (Language) languages.getSelectedItem();

            if (l != null)

                s.setLanguage(l);

        } catch (java.lang.ClassCastException exception) {
            s.setLanguage(null);
        }


        try {

            Location loc = (Location) locations.getSelectedItem();

            if (loc != null)

                s.setLocation(loc);

        } catch (java.lang.ClassCastException ex) {

            TOMA.log(TOMA.INFO, "course session: no location specified");

            s.setLocation(null);

        }


        Slot slot = (Slot) slotsList.getSelectedItem();

        if (slot != null)

            s.setSlot(slot);


        Vector teachers = teachersList.getChosenData();

        if (teachers != null)

            s.setTeachers(teachers);



        //beginValidityDate

        String begin_day = beginValidityDay.getText();

        String begin_month = beginValidityMonth.getText();

        String begin_year = beginValidityYear.getText();


        if (begin_day != null && !begin_day.equals("")

                && begin_month != null && !begin_month.equals("")

                && begin_year != null && !begin_year.equals("")) {

            try {

                int d = Integer.parseInt(begin_day);

                int m = Integer.parseInt(begin_month);

                int y = Integer.parseInt(begin_year);


                GregorianCalendar beginCal = new GregorianCalendar(y, m - 1, d);

                Date beginValidityDate = new Date(beginCal.getTime().getTime());

                s.setBeginValidityDate(beginValidityDate);

            } catch (java.lang.NumberFormatException ex) {

                TOMA.log(TOMA.SEVERE, "incorrect beginValidityDate");

            }

        } else

            s.setBeginValidityDate(null);



        //endValidityDate

        String end_day = endValidityDay.getText();

        String end_month = endValidityMonth.getText();

        String end_year = endValidityYear.getText();

        if (end_day != null && !end_day.equals("")

                && end_month != null && !end_month.equals("")

                && end_year != null && !end_year.equals("")) {

            try {

                int d = Integer.parseInt(end_day);

                int m = Integer.parseInt(end_month);

                int y = Integer.parseInt(end_year);


                GregorianCalendar endCal = new GregorianCalendar(y, m - 1, d);

                Date endValidityDate = new Date(endCal.getTime().getTime());

                s.setEndValidityDate(endValidityDate);

            } catch (java.lang.NumberFormatException ex) {

                TOMA.log(TOMA.SEVERE, "incorrect endValidityDate");

            }

        } else

            s.setEndValidityDate(null);



        //beginDate

        String begin_interval_day = beginIntervalDay.getText();

        String begin_interval_month = beginIntervalMonth.getText();

        String begin_interval_year = beginIntervalYear.getText();

        if (begin_interval_day != null && !begin_interval_day.equals("")

                && begin_interval_month != null && !begin_interval_month.equals("")

                && begin_interval_year != null && !begin_interval_year.equals("")) {

            try {

                int d = Integer.parseInt(begin_interval_day);

                int m = Integer.parseInt(begin_interval_month);

                int y = Integer.parseInt(begin_interval_year);


                GregorianCalendar beginCal = new GregorianCalendar(y, m - 1, d);

                Date beginIntervalDate = new Date(beginCal.getTime().getTime());

                s.setBeginDate(beginIntervalDate);

            } catch (java.lang.NumberFormatException ex) {

                TOMA.log(TOMA.SEVERE, "incorrect beginIntervalDate");

            }

        } else

            s.setBeginDate(null);



        //endValidityDate

        String end_interval_day = endIntervalDay.getText();

        String end_interval_month = endIntervalMonth.getText();

        String end_interval_year = endIntervalYear.getText();

        if (end_interval_day != null && !end_interval_day.equals("")

                && end_interval_month != null && !end_interval_month.equals("")

                && end_interval_year != null && !end_interval_year.equals("")) {

            try {

                int d = Integer.parseInt(end_interval_day);

                int m = Integer.parseInt(end_interval_month);

                int y = Integer.parseInt(end_interval_year);


                GregorianCalendar endCal = new GregorianCalendar(y, m - 1, d);

                Date endIntervalDate = new Date(endCal.getTime().getTime());

                s.setEndDate(endIntervalDate);

            } catch (java.lang.NumberFormatException ex) {

                TOMA.log(TOMA.SEVERE, "incorrect endIntervalDate");

            }

        } else

            s.setEndDate(null);



        //seances

        JComponent[] comboSeances = seances.getElements();

        int size = comboSeances.length;

        Vector ss = new Vector();

        for (int i = 0; i < size; i++) {

            SeancePanel panel = (SeancePanel) comboSeances[i];

            Seance seance = panel.getData();

            if (!ss.contains(seance)) //test par "equals"

                ss.add(seance);

        }

        s.setSeances(ss);


        return s;

    }


    public void setData(TrainingCourse tc) {

        int type = TOMATemplateView.COURSESESSIONVIEW;



        //tableau de sessions

        sessions = tc.getCourseSessions();

        if (sessions != null)

            list_sessions.setListData(sessions);



        //languages

        TOMATemplateResult languageResult = TOMATemplateView.getTemplateResult(type, "language");

        Vector values = languageResult.getValues();


        tc_languages = tc.getLanguages();

        allowed_languages = new Vector();


        languages.addItem(ElementNotSpecified.getInstance());

        languages.setSelectedItem(ElementNotSpecified.getInstance());


        if (tc_languages != null) {

            Iterator iter = tc_languages.iterator();

            while (iter.hasNext()) {

                Language l = (Language) iter.next();


                if (l != null) {


                    if (values != null && !values.isEmpty()) {

                        //tester s'il est dans values

                        String code = l.getCode();

                        if (code != null) {

                            boolean found = false;

                            Iterator iter2 = values.iterator();

                            while (iter2.hasNext()) {

                                String values_code = (String) iter2.next();

                                if (code.equals(values_code))

                                    found = true;

                            }

                            if (found) {

                                languages.addItem(l);

                                allowed_languages.add(l);

                            }

                        }

                    } else {

                        languages.addItem(l);

                        allowed_languages.add(l);

                    }

                }

            }

        }



        //locations

        locations.addItem(ElementNotSpecified.getInstance());

        tc_locations = tc.getLocations();

        if (tc_locations != null) {

            Iterator iter = tc_locations.iterator();

            while (iter.hasNext()) {

                Location l = (Location) iter.next();

                locations.addItem(l);

            }

        }



        //slots

        TOMATemplateResult slotResult = TOMATemplateView.getTemplateResult(type, "slot");

        Vector slotValues = slotResult.getValues();


        tc_slots = tc.getSlots();

        allowed_slots = new Vector();


        if (tc_slots != null) {

            Iterator iter = tc_slots.iterator();

            while (iter.hasNext()) {

                Slot s = (Slot) iter.next();


                if (s != null) {


                    if (slotValues != null && !slotValues.isEmpty()) {

                        //tester s'il est dans values

                        String value = s.getValue();

                        if (value != null) {

                            boolean found = false;

                            Iterator iter2 = slotValues.iterator();

                            while (iter2.hasNext()) {

                                String values_value = (String) iter2.next();

                                if (value.equals(values_value))

                                    found = true;

                            }

                            if (found) {

                                slotsList.addItem(s);

                                allowed_slots.add(s);

                            }

                        }

                    } else {

                        slotsList.addItem(s);

                        allowed_slots.add(s);

                    }

                }

            }

        }



        //teachers

        tc_teachers = tc.getTeachers();

        if (tc_teachers != null) {

            teachersList.setExistingData(tc_teachers);

        }


        this.setEnabled(false);

    }


    /**

     * called when a session is selected

     */

    public void setSessionData(CourseSession session) {

        this.session = session;


        if (!nameComponent.getClass().getName().equals("javax.swing.JComboBox"))

            name.setText(session.getSessionName());

        else

            TOMATemplateView.setTextCombo(session.getSessionName(), (JComboBox) nameComponent);


        if (!textualCalendarComponent.getClass().getName().equals("javax.swing.JComboBox"))

            textualCalendar.setText(session.getTextualCalendar());

        else

            TOMATemplateView.setTextCombo(session.getTextualCalendar(), (JComboBox) textualCalendarComponent);


        if (!priceComponent.getClass().getName().equals("javax.swing.JComboBox"))

            price.setText(session.getPrice());

        else

            TOMATemplateView.setTextCombo(session.getPrice(), (JComboBox) priceComponent);


        if (!priceCommentComponent.getClass().getName().equals("javax.swing.JComboBox"))

            priceComment.setText(session.getPriceComment());

        else

            TOMATemplateView.setTextCombo(session.getPriceComment(), (JComboBox) priceCommentComponent);


        if (!commentComponent.getClass().getName().equals("javax.swing.JComboBox"))

            comment.setText(session.getComment());

        else

            TOMATemplateView.setTextCombo(session.getComment(), (JComboBox) commentComponent);



        //languages

        Language lng = session.getLanguage();

        if (lng != null) {

            if (tc_languages != null) {

                Iterator iter = tc_languages.iterator();

                while (iter.hasNext()) {

                    Language l = (Language) iter.next();


                    if (lng.getCode().equals(l.getCode())) {

                        if (!allowed_languages.contains(l)) {

                            allowed_languages.add(l);

                            languages.addItem(l);

                        }

                        languages.setSelectedItem(l);

                    }

                }

            }

        } else

            languages.setSelectedItem(ElementNotSpecified.getInstance());



        //locations

        Location loc = session.getLocation();

        if (loc != null) {

            if (tc_locations != null) {

                Iterator iter = tc_locations.iterator();

                while (iter.hasNext()) {

                    Location l = (Location) iter.next();

                    if (loc.getDenomination().equals(l.getDenomination()))

                        locations.setSelectedItem(l);

                }

            }

        } else if (locations.getItemCount() > 0)

            locations.setSelectedIndex(0);



        //slots

        Slot slot = session.getSlot();

        if (slot != null) {

            if (tc_slots != null) {

                Iterator iter = tc_slots.iterator();

                while (iter.hasNext()) {

                    Slot s = (Slot) iter.next();

                    if (slot != null && s.getValue().equals(slot.getValue())) {

                        if (!allowed_slots.contains(s)) {

                            allowed_slots.add(s);

                            slotsList.addItem(s);

                        }

                        slotsList.setSelectedItem(s);

                    }

                }

            }

        } else if (slotsList.getItemCount() > 0)

            slotsList.setSelectedIndex(0);



        //teachers

        Vector ts = session.getTeachers();

        Vector realTeachers = new Vector();

        //les retrouver dans tc_teachers

        if (tc_teachers != null && ts != null) {

            Iterator iter_ts = ts.iterator();

            while (iter_ts.hasNext()) {

                Teacher t1 = (Teacher) iter_ts.next();

                if (t1 != null) {

                    int id = t1.getIdTeacher();


                    Teacher t_found = null;

                    Iterator iter_tct = tc_teachers.iterator();

                    while (iter_tct.hasNext() && t_found == null) {

                        Teacher t2 = (Teacher) iter_tct.next();

                        if (t2 != null && t2.getIdTeacher() == id)

                            t_found = t2;

                    }

                    if (t_found != null)

                        realTeachers.add(t_found);

                    else

                        realTeachers.add(t1);

                }


            }

        }

        teachersList.setChosenData(realTeachers);

        /*if(ts!=null)

      teachersList.setChosenData(ts);

        else

      teachersList.setChosenData(new Vector());*/



        TOMATemplateResult teachersResult = TOMATemplateView.getTemplateResult(type, "teacher");

        if (teachersResult.isForbidden())

            teachersList.setEnabled(false);



        //seances

        Vector se = session.getSeances();

        if (se != null) {

            Vector s = new Vector();

            Iterator iter = se.iterator();

            while (iter.hasNext()) {

                Seance seance = (Seance) iter.next();

                SeancePanel panel = new SeancePanel();

                panel.setData(seance);

                s.add(panel);

            }

            seances.setElements(s);

        } else

            seances.setElements(new Vector());


        TOMATemplateResult seancesResult = TOMATemplateView.getTemplateResult(type, "seance");

        if (seancesResult.isForbidden())

            seances.setEnabled(false);



        //dates

        Date creation = session.getDateCreation();

        Date maj = session.getDateMaj();

        dates.setTextWithLowerCase(labels.get("apostal.toma.trainingview.dateCreation") + creation + " " + labels.get("apostal.toma.trainingview.dateMaj") + maj);



        //beginValidityDate

        Date bvd = session.getBeginValidityDate();

        if (bvd != null) {

            GregorianCalendar beginCal = new GregorianCalendar();

            beginCal.setTime(bvd);

            int beginDay = beginCal.get(Calendar.DAY_OF_MONTH);

            int beginMonth = beginCal.get(Calendar.MONTH) + 1;

            int beginYear = beginCal.get(Calendar.YEAR);

            beginValidityDay.setText((new Integer(beginDay)).toString());

            beginValidityMonth.setText((new Integer(beginMonth)).toString());

            beginValidityYear.setText((new Integer(beginYear)).toString());

        } else {

            beginValidityDay.setText("");

            beginValidityMonth.setText("");

            beginValidityYear.setText("");

        }



        //endValidityDate

        Date evd = session.getEndValidityDate();

        if (evd != null) {

            GregorianCalendar endCal = new GregorianCalendar();

            endCal.setTime(evd);

            int endDay = endCal.get(Calendar.DAY_OF_MONTH);

            int endMonth = endCal.get(Calendar.MONTH) + 1;

            int endYear = endCal.get(Calendar.YEAR);

            endValidityDay.setText((new Integer(endDay)).toString());

            endValidityMonth.setText((new Integer(endMonth)).toString());

            endValidityYear.setText((new Integer(endYear)).toString());

        } else {

            endValidityDay.setText("");

            endValidityMonth.setText("");

            endValidityYear.setText("");

        }



        //beginIntervalDate

        Date bid = session.getBeginDate();

        if (bid != null) {

            GregorianCalendar beginCal = new GregorianCalendar();

            beginCal.setTime(bid);

            int beginDay = beginCal.get(Calendar.DAY_OF_MONTH);

            int beginMonth = beginCal.get(Calendar.MONTH) + 1;

            int beginYear = beginCal.get(Calendar.YEAR);

            beginIntervalDay.setText((new Integer(beginDay)).toString());

            beginIntervalMonth.setText((new Integer(beginMonth)).toString());

            beginIntervalYear.setText((new Integer(beginYear)).toString());

        } else {

            beginIntervalDay.setText("");

            beginIntervalMonth.setText("");

            beginIntervalYear.setText("");

        }



        //endIntervalDate

        Date eid = session.getEndDate();

        if (eid != null) {

            GregorianCalendar endCal = new GregorianCalendar();

            endCal.setTime(eid);

            int endDay = endCal.get(Calendar.DAY_OF_MONTH);

            int endMonth = endCal.get(Calendar.MONTH) + 1;

            int endYear = endCal.get(Calendar.YEAR);

            endIntervalDay.setText((new Integer(endDay)).toString());

            endIntervalMonth.setText((new Integer(endMonth)).toString());

            endIntervalYear.setText((new Integer(endYear)).toString());

        } else {

            endIntervalDay.setText("");

            endIntervalMonth.setText("");

            endIntervalYear.setText("");

        }


        this.pack();

    }


    public void addSeancesConsec(Vector seancesConsec) {
        Vector newSeances = new Vector();
        JComponent[] components = seances.getElements();
        if (components != null) {
            int size = components.length;
            for (int i = 0; i < size; i++) {
                SeancePanel panel = (SeancePanel) components[i];
                newSeances.add(panel);
            }
        }
        if (seancesConsec != null) {
            Iterator it = seancesConsec.iterator();
            while (it.hasNext()) {
                Seance seanceTemp = (Seance) it.next();
                SeancePanel paneSeance = new SeancePanel();
                paneSeance.setData(seanceTemp);
                newSeances.add(paneSeance);
            }
        }
        seances.setElements(newSeances);
    }

    public String testTemplateElements() {

        int type = TOMATemplateView.COURSESESSIONVIEW;

        CourseSession s = this.getData();


        String msg = "";


        String msg_name = TOMATemplateView.testTemplateElement(type, "sessionName", s.getSessionName(), labels.get("apostal.toma.sessionview.name"));

        if (msg_name != null)

            msg = msg + "\n" + msg_name;


        String msg_seance = TOMATemplateView.testTemplateElement(type, "seance", s.getSeances(), labels.get("apostal.toma.sessionview.seances"));

        if (msg_seance != null)

            msg = msg + "\n" + msg_seance;


        String msg_textcal = TOMATemplateView.testTemplateElement(type, "textualCalendar", s.getTextualCalendar(), labels.get("apostal.toma.sessionview.textualCalendar"));

        if (msg_textcal != null)

            msg = msg + "\n" + msg_textcal;


        String msg_lng = TOMATemplateView.testTemplateElement(type, "language", s.getLanguage(), labels.get("apostal.toma.sessionview.language"));

        if (msg_lng != null)

            msg = msg + "\n" + msg_lng;


        String msg_price = TOMATemplateView.testTemplateElement(type, "price", s.getPrice(), labels.get("apostal.toma.sessionview.price"));

        if (msg_price != null)

            msg = msg + "\n" + msg_price;


        String msg_priceComment = TOMATemplateView.testTemplateElement(type, "priceComment", s.getPriceComment(), labels.get("apostal.toma.sessionview.priceComment"));

        if (msg_priceComment != null)

            msg = msg + "\n" + msg_priceComment;


        String msg_location = TOMATemplateView.testTemplateElement(type, "location", s.getLocation(), labels.get("apostal.toma.sessionview.location"));

        if (msg_location != null)

            msg = msg + "\n" + msg_location;


        String msg_slot = TOMATemplateView.testTemplateElement(type, "slot", s.getSlot(), labels.get("apostal.toma.sessionview.slot"));

        if (msg_slot != null)

            msg = msg + "\n" + msg_slot;


        String msg_te = TOMATemplateView.testTemplateElement(type, "teacher", s.getTeachers(), labels.get("apostal.toma.sessionview.teachers"));

        if (msg_te != null)

            msg = msg + "\n" + msg_te;


        String msg_comment = TOMATemplateView.testTemplateElement(type, "comment", s.getComment(), labels.get("apostal.toma.sessionview.comment"));

        if (msg_comment != null)

            msg = msg + "\n" + msg_comment;


        return msg;

    }


}

