// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.view;

import toolbox.swing.LimitedNumericDocument;

import apostal.toma.TOMA;
import apostal.toma.data.*;
import apostal.toma.view.TOMAMultipleElementsList;
import apostal.toma.view.TOMAMultipleElements;
import apostal.toma.view.SeancePanel;
import apostal.toma.view.TrainingView;
import apostal.toma.viewcontrol.SessionEventHandler;

import toolbox.swing.MultipleLinesLabel;

import java.lang.Class;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.WindowListener;
import javax.swing.*;
import javax.swing.border.LineBorder;

import java.lang.Integer;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.util.Vector;
import java.util.Iterator;
import java.sql.Date;

public abstract class CourseUnitSessionView extends SessionView {
    protected static final int labels_length = 25;

    protected Vector tc_languages;
    protected Vector tc_locations;
    protected Vector tc_slots;
    protected Vector tc_teachers;
    protected Vector allowed_languages;
    protected Vector allowed_slots;
    protected TOMALabels labels;

    protected int type;

    //data
    protected Vector sessions;
    protected Session session;

    GridBagLayout gridBagLayout1 = new GridBagLayout();
    TOMAMultipleLinesLabel label_name = new TOMAMultipleLinesLabel(labels_length);
    TOMATextField name = new TOMATextField(30);
    JComponent nameComponent;

    TOMAMultipleLinesLabel label_beginValidityDates = new TOMAMultipleLinesLabel(labels_length);
    TOMAMultipleLinesLabel label_endValidityDates = new TOMAMultipleLinesLabel(labels_length);
    TOMAMultipleLinesLabel label_language = new TOMAMultipleLinesLabel(labels_length);
    TOMAComboBox languages = new TOMAComboBox();
    TOMAMultipleLinesLabel label_textualCalendar = new TOMAMultipleLinesLabel(labels_length);
    TOMATextArea textualCalendar = new TOMATextArea(3, 30);
    JComponent textualCalendarComponent;

    TOMAMultipleLinesLabel label_dateIntervalBegin = new TOMAMultipleLinesLabel(labels_length);
    TOMAMultipleLinesLabel label_price = new TOMAMultipleLinesLabel(labels_length);
    TOMATextArea price = new TOMATextArea(3, 30);
    JComponent priceComponent;

    TOMAMultipleLinesLabel label_priceComment = new TOMAMultipleLinesLabel(labels_length);
    TOMATextArea priceComment = new TOMATextArea(3, 30);
    JComponent priceCommentComponent;

    TOMAMultipleLinesLabel label_comment = new TOMAMultipleLinesLabel(labels_length);
    TOMATextArea comment = new TOMATextArea(3, 30);
    JComponent commentComponent;

    TOMAMultipleLinesLabel label_locations = new TOMAMultipleLinesLabel(labels_length);
    TOMAComboBox locations = new TOMAComboBox();
    TOMAMultipleLinesLabel label_slot = new TOMAMultipleLinesLabel(labels_length);

    JPanel top = new JPanel();
    JPanel main = new JPanel();
    GridBagLayout gridBagLayout2 = new GridBagLayout();
    GridBagLayout gridBagLayout3 = new GridBagLayout();
    TOMALabel label_sessionsList = new TOMALabel();
    TOMALabel label_sessionContent = new TOMALabel();
    JList list_sessions = new JList();
    TOMAButton newSession = new TOMAButton();
    TOMAButton deleteSession = new TOMAButton();
    TOMALabel label_teachers = new TOMALabel();
    TOMAMultipleElementsList teachersList;

    TOMAMultipleLinesLabel label_seances = new TOMAMultipleLinesLabel(labels_length);
    TOMAMultipleElements seances;

    TOMALabel dates = new TOMALabel();
    TOMAButton save = new TOMAButton();
    TOMAButton addConsSeances = new TOMAButton();
    TOMAMultipleLinesLabel label_dateIntervalEnd = new TOMAMultipleLinesLabel(labels_length);
    JPanel beginValidityDates = new JPanel();
    GridBagLayout gridBagLayout4 = new GridBagLayout();
    JPanel endValidityDates = new JPanel();
    GridBagLayout gridBagLayout5 = new GridBagLayout();
    JPanel beginDateInterval = new JPanel();
    GridBagLayout gridBagLayout6 = new GridBagLayout();
    JPanel endDateInterval = new JPanel();
    TOMATextField beginValidityDay = new TOMATextField(2);
    TOMATextField beginValidityMonth = new TOMATextField(2);
    TOMATextField beginValidityYear = new TOMATextField(4);
    TOMATextField endValidityDay = new TOMATextField(2);
    TOMATextField endValidityMonth = new TOMATextField(2);
    TOMATextField endValidityYear = new TOMATextField(4);
    GridBagLayout gridBagLayout7 = new GridBagLayout();
    TOMATextField beginIntervalDay = new TOMATextField(2);
    TOMATextField beginIntervalMonth = new TOMATextField(2);
    TOMATextField beginIntervalYear = new TOMATextField(4);
    TOMATextField endIntervalDay = new TOMATextField(2);
    TOMATextField endIntervalMonth = new TOMATextField(2);
    TOMATextField endIntervalYear = new TOMATextField(4);

    TOMAComboBox slotsList = new TOMAComboBox();

    public CourseUnitSessionView(int type, ActionListener listener, WindowListener wlistener) {
        try {
            labels = new TOMALabels();
            this.type = type;
            jbInit(listener, wlistener);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit(ActionListener listener, WindowListener wlistener) throws Exception {
        this.addWindowListener(wlistener);

        //name
        label_name.setText(labels.get("apostal.toma.sessionview.name"));

        TOMATemplateResult nameResult = TOMATemplateView.getTemplateResult(type, "sessionName");
        if (nameResult.getMaximum() > -1)
            label_name.setText(label_name.getText() + " (" + new Integer(nameResult.getMaximum()) + ")");
        if (nameResult.getValues() != null && !nameResult.getValues().isEmpty()) {
            Vector v = nameResult.getValues();
            TOMAComboBox nameCombo = new TOMAComboBox(v);
            nameComponent = nameCombo;
        } else
            nameComponent = name;

        //validity dates
        label_beginValidityDates.setText(labels.get("apostal.toma.sessionview.beginValidityDate"));
        label_endValidityDates.setText(labels.get("apostal.toma.sessionview.endValidityDate"));
        beginValidityDates.setLayout(gridBagLayout4);
        endValidityDates.setLayout(gridBagLayout5);

        //language
        label_language.setText(labels.get("apostal.toma.sessionview.language"));
        TOMATemplateResult languageResult = TOMATemplateView.getTemplateResult(type, "language");
        if (languageResult.isMandatory())
            label_language.setText(label_language.getText() + " (*)");
        if (languageResult.isForbidden())
            languages.setEnabled(false);

        //textual Calendar
        label_textualCalendar.setText(labels.get("apostal.toma.sessionview.textualCalendar"));

        JScrollPane textualCalendarPane = new JScrollPane();
        textualCalendarPane.getViewport().add(textualCalendar);
        TOMATemplateResult textualCalendarResult = TOMATemplateView.getTemplateResult(type, "textualCalendar");
        if (textualCalendarResult.isForbidden())
            textualCalendar.setEnabled(false);
        if (textualCalendarResult.isMandatory())
            label_textualCalendar.setText(label_textualCalendar.getText() + " (*)");
        if (textualCalendarResult.getMaximum() > -1)
            label_textualCalendar.setText(label_textualCalendar.getText() + " (" + new Integer(textualCalendarResult.getMaximum()) + ")");
        if (textualCalendarResult.getValues() != null && !textualCalendarResult.getValues().isEmpty()) {
            Vector v = textualCalendarResult.getValues();
            v.insertElementAt(ElementNotSpecified.getInstance(), 0);
            TOMAComboBox textualCalendarCombo = new TOMAComboBox(v);
            textualCalendarComponent = textualCalendarCombo;
        } else
            textualCalendarComponent = textualCalendarPane;

        //date interval
        label_dateIntervalBegin.setText(labels.get("apostal.toma.sessionview.dateBegin"));
        label_dateIntervalEnd.setText(labels.get("apostal.toma.sessionview.dateEnd"));
        beginDateInterval.setLayout(gridBagLayout6);
        endDateInterval.setLayout(gridBagLayout7);

        //price
        label_price.setText(labels.get("apostal.toma.sessionview.price"));

        JScrollPane pricePane = new JScrollPane();
        pricePane.getViewport().add(price);
        TOMATemplateResult priceResult = TOMATemplateView.getTemplateResult(type, "price");
        if (priceResult.isForbidden())
            price.setEnabled(false);
        if (priceResult.isMandatory())
            label_price.setText(label_price.getText() + " (*)");
        if (priceResult.getMaximum() > -1)
            label_price.setText(label_price.getText() + " (" + new Integer(priceResult.getMaximum()) + ")");
        if (priceResult.getValues() != null && !priceResult.getValues().isEmpty()) {
            Vector v = priceResult.getValues();
            v.insertElementAt(ElementNotSpecified.getInstance(), 0);
            TOMAComboBox priceCombo = new TOMAComboBox(v);
            priceComponent = priceCombo;
        } else
            priceComponent = pricePane;

        //priceComment
        label_priceComment.setText(labels.get("apostal.toma.sessionview.priceComment"));

        JScrollPane priceCommentPane = new JScrollPane();
        priceCommentPane.getViewport().add(priceComment);
        TOMATemplateResult priceCommentResult = TOMATemplateView.getTemplateResult(type, "priceComment");
        if (priceCommentResult.isForbidden())
            priceComment.setEnabled(false);
        if (priceCommentResult.isMandatory())
            label_priceComment.setText(label_priceComment.getText() + " (*)");
        if (priceCommentResult.getMaximum() > -1)
            label_priceComment.setText(label_priceComment.getText() + " (" + new Integer(priceCommentResult.getMaximum()) + ")");
        if (priceCommentResult.getValues() != null && !priceCommentResult.getValues().isEmpty()) {
            Vector v = priceCommentResult.getValues();
            v.insertElementAt(ElementNotSpecified.getInstance(), 0);
            TOMAComboBox priceCommentCombo = new TOMAComboBox(v);
            priceCommentComponent = priceCommentCombo;
        } else
            priceCommentComponent = priceCommentPane;

        //comment
        label_comment.setText(labels.get("apostal.toma.sessionview.comment"));

        JScrollPane commentPane = new JScrollPane();
        commentPane.getViewport().add(comment);
        TOMATemplateResult commentResult = TOMATemplateView.getTemplateResult(type, "comment");
        if (commentResult.isForbidden())
            comment.setEnabled(false);
        if (commentResult.isMandatory())
            label_comment.setText(label_comment.getText() + " (*)");
        if (commentResult.getMaximum() > -1)
            label_comment.setText(label_comment.getText() + " (" + new Integer(commentResult.getMaximum()) + ")");
        if (commentResult.getValues() != null && !commentResult.getValues().isEmpty()) {
            Vector v = commentResult.getValues();
            v.insertElementAt(ElementNotSpecified.getInstance(), 0);
            TOMAComboBox commentCombo = new TOMAComboBox(v);
            commentComponent = commentCombo;
        } else
            commentComponent = commentPane;

        //locations
        label_locations.setText(labels.get("apostal.toma.sessionview.location"));
        TOMATemplateResult locationResult = TOMATemplateView.getTemplateResult(type, "location");
        if (locationResult.isMandatory())
            label_locations.setText(label_locations.getText() + " (*)");
        if (locationResult.isForbidden())
            locations.setEnabled(false);

        //slots
        label_slot.setText(labels.get("apostal.toma.sessionview.slot"));
        TOMATemplateResult slotResult = TOMATemplateView.getTemplateResult(type, "slot");
        if (slotResult.isMandatory())
            label_slot.setText(label_slot.getText() + " (*)");
        if (slotResult.isForbidden())
            slotsList.setEnabled(false);

        //teachers
        label_teachers.setText(labels.get("apostal.toma.sessionview.teachers"));
        teachersList = new TOMAMultipleElementsList(new Vector(), labels.get("apostal.toma.sessionview.addTeacher"), labels.get("apostal.toma.sessionview.removeTeacher"), labels.get("apostal.toma.sessionview.trainingTeachers"), labels.get("apostal.toma.sessionview.sessionTeachers"), TOMAColors.multipleElementsColor, 5);
        TOMATemplateResult teacherResult = TOMATemplateView.getTemplateResult(type, "teacher");
        if (teacherResult.isMandatory())
            label_teachers.setText(label_teachers.getText() + " (*)");
        if (teacherResult.isForbidden())
            teachersList.setEnabled(false);

        //seances
        label_seances.setText(labels.get("apostal.toma.sessionview.seances"));

        addConsSeances.setText(labels.get("apostal.toma.sessionview.addSeance"));
        addConsSeances.setActionCommand("addSeance");
        addConsSeances.addActionListener(listener);

        Class[] classes = new Class[0];
        Object[] values = new Object[0];
        seances = new TOMAMultipleElements("apostal.toma.view.SeancePanel", classes, values, 0, null, labels.get("apostal.toma.sessionview.seance.add"), labels.get("apostal.toma.sessionview.seance.remove"), TOMAColors.multipleElementsColor, 490, 120);
        seances.setRemoveButtonAnchor(GridBagConstraints.SOUTH);
        TOMATemplateResult seanceResult = TOMATemplateView.getTemplateResult(type, "seance");
        if (seanceResult.isForbidden())
            seances.setEnabled(false);
        if (seanceResult.isMandatory())
            label_seances.setText(label_seances.getText() + " (*)");

        //top
        top.setLayout(gridBagLayout3);
        top.setBackground(TOMAColors.sessionsBackgroundColor);
        newSession.setText(labels.get("apostal.toma.sessionview.createSession"));
        newSession.setActionCommand("create");
        newSession.addActionListener(listener);
        deleteSession.setText(labels.get("apostal.toma.sessionview.delete"));
        deleteSession.setActionCommand("delete");
        deleteSession.addActionListener(listener);
        deleteSession.setEnabled(false);
        JScrollPane sessionsPane = new JScrollPane();
        list_sessions.setVisibleRowCount(5);
        list_sessions.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        list_sessions.addListSelectionListener(this);
        list_sessions.setFixedCellWidth(200);
        list_sessions.setBackground(TOMAColors.editingFieldColor);
        list_sessions.setFont(TOMAFonts.listsFont);
        sessionsPane.getViewport().add(list_sessions);
        label_sessionsList = new TOMALabel(labels.get("apostal.toma.sessionview.sessionsList"));
        label_sessionContent = new TOMALabel(labels.get("apostal.toma.sessionview.sessionContent"));

        dates.setText("");

        save.setText(labels.get("apostal.toma.sessionview.save"));
        save.setActionCommand("save");
        save.addActionListener(listener);

        /******** Panels ***************/
        JPanel panel = new JPanel();
        panel.setLayout(gridBagLayout1);
        panel.setBackground(TOMAColors.sessionsBackgroundColor);

        JScrollPane scrollPane = new JScrollPane();

        GridBagConstraints cons = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0);

        panel.add(top, cons);

        cons.insets = new Insets(5, 5, 0, 5);
        top.add(label_sessionsList, cons);
        cons.gridx = 1;
        cons.gridheight = 2;
        cons.insets = new Insets(5, 0, 10, 0);
        top.add(sessionsPane, cons);

        cons.gridx = 2;
        cons.gridheight = 1;
        cons.insets = new Insets(5, 5, 5, 0);
        cons.anchor = GridBagConstraints.SOUTHWEST;
        cons.weighty = 0.1;
        top.add(newSession, cons);

        cons.gridy = 1;
        cons.insets = new Insets(0, 5, 0, 0);
        cons.anchor = GridBagConstraints.NORTHWEST;
        top.add(deleteSession, cons);

        cons.weighty = 0.0;
        cons.gridx = 0;
        cons.gridy = 2;
        cons.insets = new Insets(5, 5, 0, 0);
        top.add(label_sessionContent, cons);

        main.setLayout(gridBagLayout2);
        main.setBorder(new LineBorder(Color.black, 1));
        main.setBackground(TOMAColors.sessionsMainBackgroundColor);

        cons.gridy = 1;
        cons.anchor = GridBagConstraints.CENTER;
        cons.insets = new Insets(0, 5, 5, 5);
        cons.ipadx = 10;
        cons.ipady = 10;
        panel.add(main, cons);
        cons.gridy = 0;
        cons.anchor = GridBagConstraints.NORTHWEST;
        cons.insets = new Insets(0, 0, 5, 0);
        cons.ipadx = 0;
        cons.ipady = 0;
        main.add(label_name, cons);
        cons.gridx = 1;
        cons.weightx = 1.0;
        main.add(nameComponent, cons);
        cons.gridx = 0;
        cons.gridy = 1;
        cons.weightx = 0.0;
        main.add(label_textualCalendar, cons);
        cons.gridx = 1;
        cons.gridheight = 2;
        cons.weightx = 1.0;
        main.add(textualCalendarComponent, cons);
        cons.gridx = 2;
        cons.gridy = 3;
        cons.gridheight = 1;
        cons.weightx = 0.0;
        main.add(label_language, cons);
        cons.gridx = 3;
        cons.weightx = 1.0;
        main.add(languages, cons);
        cons.gridx = 0;
        cons.gridy = 3;
        cons.weightx = 0.0;
        main.add(label_price, cons);
        cons.gridx = 1;
        cons.gridheight = 2;
        cons.weightx = 1.0;
        main.add(priceComponent, cons);
        cons.gridx = 0;
        cons.gridy = 5;
        cons.gridheight = 1;
        cons.weightx = 0.0;
        main.add(label_priceComment, cons);
        cons.gridx = 1;
        cons.gridheight = 2;
        cons.weightx = 1.0;
        main.add(priceCommentComponent, cons);
        cons.gridx = 0;
        cons.gridy = 7;
        cons.gridheight = 1;
        cons.weightx = 0.0;
        main.add(label_comment, cons);
        cons.gridx = 1;
        cons.gridheight = 2;
        cons.weightx = 1.0;
        main.add(commentComponent, cons);
        cons.gridx = 0;
        cons.gridy = 9;
        cons.gridheight = 1;
        cons.weightx = 0.0;
        main.add(label_teachers, cons);
        cons.gridy = 10;
        cons.gridwidth = 4;
        cons.gridheight = 2;
        main.add(teachersList, cons);
        cons.gridy = 14;
        cons.gridwidth = 1;
        cons.gridheight = 1;
        cons.insets = new Insets(0, 0, 0, 0);
        main.add(label_seances, cons);
        cons.gridx = 3;
        cons.gridy = 14;
        cons.gridwidth = 1;
        cons.gridheight = 1;
        cons.insets = new Insets(0, 0, 0, 0);
        main.add(addConsSeances, cons);
        cons.gridx = 0;
        cons.gridy = 15;
        cons.gridwidth = 3;
        cons.gridheight = 3;
        main.add(seances, cons);
        cons.gridx = 2;
        cons.gridy = 1;
        cons.gridwidth = 1;
        cons.gridheight = 1;
        cons.insets = new Insets(0, 0, 5, 0);
        main.add(label_locations, cons);
        cons.gridx = 3;
        cons.weightx = 1.0;
        main.add(locations, cons);
        cons.gridx = 2;
        cons.gridy = 2;
        cons.weightx = 0.0;
        main.add(label_slot, cons);
        cons.gridx = 3;
        main.add(slotsList, cons);
        cons.gridx = 0;
        cons.gridy = 12;
        main.add(label_beginValidityDates, cons);
        cons.gridy = 13;
        main.add(label_endValidityDates, cons);
        cons.gridx = 1;
        cons.gridy = 12;
        main.add(beginValidityDates, cons);
        cons.gridy = 13;
        main.add(endValidityDates, cons);
        cons.gridx = 2;
        cons.gridy = 12;
        main.add(label_dateIntervalBegin, cons);
        cons.gridy = 13;
        main.add(label_dateIntervalEnd, cons);
        cons.gridx = 3;
        cons.gridy = 12;
        main.add(beginDateInterval, cons);
        cons.gridy = 13;
        main.add(endDateInterval, cons);
        cons.gridx = 0;
        cons.gridy = 19;
        cons.gridwidth = 3;
        cons.insets = new Insets(5, 0, 0, 0);
        main.add(dates, cons);
        cons.gridx = 3;
        cons.gridwidth = 1;
        cons.insets = new Insets(0, 0, 0, 0);
        cons.anchor = GridBagConstraints.SOUTH;
        main.add(save, cons);

        //dates
        beginValidityDay.setDocument(new LimitedNumericDocument(2));
        beginValidityMonth.setDocument(new LimitedNumericDocument(2));
        beginValidityYear.setDocument(new LimitedNumericDocument(4));
        endValidityDay.setDocument(new LimitedNumericDocument(2));
        endValidityMonth.setDocument(new LimitedNumericDocument(2));
        endValidityYear.setDocument(new LimitedNumericDocument(4));
        beginIntervalDay.setDocument(new LimitedNumericDocument(2));
        beginIntervalMonth.setDocument(new LimitedNumericDocument(2));
        beginIntervalYear.setDocument(new LimitedNumericDocument(4));
        endIntervalDay.setDocument(new LimitedNumericDocument(2));
        endIntervalMonth.setDocument(new LimitedNumericDocument(2));
        endIntervalYear.setDocument(new LimitedNumericDocument(4));

        cons.gridx = 0;
        cons.gridy = 0;
        cons.anchor = GridBagConstraints.NORTHWEST;
        beginValidityDates.add(beginValidityDay, cons);
        cons.gridx = 1;
        beginValidityDates.add(beginValidityMonth, cons);
        cons.gridx = 2;
        beginValidityDates.add(beginValidityYear, cons);
        cons.gridx = 0;
        endValidityDates.add(endValidityDay, cons);
        cons.gridx = 1;
        endValidityDates.add(endValidityMonth, cons);
        cons.gridx = 2;
        endValidityDates.add(endValidityYear, cons);
        cons.gridx = 0;
        beginDateInterval.add(beginIntervalDay, cons);
        cons.gridx = 1;
        beginDateInterval.add(beginIntervalMonth, cons);
        cons.gridx = 2;
        beginDateInterval.add(beginIntervalYear, cons);
        cons.gridx = 0;
        endDateInterval.add(endIntervalDay, cons);
        cons.gridx = 1;
        endDateInterval.add(endIntervalMonth, cons);
        cons.gridx = 2;
        endDateInterval.add(endIntervalYear, cons);
        scrollPane.getViewport().add(panel);
        this.setContentPane(scrollPane);
    }

    public void refresh() {
        deleteSession.setEnabled(false);
        this.setEnabled(false);

        this.clearData();
    }

    public void clearData() {
        name.setText("");
        textualCalendar.setText("");
        price.setText("");
        priceComment.setText("");
        comment.setText("");
        teachersList.setChosenData(new Vector());
        seances.setElements(new Vector());
        beginValidityDay.setText("");
        beginValidityMonth.setText("");
        beginValidityYear.setText("");
        endValidityDay.setText("");
        endValidityMonth.setText("");
        endValidityYear.setText("");
        beginIntervalDay.setText("");
        beginIntervalMonth.setText("");
        beginIntervalYear.setText("");
        endIntervalDay.setText("");
        endIntervalMonth.setText("");
        endIntervalYear.setText("");
    }

    public void setEnabled(boolean enabled) {
        if (!enabled) {
            name.setEnabled(false);
            if (nameComponent != null)
                nameComponent.setEnabled(false);

            seances.setEnabled(false);

            textualCalendar.setEnabled(false);
            if (textualCalendarComponent != null)
                textualCalendarComponent.setEnabled(false);

            languages.setEnabled(false);

            price.setEnabled(false);
            if (priceComponent != null)
                priceComponent.setEnabled(false);

            priceComment.setEnabled(false);
            if (priceCommentComponent != null)
                priceCommentComponent.setEnabled(false);

            locations.setEnabled(false);
            slotsList.setEnabled(false);
            teachersList.setEnabled(false);
            comment.setEnabled(false);
            if (commentComponent != null)
                commentComponent.setEnabled(false);

            beginValidityDay.setEnabled(false);
            beginValidityMonth.setEnabled(false);
            beginValidityYear.setEnabled(false);
            endValidityDay.setEnabled(false);
            endValidityMonth.setEnabled(false);
            endValidityYear.setEnabled(false);
            beginIntervalDay.setEnabled(false);
            beginIntervalMonth.setEnabled(false);
            beginIntervalYear.setEnabled(false);
            endIntervalDay.setEnabled(false);
            endIntervalMonth.setEnabled(false);
            endIntervalYear.setEnabled(false);
            save.setEnabled(false);
            addConsSeances.setEnabled(false);
        } else {
            name.setEnabled(true);
            if (nameComponent != null)
                nameComponent.setEnabled(true);

            TOMATemplateResult result = TOMATemplateView.getTemplateResult(type, "seance");
            if (!result.isForbidden())
                seances.setEnabled(true);

            result = TOMATemplateView.getTemplateResult(type, "textualCalendar");
            if (!result.isForbidden()) {
                textualCalendar.setEnabled(true);
                if (textualCalendarComponent != null)
                    textualCalendarComponent.setEnabled(true);
            }

            result = TOMATemplateView.getTemplateResult(type, "language");
            if (!result.isForbidden())
                languages.setEnabled(true);

            result = TOMATemplateView.getTemplateResult(type, "price");
            if (!result.isForbidden()) {
                price.setEnabled(true);
                if (priceComponent != null)
                    priceComponent.setEnabled(true);
            }

            result = TOMATemplateView.getTemplateResult(type, "priceComment");
            if (!result.isForbidden()) {
                priceComment.setEnabled(true);
                if (priceCommentComponent != null)
                    priceCommentComponent.setEnabled(true);
            }

            result = TOMATemplateView.getTemplateResult(type, "location");
            if (!result.isForbidden())
                locations.setEnabled(true);

            result = TOMATemplateView.getTemplateResult(type, "slot");
            if (!result.isForbidden())
                slotsList.setEnabled(true);

            result = TOMATemplateView.getTemplateResult(type, "teacher");
            if (!result.isForbidden())
                teachersList.setEnabled(true);

            result = TOMATemplateView.getTemplateResult(type, "comment");
            if (!result.isForbidden()) {
                comment.setEnabled(true);
                if (commentComponent != null)
                    commentComponent.setEnabled(true);
            }

            beginValidityDay.setEnabled(true);
            beginValidityMonth.setEnabled(true);
            beginValidityYear.setEnabled(true);
            endValidityDay.setEnabled(true);
            endValidityMonth.setEnabled(true);
            endValidityYear.setEnabled(true);
            beginIntervalDay.setEnabled(true);
            beginIntervalMonth.setEnabled(true);
            beginIntervalYear.setEnabled(true);
            endIntervalDay.setEnabled(true);
            endIntervalMonth.setEnabled(true);
            endIntervalYear.setEnabled(true);
            save.setEnabled(true);
            addConsSeances.setEnabled(true);
        }
    }


    public void deleteSession(Session s) {
        sessions.remove(s);
        list_sessions.setListData(sessions);

        this.refresh();

        if (sessions.size() > 0)
            list_sessions.setSelectedIndex(0);
        /*else
      this.setEnabled(false);*/
    }


    public void createSession(Session s) {
        sessions.add(s);
        list_sessions.setListData(sessions);

        list_sessions.setSelectedValue(s, true);
    }
}
