// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.view;

import apostal.toma.data.PublicationUnit;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import apostal.toma.data.TOMALabels;

import java.util.Vector;

public class CreatePublicationUnit extends TOMACreate {

    private JLabel label_name;
    private JTextField name;
    ButtonGroup group_Types = new ButtonGroup();
    JPanel panelRadio = new JPanel();


    public CreatePublicationUnit(ActionListener listener, TOMAFrame parent) {

        super(parent);
        this.setMessage(labels.get("apostal.toma.publication.creation.message"));
        this.setTitle(labels.get("apostal.toma.publication.creation.title"));

        //radio buttons
        //HTML
        JRadioButton bHtml = new JRadioButton();
        bHtml.setText(labels.get("apostal.toma.publicationUnit.html"));
        bHtml.setActionCommand(String.valueOf(PublicationUnit.PUBLICATION_HTML));
        bHtml.setBackground(TOMAColors.tomaBackgroundColor);
        //PDF
        JRadioButton bPdf = new JRadioButton();
        bPdf.setText(labels.get("apostal.toma.publicationUnit.pdf"));
        bPdf.setActionCommand(String.valueOf(PublicationUnit.PUBLICATION_PDF));
        bPdf.setBackground(TOMAColors.tomaBackgroundColor);
        //RTF
        JRadioButton bRtf = new JRadioButton();
        bRtf.setText(labels.get("apostal.toma.publicationUnit.rtf"));
        bRtf.setActionCommand(String.valueOf(PublicationUnit.PUBLICATION_RTF));
        bRtf.setBackground(TOMAColors.tomaBackgroundColor);
        //XML
        JRadioButton bXml = new JRadioButton();
        bXml.setSelected(true);
        bXml.setText(labels.get("apostal.toma.publicationUnit.xml"));
        bXml.setActionCommand(String.valueOf(PublicationUnit.PUBLICATION_XML));
        bXml.setBackground(TOMAColors.tomaBackgroundColor);
        //SOAP
        JRadioButton bsoap = new JRadioButton();
        bsoap.setText(labels.get("apostal.toma.publicationUnit.soap"));
        bsoap.setActionCommand(String.valueOf(PublicationUnit.PUBLICATION_SOAP));
        bsoap.setBackground(TOMAColors.tomaBackgroundColor);
        //XSL
        JRadioButton bXsl = new JRadioButton();
        bXsl.setText(labels.get("apostal.toma.publicationUnit.xsl"));
        bXsl.setActionCommand(String.valueOf(PublicationUnit.PUBLICATION_XSL));
        bXsl.setBackground(TOMAColors.tomaBackgroundColor);
        //SOAP Delete
        JRadioButton bsoapdelete = new JRadioButton();
        bsoapdelete.setText(labels.get("apostal.toma.publicationUnit.soapDelete"));
        bsoapdelete.setActionCommand(String.valueOf(PublicationUnit.PUBLICATION_SOAP_DELETE));
        bsoapdelete.setBackground(TOMAColors.tomaBackgroundColor);        
		
        group_Types.add(bsoap);
        group_Types.add(bHtml);
        group_Types.add(bRtf);
        group_Types.add(bPdf);
        group_Types.add(bXml);
        group_Types.add(bXsl);
		group_Types.add(bsoapdelete);

        panelRadio.setLayout(new GridBagLayout());
        panelRadio.add(bHtml, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelRadio.add(bRtf, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelRadio.add(bPdf, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelRadio.add(bXml, new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelRadio.add(bsoap, new GridBagConstraints(4, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelRadio.add(bXsl, new GridBagConstraints(5, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
		panelRadio.add(bsoapdelete, new GridBagConstraints(6, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        questions.setLayout(new GridBagLayout());

        label_name = new JLabel("");
        questions.add(label_name, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        name = new JTextField();
        name.setColumns(30);
        questions.add(name, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
        questions.add(panelRadio, new GridBagConstraints(0, 1, 2, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        ok.addActionListener(listener);
    }


    public Object getData() {

        Vector temp = new Vector();
        String type = "";
        ButtonModel exportSelected = group_Types.getSelection();
        if (exportSelected != null) {
            String exportCode = exportSelected.getActionCommand();
            type = exportCode;
        }
        temp.add(name.getText());
        temp.add(type);
        return temp;

    }
}


