// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import javax.swing.*;
import java.awt.Insets;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionListener;

import apostal.toma.data.TOMALabels;
import apostal.toma.data.Teacher;
import apostal.toma.TOMA;

import javax.swing.JFrame;


public class CreateTeacher extends TOMACreate {


    private JLabel label_lastname;
    private JLabel label_firstname;
    private JLabel label_function;
    private JTextField firstname;
    private JTextField lastname;
    private JTextField function;

    public CreateTeacher(ActionListener listener, TOMAFrame parent) {

        super(parent);
        this.setTitle(labels.get("apostal.toma.teacher.create.title"));
        questions.setLayout(new GridBagLayout());

        label_firstname = new JLabel(labels.get("apostal.toma.teacher.create.firstname"));
        questions.add(label_firstname, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
        firstname = new JTextField();
        firstname.setColumns(20);
        questions.add(firstname, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        label_lastname = new JLabel(labels.get("apostal.toma.teacher.create.lastname"));
        questions.add(label_lastname, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
        lastname = new JTextField();
        lastname.setColumns(20);
        questions.add(lastname, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        label_function = new JLabel(labels.get("apostal.toma.teacher.create.function"));
        questions.add(label_function, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
        function = new JTextField();
        function.setColumns(20);
        questions.add(function, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        ok.addActionListener(listener);

    }


    public String getFirstname() {
        return firstname.getText();
    }

    public String getLastname() {
        return lastname.getText();
    }

    public String getFunction() {
        return function.getText();
    }


    public Object getData() {
        return firstname.getText();
    }

}

