// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import javax.swing.*;
import java.awt.Insets;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionListener;
import javax.swing.JFrame;

import apostal.toma.TOMA;
import apostal.toma.data.TOMALabels;
import apostal.toma.data.TrainingCourse;

public class CreateTrainingCourse extends TOMACreate {

    private TOMALabel lcode;
    private TOMALabel ltitle;
    private TOMATextField code;
    private TOMATextField trainingTitle;

    public CreateTrainingCourse(ActionListener listener, TOMAFrame parent) {
        super(parent);
        this.setTitle(labels.get("apostal.toma.catalogue.course.titlebar"));

        //remplir questions
        questions.setLayout(new GridBagLayout());

        lcode = new TOMALabel(labels.get("apostal.toma.catalogue.course.code"));
        questions.add(lcode, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
        code = new TOMATextField();
        //code.setColumns(20);
        questions.add(code, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        ltitle = new TOMALabel(labels.get("apostal.toma.catalogue.course.title"));
        questions.add(ltitle, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
        trainingTitle = new TOMATextField();
        //trainingTitle.setColumns(20);
        questions.add(trainingTitle, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        ok.addActionListener(listener);
    }

    public Object getData() {
        TrainingCourse tc = new TrainingCourse();
        tc.setCode(code.getText());
        tc.setTitle(trainingTitle.getText());
        return tc;
    }
}
