// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import java.util.*;

import apostal.toma.data.*;
import apostal.toma.viewcontrol.*;
import apostal.toma.data.TOMALabels;
import apostal.toma.datacontrol.LocationsControl;
import apostal.toma.TOMA;
import apostal.toma.data.*;
import apostal.ted.*;
import apostal.toma.datacontrol.ImportTEDControl;
import apostal.toma.view.TOMATree;
import apostal.toma.external.ObjecttoImport;
import apostal.toma.data.TOMALabels;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

import toolbox.util.*;

public class ImportTrainingView extends JDialog {

    /**

     * the TrainingXML that is to be imported.

     * the data is put as described in ImportTedControl

     */

    private TrainingXML data;
    private TrainingProgrammeXML prog;
    JPanel panelMain = new JPanel();
    private JPanel panel;
    private GridBagLayout layout;
    private GridBagConstraints c;


    GridBagLayout gridBagLayout1 = new GridBagLayout();
    TOMALabel jtitle = new TOMALabel();
    TOMATextField jTFtitle = new TOMATextField();
    TOMALabel jcode = new TOMALabel();
    TOMATextField jTFcode = new TOMATextField();
    JPanel jPanel1 = new JPanel();
    TitledBorder titledBorder1;
    GridBagLayout gridBagLayout2 = new GridBagLayout();
    JComboBox jCBunits = new JComboBox();
    TOMATextField jTFunits = new TOMATextField();
    JPanel jPanel2 = new JPanel();
    GridBagLayout gridBagLayout3 = new GridBagLayout();
    Border border1;
    TitledBorder titledBorder2;
    TitledBorder titledBorder3;
    TOMALabel jpartnership = new TOMALabel();
    TOMATextField jTFpartnership = new TOMATextField();
    JPanel jPanel3 = new JPanel();
    Border border2;
    TitledBorder titledBorder4;
    JPanel jPanel4 = new JPanel();
    JPanel jPanel5 = new JPanel();
    GridBagLayout gridBagLayout4 = new GridBagLayout();
    GridBagLayout gridBagLayout5 = new GridBagLayout();
    GridBagLayout gridBagLayout6 = new GridBagLayout();
    TOMAButton jButton1 = new TOMAButton();
    TOMAButton jButton2 = new TOMAButton();
    JComboBox jCBteacher1 = new JComboBox();
    TOMALabel jLabel1 = new TOMALabel();
    JRadioButton jnotimport = new JRadioButton();
    JRadioButton jimport = new JRadioButton();
    JRadioButton jcreate = new JRadioButton();
    JRadioButton jreplace = new JRadioButton();
    JComboBox jCBteacher2 = new JComboBox();
    TOMALabel jtfirstname = new TOMALabel();
    TOMATextField jTFfirstname = new TOMATextField();
    TOMALabel jlastname = new TOMALabel();
    TOMALabel jfunction = new TOMALabel();
    TOMATextField jTFlastname = new TOMATextField();
    TOMATextField jTFfunction = new TOMATextField();
    TOMALabel jLabel2 = new TOMALabel();
    JComboBox jCBcontacts1 = new JComboBox();
    JRadioButton jcnotimport = new JRadioButton();
    JRadioButton jcimport = new JRadioButton();
    JRadioButton jccreate = new JRadioButton();
    JRadioButton jcreplace = new JRadioButton();
    JComboBox jCBcontacts2 = new JComboBox();
    TOMALabel jcfirstname = new TOMALabel();
    TOMALabel jclastname = new TOMALabel();
    TOMALabel jctel = new TOMALabel();
    TOMALabel jcemail = new TOMALabel();
    TOMATextField jTFcfirstname = new TOMATextField();
    TOMATextField jTFclastname = new TOMATextField();
    TOMATextField jTFctel = new TOMATextField();
    TOMATextField jTFcemail = new TOMATextField();
    TOMALabel jLabel3 = new TOMALabel();
    JComboBox jCBlocations1 = new JComboBox();
    JRadioButton jlnotimport = new JRadioButton();
    JRadioButton jlimport = new JRadioButton();
    JRadioButton jlcreate = new JRadioButton();
    JRadioButton jlreplace = new JRadioButton();
    TOMATreeControl control = new TOMATreeControl();
    private TOMATree tree;
    private JScrollPane treePane;
    TOMALabel jLabel4 = new TOMALabel();
    TOMATextField jTFdenomination1 = new TOMATextField();
    JComboBox jCBlocations2 = new JComboBox();
    protected TOMALabels labels;

    JScrollPane jScrollPane = new JScrollPane();
    JScrollPane jScrollPane1 = new JScrollPane();

    ButtonGroup grteachers = new ButtonGroup();
    ButtonGroup grteachers1 = new ButtonGroup();
    ButtonGroup grlocations = new ButtonGroup();
    ButtonGroup grlocations1 = new ButtonGroup();
    ButtonGroup grcontacts = new ButtonGroup();
    ButtonGroup gecontacts1 = new ButtonGroup();

    // Save le choix de garder ou ecraser object
    Vector choiceteacher = new Vector();
    Vector choicelocation = new Vector();
    Vector choicecontact = new Vector();
    /*Vector choicetrcontact = new Vector();
    Vector choiceinscontact = new Vector();*/

    Vector doublecontact = new Vector();
    Vector doubleteacher = new Vector();
    Vector doublelocation = new Vector();

    Vector allteachers = new Vector();
    Vector alllocations = new Vector();
    Vector allcontacts = new Vector();
    Vector allunits = new Vector();


    private TeacherXML teacher = new TeacherXML();
    private LocationXML location = new LocationXML();
    private ContactXML contact = new ContactXML();
    private UnitXML unit = new UnitXML();

    private ImportTEDControl trcontrol = new ImportTEDControl();
    TitledBorder titledBorder5;
    TitledBorder titledBorder6;
    TitledBorder titledBorder7;
    ImportTEDEventHandler handler = new ImportTEDEventHandler(this);

    public void setData(TrainingXML training, Vector _allteachers, Vector _alllocations, Vector _allcontacts) {
        this.data = training;
        /*Vector icontacts = new Vector();
        Vector trcontacts = new Vector();*/
        //units
        try {
            prog = (TrainingProgrammeXML) training;
            allunits = prog.getUnits();
        } catch (ClassCastException c) {
        }
        if (allunits.size() == 0) {
            jPanel1.setVisible(false);
        }
        //teachers
        /*try
        {
          allteachers = training.getTeachers();
        }
        catch(NullPointerException np){}*/
        allteachers = _allteachers;
        // mettre locations dans vecteur alllocations
        /*try
        {
          alllocations = training.getLocations();
        }
        catch(NullPointerException np){}*/
        alllocations = _alllocations;

        // mettre contacts dans le vecteur allcontacts
        /*try
        {
          trcontacts = training.getTrainingContacts();
        }
        catch(NullPointerException np){}
        allcontacts = trcontrol.addVectors(allcontacts, trcontacts);*/
        allcontacts = _allcontacts;

        /*try
        {
          icontacts = training.getInscriptionContacts();
        }
        catch(NullPointerException np){}
        allcontacts = trcontrol.addVectors(allcontacts, icontacts);*/


        // Initialiser le choix sur "not import"
        choicecontact = trcontrol.init(_allcontacts);
        /*choicetrcontact = trcontrol.init(trcontacts);
        choiceinscontact = trcontrol.init(icontacts);*/
        choiceteacher = trcontrol.init(allteachers);
        choicelocation = trcontrol.init(alllocations);

        // Afficher les donnes dans la fentre

        jTFtitle.setText(training.getTitle());
        jTFcode.setText(training.getCode());
        jTFpartnership.setText(training.getPartnership());

        //Units
        for (int i = 0; i < allunits.size(); i++) {
            jCBunits.addItem(((UnitXML) allunits.elementAt(i)));
        }
        //Teachers
        for (int i = 0; i < allteachers.size(); i++) {
            jCBteacher1.addItem(((TeacherXML) allteachers.elementAt(i)));
        }

        //Contacts
        for (int i = 0; i < allcontacts.size(); i++) {
            ContactXML c = (ContactXML) allcontacts.elementAt(i);
            if (!trcontrol.testItem(jCBcontacts1, c)) {
                jCBcontacts1.addItem(c);
            } else {
                doublecontact.addElement(c);
            }
        }

        //Locations
        for (int i = 0; i < alllocations.size(); i++) {
            jCBlocations1.addItem(((LocationXML) alllocations.elementAt(i)));
        }

    }

    public Object getData() {
        return data;
    }

    public ImportTrainingView() {
        try {
            this.setModal(true);
            labels = new TOMALabels();
            jbInit();
            pack();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        //Definition du tree
        tree = control.createRootTree(false, false, true, false, false, TOMA.getInstance().getTomaParameters().getLanguage());
        treePane = new JScrollPane();
        TOMAJTree jtree = tree.getTree();
        jtree.setVisibleRowCount(20);

        treePane.getViewport().add(jtree);
        Dimension panelTreeMax = new Dimension(264, 302);
        treePane.setPreferredSize(panelTreeMax);

        titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(134, 134, 134)), labels.get("apostal.toma.import.contact"));
        border1 = BorderFactory.createEmptyBorder();
        titledBorder2 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(134, 134, 134)), labels.get("apostal.toma.import.catalogue"));
        titledBorder3 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(134, 134, 134)), labels.get("apostal.toma.import.catalogue"));
        border2 = BorderFactory.createEmptyBorder();
        titledBorder4 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(134, 134, 134)), labels.get("apostal.toma.import.teacher"));
        titledBorder5 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(134, 134, 134)), labels.get("apostal.toma.import.contact"));
        titledBorder6 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(134, 134, 134)), labels.get("apostal.toma.import.locations"));
        titledBorder7 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(134, 134, 134)), labels.get("apostal.toma.import.units"));
        jtitle.setText(labels.get("apostal.toma.import.title"));
        panelMain.setLayout(gridBagLayout1);
        jTFtitle.setColumns(20);
        jcode.setText(labels.get("apostal.toma.import.code"));
        jTFcode.setColumns(20);
        jPanel1.setBackground(TOMAColors.treeBackgroundColor);
        jPanel1.setBorder(titledBorder7);
        jPanel1.setLayout(gridBagLayout2);
        jTFunits.setColumns(20);
        jPanel2.setLayout(gridBagLayout3);
        jPanel2.setBorder(titledBorder3);
        jPanel2.setBackground(TOMAColors.treeBackgroundColor);
        jpartnership.setText(labels.get("apostal.toma.import.partnership"));
        jTFpartnership.setColumns(20);
        jPanel3.setLayout(gridBagLayout4);
        jPanel3.setBackground(TOMAColors.treeBackgroundColor);
        jPanel3.setBorder(titledBorder4);
        jPanel4.setLayout(gridBagLayout5);
        jPanel4.setBackground(TOMAColors.treeBackgroundColor);
        jPanel4.setBorder(titledBorder5);
        jPanel5.setLayout(gridBagLayout6);
        jPanel5.setBackground(TOMAColors.treeBackgroundColor);
        jPanel5.setBorder(titledBorder6);

        jButton1.setText(labels.get("apostal.toma.import.cancel"));
        jButton1.addActionListener(handler);
        jButton1.setActionCommand(".cancel");

        jButton2.setText(labels.get("apostal.toma.import.import"));
        jButton2.addActionListener(handler);
        jButton2.setActionCommand(".import");

        jLabel1.setText(labels.get("apostal.toma.import.checkteacher"));
        jnotimport.setText(labels.get("apostal.toma.import.notimport"));
        jnotimport.setForeground(TOMAColors.unclickableTextColor);
        //jnotimport.setSelected(true);
        jnotimport.setBackground(TOMAColors.treeBackgroundColor);
        jimport.setText(labels.get("apostal.toma.import.import"));
        jimport.setForeground(TOMAColors.unclickableTextColor);
        jimport.setBackground(TOMAColors.treeBackgroundColor);
        jcreate.setText(labels.get("apostal.toma.import.create"));
        jcreate.setForeground(TOMAColors.unclickableTextColor);
        //jcreate.setSelected(true);
        jcreate.setBackground(TOMAColors.treeBackgroundColor);
        jreplace.setText(labels.get("apostal.toma.import.replace"));
        jreplace.setForeground(TOMAColors.unclickableTextColor);
        jreplace.setBackground(TOMAColors.treeBackgroundColor);
        jtfirstname.setText(labels.get("apostal.toma.import.firstname"));
        jlastname.setText(labels.get("apostal.toma.import.lastname"));
        jfunction.setText(labels.get("apostal.toma.import.function"));

        jTFfirstname.setColumns(20);
        jTFlastname.setColumns(20);
        jTFfunction.setColumns(20);
        jLabel2.setText(labels.get("apostal.toma.import.checkcontact"));
        jcnotimport.setText(labels.get("apostal.toma.import.notimport"));
        jcnotimport.setForeground(TOMAColors.unclickableTextColor);
        jcnotimport.setSelected(true);
        jcnotimport.setBackground(TOMAColors.treeBackgroundColor);
        jcimport.setText(labels.get("apostal.toma.import.import"));
        jcimport.setForeground(TOMAColors.unclickableTextColor);
        jcimport.setBackground(TOMAColors.treeBackgroundColor);
        jccreate.setText(labels.get("apostal.toma.import.create"));
        jccreate.setForeground(TOMAColors.unclickableTextColor);
        //jccreate.setSelected(true);
        jccreate.setBackground(TOMAColors.treeBackgroundColor);
        jcreplace.setText(labels.get("apostal.toma.import.replace"));
        jcreplace.setForeground(TOMAColors.unclickableTextColor);
        jcreplace.setBackground(TOMAColors.treeBackgroundColor);
        jcfirstname.setText(labels.get("apostal.toma.import.firstname"));
        jclastname.setText(labels.get("apostal.toma.import.lastname"));
        jctel.setText(labels.get("apostal.toma.import.telephone"));
        jcemail.setText(labels.get("apostal.toma.import.email"));
        jTFcfirstname.setColumns(20);
        jTFclastname.setColumns(20);
        jTFctel.setColumns(20);
        jTFcemail.setColumns(20);
        jLabel3.setText(labels.get("apostal.toma.import.checklocation"));
        jlnotimport.setText(labels.get("apostal.toma.import.notimport"));
        jlnotimport.setForeground(TOMAColors.unclickableTextColor);
        //jlnotimport.setSelected(true);
        jlnotimport.setBackground(TOMAColors.treeBackgroundColor);
        jlimport.setText(labels.get("apostal.toma.import.import"));
        jlimport.setForeground(TOMAColors.unclickableTextColor);
        jlimport.setBackground(TOMAColors.treeBackgroundColor);
        jlcreate.setText(labels.get("apostal.toma.import.create"));
        jlcreate.setForeground(TOMAColors.unclickableTextColor);
        //jlcreate.setSelected(true);
        jlcreate.setBackground(TOMAColors.treeBackgroundColor);
        jlreplace.setText(labels.get("apostal.toma.import.replace"));
        jlreplace.setForeground(TOMAColors.unclickableTextColor);
        jlreplace.setBackground(TOMAColors.treeBackgroundColor);
        jLabel4.setText(labels.get("apostal.toma.import.denomination"));
        jCBcontacts1.setBackground(TOMAColors.editingFieldColor);
        jCBcontacts1.setPreferredSize(new Dimension(125, 21));
        jCBcontacts1.addActionListener(handler);
        jCBcontacts1.setActionCommand(".contact");

        jCBcontacts2.setBackground(TOMAColors.editingFieldColor);
        jCBcontacts2.setPreferredSize(new Dimension(125, 21));
        jTFdenomination1.setBackground(TOMAColors.editingFieldColor);
        jTFdenomination1.setColumns(20);
        jCBlocations1.setBackground(TOMAColors.editingFieldColor);
        jCBlocations1.setPreferredSize(new Dimension(125, 21));
        jCBlocations1.addActionListener(handler);
        jCBlocations1.setActionCommand(".location");
        jCBlocations2.setBackground(TOMAColors.editingFieldColor);
        jCBlocations2.setPreferredSize(new Dimension(125, 21));

        jCBteacher1.setBackground(TOMAColors.editingFieldColor);
        jCBteacher1.setPreferredSize(new Dimension(125, 21));
        jCBteacher1.addActionListener(handler);
        jCBteacher1.setActionCommand(".teacher");

        jCBunits.setBackground(TOMAColors.editingFieldColor);
        jCBunits.setPreferredSize(new Dimension(125, 21));
        jCBunits.addActionListener(handler);
        jCBunits.setActionCommand(".unit");

        jCBteacher2.setBackground(TOMAColors.editingFieldColor);
        jCBteacher2.setPreferredSize(new Dimension(125, 21));
        jCBunits.setBackground(TOMAColors.editingFieldColor);

        grteachers.add(jnotimport);
        grteachers.add(jimport);
        grlocations.add(jlnotimport);
        grlocations.add(jlimport);
        grcontacts.add(jcnotimport);
        grcontacts.add(jcimport);
        grteachers1.add(jcreate);
        grteachers1.add(jreplace);
        grlocations1.add(jlcreate);
        grlocations1.add(jlreplace);
        gecontacts1.add(jccreate);
        gecontacts1.add(jcreplace);

        //selectionner le bouton import automatiquement
        jcreate.addActionListener(handler);
        jcreate.setActionCommand(".timport");
        jreplace.addActionListener(handler);
        jreplace.setActionCommand(".timport");

        jlcreate.addActionListener(handler);
        jlcreate.setActionCommand(".limport");
        jlreplace.addActionListener(handler);
        jlreplace.setActionCommand(".limport");

        jccreate.addActionListener(handler);
        jccreate.setActionCommand(".cimport");
        jcreplace.addActionListener(handler);
        jcreplace.setActionCommand(".cimport");


        //Liste des teachers de la BD
        Vector vteachers = trcontrol.loadTeachers(true);
        //trier les teachers
        ToStringComparator comp = new ToStringComparator();
        QuickSort sort = new QuickSort(comp);
        vteachers = sort.qsort(vteachers);
        for (int i = 0; i < vteachers.size(); i++) {
            jCBteacher2.addItem(((Teacher) vteachers.elementAt(i)));
        }

        //Liste des contacts de la BD
        Vector vcontacts = trcontrol.loadContacts(true);
        //trier les contacts
        vcontacts = sort.qsort(vcontacts);
        for (int i = 0; i < vcontacts.size(); i++) {
            jCBcontacts2.addItem(((Contact) vcontacts.elementAt(i)));
        }

        //Liste des locations de la BD
        Vector vlocations = trcontrol.loadLocations(true);
        //trier les locations
        vlocations = sort.qsort(vlocations);
        for (int i = 0; i < vlocations.size(); i++) {
            jCBlocations2.addItem(((Location) vlocations.elementAt(i)));
        }

        panelMain.add(jtitle, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelMain.add(jTFtitle, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelMain.add(jcode, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelMain.add(jTFcode, new GridBagConstraints(1, 1, 1, 2, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelMain.add(jPanel1, new GridBagConstraints(0, 3, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(jCBunits, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(jTFunits, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelMain.add(jpartnership, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelMain.add(jTFpartnership, new GridBagConstraints(1, 4, 1, 2, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel3.add(jnotimport, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel3.add(jimport, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel3.add(jCBteacher2, new GridBagConstraints(1, 8, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel3.add(jtfirstname, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel3.add(jTFfirstname, new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel3.add(jlastname, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel3.add(jTFlastname, new GridBagConstraints(1, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel3.add(jfunction, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        jPanel3.add(jTFfunction, new GridBagConstraints(1, 6, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        jPanel3.add(jLabel1, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel3.add(jCBteacher1, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel3.add(jreplace, new GridBagConstraints(0, 8, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 15, 0, 0), 0, 0));
        jPanel3.add(jcreate, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 15, 0, 0), 0, 0));
        panelMain.add(jButton1, new GridBagConstraints(2, 9, 2, 1, 0.0, 0.0
                , GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelMain.add(jButton2, new GridBagConstraints(4, 9, 1, 1, 0.0, 0.0
                , GridBagConstraints.SOUTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelMain.add(jPanel5, new GridBagConstraints(0, 8, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelMain.add(jPanel2, new GridBagConstraints(2, 0, 1, 8, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel2.add(treePane, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelMain.add(jPanel4, new GridBagConstraints(2, 8, 4, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel5.add(jLabel3, new GridBagConstraints(0, 0, 3, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel5.add(jlimport, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel5.add(jLabel4, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel5.add(jCBlocations2, new GridBagConstraints(2, 6, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel5.add(jTFdenomination1, new GridBagConstraints(2, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel5.add(jCBlocations1, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel5.add(jlcreate, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 15, 0, 0), 0, 0));
        jPanel5.add(jlreplace, new GridBagConstraints(0, 6, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 15, 0, 0), 0, 0));
        jPanel5.add(jlnotimport, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelMain.add(jPanel3, new GridBagConstraints(0, 6, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jLabel2, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jcreplace, new GridBagConstraints(0, 9, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 15, 0, 0), 0, 0));
        jPanel4.add(jCBcontacts2, new GridBagConstraints(1, 9, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jcimport, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jcnotimport, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jcfirstname, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jclastname, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jctel, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jcemail, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jTFcfirstname, new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jTFclastname, new GridBagConstraints(1, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jTFctel, new GridBagConstraints(1, 6, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jTFcemail, new GridBagConstraints(1, 7, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jCBcontacts1, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel4.add(jccreate, new GridBagConstraints(0, 8, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 15, 0, 0), 0, 0));
        panelMain.setBackground(TOMAColors.tomaBackgroundColor);
        jScrollPane.getViewport().add(panelMain);
        this.getContentPane().add(jScrollPane);
        this.setTitle(labels.get("apostal.toma.import.title"));
        this.getContentPane().setBackground(TOMAColors.tomaBackgroundColor);
        //this.setResizable(false);
        this.pack();
    }

    public void showUnit() {
        //unit choisi dans le choicebox
        unit = (UnitXML) jCBunits.getSelectedItem();
        jTFunits.setText(unit.getCode());
    }

    public void saveUnit() {
        String code = jTFunits.getText();
        if (code.compareTo("") != 0) {
            unit.setCode(jTFunits.getText());
        }
    }

    public void showTeacher() {
        //teacher choisi dans le choicebox
        teacher = (TeacherXML) jCBteacher1.getSelectedItem();
        jTFfirstname.setText(teacher.getFirstname());
        jTFlastname.setText(teacher.getLastname());
        jTFfunction.setText(teacher.getFunction());
        try {
            ObjecttoImport toImport = findTeacher(teacher);
            //test import/ not import
            if (toImport.getImporter() == true) {
                jimport.setSelected(true);
                jnotimport.setSelected(false);
            } else {
                jnotimport.setSelected(true);
                jimport.setSelected(false);
            }
            //test create/ replace
            if (toImport.getCreator() == -1) {
                jcreate.setSelected(true);
                jreplace.setSelected(false);
            } else {
                jreplace.setSelected(true);
                jcreate.setSelected(false);
                //afficher le teacher  remplacer
                jCBteacher2.setSelectedIndex(getIndex(toImport.getCreator(), "teacher"));
            }
        } catch (NullPointerException np) {
            np.printStackTrace();
        }
    }


    public void showLocation() {
//location choisi dans le choicebox
        location = (LocationXML) jCBlocations1.getSelectedItem();
        jTFdenomination1.setText(location.getDenomination());
        try {
            ObjecttoImport toImport = findLocation(location);
            //location sauvegard dans object avec autres choix
            LocationXML l = (LocationXML) toImport.getObject();
            //test import/ not import
            if (toImport.getImporter() == true) {
                jlimport.setSelected(true);
                jlnotimport.setSelected(false);
            } else {
                jlnotimport.setSelected(true);
                jlimport.setSelected(false);
            }
            //test create/ replace
            if (toImport.getCreator() == -1) {
                jlcreate.setSelected(true);
                jlreplace.setSelected(false);
            } else {
                jlreplace.setSelected(true);
                jlcreate.setSelected(false);
                //afficher le location  remplacer
                jCBlocations2.setSelectedIndex(getIndex(toImport.getCreator(), "location"));
            }
        } catch (NullPointerException np) {
            np.printStackTrace();
        }
    }

    public void showContact() {
        //Contact choisi dans le choicebox
        contact = (ContactXML) jCBcontacts1.getSelectedItem();
        jTFcfirstname.setText(contact.getFirstname());
        jTFclastname.setText(contact.getLastname());
        jTFcemail.setText(contact.getEmail());
        jTFctel.setText(contact.getTel());
        try {
            ObjecttoImport toImport = findContact(contact);
            //test import/ not import
            if (toImport.getImporter() == true) {
                jcimport.setSelected(true);
                jcnotimport.setSelected(false);
            } else {
                jcnotimport.setSelected(true);
                jcimport.setSelected(false);
            }
            //test create/ replace
            if (toImport.getCreator() == -1) {
                jccreate.setSelected(true);
                jcreplace.setSelected(false);
            } else {
                jcreplace.setSelected(true);
                jccreate.setSelected(false);
                //afficher le contact  remplacer
                jCBcontacts2.setSelectedIndex(getIndex(toImport.getCreator(), "contact"));
            }
        } catch (NullPointerException np) {
            np.printStackTrace();
        }
    }

    //Trouver le teacher selectionn dans le vecteur des objects qui contiennent le choix
    //import/notimport/create/replace
    public ObjecttoImport findTeacher(TeacherXML teacher) {
        ObjecttoImport toImport = null;
        int cpt = 0;
        int size = choiceteacher.size();
        while (toImport == null && cpt < size) {
            ObjecttoImport o2 = (ObjecttoImport) choiceteacher.elementAt(cpt);
            if (o2 != null && o2.getObject() != null && ((TeacherXML) o2.getObject()).equals(teacher))
                toImport = o2;
            cpt++;
        }
        if (toImport != null)
            return toImport;
        else
            return new ObjecttoImport();

        /*TeacherXML t = new TeacherXML();
        int idsearched = -1;
        //Vector choiceteacher contient les choix
        for (int i=0; i<choiceteacher.size();i++)
        {
          toImport = (ObjecttoImport)choiceteacher.elementAt(i);
          try
          {
            String lastnamesaved = ((TeacherXML)toImport.getObject()).getLastname();
            if (lastnamesaved.compareTo(lastname)==0)
            {
              idsearched = i;
            }
          }
          catch(NullPointerException np){}
        }
        if (idsearched ==-1)
        {
          return toImport;
        }
        else
        {
          return (ObjecttoImport)choiceteacher.elementAt(idsearched);
        }*/
    }


    /*public void replaceTeacher(String lastname, ObjecttoImport objecttoreplace)
    {
       ObjecttoImport toImport = new ObjecttoImport();
       TeacherXML t = new TeacherXML();
       int idsearched = -1;
       //Vector choiceteacher contient les choix
       for (int i=0; i<choiceteacher.size();i++)
       {
         toImport = (ObjecttoImport)choiceteacher.elementAt(i);
         try
         {
           String lastnamesaved = ((TeacherXML)toImport.getObject()).getLastname();
           if (lastnamesaved.compareTo(lastname)==0)
           {
             //remplacer object par object chang
             choiceteacher.removeElementAt(i);
             choiceteacher.addElement(objecttoreplace);
           }
         }
         catch(NullPointerException np){}
       }

    }*/


    //Trouver le Contact selectionn dans le vecteur des objects qui contiennent le choix
    //import/notimport/create/replace
    public ObjecttoImport findContact(ContactXML contact) {
        ObjecttoImport toImport = null;
        int cpt = 0;
        int size = choicecontact.size();
        while (toImport == null && cpt < size) {
            ObjecttoImport o2 = (ObjecttoImport) choicecontact.elementAt(cpt);
            if (o2 != null && o2.getObject() != null && ((ContactXML) o2.getObject()).equals(contact))
                toImport = o2;
            cpt++;
        }

        if (toImport != null) {
            return toImport;
        } else {
            return new ObjecttoImport();
        }

        /*
        String classname = contact.getClass().getName();
        ObjecttoImport toImport = new ObjecttoImport();
        int idsearched = -1;
        ContactXML c = new ContactXML();

        try
        {
          InscriptionContactXML inscontact = (InscriptionContactXML)contact;
          //Vector choicecontact contient les choix
          for (int i=0; i<choiceinscontact.size();i++)
          {
            toImport = (ObjecttoImport)choiceinscontact.elementAt(i);
            try
            {
              try
              {
                c = (InscriptionContactXML)toImport.getObject();

                if (trcontrol.equalscontact(inscontact, c))
                {
                  idsearched = i;
                }
              }
              catch(ClassCastException n){}
            }
            catch(NullPointerException np){}
          }
          if (idsearched!=-1)
          {
             toImport = (ObjecttoImport)choiceinscontact.elementAt(idsearched);
          }
          else
          {
              toImport = new ObjecttoImport();
          }
        }
        catch(ClassCastException cr){}

        try
        {
          TrainingContactXML trcontact = (TrainingContactXML)contact;
          //Vector choicecontact contient les choix
          for (int i=0; i<choicetrcontact.size();i++)
          {
            toImport = (ObjecttoImport)choicetrcontact.elementAt(i);
            try
            {
              try
              {
                  c = (TrainingContactXML)toImport.getObject();

                  if (trcontrol.equalscontact(trcontact, c))
                  {
                    idsearched = i;
                  }
              }
              catch(ClassCastException n){}
            }
            catch(NullPointerException np){}
          }
          if (idsearched!=-1)
          {
             toImport = (ObjecttoImport)choicetrcontact.elementAt(idsearched);
          }
          else
          {
              toImport = new ObjecttoImport();
          }
        }
        catch(ClassCastException n){}

        return toImport;*/
    }


    /*public void replaceContact(String lastname, ObjecttoImport objecttoreplace)
    {
       ObjecttoImport toImport = new ObjecttoImport();
       ContactXML c = new ContactXML();
       int idsearched = -1;
       //Vector choicecontact contient les choix
       for (int i=0; i<choicecontact.size();i++)
       {
         toImport = (ObjecttoImport)choicecontact.elementAt(i);
         try
         {
           String lastnamesaved = ((ContactXML)toImport.getObject()).getLastname();
           if (lastnamesaved.compareTo(lastname)==0)
           {
             //remplacer object par object chang
             choicecontact.removeElementAt(i);
             choicecontact.add(i,objecttoreplace);
             if (idsearched!=-1)
             {
               trcontrol.setKey(objecttoreplace);
             }
             idsearched = i;
           }
         }
         catch(NullPointerException np){}
       }

    }*/

    //Trouver le Location selectionn dans le vecteur des objects qui contiennent le choix
    //import/notimport/create/replace
    public ObjecttoImport findLocation(LocationXML location) {
        ObjecttoImport toImport = null;
        int cpt = 0;
        int size = choicelocation.size();
        while (toImport == null && cpt < size) {
            ObjecttoImport o2 = (ObjecttoImport) choicelocation.elementAt(cpt);
            if (o2 != null && o2.getObject() != null && ((LocationXML) o2.getObject()).equals(location))
                toImport = o2;
            cpt++;
        }

        if (toImport != null)
            return toImport;
        else
            return new ObjecttoImport();

        /*
        ObjecttoImport toImport = new ObjecttoImport();
        LocationXML l = new LocationXML();
        int idsearched = -1;
        //Vector choicelocation contient les choix
        for (int i=0; i<choicelocation.size();i++)
        {
          toImport = (ObjecttoImport)choicelocation.elementAt(i);
          try
          {
            String denomsaved = ((LocationXML)toImport.getObject()).getDenomination();
            if (denomsaved.compareTo(denomination)==0)
            {
              idsearched = i;
            }
          }
          catch(NullPointerException np){}
        }
        if (idsearched ==-1)
        {
          return toImport;
        }
        else
        {
          return (ObjecttoImport)choicelocation.elementAt(idsearched);
        }*/
    }


    /*public void replaceLocation(String denomination, ObjecttoImport objecttoreplace)
    {
       ObjecttoImport toImport = new ObjecttoImport();
       LocationXML l = new LocationXML();
       int idsearched = -1;
       //Vector choicelocation contient les choix
       for (int i=0; i<choicelocation.size();i++)
       {
         toImport = (ObjecttoImport)choicelocation.elementAt(i);
         try
         {
           String denomsaved = ((LocationXML)toImport.getObject()).getDenomination();
           if (denomsaved.compareTo(denomination)==0)
           {
             //remplacer object par object chang
             choicelocation.removeElementAt(i);
             choicelocation.addElement(objecttoreplace);
           }
         }
         catch(NullPointerException np){}
       }

    }*/

    public void saveChoiceTeacher() {
        ObjecttoImport objectteacher = new ObjecttoImport();

        //trouver objectteacher s'il existe
        //String lastnamesave = teacher.getLastname();
        objectteacher = findTeacher(teacher);

        //Choix import / not import
        if (jimport.isSelected()) {
            objectteacher.setImporter(true);
            //Choix create / replace
            if (jcreate.isSelected()) {
                //Creation, id = -1
                objectteacher.setCreator(-1);
            } else {
                // Remplacer
                Teacher t_replace = (Teacher) jCBteacher2.getSelectedItem();
                int id = t_replace.getIdTeacher();
                objectteacher.setCreator(id);
            }
            //Sauvergarder les changements
            /*String fname = jTFfirstname.getText();
            String lname = jTFlastname.getText();
            String function = jTFfunction.getText();
            teacher.setFirstname(fname);
            teacher.setLastname(lname);
            teacher.setFunction(function);
            objectteacher.setObject(teacher);*/
            TeacherXML newTeacher = (TeacherXML) teacher.clone();
            String fname = jTFfirstname.getText();
            String lname = jTFlastname.getText();
            String function = jTFfunction.getText();
            newTeacher.setFirstname(fname);
            newTeacher.setLastname(lname);
            newTeacher.setFunction(function);
            objectteacher.setFixedObject(newTeacher);
        } else {
            objectteacher.setImporter(false);
        }

        //Introduire object concerne, modifi si ncessaire
        //replaceTeacher(lastnamesave, objectteacher);
    }

    public void saveChoiceContact() {
        ObjecttoImport objectcontact = new ObjecttoImport();
        String lastnamesave = contact.getLastname();
        //contact = (ContactXML)jCBcontacts1.getSelectedItem();
        objectcontact = findContact(contact);
        boolean selected = false;
        //Choix import / not import
        if (jcimport.isSelected()) {
            selected = true;
            objectcontact.setImporter(true);
            //Choix create / replace
            if (jccreate.isSelected()) {
                //Creation, id = -1
                objectcontact.setCreator(-1);
            } else {
                // Remplacer
                Contact c_replace = (Contact) jCBcontacts2.getSelectedItem();
                int id = c_replace.getIdContact();
                objectcontact.setCreator(id);
            }
            //Sauvergarder les changements
            ContactXML newContact = (ContactXML) contact.clone();
            String fname = jTFcfirstname.getText();
            String lname = jTFclastname.getText();
            String email = jTFcemail.getText();
            String tel = jTFctel.getText();
            newContact.setFirstname(fname);
            newContact.setLastname(lname);
            newContact.setEmail(email);
            newContact.setTel(tel);
            objectcontact.setFixedObject(newContact);
        } else {
            objectcontact.setImporter(false);
        }
        //Introduire object concerne, modifi si ncessaire
        //replaceContact(lastnamesave, objectcontact);
        /*Vector doubles = trcontrol.getdoubleContacts(doublecontact,contact);
        for (int i=0; i<doubles.size(); i++)
        {
          objectcontact = findContact((ContactXML)doubles.elementAt(i));
          objectcontact.setObject(contact);
          replaceContact(lastnamesave, objectcontact);
        }*/

    }

    public boolean getReplaceLocations() {
        if (jlreplace.isSelected())
            return true;
        else
            return false;
    }

    public boolean getReplaceContacts() {
        boolean replace = true;
        if (jcreplace.isSelected())
            return true;
        else
            return false;
    }

    public boolean getReplaceTeachers() {
        boolean replace = true;
        if (jreplace.isSelected())
            return true;
        else
            return false;
    }

    //Location de la bd le mme que celui  remplacer
    public boolean testEqualLocations(LocationXML loc) {
        boolean test = true;
        String key = loc.getKey();
        //Recherche du mme lement de la BD
        for (int i = 0; i < jCBlocations2.getItemCount(); i++) {
            Location locdb = (Location) jCBlocations2.getItemAt(i);
            String keydb = locdb.getIdLocation() + "";
            if (key.compareTo(keydb) == 0) {
                test = trcontrol.compareString(loc.getDenomination(), locdb.getDenomination());
            }
        }
        return test;
    }

    //Teacher de la bd le mme que celui  remplacer
    public boolean testEqualTeachers(TeacherXML teacher) {
        boolean test = true;
        String key = teacher.getKey();
        //Recherche du mme lement de la BD
        for (int i = 0; i < jCBteacher2.getItemCount(); i++) {
            Teacher teachdb = (Teacher) jCBteacher2.getItemAt(i);
            String keydb = teachdb.getIdTeacher() + "";
            if (key.compareTo(keydb) == 0) {
                test = trcontrol.compareString(teacher.getLastname(), teachdb.getLastname());
                test = test && trcontrol.compareString(teacher.getFirstname(), teachdb.getFirstname());
                test = test && trcontrol.compareString(teacher.getFunction(), teachdb.getFunction());
            }
        }
        return test;
    }

    //Contact de la bd le mme que celui  remplacer
    public boolean testEqualContacts(ContactXML contact) {
        boolean test = true;
        String key = contact.getKey();
        //Recherche du mme lement de la BD
        for (int i = 0; i < jCBcontacts2.getItemCount(); i++) {
            Contact contactdb = (Contact) jCBcontacts2.getItemAt(i);
            String keydb = contactdb.getIdContact() + "";
            if (key.compareTo(keydb) == 0) {
                test = trcontrol.compareString(contact.getLastname(), contactdb.getLastname());
                test = test && trcontrol.compareString(contact.getFirstname(), contactdb.getFirstname());
                test = test && trcontrol.compareString(contact.getTel(), contactdb.getTel());
                test = test && trcontrol.compareString(contact.getEmail(), contactdb.getEmail());
            }
        }
        return test;
    }

    public void saveChoiceLocation() {
        ObjecttoImport objectlocation = new ObjecttoImport();
        //trouver objectlocation s'il existe
        //String lastdenom = location.getDenomination();
        objectlocation = findLocation(location);
        //Choix import / not import
        if (jlimport.isSelected()) {
            objectlocation.setImporter(true);
            //Choix create / replace
            if (jlcreate.isSelected()) {
                //Creation, id = -1
                objectlocation.setCreator(-1);
            } else {
                // Remplacer
                Location l_replace = (Location) jCBlocations2.getSelectedItem();
                int id = l_replace.getIdLocation();
                objectlocation.setCreator(id);
            }
            //Sauvergarder les changements
            /*String denom = jTFdenomination1.getText();
            location.setDenomination(denom);
            objectlocation.setObject(location);*/
            LocationXML newLocation = (LocationXML) location.clone();
            String denom = jTFdenomination1.getText();
            newLocation.setDenomination(denom);
            objectlocation.setFixedObject(newLocation);
        } else {
            objectlocation.setImporter(false);
        }
        //Introduire object concerne, modifi si ncessaire
        //replaceLocation(lastdenom, objectlocation);
    }

    public Catalogue getSelectedCatalogue() {
        //id du catalogue slectionn, si -1 pas de catalogue slectionn
        Catalogue c = new Catalogue();
        try {
            c = (Catalogue) control.getSelection(tree.getTree().getSelectionPath());
        } catch (NullPointerException np) {
        }
        return c;
    }

    public int getIndex(int id, String objectname) {
        int index = -1;
        if (objectname.compareTo("contact") == 0) {
            Vector vcontacts = trcontrol.loadContacts(true);
            for (int i = 0; i < vcontacts.size(); i++) {
                if (((Contact) vcontacts.elementAt(i)).getIdContact() == id) {
                    index = i;
                }
            }
        } else if (objectname.compareTo("location") == 0) {
            Vector vlocations = trcontrol.loadLocations(true);
            for (int i = 0; i < vlocations.size(); i++) {
                if (((Location) vlocations.elementAt(i)).getIdLocation() == id) {
                    index = i;
                }
            }
        } else if (objectname.compareTo("teacher") == 0) {
            Vector vteachers = trcontrol.loadTeachers(true);
            for (int i = 0; i < vteachers.size(); i++) {
                if (((Teacher) vteachers.elementAt(i)).getIdTeacher() == id) {
                    index = i;
                }
            }
        }
        return index;
    }

    public TrainingXML saveObjectTedXML() {
        //modifier les donnes de data
        data.setPartnership(jTFpartnership.getText());
        data.setTitle(jTFtitle.getText());
        data.setCode(jTFcode.getText());
        data.setKey("");
        //choiceteacher contient toutes les teachers avec modifications
        for (int i = 0; i < choiceteacher.size(); i++) {
            ObjecttoImport oimport = (ObjecttoImport) choiceteacher.elementAt(i);
            this.computeTeacher(oimport);
            /*if (oimport.getImporter()==false)
            {
              deleteTeacher((TeacherXML)oimport.getObject());
            }
            else if (oimport.getCreator()==-1)
            {
              createTeacher((TeacherXML)oimport.getObject());
            }
            else
            {
              replaceTeacher((TeacherXML)oimport.getObject(), oimport.getCreator());
            }*/
        }

        //choicelocation contient toutes les location avec modifications
        for (int i = 0; i < choicelocation.size(); i++) {
            ObjecttoImport oimport = (ObjecttoImport) choicelocation.elementAt(i);
            this.computeLocations(oimport);
            /*if (oimport.getImporter()==false)
            {
              deleteLocation((LocationXML)oimport.getObject());
            }
            else if (oimport.getCreator()==-1)
            {
              createLocation((LocationXML)oimport.getObject());
            }
            else
            {
              replaceLocation((LocationXML)oimport.getObject(), oimport.getCreator());
            }*/
        }

        //choicecontact contient toutes les contacts avec modifications
        for (int i = 0; i < choicecontact.size(); i++) {
            ObjecttoImport oimport = (ObjecttoImport) choicecontact.elementAt(i);
            this.computeContacts(oimport);
            /*if (oimport.getImporter()==false)
            {
              deleteContact((ContactXML)oimport.getObject());
            }
            else if (oimport.getCreator()==-1)
            {
              createContact((ContactXML)oimport.getObject());
            }
            else
            {
              replaceContact((ContactXML)oimport.getObject(), oimport.getCreator());
            }*/
        }
        return data;
    }

    public void computeTeacher(ObjecttoImport o) {
        boolean alreadyWritten = false;

        if (data.getTeachers() != null) {
            Iterator it = data.getTeachers().iterator();
            Vector dataTeachers = (Vector) data.getTeachers().clone();
            while (it.hasNext()) {
                TeacherXML teacher = (TeacherXML) it.next();
                TeacherXML t2 = o.compareTeachers(teacher, alreadyWritten);

                if (t2 != null)
                    TOMA.log(TOMA.WARNING, "result=" + t2 + " (with key=" + t2.getKey() + ")");
                else
                    TOMA.log(TOMA.WARNING, "result=null");

                dataTeachers.remove(teacher);
                if (t2 != null) {
                    dataTeachers.add(t2);
                    //si t2!=teacher: pas le mme objet, on y a touch -> create ou replace
                    // et cl=vide ou null: create
                    if ((t2.getKey() == null || t2.getKey().equals("")) && t2 != teacher)
                        alreadyWritten = true;
                }
            }
            data.setTeachers(dataTeachers);
        }
        if (data instanceof apostal.ted.TrainingCourseXML) {
            TrainingCourseXML tc = (TrainingCourseXML) data;
            Vector sessions = tc.getCourseSessions();
            if (sessions != null) {
                Iterator it = sessions.iterator();
                while (it.hasNext()) {
                    CourseSessionXML cs = (CourseSessionXML) it.next();
                    if (cs != null) {
                        Vector csteachers = cs.getTeachers();
                        if (csteachers != null) {
                            Iterator it2 = csteachers.iterator();
                            Vector sessionTeachers = (Vector) csteachers.clone();
                            while (it2.hasNext()) {
                                TeacherXML teacher = (TeacherXML) it2.next();
                                TeacherXML t2 = o.compareTeachers(teacher, alreadyWritten);
                                sessionTeachers.remove(teacher);
                                if (t2 != null) {
                                    sessionTeachers.add(t2);
                                    if ((t2.getKey() == null || t2.getKey().equals("")) && t2 != teacher)
                                        alreadyWritten = true;
                                }
                            }
                            cs.setTeachers(sessionTeachers);
                        }
                    }
                }
            }
        } else //TrainingProgrammeXML
        {
            TrainingProgrammeXML tp = (TrainingProgrammeXML) data;
            if (tp.getUnits() != null) {
                Iterator it = tp.getUnits().iterator();
                while (it.hasNext()) {
                    UnitXML unit = (UnitXML) it.next();
                    if (unit != null) {
                        Vector uteachers = unit.getTeachers();
                        if (uteachers != null) {
                            Iterator it2 = uteachers.iterator();
                            Vector unitTeachers = (Vector) uteachers.clone();
                            while (it2.hasNext()) {
                                TeacherXML teacher = (TeacherXML) it2.next();
                                TeacherXML t2 = o.compareTeachers(teacher, alreadyWritten);
                                unitTeachers.remove(teacher);
                                if (t2 != null) {
                                    unitTeachers.add(t2);
                                    if ((t2.getKey() == null || t2.getKey().equals("")) && t2 != teacher)
                                        alreadyWritten = true;
                                }
                            }
                            unit.setTeachers(unitTeachers);
                        }
                        if (unit.getUnitSessions() != null) {
                            Iterator it2 = unit.getUnitSessions().iterator();
                            while (it2.hasNext()) {
                                UnitSessionXML session = (UnitSessionXML) it2.next();
                                if (session != null && session.getTeachers() != null) {
                                    Iterator it3 = session.getTeachers().iterator();
                                    Vector sessionTeachers = (Vector) session.getTeachers().clone();
                                    while (it3.hasNext()) {
                                        TeacherXML teacher = (TeacherXML) it3.next();
                                        TeacherXML t2 = o.compareTeachers(teacher, alreadyWritten);
                                        sessionTeachers.remove(teacher);
                                        if (t2 != null) {
                                            sessionTeachers.add(t2);
                                            if ((t2.getKey() == null || t2.getKey().equals("")) && t2 != teacher)
                                                alreadyWritten = true;
                                        }
                                    }
                                    session.setTeachers(sessionTeachers);
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    public void computeContacts(ObjecttoImport o) {
        boolean alreadyWritten = false;

        if (data.getTrainingContacts() != null) {
            Iterator it = data.getTrainingContacts().iterator();
            Vector dataTrContacts = (Vector) data.getTrainingContacts().clone();
            while (it.hasNext()) {
                ContactXML contact = (ContactXML) it.next();
                ContactXML c2 = o.compareContacts(contact, alreadyWritten);

                dataTrContacts.remove(contact);
                if (c2 != null) {
                    dataTrContacts.add(c2);
                    if ((c2.getKey() == null || c2.getKey().equals("")) && c2 != contact)
                        alreadyWritten = true;
                }
            }
            data.setTrainingContacts(dataTrContacts);
        }

        if (data.getInscriptionContacts() != null) {
            Iterator it = data.getInscriptionContacts().iterator();
            Vector dataInsContacts = (Vector) data.getInscriptionContacts().clone();
            while (it.hasNext()) {
                ContactXML contact = (ContactXML) it.next();
                ContactXML c2 = o.compareContacts(contact, alreadyWritten);

                TOMA.log(TOMA.WARNING, " " + o.getObject() + " processing a contact: " + contact + " alreadyWritten " + alreadyWritten);

                if (c2 != null)
                    TOMA.log(TOMA.WARNING, "result compare =" + c2 + " (with key=" + c2.getKey() + ")");
                else
                    TOMA.log(TOMA.WARNING, "result=null");


                dataInsContacts.remove(contact);
                if (c2 != null) {
                    dataInsContacts.add(c2);
                    if ((c2.getKey() == null || c2.getKey().equals("")) && c2 != contact)
                        alreadyWritten = true;
                }
            }
            data.setInscriptionContacts(dataInsContacts);
        }

        if (data instanceof apostal.ted.TrainingProgrammeXML) {
            TrainingProgrammeXML tp = (TrainingProgrammeXML) data;
            if (tp.getUnits() != null) {
                Iterator it = tp.getUnits().iterator();
                while (it.hasNext()) {
                    UnitXML unit = (UnitXML) it.next();
                    if (unit != null && unit.getTrainingContacts() != null) {
                        Iterator it2 = unit.getTrainingContacts().iterator();
                        Vector unitTrContacts = (Vector) unit.getTrainingContacts().clone();
                        while (it2.hasNext()) {
                            ContactXML contact = (ContactXML) it2.next();
                            ContactXML c2 = o.compareContacts(contact, alreadyWritten);
                            unitTrContacts.remove(contact);
                            if (c2 != null) {
                                unitTrContacts.add(c2);
                                if ((c2.getKey() == null || c2.getKey().equals("")) && c2 != contact)
                                    alreadyWritten = true;
                            }
                        }
                        unit.setTrainingContacts(unitTrContacts);
                    }
                }
            }
        }
    }

    public void computeLocations(ObjecttoImport o) {
        boolean alreadyWritten = false;

        if (data.getLocations() != null) {
            Iterator it = data.getLocations().iterator();
            Vector dataLocations = (Vector) data.getLocations().clone();
            while (it.hasNext()) {
                LocationXML location = (LocationXML) it.next();
                LocationXML l2 = o.compareLocations(location, alreadyWritten);
                dataLocations.remove(location);
                if (l2 != null) {
                    dataLocations.add(l2);
                    if ((l2.getKey() == null || l2.getKey().equals("")) && l2 != location)
                        alreadyWritten = true;
                }
            }
            data.setLocations(dataLocations);
        }

        if (data instanceof apostal.ted.TrainingCourseXML) {
            TrainingCourseXML tc = (TrainingCourseXML) data;
            Vector sessions = tc.getCourseSessions();
            if (sessions != null) {
                Iterator it = sessions.iterator();
                while (it.hasNext()) {
                    CourseSessionXML cs = (CourseSessionXML) it.next();
                    if (cs != null && cs.getLocation() != null) {
                        LocationXML location = cs.getLocation();
                        LocationXML l2 = o.compareLocations(location, alreadyWritten);
                        if (l2 != null) {
                            cs.setLocation(l2);
                            if ((l2.getKey() == null || l2.getKey().equals("")) && l2 != location)
                                alreadyWritten = true;
                        }
                    }
                }
            }
        } else {
            TrainingProgrammeXML tp = (TrainingProgrammeXML) data;
            Vector sessions = tp.getProgrammeSessions();
            if (sessions != null) {
                Iterator it = sessions.iterator();
                while (it.hasNext()) {
                    ProgrammeSessionXML session = (ProgrammeSessionXML) it.next();
                    if (session != null && session.getLocations() != null) {
                        Iterator it2 = session.getLocations().iterator();
                        Vector sessionLocations = (Vector) session.getLocations().clone();
                        while (it2.hasNext()) {
                            LocationXML location = (LocationXML) it2.next();
                            LocationXML l2 = o.compareLocations(location, alreadyWritten);
                            sessionLocations.remove(location);
                            if (l2 != null) {
                                sessionLocations.add(l2);
                                if ((l2.getKey() == null || l2.getKey().equals("")) && l2 != location)
                                    alreadyWritten = true;
                            }
                        }
                        session.setLocations(sessionLocations);
                    }
                }
            }
            if (tp.getUnits() != null) {
                Iterator it = tp.getUnits().iterator();
                while (it.hasNext()) {
                    UnitXML unit = (UnitXML) it.next();
                    if (unit != null) {
                        if (unit.getLocations() != null) {
                            Iterator it3 = unit.getLocations().iterator();
                            Vector unitLocations = (Vector) unit.getLocations().clone();
                            while (it3.hasNext()) {
                                LocationXML location = (LocationXML) it3.next();
                                LocationXML l2 = o.compareLocations(location, alreadyWritten);
                                unitLocations.remove(location);
                                if (l2 != null) {
                                    unitLocations.add(l2);
                                    if ((l2.getKey() == null || l2.getKey().equals("")) && l2 != location)
                                        alreadyWritten = true;
                                }
                            }
                            unit.setLocations(unitLocations);
                        }

                        if (unit.getUnitSessions() != null) {
                            Iterator it2 = unit.getUnitSessions().iterator();
                            while (it2.hasNext()) {
                                UnitSessionXML session = (UnitSessionXML) it2.next();
                                if (session != null && session.getLocation() != null) {
                                    LocationXML location = session.getLocation();
                                    LocationXML l2 = o.compareLocations(location, alreadyWritten);
                                    if (l2 != null) {
                                        session.setLocation(l2);
                                        if ((l2.getKey() == null || l2.getKey().equals("")) && l2 != location)
                                            alreadyWritten = true;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    /*
      // not import, delete from data
      public void deleteContact(ContactXML contact)
      {
          //Vector TrainingContacts
          Vector tc = data.getTrainingContacts();
          //Chaque TrainingContact
          for(int j=0; j<tc.size(); j++)
          {
            TrainingContactXML trcontact = (TrainingContactXML)tc.elementAt(j);
            if (trcontact.equals(contact))
            {
                tc.removeElementAt(j);
            }
          }
          //Vector InscriptionContacts
          Vector ic = data.getInscriptionContacts();
          //Chaque InscriptionContact
          for(int j=0; j<ic.size(); j++)
          {
            InscriptionContactXML inscontact = (InscriptionContactXML)ic.elementAt(j);
            if (inscontact.equals(contact))
            {
                ic.removeElementAt(j);
            }
          }
      }

      public void replaceContact(ContactXML contact, int id)
      {
        TOMA.log(TOMA.WARNING, "replaceContact");
        //remplacer contact avec id dans data
        //Transformer le id en String pour le sauvegarder en key
        String key = (new Integer(id)).toString();
          //Vector TrainingContacts
          Vector tc = data.getTrainingContacts();
          //Chaque TrainingContact
          for(int j=0; j<tc.size(); j++)
          {
            TrainingContactXML trcontact = (TrainingContactXML)tc.elementAt(j);
            if (trcontrol.equalscontact(contact, trcontact))
            {
                TOMA.log(TOMA.WARNING, contact +" equals " +trcontact);
                //replace in data
                trcontact.setLastname(contact.getLastname());
                trcontact.setFirstname(contact.getFirstname());
                trcontact.setEmail(contact.getEmail());
                trcontact.setTel(contact.getTel());
                trcontact.setKey(key);
            }
          }
          //Vector InscriptionContacts
          Vector ic = data.getInscriptionContacts();
          //Chaque InscriptionContact
          for(int j=0; j<ic.size(); j++)
          {
            InscriptionContactXML inscontact = (InscriptionContactXML)ic.elementAt(j);
            if (trcontrol.equalscontact(contact, inscontact))
            {
                TOMA.log(TOMA.WARNING, contact +" equals " +inscontact);
                inscontact.setLastname(contact.getLastname());
                inscontact.setFirstname(contact.getFirstname());
                inscontact.setEmail(contact.getEmail());
                inscontact.setTel(contact.getTel());
                inscontact.setKey(key);
            }
          }
      }

      public void createContact(ContactXML contact)
      {
        //remplacer contact dans data
        TOMA.log(TOMA.WARNING, "Contact to create: " +contact);
          //Vector TrainingContacts
          Vector tc = data.getTrainingContacts();
          //Chaque TrainingContact
          for(int j=0; j<tc.size(); j++)
          {
            TrainingContactXML trcontact = (TrainingContactXML)tc.elementAt(j);
            if (trcontact.equals(contact))
            {
                TOMA.log(TOMA.WARNING, contact +" equals " +trcontact);
                trcontact.setLastname(contact.getLastname());
                trcontact.setFirstname(contact.getFirstname());
                trcontact.setEmail(contact.getEmail());
                trcontact.setTel(contact.getTel());
                trcontact.setKey("");
                TOMA.log(TOMA.WARNING, "--------------Key tr contact: " + trcontact.getKey());
            }
          }
          //Vector InscriptionContacts
          Vector ic = data.getInscriptionContacts();
          //Chaque InscriptionContact
          for(int j=0; j<ic.size(); j++)
          {
            InscriptionContactXML inscontact = (InscriptionContactXML)ic.elementAt(j);
            if (inscontact.equals(contact))
            {
                TOMA.log(TOMA.WARNING, contact +" equals " +inscontact);
                inscontact.setLastname(contact.getLastname());
                inscontact.setFirstname(contact.getFirstname());
                inscontact.setEmail(contact.getEmail());
                inscontact.setTel(contact.getTel());
                inscontact.setKey("");
            }
          }
      }

      public void deleteLocation(LocationXML location)
      {
        TOMA.log(TOMA.WARNING, "Location to delete: " +location);
        //delete location de data
          //Vector Location
          Vector l = data.getLocations();
          //Chaque Location
          for(int j=0; j<l.size(); j++)
          {
            LocationXML loc = (LocationXML)l.elementAt(j);
            if (loc.equals(location))
            {
                //delete from data
                l.removeElementAt(j);
            }
          }
      }

      public void replaceLocation(LocationXML location, int id)
      {
        //remplacer location avec id dans data
        TOMA.log(TOMA.WARNING, "Location to replace: " +location);
        //Transformer le id en String pour le sauvegarder en key
        String key = (new Integer(id)).toString();
        TOMA.log(TOMA.WARNING, "Key: " +key +" ID " +id);

          //Vector locations
          Vector l = data.getLocations();
          //Chaque location
          for(int j=0; j<l.size(); j++)
          {
            LocationXML loc = (LocationXML)l.elementAt(j);
            if (loc.equals(location))
            {
                TOMA.log(TOMA.WARNING, location +" equals " +loc);
                //replace from data
                loc.setDenomination(location.getDenomination());
                loc.setKey(key);
            }
          }
      }

      public void createLocation(LocationXML location)
      {
        //remplacer location dans data
        TOMA.log(TOMA.WARNING, "Location to create: --------------------------> " +location);
          //Vector location
          Vector l = data.getLocations();
          //Chaque location
          for(int j=0; j<l.size(); j++)
          {
            LocationXML loc = (LocationXML)l.elementAt(j);
            if (loc.equals(location))
            {
                TOMA.log(TOMA.WARNING, location +" equals " +loc);
                //replace from data
                loc.setDenomination(location.getDenomination());
                loc.setKey("");
                TOMA.log(TOMA.WARNING, "--------------Key Location: " + loc.getKey());
            }
          }
      }

      public void deleteTeacher(TeacherXML teacher)
      {
        TOMA.log(TOMA.WARNING, "Teacher to delete: " +teacher);
        //delete de teacher dans data
          //Vector Teacher
          Vector t = data.getTeachers();
          //Chaque Teacher
          for(int j=0; j<t.size(); j++)
          {
            TeacherXML teach = (TeacherXML)t.elementAt(j);
            if (teach.equals(teacher))
            {
                //delete from data
                t.removeElementAt(j);
            }
          }
      }

      public void replaceTeacher(TeacherXML teacher, int id)
      {
        //remplacer teacher avec id dans data
        TOMA.log(TOMA.WARNING, "Teacher to reaplace: " +teacher);
        //Transformer le id en String pour le sauvegarder en key
        String key = (new Integer(id)).toString();
        TOMA.log(TOMA.WARNING, "Key: " +key +" ID " +id);
          //Vector Teacher
          Vector t = data.getTeachers();
          //Chaque Teacher
          for(int j=0; j<t.size(); j++)
          {
            TeacherXML teach = (TeacherXML)t.elementAt(j);
            if (teach.equals(teacher))
            {
                TOMA.log(TOMA.WARNING, teacher +" equals " +teach);
                //replace from data
                teach.setLastname(teacher.getLastname());
                teach.setFirstname(teacher.getFirstname());
                teach.setKey(key);
            }
          }
      }

      public void createTeacher(TeacherXML teacher)
      {
        //remplacer teacher avec id dans data
        TOMA.log(TOMA.WARNING, "Teacher to create: " +teacher);
          //Vector Teacher
          Vector t = data.getTeachers();
          //Chaque Teacher
          for(int j=0; j<t.size(); j++)
          {
            TeacherXML teach = (TeacherXML)t.elementAt(j);
            if (teach.equals(teacher))
            {
                TOMA.log(TOMA.WARNING, teacher +" equals " +teach);
                teach.setLastname(teacher.getLastname());
                teach.setFirstname(teacher.getFirstname());
                teach.setKey("");
            }
          }
      }
  */
    //Delete Catalogues dans TrainingXML, Vecteur catalogues importer sparment
    public Vector gestCatalogues() {
        Vector vcat = new Vector();
        //annuler ancien vecteur catalogues
        //Vecteur des catalogues
        Vector cat = data.getCatalogues();
        cat = new Vector();

        //Catalogue choisi
        Catalogue c = getSelectedCatalogue();
        int id = c.getIdCatalogue();
        if (id == -1) {
            c = (Catalogue) control.getSelection(tree.getTree().getClosestPathForLocation(0, 0));
        }
        vcat.addElement(c);
        return vcat;
    }

    //slectionner import teacher
    public void selecttimport() {
        jimport.setSelected(true);
    }

    //slectionner import location
    public void selectlimport() {
        jlimport.setSelected(true);
    }

    //slectionner import contact
    public void selectcimport() {
        jcimport.setSelected(true);
    }
}

