// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.view;

import apostal.toma.data.PublicationUnit;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import apostal.toma.data.TOMALabels;
import apostal.toma.data.SyrecosLogin;

import java.util.Vector;

public class LoginSOAP extends JDialog implements ActionListener {

    protected TOMAButton ok;
    protected TOMAButton cancel;
    protected TOMAMultipleLinesLabel label;
    protected JPanel pane;
    protected TOMALabels labels = new TOMALabels();

    private JPanel boutons;
    private JPanel textFields;
    private TOMALabel lUsername;
    private TOMALabel lPassword;
    private TOMALabel lWarningConn;
    private TOMATextField tfUsername;
    private JPasswordField tfPassword;
    private TOMAFrame parent;


    public LoginSOAP(ActionListener listener, TOMAFrame parent) {
        super(apostal.toma.TOMA.getInstance().getTomaView(), "", true);
        this.parent = parent;
        this.setTitle(labels.get("apostal.toma.publication.soap.login.title"));

        lUsername = new TOMALabel(labels.get("apostal.toma.publication.soap.login.username"));
        lPassword = new TOMALabel(labels.get("apostal.toma.publication.soap.login.password"));
        String warningMessage = TOMAFonts.htmlBegin;
        warningMessage = warningMessage + labels.get("apostal.toma.publication.soap.login.warning");
        warningMessage = warningMessage + TOMAFonts.htmlEnd;
        lWarningConn = new TOMALabel(warningMessage);


        tfUsername = new TOMATextField();
        tfPassword = new JPasswordField(20);
        tfPassword.setBackground(TOMAColors.editingFieldColor);
        tfPassword.setFont(TOMAFonts.editingFont);

        cancel = new TOMAButton(labels.get("apostal.toma.create.cancel"));
        cancel.setActionCommand("cancel");
        cancel.addActionListener(this);

        ok = new TOMAButton(labels.get("apostal.toma.publication.soap.login.ok"));
        ok.setActionCommand("soap_login_ok");
        ok.addActionListener(listener);

        boutons = new JPanel(new GridBagLayout());
        boutons.add(cancel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        boutons.add(ok, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        textFields = new JPanel(new GridBagLayout());
        textFields.add(lUsername, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        textFields.add(lPassword, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        textFields.add(tfUsername, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        textFields.add(tfPassword, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        pane = new JPanel();
        pane.setLayout(new GridBagLayout());

        pane.add(textFields, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        pane.add(lWarningConn, new GridBagConstraints(0, 1, 2, 1, 0.1, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 0, 0), 0, 0));

        pane.add(boutons, new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));


        this.setBackground(TOMAColors.tomaBackgroundColor);
        pane.setBackground(TOMAColors.tomaBackgroundColor);
        boutons.setBackground(TOMAColors.tomaBackgroundColor);
        this.getContentPane().add(pane);

    }

    public SyrecosLogin getLogin() {
        SyrecosLogin login = new SyrecosLogin();
        login.setLogin(tfUsername.getText());
        String pass = new String(tfPassword.getPassword());
        login.setPassword(pass);
        return login;
    }

    public void center() {
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = this.getSize();
        this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        if (cmd.equals("cancel")) {
            this.dispose();
            parent.show();

        }
    }

}
