// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */


package apostal.toma.view;


import toolbox.swing.LimitedNumericDocument;


import apostal.toma.TOMA;

import apostal.toma.data.*;

import apostal.toma.view.TOMAMultipleElementsList;

import apostal.toma.view.TOMAMultipleElements;

import apostal.toma.view.SeancePanel;

import apostal.toma.view.TrainingView;


import toolbox.swing.MultipleLinesLabel;


import java.lang.Class;

import java.awt.*;

import java.awt.event.ActionListener;

import java.awt.event.WindowListener;

import javax.swing.*;

import javax.swing.border.LineBorder;

import javax.swing.event.ListSelectionEvent;

import javax.swing.event.ListSelectionListener;


import java.lang.Integer;

import java.util.GregorianCalendar;

import java.util.Calendar;

import java.util.Vector;

import java.util.Iterator;

import java.sql.Date;


public class ProgrammeSessionView extends SessionView {

    protected static final int labels_length = 25;


    protected Vector tc_languages;

    protected Vector tc_locations;

    protected Vector tc_slots;

    protected TOMALabels labels;

    protected Vector allowed_languages;

    protected Vector allowed_slots;


    private Vector sessions;

    private ProgrammeSession session;


    GridBagLayout gridBagLayout1 = new GridBagLayout();

    TOMAMultipleLinesLabel label_name = new TOMAMultipleLinesLabel(labels_length);

    TOMATextField name = new TOMATextField(30);

    JComponent nameComponent;


    TOMAMultipleLinesLabel label_beginValidityDates = new TOMAMultipleLinesLabel(labels_length);

    TOMAMultipleLinesLabel label_endValidityDates = new TOMAMultipleLinesLabel(labels_length);


    TOMAMultipleLinesLabel label_language = new TOMAMultipleLinesLabel(labels_length);

    TOMAComboBox languages = new TOMAComboBox();


    TOMAMultipleLinesLabel label_dateIntervalBegin = new TOMAMultipleLinesLabel(labels_length);

    TOMAMultipleLinesLabel label_price = new TOMAMultipleLinesLabel(labels_length);

    TOMATextArea price = new TOMATextArea(3, 30);

    JComponent priceComponent;


    TOMAMultipleLinesLabel label_priceComment = new TOMAMultipleLinesLabel(labels_length);

    TOMATextArea priceComment = new TOMATextArea(3, 30);

    JComponent priceCommentComponent;


    TOMAMultipleLinesLabel label_comment = new TOMAMultipleLinesLabel(labels_length);

    TOMATextArea comment = new TOMATextArea(3, 30);

    JComponent commentComponent;


    TOMAMultipleLinesLabel label_locations = new TOMAMultipleLinesLabel(labels_length);

    TOMAMultipleElementsList locations;

    TOMAMultipleLinesLabel label_slot = new TOMAMultipleLinesLabel(labels_length);


    JPanel top = new JPanel();

    JPanel main = new JPanel();

    GridBagLayout gridBagLayout2 = new GridBagLayout();

    GridBagLayout gridBagLayout3 = new GridBagLayout();

    TOMALabel label_sessionsList;

    TOMALabel label_sessionContent;

    JList list_sessions = new JList();

    TOMAButton newSession = new TOMAButton();

    TOMAButton deleteSession = new TOMAButton();

    TOMALabel label_teachers = new TOMALabel();

    TOMAMultipleElementsList teachersList;


    TOMALabel dates = new TOMALabel();

    TOMAButton save = new TOMAButton();

    TOMAMultipleLinesLabel label_dateIntervalEnd = new TOMAMultipleLinesLabel(labels_length);

    JPanel beginValidityDates = new JPanel();

    GridBagLayout gridBagLayout4 = new GridBagLayout();

    JPanel endValidityDates = new JPanel();

    GridBagLayout gridBagLayout5 = new GridBagLayout();

    JPanel beginDateInterval = new JPanel();

    GridBagLayout gridBagLayout6 = new GridBagLayout();

    JPanel endDateInterval = new JPanel();

    TOMATextField beginValidityDay = new TOMATextField(2);

    TOMATextField beginValidityMonth = new TOMATextField(2);

    TOMATextField beginValidityYear = new TOMATextField(4);

    TOMATextField endValidityDay = new TOMATextField(2);

    TOMATextField endValidityMonth = new TOMATextField(2);

    TOMATextField endValidityYear = new TOMATextField(4);

    GridBagLayout gridBagLayout7 = new GridBagLayout();

    TOMATextField beginIntervalDay = new TOMATextField(2);

    TOMATextField beginIntervalMonth = new TOMATextField(2);

    TOMATextField beginIntervalYear = new TOMATextField(4);

    TOMATextField endIntervalDay = new TOMATextField(2);

    TOMATextField endIntervalMonth = new TOMATextField(2);

    TOMATextField endIntervalYear = new TOMATextField(4);



    //TOMAComboBox slotsList=new TOMAComboBox();

    JPanel slotsPanel = new JPanel();

    Vector slotsCheckBoxes = new Vector();


    public ProgrammeSessionView(ActionListener listener, WindowListener wlistener) {

        try {

            labels = new TOMALabels();

            jbInit(listener, wlistener);

        } catch (Exception e) {

            e.printStackTrace();

        }


    }


    private void jbInit(ActionListener listener, WindowListener wlistener) throws Exception {

        int type = TOMATemplateView.PROGRAMMESESSIONVIEW;


        this.setTitle(labels.get("apostal.toma.programmesessionview.title"));


        this.addWindowListener(wlistener);



        //name

        label_name.setText(labels.get("apostal.toma.sessionview.name"));

        TOMATemplateResult nameResult = TOMATemplateView.getTemplateResult(type, "sessionName");

        if (nameResult.getMaximum() > -1)

            label_name.setText(label_name.getText() + " (" + new Integer(nameResult.getMaximum()) + ")");

        if (nameResult.getValues() != null && !nameResult.getValues().isEmpty()) {

            TOMAComboBox nameCombo = new TOMAComboBox(nameResult.getValues());

            nameComponent = nameCombo;

        } else

            nameComponent = name;



        //validity dates

        label_beginValidityDates.setText(labels.get("apostal.toma.sessionview.beginValidityDate"));

        label_endValidityDates.setText(labels.get("apostal.toma.sessionview.endValidityDate"));

        beginValidityDates.setLayout(gridBagLayout4);

        endValidityDates.setLayout(gridBagLayout5);



        //language

        label_language.setText(labels.get("apostal.toma.sessionview.language"));

        TOMATemplateResult languageResult = TOMATemplateView.getTemplateResult(type, "language");

        if (languageResult.isMandatory())

            label_language.setText(label_language.getText() + " (*)");

        if (languageResult.isForbidden())

            languages.setEnabled(false);



        //date interval

        label_dateIntervalBegin.setText(labels.get("apostal.toma.sessionview.dateBegin"));

        label_dateIntervalEnd.setText(labels.get("apostal.toma.sessionview.dateEnd"));

        beginDateInterval.setLayout(gridBagLayout6);

        endDateInterval.setLayout(gridBagLayout7);



        //price

        label_price.setText(labels.get("apostal.toma.sessionview.price"));


        JScrollPane pricePane = new JScrollPane();

        pricePane.getViewport().add(price);

        TOMATemplateResult priceResult = TOMATemplateView.getTemplateResult(type, "price");

        if (priceResult.isForbidden())

            price.setEnabled(false);

        if (priceResult.isMandatory())

            label_price.setText(label_price.getText() + " (*)");

        if (priceResult.getMaximum() > -1)

            label_price.setText(label_price.getText() + " (" + new Integer(priceResult.getMaximum()) + ")");

        if (priceResult.getValues() != null && !priceResult.getValues().isEmpty()) {

            Vector v = priceResult.getValues();

            v.insertElementAt(ElementNotSpecified.getInstance(), 0);

            TOMAComboBox priceCombo = new TOMAComboBox(v);

            priceComponent = priceCombo;

        } else

            priceComponent = pricePane;



        //priceComment

        label_priceComment.setText(labels.get("apostal.toma.sessionview.priceComment"));

        JScrollPane priceCommentPane = new JScrollPane();

        priceCommentPane.getViewport().add(priceComment);

        TOMATemplateResult priceCommentResult = TOMATemplateView.getTemplateResult(type, "priceComment");

        if (priceCommentResult.isForbidden())

            priceComment.setEnabled(false);

        if (priceCommentResult.isMandatory())

            label_priceComment.setText(label_priceComment.getText() + " (*)");

        if (priceCommentResult.getMaximum() > -1)

            label_priceComment.setText(label_priceComment.getText() + " (" + new Integer(priceCommentResult.getMaximum()) + ")");

        if (priceCommentResult.getValues() != null && !priceCommentResult.getValues().isEmpty()) {

            Vector v = priceCommentResult.getValues();

            v.insertElementAt(ElementNotSpecified.getInstance(), 0);

            TOMAComboBox priceCommentCombo = new TOMAComboBox(v);

            priceCommentComponent = priceCommentCombo;

        } else

            priceCommentComponent = priceCommentPane;



        //comment

        label_comment.setText(labels.get("apostal.toma.sessionview.comment"));


        JScrollPane commentPane = new JScrollPane();

        commentPane.getViewport().add(comment);

        TOMATemplateResult commentResult = TOMATemplateView.getTemplateResult(type, "comment");

        if (commentResult.isForbidden())

            comment.setEnabled(false);

        if (commentResult.isMandatory())

            label_comment.setText(label_comment.getText() + " (*)");

        if (commentResult.getMaximum() > -1)

            label_comment.setText(label_comment.getText() + " (" + new Integer(commentResult.getMaximum()) + ")");

        if (commentResult.getValues() != null && !commentResult.getValues().isEmpty()) {

            Vector v = commentResult.getValues();

            v.insertElementAt(ElementNotSpecified.getInstance(), 0);

            TOMAComboBox commentCombo = new TOMAComboBox(v);

            commentComponent = commentCombo;

        } else

            commentComponent = commentPane;



        //locations

        label_locations.setText(labels.get("apostal.toma.sessionview.locations"));

        locations = new TOMAMultipleElementsList(new Vector(), labels.get("apostal.toma.sessionview.addLocation"), labels.get("apostal.toma.sessionview.removeLocation"), labels.get("apostal.toma.sessionview.trainingLocations"), labels.get("apostal.toma.sessionview.sessionLocations"), TOMAColors.multipleElementsColor, 5);

        TOMATemplateResult locationResult = TOMATemplateView.getTemplateResult(type, "location");

        if (locationResult.isMandatory())

            label_locations.setText(label_locations.getText() + " (*)");

        if (locationResult.isForbidden())

            locations.setEnabled(false);



        //slots

        slotsPanel.setLayout(new GridBagLayout());

        slotsPanel.setBackground(TOMAColors.sessionsMainBackgroundColor);

        label_slot.setText(labels.get("apostal.toma.sessionview.slots"));

        TOMATemplateResult slotResult = TOMATemplateView.getTemplateResult(type, "slot");

        if (slotResult.isMandatory())

            label_slot.setText(label_slot.getText() + " (*)");

        if (slotResult.isForbidden()) {

            Iterator iter = slotsCheckBoxes.iterator();

            while (iter.hasNext()) {

                JCheckBox box = (JCheckBox) iter.next();

                box.setEnabled(false);

            }

        }



        //top
        top.setLayout(gridBagLayout3);
        top.setBackground(TOMAColors.sessionsBackgroundColor);
        newSession.setText(labels.get("apostal.toma.sessionview.createSession"));
        newSession.setActionCommand("create");
        newSession.addActionListener(listener);
        deleteSession.setText(labels.get("apostal.toma.sessionview.delete"));
        deleteSession.setActionCommand("delete");
        deleteSession.addActionListener(listener);
        deleteSession.setEnabled(false);
        JScrollPane sessionsPane = new JScrollPane();
        list_sessions.setVisibleRowCount(5);
        list_sessions.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        list_sessions.addListSelectionListener(this);
        list_sessions.setFixedCellWidth(200);
        list_sessions.setBackground(TOMAColors.editingFieldColor);
        list_sessions.setFont(TOMAFonts.listsFont);
        sessionsPane.getViewport().add(list_sessions);
        label_sessionsList = new TOMALabel(labels.get("apostal.toma.sessionview.sessionsList"));
        label_sessionContent = new TOMALabel(labels.get("apostal.toma.sessionview.sessionContent"));
        dates.setText("");
        save.setText(labels.get("apostal.toma.sessionview.save"));
        save.setActionCommand("save");
        save.addActionListener(listener);

        /******** Panels ***************/

        JPanel panel = new JPanel();
        panel.setLayout(gridBagLayout1);
        panel.setBackground(TOMAColors.sessionsBackgroundColor);
        JScrollPane scrollPane = new JScrollPane(panel);
        GridBagConstraints cons = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0);

        panel.add(top, cons);

        cons.insets = new Insets(5, 5, 0, 0);
        top.add(label_sessionsList, cons);

        cons.gridx = 1;
        cons.gridheight = 2;
        cons.insets = new Insets(5, 0, 10, 0);
        top.add(sessionsPane, cons);

        cons.gridx = 2;
        cons.gridheight = 1;
        cons.insets = new Insets(5, 5, 5, 0);
        cons.anchor = GridBagConstraints.SOUTHWEST;
        cons.weighty = 0.1;
        top.add(newSession, cons);

        cons.gridy = 1;
        cons.anchor = GridBagConstraints.NORTHWEST;
        cons.insets = new Insets(0, 5, 10, 0);
        top.add(deleteSession, cons);

        cons.weighty = 0.0;
        cons.gridx = 0;
        cons.gridy = 2;
        cons.insets = new Insets(0, 5, 0, 0);
        top.add(label_sessionContent, cons);

        main.setLayout(gridBagLayout2);
        main.setBorder(new LineBorder(Color.black, 1));
        main.setBackground(TOMAColors.sessionsMainBackgroundColor);
        cons.gridy = 1;
        cons.anchor = GridBagConstraints.CENTER;
        cons.insets = new Insets(0, 5, 5, 5);
        cons.ipadx = 10;
        cons.ipady = 10;
        panel.add(main, cons);

        cons.gridy = 0;
        cons.anchor = GridBagConstraints.NORTHWEST;

        cons.insets = new Insets(0, 0, 5, 0);

        cons.ipadx = 0;

        cons.ipady = 0;

        main.add(label_name, cons);

        cons.gridx = 1;

        cons.weightx = 1.0;

        main.add(nameComponent, cons);

        cons.gridx = 2;

        cons.gridy = 0;

        cons.weightx = 0.0;

        main.add(label_language, cons);

        cons.gridx = 3;

        cons.weightx = 1.0;

        main.add(languages, cons);

        cons.gridx = 0;

        cons.gridy = 1;

        cons.weightx = 0.0;

        main.add(label_price, cons);

        cons.gridx = 1;

        cons.gridheight = 2;

        cons.weightx = 1.0;

        main.add(priceComponent, cons);

        cons.gridx = 0;

        cons.gridy = 3;

        cons.gridheight = 1;

        cons.weightx = 0.0;

        main.add(label_priceComment, cons);

        cons.gridx = 1;

        cons.gridheight = 2;

        cons.weightx = 1.0;

        main.add(priceCommentComponent, cons);

        cons.gridx = 0;

        cons.gridy = 5;

        cons.gridheight = 1;

        cons.weightx = 0.0;

        main.add(label_comment, cons);

        cons.gridx = 1;

        cons.gridheight = 2;

        cons.weightx = 1.0;

        main.add(commentComponent, cons);

        cons.gridx = 0;

        cons.gridy = 7;

        cons.gridheight = 1;

        cons.weightx = 0.0;

        main.add(label_locations, cons);

        cons.gridx = 0;

        cons.gridy = 8;

        cons.gridwidth = 4;

        cons.weightx = 1.0;

        main.add(locations, cons);

        cons.gridx = 2;

        cons.gridy = 1;

        cons.gridwidth = 1;

        cons.weightx = 0.0;

        main.add(label_slot, cons);

        cons.gridx = 3;

        main.add(slotsPanel, cons);
        cons.gridx = 0;
        cons.gridy = 10;
        main.add(label_beginValidityDates, cons);
        cons.gridy = 11;
        main.add(label_endValidityDates, cons);
        cons.gridx = 1;
        cons.gridy = 10;
        main.add(beginValidityDates, cons);
        cons.gridy = 11;
        main.add(endValidityDates, cons);
        cons.gridx = 2;
        cons.gridy = 10;
        main.add(label_dateIntervalBegin, cons);
        cons.gridy = 11;
        main.add(label_dateIntervalEnd, cons);
        cons.gridx = 3;
        cons.gridy = 10;
        main.add(beginDateInterval, cons);
        cons.gridy = 11;
        main.add(endDateInterval, cons);

        cons.gridy = 12;

        cons.anchor = GridBagConstraints.SOUTH;

        cons.insets = new Insets(0, 0, 0, 0);

        main.add(save, cons);

        cons.gridx = 0;

        cons.gridwidth = 3;

        cons.anchor = GridBagConstraints.NORTHWEST;

        main.add(dates, cons);



        //dates

        beginValidityDay.setDocument(new LimitedNumericDocument(2));

        beginValidityMonth.setDocument(new LimitedNumericDocument(2));

        beginValidityYear.setDocument(new LimitedNumericDocument(4));

        endValidityDay.setDocument(new LimitedNumericDocument(2));

        endValidityMonth.setDocument(new LimitedNumericDocument(2));

        endValidityYear.setDocument(new LimitedNumericDocument(4));

        beginIntervalDay.setDocument(new LimitedNumericDocument(2));

        beginIntervalMonth.setDocument(new LimitedNumericDocument(2));

        beginIntervalYear.setDocument(new LimitedNumericDocument(4));

        endIntervalDay.setDocument(new LimitedNumericDocument(2));

        endIntervalMonth.setDocument(new LimitedNumericDocument(2));

        endIntervalYear.setDocument(new LimitedNumericDocument(4));


        cons.gridx = 0;

        cons.gridy = 0;

        cons.gridwidth = 1;

        beginValidityDates.add(beginValidityDay, cons);

        cons.gridx = 1;

        beginValidityDates.add(beginValidityMonth, cons);

        cons.gridx = 2;

        beginValidityDates.add(beginValidityYear, cons);

        cons.gridx = 0;

        endValidityDates.add(endValidityDay, cons);

        cons.gridx = 1;

        endValidityDates.add(endValidityMonth, cons);

        cons.gridx = 2;

        endValidityDates.add(endValidityYear, cons);

        cons.gridx = 0;

        beginDateInterval.add(beginIntervalDay, cons);

        cons.gridx = 1;

        beginDateInterval.add(beginIntervalMonth, cons);

        cons.gridx = 2;

        beginDateInterval.add(beginIntervalYear, cons);

        cons.gridx = 0;

        endDateInterval.add(endIntervalDay, cons);

        cons.gridx = 1;

        endDateInterval.add(endIntervalMonth, cons);

        cons.gridx = 2;

        endDateInterval.add(endIntervalYear, cons);


        this.setContentPane(panel);

    }


    public void sessionSelected() {
        //mettre dans le tableau les anciennes valeurs
        session = this.getData();

        ProgrammeSession s = (ProgrammeSession) list_sessions.getSelectedValue();
        if (s != null) {
            this.setSessionData(s);
            deleteSession.setEnabled(true);
        }

    }


    /**

     * get the data of the current session

     */

    public ProgrammeSession getData() {

        ProgrammeSession s = this.session;

        if (s == null) {

            s = new ProgrammeSession();

            TOMA.log(TOMA.INFO, "the programme session wasn't chosen when there was a getData() operation");

        }


        if (!nameComponent.getClass().getName().equals("apostal.toma.view.TOMAComboBox"))

            s.setSessionName(name.getText());

        else {

            try {

                s.setSessionName((String) ((TOMAComboBox) nameComponent).getSelectedItem());

            } catch (java.lang.ClassCastException exception) {
                s.setSessionName(null);
            }

        }


        if (!priceComponent.getClass().getName().equals("apostal.toma.view.TOMAComboBox"))

            s.setPrice(price.getText());

        else {

            try {

                s.setPrice((String) ((TOMAComboBox) priceComponent).getSelectedItem());

            } catch (java.lang.ClassCastException exception) {
                s.setPrice(null);
            }

        }


        if (!priceCommentComponent.getClass().getName().equals("apostal.toma.view.TOMAComboBox"))

            s.setPriceComment(priceComment.getText());

        else {

            try {

                s.setPriceComment((String) ((TOMAComboBox) priceCommentComponent).getSelectedItem());

            } catch (java.lang.ClassCastException exception) {
                s.setPriceComment(null);
            }

        }


        if (!commentComponent.getClass().getName().equals("apostal.toma.view.TOMAComboBox"))

            s.setComment(comment.getText());

        else {

            try {

                s.setComment((String) ((TOMAComboBox) commentComponent).getSelectedItem());

            } catch (java.lang.ClassCastException exception) {
                s.setComment(null);
            }

        }


        try {

            Language l = (Language) languages.getSelectedItem();

            if (l != null)

                s.setLanguage(l);

        } catch (java.lang.ClassCastException exception) {
            s.setLanguage(null);
        }


        Vector locs = locations.getChosenData();

        if (locs != null)

            s.setLocations(locs);



        //slots

        Vector slots = new Vector();

        Iterator iter_slots = slotsCheckBoxes.iterator();

        while (iter_slots.hasNext()) {

            JCheckBox box = (JCheckBox) iter_slots.next();

            if (box.isSelected()) {

                String value = box.getActionCommand();

                Slot sl = new Slot(value);

                slots.add(sl);

            }

        }

        s.setSlots(slots);



        //beginValidityDate

        String begin_day = beginValidityDay.getText();

        String begin_month = beginValidityMonth.getText();

        String begin_year = beginValidityYear.getText();

        if (begin_day != null && !begin_day.equals("")

                && begin_month != null && !begin_month.equals("")

                && begin_year != null && !begin_year.equals("")) {

            try {

                int d = Integer.parseInt(begin_day);

                int m = Integer.parseInt(begin_month);

                int y = Integer.parseInt(begin_year);


                GregorianCalendar beginCal = new GregorianCalendar(y, m - 1, d);

                Date beginValidityDate = new Date(beginCal.getTime().getTime());

                s.setBeginValidityDate(beginValidityDate);

            } catch (java.lang.NumberFormatException ex) {

                TOMA.log(TOMA.SEVERE, "incorrect beginValidityDay");

            }

        } else
            s.setBeginValidityDate(null);



        //endValidityDate

        String end_day = endValidityDay.getText();

        String end_month = endValidityMonth.getText();

        String end_year = endValidityYear.getText();

        if (end_day != null && !end_day.equals("")

                && end_month != null && !end_month.equals("")

                && end_year != null && !end_year.equals("")) {

            try {

                int d = Integer.parseInt(end_day);

                int m = Integer.parseInt(end_month);

                int y = Integer.parseInt(end_year);


                GregorianCalendar endCal = new GregorianCalendar(y, m - 1, d);

                Date endValidityDate = new Date(endCal.getTime().getTime());

                s.setEndValidityDate(endValidityDate);

            } catch (java.lang.NumberFormatException ex) {

                TOMA.log(TOMA.SEVERE, "incorrect endValidityDay");

            }

        } else
            s.setEndValidityDate(null);



        //beginDate

        String begin_interval_day = beginIntervalDay.getText();

        String begin_interval_month = beginIntervalMonth.getText();

        String begin_interval_year = beginIntervalYear.getText();

        if (begin_interval_day != null && !begin_interval_day.equals("")

                && begin_interval_month != null && !begin_interval_month.equals("")

                && begin_interval_year != null && !begin_interval_year.equals("")) {

            try {

                int d = Integer.parseInt(begin_interval_day);

                int m = Integer.parseInt(begin_interval_month);

                int y = Integer.parseInt(begin_interval_year);


                GregorianCalendar beginCal = new GregorianCalendar(y, m - 1, d);

                Date beginIntervalDate = new Date(beginCal.getTime().getTime());

                s.setBeginDate(beginIntervalDate);

            } catch (java.lang.NumberFormatException ex) {

                TOMA.log(TOMA.SEVERE, "incorrect beginIntervalDay");

            }

        } else
            s.setBeginDate(null);



        //endValidityDate

        String end_interval_day = endIntervalDay.getText();

        String end_interval_month = endIntervalMonth.getText();

        String end_interval_year = endIntervalYear.getText();

        if (end_interval_day != null && !end_interval_day.equals("")

                && end_interval_month != null && !end_interval_month.equals("")

                && end_interval_year != null && !end_interval_year.equals("")) {

            try {

                int d = Integer.parseInt(end_interval_day);

                int m = Integer.parseInt(end_interval_month);

                int y = Integer.parseInt(end_interval_year);


                GregorianCalendar endCal = new GregorianCalendar(y, m - 1, d);

                Date endIntervalDate = new Date(endCal.getTime().getTime());

                s.setEndDate(endIntervalDate);

            } catch (java.lang.NumberFormatException ex) {

                TOMA.log(TOMA.SEVERE, "incorrect endIntervalDay");

            }

        } else
            s.setEndDate(null);


        return s;

    }


    public void setData(TrainingProgramme t) {

        int type = TOMATemplateView.PROGRAMMESESSIONVIEW;



        //tableau de sessions

        sessions = t.getProgrammeSessions();

        if (sessions != null)

            list_sessions.setListData(sessions);



        //languages

        TOMATemplateResult languageResult = TOMATemplateView.getTemplateResult(type, "language");

        Vector values = languageResult.getValues();


        languages.insertItemAt(ElementNotSpecified.getInstance(), 0);

        languages.setSelectedIndex(0);


        tc_languages = t.getLanguages();

        allowed_languages = new Vector();

        if (tc_languages != null) {

            Iterator iter = tc_languages.iterator();

            while (iter.hasNext()) {

                Language l = (Language) iter.next();


                if (l != null) {


                    if (values != null && !values.isEmpty()) {

                        //tester s'il est dans values

                        String code = l.getCode();

                        if (code != null) {

                            boolean found = false;

                            Iterator iter2 = values.iterator();

                            while (iter2.hasNext()) {

                                try {

                                    String values_code = (String) iter2.next();

                                    if (code.equals(values_code))

                                        found = true;

                                } catch (java.lang.ClassCastException exception) {
                                }

                            }

                            if (found) {

                                languages.addItem(l);

                                allowed_languages.add(l);

                            }

                        }

                    } else {

                        languages.addItem(l);

                        allowed_languages.add(l);

                    }

                }

            }

        }



        //locations

        tc_locations = t.getLocations();

        if (tc_locations != null) {

            locations.setExistingData(tc_locations);

        }



        //slots

        TOMATemplateResult slotResult = TOMATemplateView.getTemplateResult(type, "slot");

        Vector slotValues = slotResult.getValues();


        tc_slots = t.getSlots();

        allowed_slots = new Vector();


        if (tc_slots != null) {

            Iterator iter = tc_slots.iterator();

            while (iter.hasNext()) {

                Slot s = (Slot) iter.next();

                if (s != null) {


                    if (slotValues != null && !slotValues.isEmpty()) {

                        //tester s'il est dans values

                        String value = s.getValue();

                        if (value != null) {

                            boolean found = false;

                            Iterator iter2 = slotValues.iterator();

                            while (iter2.hasNext()) {

                                String values_value = (String) iter2.next();

                                if (value.equals(values_value))

                                    found = true;

                            }

                            if (found) {

                                //autoris

                                allowed_slots.add(s);



                                //ajout aux slots

                                this.addSlot(s);

                            }

                        }

                    } else {

                        //autoris

                        allowed_slots.add(s);

                        //ajout aux slots

                        this.addSlot(s);

                    }

                }

            }

        }


        this.setEnabled(false);


    }


    private void addSlot(Slot slot) {

        int cptSlots = slotsCheckBoxes.size();



        //label

        TOMALabel label = new TOMALabel(slot.getName());

        label.setBackground(TOMAColors.sessionsMainBackgroundColor);

        slotsPanel.add(label, new GridBagConstraints(0, cptSlots, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(2, 0, 0, 0), 0, 0));



        //box

        JCheckBox box = new JCheckBox();

        box.setBackground(TOMAColors.sessionsMainBackgroundColor);

        box.setName(slot.getName());

        box.setActionCommand(slot.getValue());

        slotsPanel.add(box, new GridBagConstraints(1, cptSlots, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));

        slotsCheckBoxes.add(box);


        this.pack();

    }


    /**

     * called when a session is selected

     */

    public void setSessionData(ProgrammeSession session) {

        this.session = session;


        if (!nameComponent.getClass().getName().equals("apostal.toma.view.TOMAComboBox"))

            name.setText(session.getSessionName());

        else

            TOMATemplateView.setTextCombo(session.getSessionName(), (TOMAComboBox) nameComponent);


        if (!priceComponent.getClass().getName().equals("apostal.toma.view.TOMAComboBox"))

            price.setText(session.getPrice());

        else

            TOMATemplateView.setTextCombo(session.getPrice(), (TOMAComboBox) priceComponent);


        if (!priceCommentComponent.getClass().getName().equals("apostal.toma.view.TOMAComboBox"))

            priceComment.setText(session.getPriceComment());

        else

            TOMATemplateView.setTextCombo(session.getPriceComment(), (TOMAComboBox) priceCommentComponent);


        if (!commentComponent.getClass().getName().equals("apostal.toma.view.TOMAComboBox"))

            comment.setText(session.getComment());

        else

            TOMATemplateView.setTextCombo(session.getComment(), (TOMAComboBox) commentComponent);



        //languages

        Language lng = session.getLanguage();

        if (lng != null) {

            if (tc_languages != null) {

                Iterator iter = tc_languages.iterator();

                while (iter.hasNext()) {

                    Language l = (Language) iter.next();

                    if (lng.getCode().equals(l.getCode())) {

                        if (!allowed_languages.contains(l)) {

                            allowed_languages.add(l);

                            languages.addItem(l);

                        }

                        languages.setSelectedItem(l);

                    }

                }

            }

        } else

            languages.setSelectedItem(ElementNotSpecified.getInstance());



        //locations

        /*Location loc=session.getLocation();

        if(tc_locations!=null)

        {

          Iterator iter = tc_locations.iterator();

      while (iter.hasNext())

      {

        Location l = (Location) iter.next();

        if(loc!=null && loc==l)

            locations.setSelectedItem(l);

      }

        }*/



        //locations

        Vector ls = session.getLocations();

        Vector realLocations = new Vector();

        //les retrouver dans tc_locations

        if (tc_locations != null && ls != null) {

            Iterator iter_ls = ls.iterator();

            while (iter_ls.hasNext()) {

                Location l1 = (Location) iter_ls.next();

                if (l1 != null) {

                    String denom = l1.getDenomination();

                    Location l_found = null;

                    Iterator iter_tcloc = tc_locations.iterator();

                    while (iter_tcloc.hasNext() && l_found == null) {

                        Location l2 = (Location) iter_tcloc.next();

                        if (l2 != null && l2.getDenomination().equals(denom))

                            l_found = l2;

                    }

                    if (l_found != null)

                        realLocations.add(l_found);

                    else

                        realLocations.add(l1);

                }


            }

        }

        locations.setChosenData(realLocations);

        /*if(ls!=null)

      locations.setChosenData(ls);

        else

      locations.setChosenData(new Vector());*/



        TOMATemplateResult result = TOMATemplateView.getTemplateResult(TOMATemplateView.PROGRAMMESESSIONVIEW, "location");

        if (result.isForbidden())

            locations.setEnabled(false);



        //slots



        //commencer par enlever tous ceux qui sont mis

        Iterator iter_checkboxes = slotsCheckBoxes.iterator();

        while (iter_checkboxes.hasNext()) {

            JCheckBox box = (JCheckBox) iter_checkboxes.next();

            box.setSelected(false);

        }



        //mettre les bons slots

        Vector sessionSlots = session.getSlots();

        if (sessionSlots != null) {

            Iterator iter = sessionSlots.iterator();

            while (iter.hasNext()) {

                Slot slot = (Slot) iter.next();

                if (slot != null) {

                    Iterator iter2 = tc_slots.iterator();

                    while (iter2.hasNext()) {

                        Slot s = (Slot) iter2.next();

                        if (s.getValue().equals(slot.getValue())) {

                            if (!allowed_slots.contains(s)) {

                                allowed_slots.add(s);

                                this.addSlot(s);

                            }



                            //trouver le slot dans slotsCheckBoxes pour le slectionner

                            Iterator iter_boxes = slotsCheckBoxes.iterator();

                            boolean found = false;

                            while (iter_boxes.hasNext() && !found) {

                                JCheckBox box = (JCheckBox) iter_boxes.next();

                                if (box.getActionCommand().equals(s.getValue())) {

                                    found = true;

                                    box.setSelected(true);

                                }

                            }

                        }

                    }

                }

            }

        }



        //dates

        Date creation = session.getDateCreation();

        Date maj = session.getDateMaj();

        dates.setTextWithLowerCase(labels.get("apostal.toma.trainingview.dateCreation") + creation + " " + labels.get("apostal.toma.trainingview.dateMaj") + maj);



        //beginValidityDate

        Date bvd = session.getBeginValidityDate();

        if (bvd != null) {

            GregorianCalendar beginCal = new GregorianCalendar();

            beginCal.setTime(bvd);

            int beginDay = beginCal.get(Calendar.DAY_OF_MONTH);

            int beginMonth = beginCal.get(Calendar.MONTH) + 1;

            int beginYear = beginCal.get(Calendar.YEAR);

            beginValidityDay.setText((new Integer(beginDay)).toString());

            beginValidityMonth.setText((new Integer(beginMonth)).toString());

            beginValidityYear.setText((new Integer(beginYear)).toString());

        } else {

            beginValidityDay.setText("");

            beginValidityMonth.setText("");

            beginValidityYear.setText("");

        }



        //endValidityDate

        Date evd = session.getEndValidityDate();

        if (evd != null) {

            GregorianCalendar endCal = new GregorianCalendar();

            endCal.setTime(evd);

            int endDay = endCal.get(Calendar.DAY_OF_MONTH);

            int endMonth = endCal.get(Calendar.MONTH) + 1;

            int endYear = endCal.get(Calendar.YEAR);

            endValidityDay.setText((new Integer(endDay)).toString());

            endValidityMonth.setText((new Integer(endMonth)).toString());

            endValidityYear.setText((new Integer(endYear)).toString());

        } else {

            endValidityDay.setText("");

            endValidityMonth.setText("");

            endValidityYear.setText("");

        }



        //beginIntervalDate

        Date bid = session.getBeginDate();

        if (bid != null) {

            GregorianCalendar beginCal = new GregorianCalendar();

            beginCal.setTime(bid);

            int beginDay = beginCal.get(Calendar.DAY_OF_MONTH);

            int beginMonth = beginCal.get(Calendar.MONTH) + 1;

            int beginYear = beginCal.get(Calendar.YEAR);

            beginIntervalDay.setText((new Integer(beginDay)).toString());

            beginIntervalMonth.setText((new Integer(beginMonth)).toString());

            beginIntervalYear.setText((new Integer(beginYear)).toString());

        } else {

            beginIntervalDay.setText("");

            beginIntervalMonth.setText("");

            beginIntervalYear.setText("");

        }



        //endIntervalDate

        Date eid = session.getEndDate();

        if (eid != null) {

            GregorianCalendar endCal = new GregorianCalendar();

            endCal.setTime(eid);

            int endDay = endCal.get(Calendar.DAY_OF_MONTH);

            int endMonth = endCal.get(Calendar.MONTH) + 1;

            int endYear = endCal.get(Calendar.YEAR);

            endIntervalDay.setText((new Integer(endDay)).toString());

            endIntervalMonth.setText((new Integer(endMonth)).toString());

            endIntervalYear.setText((new Integer(endYear)).toString());

        } else {

            endIntervalDay.setText("");

            endIntervalMonth.setText("");

            endIntervalYear.setText("");

        }


        this.pack();

    }


    public void refresh() {
        deleteSession.setEnabled(false);
        this.setEnabled(false);

        this.clearData();
    }

    public void clearData() {
        name.setText("");
        price.setText("");
        priceComment.setText("");
        comment.setText("");
        locations.setChosenData(new Vector());
        beginValidityDay.setText("");
        beginValidityMonth.setText("");
        beginValidityYear.setText("");
        endValidityDay.setText("");
        endValidityMonth.setText("");
        endValidityYear.setText("");
        beginIntervalDay.setText("");
        beginIntervalMonth.setText("");
        beginIntervalYear.setText("");
        endIntervalDay.setText("");
        endIntervalMonth.setText("");
        endIntervalYear.setText("");
    }

    public void setEnabled(boolean enabled) {

        if (!enabled) {

            name.setEnabled(false);

            if (nameComponent != null)

                nameComponent.setEnabled(false);


            languages.setEnabled(false);


            price.setEnabled(false);

            if (priceComponent != null)

                priceComponent.setEnabled(false);


            priceComment.setEnabled(false);

            if (priceCommentComponent != null)

                priceCommentComponent.setEnabled(false);


            comment.setEnabled(false);

            if (commentComponent != null)

                commentComponent.setEnabled(false);


            beginValidityDay.setEnabled(false);

            beginValidityMonth.setEnabled(false);

            beginValidityYear.setEnabled(false);

            endValidityDay.setEnabled(false);

            endValidityMonth.setEnabled(false);

            endValidityYear.setEnabled(false);

            beginIntervalDay.setEnabled(false);

            beginIntervalMonth.setEnabled(false);

            beginIntervalYear.setEnabled(false);

            endIntervalDay.setEnabled(false);

            endIntervalMonth.setEnabled(false);

            endIntervalYear.setEnabled(false);

            locations.setEnabled(false);


            Iterator iter = slotsCheckBoxes.iterator();

            while (iter.hasNext()) {

                JCheckBox box = (JCheckBox) iter.next();

                box.setEnabled(false);

            }


            save.setEnabled(false);

        } else {

            int type = TOMATemplateView.PROGRAMMESESSIONVIEW;


            name.setEnabled(true);

            if (nameComponent != null)

                nameComponent.setEnabled(true);


            TOMATemplateResult result = TOMATemplateView.getTemplateResult(type, "language");

            if (!result.isForbidden())

                languages.setEnabled(true);


            result = TOMATemplateView.getTemplateResult(type, "price");

            if (!result.isForbidden()) {

                price.setEnabled(true);

                if (priceComponent != null)

                    priceComponent.setEnabled(true);

            }


            result = TOMATemplateView.getTemplateResult(type, "priceComment");

            if (!result.isForbidden()) {

                priceComment.setEnabled(true);

                if (priceCommentComponent != null)

                    priceCommentComponent.setEnabled(true);

            }


            result = TOMATemplateView.getTemplateResult(type, "location");

            if (!result.isForbidden())

                locations.setEnabled(true);


            result = TOMATemplateView.getTemplateResult(type, "slot");

            if (!result.isForbidden()) {

                Iterator iter = slotsCheckBoxes.iterator();

                while (iter.hasNext()) {

                    JCheckBox box = (JCheckBox) iter.next();

                    box.setEnabled(true);

                }

            }


            result = TOMATemplateView.getTemplateResult(type, "comment");

            if (!result.isForbidden()) {

                comment.setEnabled(true);

                if (commentComponent != null)

                    commentComponent.setEnabled(true);

            }


            beginValidityDay.setEnabled(true);

            beginValidityMonth.setEnabled(true);

            beginValidityYear.setEnabled(true);

            endValidityDay.setEnabled(true);

            endValidityMonth.setEnabled(true);

            endValidityYear.setEnabled(true);

            beginIntervalDay.setEnabled(true);

            beginIntervalMonth.setEnabled(true);

            beginIntervalYear.setEnabled(true);

            endIntervalDay.setEnabled(true);

            endIntervalMonth.setEnabled(true);

            endIntervalYear.setEnabled(true);

            save.setEnabled(true);

        }

    }


    public String testTemplateElements() {

        int type = TOMATemplateView.PROGRAMMESESSIONVIEW;

        ProgrammeSession s = this.getData();


        String msg = "";


        return msg;

    }


    public void deleteSession(ProgrammeSession s) {
        sessions.remove(s);
        list_sessions.setListData(sessions);

        this.refresh();
        if (sessions.size() > 0)
            list_sessions.setSelectedIndex(0);
        /*else
      this.setEnabled(false);*/
    }


    public void createSession(ProgrammeSession s) {

        sessions.add(s);

        list_sessions.setListData(sessions);


        list_sessions.setSelectedValue(s, true);

    }

}

