// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.view;

import apostal.toma.data.*;
import apostal.toma.viewcontrol.*;
import apostal.toma.data.TOMALabels;
import apostal.toma.datacontrol.PublicationsControl;
import apostal.toma.TOMA;
import apostal.toma.database.PublicationUnitDB;

import toolbox.swing.LimitedNumericDocument;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.tree.TreeSelectionModel;

import java.util.*;


public class PublicationUnitsView extends AuxiliarElementsView implements ActionListener, ListSelectionListener {

    private PublicationUnit data;
    private Vector vlist = new Vector();
    private Vector vPublicationUnits = new Vector();
    private PublicationsControl control = new PublicationsControl();
    private TOMATree tree;

    PublicationUnitsEventHandler handler = new PublicationUnitsEventHandler(this);

    JList jListPublicationUnits = new JList();

    TOMAButton jButtonNew = new TOMAButton();
    TOMAButton jButtonDelete = new TOMAButton();
    TOMAButton jButtonBrowseDestPath = new TOMAButton();
    TOMAButton jButtonBrowseTemp = new TOMAButton();
    TOMAButton jButtonBrowseProp = new TOMAButton();
    TOMAButton jButtonSave = new TOMAButton();
    TOMAButton jButtonSavePublish = new TOMAButton();
    TOMAButton jButtonViewSelection = new TOMAButton();

    ButtonGroup group_exportLanguage = new ButtonGroup();
    private Vector exportLanguages;
    Vector radio_exportLanguages = new Vector();

    TitledBorder titledBorder1;

    private JScrollPane panelTree = new JScrollPane();
    private JScrollPane panelList = new JScrollPane();

    private JPanel contentPane;
    private JPanel panelInfosPub = new JPanel();
    private JPanel panelLanguages = new JPanel();
    private JPanel panelDateInterval = new JPanel();
    private JPanel panelDateIntervalEnd = new JPanel();

    TOMAFileChooser jChooseDestinationPath;
    TOMAFileChooser jChooseTemplateFile;
    TOMAFileChooser jChoosePropertiesFile;

    TitledBorder titledBorder;

    JCheckBox cbOrganismData;
    JCheckBox cbValidityDates;
    JCheckBox cbDateInterval;

    TOMALabel jLabelDestinationPath = new TOMALabel();
    TOMALabel jLabelLanguage = new TOMALabel();
    TOMALabel jLabelTemplateFile = new TOMALabel();
    TOMALabel jLabelPropertiesFile = new TOMALabel();
    TOMALabel jLabelValidityDates = new TOMALabel();
    TOMALabel jLabelOrganismData = new TOMALabel();
    TOMAMultipleLinesLabel jLabelTitleTree = new TOMAMultipleLinesLabel(3);
    TOMALabel jLabelName = new TOMALabel();
    TOMALabel jLabelType = new TOMALabel();
    TOMALabel jLabelExportLanguage = new TOMALabel();
    TOMALabel jLabelCreated = new TOMALabel();
    TOMALabel jLabelLastModification = new TOMALabel();
    TOMALabel jLabelCreatedDate = new TOMALabel();
    TOMALabel jLabelLastModificationDate = new TOMALabel();
    TOMALabel jLabelFirstCatName = new TOMALabel();
    TOMALabel jLabelDateInterval = new TOMALabel();
    TOMALabel jLabelDateIntervalEnd = new TOMALabel();
    TOMALabel jLabelDateIntervalBegin = new TOMALabel();

    TOMAMultipleLinesLabel jLabelDatesSyrecos = new TOMAMultipleLinesLabel(25);

    TOMATextField jTFName = new TOMATextField();
    TOMATextField jTFType = new TOMATextField();
    TOMATextField jTFFirstCatName = new TOMATextField();
    TOMATextField jTFBrowseDestPath = new TOMATextField();
    TOMATextField jTFBrowseTemp = new TOMATextField();
    TOMATextField jTFBrowseProp = new TOMATextField();
    TOMATextField jTFDateBeginDay = new TOMATextField(2);
    TOMATextField jTFDateBeginMonth = new TOMATextField(2);
    TOMATextField jTFDateBeginYear = new TOMATextField(4);
    TOMATextField jTFDateEndDay = new TOMATextField(2);
    TOMATextField jTFDateEndMonth = new TOMATextField(2);
    TOMATextField jTFDateEndYear = new TOMATextField(4);


    //pour les �l�ments lock�s
    private TOMALocked panelLocked = new TOMALocked(null);
    private boolean screenIsLocked = false;
    private boolean notSelect = true;
    public boolean alreadyWarned;
    public int selectedIndex;

    protected TOMALabels labels;

    public void getExportLanguages() {
        exportLanguages = PublicationsControl.getExportLanguages();
    }

    public PublicationUnitsView() {

        this.getExportLanguages();
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            labels = new TOMALabels();

            jbInit();
            pack();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public TOMATree getTree() {
        return this.tree;
    }

    private void jbInit() throws Exception {
        jButtonNew.setText(labels.get("apostal.toma.publication.new"));
        jButtonNew.addActionListener(handler);
        jButtonNew.setActionCommand("new");

        jButtonDelete.setText(labels.get("apostal.toma.publication.delete"));
        jButtonDelete.addActionListener(handler);
        jButtonDelete.setActionCommand("delete");
        jButtonDelete.setEnabled(false);

        jButtonSave.setText(labels.get("apostal.toma.publication.save"));
        jButtonSave.addActionListener(handler);
        jButtonSave.setActionCommand("save");
        jButtonSave.setEnabled(false);

        jButtonSavePublish.setText(labels.get("apostal.toma.publication.save_publish"));
        jButtonSavePublish.addActionListener(handler);
        jButtonSavePublish.setActionCommand("save_publish");
        jButtonSavePublish.setEnabled(false);

        jButtonViewSelection.setText(labels.get("apostal.toma.publication.view"));
        jButtonViewSelection.addActionListener(handler);
        jButtonViewSelection.setActionCommand("view");
        jButtonViewSelection.setEnabled(false);

        jButtonBrowseDestPath.setText(labels.get("apostal.toma.publication.dest_path"));
        jButtonBrowseDestPath.addActionListener(handler);
        jButtonBrowseDestPath.setActionCommand("choose_destination");
        jButtonBrowseDestPath.setEnabled(false);

        jButtonBrowseTemp.setText(labels.get("apostal.toma.publication.temp_file"));
        jButtonBrowseTemp.addActionListener(handler);
        jButtonBrowseTemp.setActionCommand("choose_template");
        jButtonBrowseTemp.setEnabled(false);

        jButtonBrowseProp.setText(labels.get("apostal.toma.publication.prop_file"));
        jButtonBrowseProp.addActionListener(handler);
        jButtonBrowseProp.setActionCommand("choose_properties");
        jButtonBrowseProp.setEnabled(false);

        jLabelDestinationPath.setText(labels.get("apostal.toma.publication.destination_directory"));
        jLabelLanguage.setText(labels.get("apostal.toma.publication.language"));
        jLabelTemplateFile.setText(labels.get("apostal.toma.publication.template_file"));
        jLabelPropertiesFile.setText(labels.get("apostal.toma.publication.properties_file"));
        jLabelValidityDates.setText(labels.get("apostal.toma.publication.validity_dates"));
        jLabelOrganismData.setText(labels.get("apostal.toma.publication.organism_data"));
        jLabelTitleTree.setText(labels.get("apostal.toma.publication.tree_title"));
        jLabelName.setText(labels.get("apostal.toma.publication.name"));
        jLabelType.setText(labels.get("apostal.toma.publication.type"));
        jLabelExportLanguage.setText(labels.get("apostal.toma.parameters.exportlanguage"));
        jLabelCreated.setText(labels.get("apostal.toma.publication.created"));
        jLabelLastModification.setText(labels.get("apostal.toma.publication.last_modification"));
        jLabelFirstCatName.setText(labels.get("apostal.toma.publication.firstCatName"));
        jLabelDatesSyrecos.setText(labels.get("apostal.toma.publication.syrecos.validityDates"));
        jLabelDateInterval.setText(labels.get("apostal.toma.publication.dateInteval.title"));
        jLabelDateIntervalEnd.setText(labels.get("apostal.toma.publication.dateInteval.end"));
        jLabelDateIntervalBegin.setText(labels.get("apostal.toma.publication.dateInteval.begin"));

        cbOrganismData = new JCheckBox(jLabelOrganismData.getText());
        cbOrganismData.setBackground(TOMAColors.auxBackgroundColor2);
        cbOrganismData.setBorder(new LineBorder(TOMAColors.buttonsBorderColor, 1));
        cbOrganismData.setForeground(Color.black);
        cbOrganismData.setFont(TOMAFonts.listsFont);
        cbValidityDates = new JCheckBox(jLabelValidityDates.getText());
        cbValidityDates.setBackground(TOMAColors.auxBackgroundColor2);
        cbValidityDates.setBorder(new LineBorder(TOMAColors.buttonsBorderColor, 1));
        cbValidityDates.setForeground(Color.black);
        cbValidityDates.setFont(TOMAFonts.listsFont);
        cbDateInterval = new JCheckBox();
        cbDateInterval.setBackground(TOMAColors.auxBackgroundColor2);
        cbDateInterval.setBorder(new LineBorder(TOMAColors.buttonsBorderColor, 1));
        cbDateInterval.setForeground(Color.black);
        cbDateInterval.setFont(TOMAFonts.listsFont);

        jTFDateBeginDay.setDocument(new LimitedNumericDocument(2));
        jTFDateBeginMonth.setDocument(new LimitedNumericDocument(2));
        jTFDateBeginYear.setDocument(new LimitedNumericDocument(4));
        jTFDateEndDay.setDocument(new LimitedNumericDocument(2));
        jTFDateEndMonth.setDocument(new LimitedNumericDocument(2));
        jTFDateEndYear.setDocument(new LimitedNumericDocument(4));


        jTFType.setEditable(false);
        /* liste des publications units */

        jListPublicationUnits.setBackground(TOMAColors.editingFieldColor);
        jListPublicationUnits.addListSelectionListener(this);
        /*jListPublicationUnits.addMouseListener(new java.awt.event.MouseAdapter()
      	{
        	public void mouseClicked(MouseEvent e)
        	{
          		jListPublicationUnits_mouseClicked(e);
        	}
      	});*/
        jListPublicationUnits.setVisibleRowCount(5);
        jListPublicationUnits.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        jListPublicationUnits.setFixedCellWidth(200);
        jListPublicationUnits.setFont(TOMAFonts.listsFont);
        vlist = loadPublicationUnits();
        jListPublicationUnits.setListData(vlist);
        panelList.getViewport().add(jListPublicationUnits, null);

        /* Informations pour une publicationUnit */


        titledBorder = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(134, 134, 134)), labels.get("apostal.toma.publication.title"));

        panelInfosPub.setBackground(TOMAColors.auxBackgroundColor2);
        panelInfosPub.setBorder(titledBorder);
        panelInfosPub.setLayout(new GridBagLayout());

        panelDateInterval.setBackground(TOMAColors.auxBackgroundColor2);
        panelDateInterval.setLayout(new GridBagLayout());

        panelDateIntervalEnd.setBackground(TOMAColors.auxBackgroundColor2);
        panelDateIntervalEnd.setLayout(new GridBagLayout());


        panelLanguages.setBackground(TOMAColors.auxBackgroundColor2);
        panelLanguages.setLayout(new GridBagLayout());
        panelLanguages.setBorder(new EmptyBorder(new Insets(0, 0, 0, 0)));

        panelDateInterval.add(jLabelDateInterval, new GridBagConstraints(0, 0, 4, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelDateInterval.add(jLabelDateIntervalBegin, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelDateInterval.add(jTFDateBeginDay, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelDateInterval.add(jTFDateBeginMonth, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelDateInterval.add(jTFDateBeginYear, new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelDateInterval.add(jLabelDateIntervalEnd, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelDateInterval.add(jTFDateEndDay, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelDateInterval.add(jTFDateEndMonth, new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelDateInterval.add(jTFDateEndYear, new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));


        panelLanguages.add(jLabelExportLanguage, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        int el_size = exportLanguages.size();
        for (int i = 0; i < el_size; i++) {
            Language l = (Language) exportLanguages.elementAt(i);
            JRadioButton b = new JRadioButton();
            b.setForeground(Color.black);
            b.setBackground(TOMAColors.auxBackgroundColor2);
            b.setText(l.getName());
            b.setActionCommand(l.getCode());
            b.setFont(TOMAFonts.listsFont);
            group_exportLanguage.add(b);
            panelLanguages.add(b, new GridBagConstraints(1 + i, 0, 1, 1, 1.0, 0.0
                    , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
            radio_exportLanguages.add(b);
        }

        panelInfosPub.add(panelLanguages, new GridBagConstraints(0, 2, 5, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));

        panelTree.setBackground(TOMAColors.auxBackgroundColor2);
        /*tree.getTree().setBackground(TOMAColors.auxBackgroundColor2);
      	tree.getTree().addTreeSelectionListener(handler);
      	tree.getTree().addTreeWillExpandListener(handler);
      	tree.getTree().addTreeExpansionListener(handler);*/

        Dimension panelTreeMax = new Dimension(400, 200);
        panelTree.setPreferredSize(panelTreeMax);

        panelTree.setBorder(new LineBorder(TOMAColors.scrollBarBackgroundColor, 2));

        panelInfosPub.add(jLabelName, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jLabelType, new GridBagConstraints(0, 1, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jLabelDestinationPath, new GridBagConstraints(0, 3, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jLabelPropertiesFile, new GridBagConstraints(0, 5, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jLabelTemplateFile, new GridBagConstraints(0, 4, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jLabelFirstCatName, new GridBagConstraints(0, 6, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jTFName, new GridBagConstraints(2, 0, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jTFType, new GridBagConstraints(2, 1, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jTFFirstCatName, new GridBagConstraints(2, 6, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jTFBrowseDestPath, new GridBagConstraints(2, 3, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jTFBrowseTemp, new GridBagConstraints(2, 4, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jTFBrowseProp, new GridBagConstraints(2, 5, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jButtonBrowseDestPath, new GridBagConstraints(4, 3, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jButtonBrowseTemp, new GridBagConstraints(4, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(jButtonBrowseProp, new GridBagConstraints(4, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfosPub.add(cbOrganismData, new GridBagConstraints(6, 0, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        panelInfosPub.add(jLabelDatesSyrecos, new GridBagConstraints(6, 1, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jLabelDatesSyrecos.setVisible(false);
        panelInfosPub.add(cbValidityDates, new GridBagConstraints(6, 1, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));


        panelInfosPub.add(jLabelTitleTree, new GridBagConstraints(0, 7, 3, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        //this.setTree(tree);

        panelInfosPub.add(panelTree, new GridBagConstraints(3, 7, 3, 5, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        panelInfosPub.add(jButtonViewSelection, new GridBagConstraints(6, 7, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        panelInfosPub.add(panelDateInterval, new GridBagConstraints(6, 8, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        /* panelInfosPub.add(panelDateIntervalEnd, new GridBagConstraints(6, 9, 1, 1, 0.0, 0.0
             ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
         */
        panelInfosPub.add(jButtonSave, new GridBagConstraints(6, 12, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        panelInfosPub.add(jButtonSavePublish, new GridBagConstraints(6, 13, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        panelInfosPub.add(jLabelCreated, new GridBagConstraints(0, 12, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        panelInfosPub.add(jLabelLastModification, new GridBagConstraints(0, 13, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        panelInfosPub.add(jLabelCreatedDate, new GridBagConstraints(2, 12, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        panelInfosPub.add(jLabelLastModificationDate, new GridBagConstraints(2, 13, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelTree.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        //JPanel contentPane = (JPanel)this.getContentPane();
        contentPane = (JPanel) this.getContentPane();
        contentPane.setLayout(new GridBagLayout());
        contentPane.add(panelList, new GridBagConstraints(0, 0, 1, 2, 0.1, 0.0
                , GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 0, 0));
        contentPane.add(jButtonNew, new GridBagConstraints(1, 0, 1, 1, 0.1, 0.1
                , GridBagConstraints.SOUTHWEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
        contentPane.add(jButtonDelete, new GridBagConstraints(1, 1, 1, 1, 0.1, 0.1
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
        contentPane.add(panelInfosPub, new GridBagConstraints(0, 2, 2, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        panelLocked.setVisible(false);
        contentPane.add(panelLocked, new GridBagConstraints(0, 3, 2, 1, 1.0, 1.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));


        this.addWindowListener(handler);
        this.setTitle(labels.get("apostal.toma.publication.title"));
        this.pack();
        this.setVisible(true);
        //this.refresh();
    }

    public Vector getData() {
        if (screenIsLocked || notSelect) {
            return null;
        } else {
            String name = jTFName.getText();
            String type = jTFType.getText();
            String destinationPath = jTFBrowseDestPath.getText();
            String template = jTFBrowseTemp.getText();
            String properties = jTFBrowseProp.getText();
            String firstCatalogueTitle = jTFFirstCatName.getText();
            boolean validityDates = cbValidityDates.isSelected();
            boolean organism = cbOrganismData.isSelected();
            boolean presDate = true;
            int beginIntervalDay = 0;
            int beginIntervalMonth = 0;
            int beginIntervalYear = 0;
            int endIntervalDay = 0;
            int endIntervalMonth = 0;
            int endIntervalYear = 0;
            Date endIntervalDate = null;
            Date beginIntervalDate = null;
            if (jTFDateBeginDay.getText() != null && !jTFDateBeginDay.getText().equals("")) {
                beginIntervalDay = Integer.parseInt(jTFDateBeginDay.getText());
            } else {
                presDate = false;
            }
            if (jTFDateBeginMonth.getText() != null && !jTFDateBeginMonth.getText().equals("")) {
                beginIntervalMonth = Integer.parseInt(jTFDateBeginMonth.getText());
            } else {
                presDate = false;
            }
            if (jTFDateBeginYear.getText() != null && !jTFDateBeginYear.getText().equals("")) {
                beginIntervalYear = Integer.parseInt(jTFDateBeginYear.getText());
            } else {
                presDate = false;
            }
            if (jTFDateEndDay.getText() != null && !jTFDateEndDay.getText().equals("")) {
                endIntervalDay = Integer.parseInt(jTFDateEndDay.getText());
            } else {
                presDate = false;
            }
            if (jTFDateEndMonth.getText() != null && !jTFDateEndMonth.getText().equals("")) {
                endIntervalMonth = Integer.parseInt(jTFDateEndMonth.getText());
            } else {
                presDate = false;
            }
            if (jTFDateEndYear.getText() != null && !jTFDateEndYear.getText().equals("")) {
                endIntervalYear = Integer.parseInt(jTFDateEndYear.getText());
            } else {
                presDate = false;
            }
            if (presDate) {
                GregorianCalendar debut = new GregorianCalendar(beginIntervalYear, beginIntervalMonth - 1, beginIntervalDay);
                beginIntervalDate = debut.getTime();
                GregorianCalendar fin = new GregorianCalendar(endIntervalYear, endIntervalMonth - 1, endIntervalDay);
                endIntervalDate = fin.getTime();
            }
            ButtonModel exportSelected = group_exportLanguage.getSelection();
            if (exportSelected != null) {
                String exportCode = exportSelected.getActionCommand();
                Language exportLanguage = PublicationsControl.getLanguageByCode(exportCode);
                data.setLanguage(exportLanguage);
            }
            data.setName(name);
            data.setDestinationPath(destinationPath);
            data.setTemplateFile(template);
            data.setPropertiesFile(properties);
            data.setConsiderValidityDates(validityDates);
            data.setPublishOrganismData(organism);
            data.setFirstCatalogueTitle(firstCatalogueTitle);
            handler.setTrainingToPublish(data, this.tree);
            Vector datas = new Vector();
            datas.add(data);
            datas.add(beginIntervalDate);
            datas.add(endIntervalDate);
            return datas;
        }
    }

    public void setData(PublicationUnit data) {
        clearData(false);
        this.data = data;
        jButtonBrowseDestPath.setEnabled(true);
        jButtonBrowseTemp.setEnabled(true);
        jButtonBrowseProp.setEnabled(true);
        jButtonSave.setEnabled(true);
        jButtonSavePublish.setEnabled(true);
        jButtonViewSelection.setEnabled(true);

        boolean validityDates = data.getConsiderValidityDates();
        boolean organismData = data.getPublishOrganismData();
        java.sql.Date dateCreation = data.getDateCreation();
        java.sql.Date dateLastModified = data.getDateMaj();
        int typePublication = data.getType();
        String destinationPath = data.getDestinationPath();
        String templateFile = data.getTemplateFile();
        String propertiesFile = data.getPropertiesFile();
        String name = data.getName();
        String firstCatTitle = data.getFirstCatalogueTitle();
        Language lang = data.getLanguage();
        String typeString = "";
        if (typePublication == PublicationUnit.PUBLICATION_HTML) {
            typeString = "HTML";
            jLabelDestinationPath.setText(labels.get("apostal.toma.publication.destination_directory"));
        } else if (typePublication == PublicationUnit.PUBLICATION_PDF) {
            typeString = "PDF";
            jLabelDestinationPath.setText(labels.get("apostal.toma.publication.destination_file"));
        } else if (typePublication == PublicationUnit.PUBLICATION_RTF) {
            typeString = "RTF";
            jLabelDestinationPath.setText(labels.get("apostal.toma.publication.destination_file"));
        }
        else if (typePublication == PublicationUnit.PUBLICATION_XML) {
            typeString = "XML (TED)";
            jLabelDestinationPath.setText(labels.get("apostal.toma.publication.destination_file"));
            jTFBrowseProp.setVisible(false);
            jTFBrowseTemp.setVisible(false);
            jButtonBrowseTemp.setVisible(false);
            jButtonBrowseProp.setVisible(false);
            jLabelTemplateFile.setVisible(false);
            jLabelPropertiesFile.setVisible(false);
        } else if (typePublication == PublicationUnit.PUBLICATION_SOAP || typePublication == PublicationUnit.PUBLICATION_SOAP_DELETE) {            
			if(typePublication == PublicationUnit.PUBLICATION_SOAP_DELETE)
				typeString="Server (delete)";
			else
				typeString = "Server";

            jLabelPropertiesFile.setText(labels.get("apostal.toma.publication.properties_file"));

            jTFBrowseDestPath.setVisible(false);
            jLabelDestinationPath.setVisible(false);
            jButtonBrowseDestPath.setVisible(false);

            jLabelTemplateFile.setVisible(false);
            jTFBrowseTemp.setVisible(false);
            jButtonBrowseTemp.setVisible(false);

            this.jLabelOrganismData.setVisible(false);
            this.cbOrganismData.setVisible(false);

            cbValidityDates.setVisible(false);
            jLabelValidityDates.setVisible(false);
            jTFDateBeginDay.setVisible(false);
            jTFDateBeginMonth.setVisible(false);
            jTFDateBeginYear.setVisible(false);
            jTFDateEndDay.setVisible(false);
            jTFDateEndMonth.setVisible(false);
            jTFDateEndYear.setVisible(false);

            jLabelExportLanguage.setVisible(false);
            panelLanguages.setVisible(false);

            cbDateInterval.setVisible(false);
            jLabelDateInterval.setVisible(false);
            jLabelDateIntervalBegin.setVisible(false);
            jLabelDateIntervalEnd.setVisible(false);

            jTFFirstCatName.setVisible(false);
            this.jLabelFirstCatName.setVisible(false);
        }
        else if (typePublication == PublicationUnit.PUBLICATION_XSL) {
            typeString = "Generic XSL";
            
            jLabelDestinationPath.setText(labels.get("apostal.toma.publication.destination_file"));
            jLabelPropertiesFile.setText(labels.get("apostal.toma.publication.properties_file"));
            
            jLabelTemplateFile.setVisible(false);
            jTFBrowseTemp.setVisible(false);
            jButtonBrowseTemp.setVisible(false);

            this.jLabelOrganismData.setVisible(false);
            this.cbOrganismData.setVisible(false);

            cbValidityDates.setVisible(false);
            jLabelValidityDates.setVisible(false);
            jTFDateBeginDay.setVisible(false);
            jTFDateBeginMonth.setVisible(false);
            jTFDateBeginYear.setVisible(false);
            jTFDateEndDay.setVisible(false);
            jTFDateEndMonth.setVisible(false);
            jTFDateEndYear.setVisible(false);

            jLabelExportLanguage.setVisible(false);
            panelLanguages.setVisible(false);

            cbDateInterval.setVisible(false);
            jLabelDateInterval.setVisible(false);
            jLabelDateIntervalBegin.setVisible(false);
            jLabelDateIntervalEnd.setVisible(false);

            jTFFirstCatName.setVisible(false);
            this.jLabelFirstCatName.setVisible(false);            
        }

        if (firstCatTitle != null)
            jTFFirstCatName.setText(firstCatTitle);
        if (name != null)
            jTFName.setText(name);
        if (destinationPath != null)
            jTFBrowseDestPath.setText(destinationPath);
        if (templateFile != null)
            jTFBrowseTemp.setText(templateFile);
        if (propertiesFile != null)
            jTFBrowseProp.setText(propertiesFile);
        if (dateCreation != null)
            jLabelCreatedDate.setText(dateCreation.toString());
        if (dateLastModified != null)
            jLabelLastModificationDate.setText(dateLastModified.toString());

        jTFType.setText(typeString);

        String el_code = data.getLanguage().getCode();
        Iterator iter_el = radio_exportLanguages.iterator();
        while (iter_el.hasNext()) {
            JRadioButton radio = (JRadioButton) iter_el.next();
            String cmd = radio.getActionCommand();
            if (el_code.equals(cmd))
                radio.setSelected(true);
            else
                radio.setSelected(false);
        }

        handler.setTreeSelection(data, this.tree);
        if (validityDates == true)
            cbValidityDates.setSelected(true);
        else
            cbValidityDates.setSelected(false);

        if (organismData == true)
            cbOrganismData.setSelected(true);
        else
            cbOrganismData.setSelected(false);
        this.pack();
        this.setEnabled(true);
    }

    public void setTemplateFile(String templateFile) {
        jTFBrowseTemp.setText(templateFile);
    }

    public void setDestinationPath(String destinationPath) {
        jTFBrowseDestPath.setText(destinationPath);
    }

    public void setPropertiesFile(String propertiesFile) {
        jTFBrowseProp.setText(propertiesFile);
    }

    public void clearData(boolean refresh) {
        jTFBrowseProp.setVisible(true);
        jTFBrowseTemp.setVisible(true);
        jButtonBrowseTemp.setVisible(true);
        jButtonBrowseProp.setVisible(true);
        jLabelTemplateFile.setVisible(true);
        jLabelPropertiesFile.setVisible(true);
        jLabelDestinationPath.setVisible(true);
        jLabelFirstCatName.setVisible(true);
        jTFFirstCatName.setVisible(true);
        jTFBrowseDestPath.setVisible(true);
        jButtonBrowseDestPath.setVisible(true);
        cbOrganismData.setVisible(true);
        cbValidityDates.setVisible(true);
        jLabelDatesSyrecos.setVisible(false);

        jLabelValidityDates.setVisible(true);
        jTFDateBeginDay.setVisible(true);
        jTFDateBeginMonth.setVisible(true);
        jTFDateBeginYear.setVisible(true);
        jTFDateEndDay.setVisible(true);
        jTFDateEndMonth.setVisible(true);
        jTFDateEndYear.setVisible(true);

        jLabelExportLanguage.setVisible(true);
        panelLanguages.setVisible(true);

        cbDateInterval.setVisible(true);
        jLabelDateInterval.setVisible(true);
        jLabelDateIntervalBegin.setVisible(true);
        jLabelDateIntervalEnd.setVisible(true);

        jButtonSave.setEnabled(false);
        jButtonSavePublish.setEnabled(false);
        jButtonViewSelection.setEnabled(false);
        jButtonBrowseDestPath.setEnabled(false);
        jButtonBrowseTemp.setEnabled(false);
        jButtonBrowseProp.setEnabled(false);

        jTFName.setText("");
        jTFType.setText("");
        jTFBrowseDestPath.setText("");
        jTFBrowseTemp.setText("");
        jTFBrowseProp.setText("");
        jTFFirstCatName.setText("");
        jTFDateBeginDay.setText("");
        jTFDateBeginMonth.setText("");
        jTFDateBeginYear.setText("");
        jTFDateEndDay.setText("");
        jTFDateEndMonth.setText("");
        jTFDateEndYear.setText("");
        cbValidityDates.setSelected(false);
        cbOrganismData.setSelected(false);
        if (!refresh) {
            TOMATreeControl control = new TOMATreeControl();
            tree = control.createRootTree(true, true, false, true, true, TOMA.getInstance().getTomaParameters().getLanguage());
            tree.getTree().getSelectionModel().setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
            String syst = System.getProperty("os.name");
            if (!syst.equals("Mac OS X")) {
                tree.addTOMAControlKeySimulator(this);
            }
            tree.getTree().addTreeSelectionListener(handler);
            tree.getTree().addTreeWillExpandListener(handler);
            tree.getTree().addTreeExpansionListener(handler);
            setTree(tree);
        }
        this.setEnabled(false);
    }

    public void setEnabled(boolean b) {
        jTFName.setEnabled(b);
        jTFType.setEnabled(b);
        jTFBrowseDestPath.setEnabled(b);
        jTFBrowseTemp.setEnabled(b);
        jTFBrowseProp.setEnabled(b);
        jTFFirstCatName.setEnabled(b);
        cbOrganismData.setEnabled(b);
        cbValidityDates.setEnabled(b);

        //languages
        if (radio_exportLanguages != null) {
            Iterator itr = radio_exportLanguages.iterator();
            while (itr.hasNext()) {
                JRadioButton radio = (JRadioButton) itr.next();
                radio.setEnabled(b);
            }
        }

        //list
        if (tree != null) {
            tree.getTree().setEnabled(b);
        }
    }

    public boolean publicationUnitSelected() {
        return !screenIsLocked && !notSelect && !jListPublicationUnits.isSelectionEmpty();
    }

    public void selectPublicationUnit(int id) {
        alreadyWarned = true;
        if (vlist != null) {
            Iterator it = vlist.iterator();
            boolean found = false;
            while (it.hasNext() && !found) {
                PublicationUnit p = (PublicationUnit) it.next();
                if (p.getIdPublicationUnit() == id) {
                    found = true;
                    jListPublicationUnits.setSelectedValue(p, true);
                    this.changeSelection();
                }
            }
        }
    }

    public void changeSelection() {
        int index = jListPublicationUnits.getSelectedIndex();
        selectedIndex = index;
        if (index > -1) {
            try {
                //unlock publicationUnit locked
                // data=donn�es de l'�cran avant qu'on change
                // si ces donn�es �taient un �cran de lock, alors data=null
                if (data != null) {
                    control.unlockPublicationUnit(data);
                    TOMA.log(TOMA.WARNING, "PublicationUnitsView, unlocking previous data=" + data);
                }

                //test lock from new publicationUnit
                PublicationUnit publication = (PublicationUnit) vlist.elementAt(index);
                control.loadPublicationUnit(publication, true);
                //control.unlockPublicationUnit(publication);

                boolean idtest = control.getLock(publication);
                if (!idtest) {
                    jButtonDelete.setEnabled(true);
                    notSelect = false;

                    TOMA.log(TOMA.WARNING, "PublicationUnitsView, publication is not locked: " + publication);
                    //lock new publicationUnit
                    control.lockPublicationUnit(publication);
                    //si l'�cran d'avant �tait "locked":
                    if (screenIsLocked) {
                        screenIsLocked = false;
                        panelInfosPub.setVisible(true);
                        panelLocked.setVisible(false);
                    }
                    //get new publicationUnit
                    setData(publication);
                    this.setEnabled(true);
                    this.pack();
                } else {
                    jButtonDelete.setEnabled(false);

                    TOMA.log(TOMA.WARNING, "PublicationUnitsView, publication is locked: " + publication + ", showing Lock panel");
                    //Show Message
                    //panelLocked = new TOMALocked(publication);
                    panelLocked.changeElement(publication);

                    if (!screenIsLocked) //on n'�tait pas d�j� lock�
                    {
                        data = null;
                        panelInfosPub.setVisible(false);
                        panelLocked.setVisible(true);
                        screenIsLocked = true;
                        notSelect = true;
                    } else {
                        panelLocked.setVisible(false);
                        panelLocked.setVisible(true);
                    }
                }
            } catch (NullPointerException np) {
            }
        }
    }

    public void valueChanged(ListSelectionEvent e)
            //public void jListPublicationUnits_mouseClicked(MouseEvent e)
    {

        int result = 0;

        if (!alreadyWarned) {
            if (selectedIndex > -1 && this.publicationUnitSelected() && TOMA.getInstance().getTomaParameters().getOpenWarningWindow()) {
                TOMAQuestion tq = new TOMAQuestion(TOMAFonts.htmlBegin + labels.get("apostal.toma.changeSelection.publicationUnit.confirm") + TOMAFonts.htmlEnd, labels.get("apostal.toma.changeSelection.publicationUnit.confirm.title"));
                result = tq.getResult();
                alreadyWarned = true;
            }
            if (result == 0) {
                this.changeSelection();
                //alreadyWarned = false;
                alreadyWarned = true;
            } else {
                alreadyWarned = true;
                //jListPublicationUnits.setSelectedIndex(e.getLastIndex());
                jListPublicationUnits.setSelectedIndex(selectedIndex);
            }

        } else {
            alreadyWarned = false;
        }

    }

    public void refresh() {
        this.clearData(true);
        vlist = loadPublicationUnits();
        jListPublicationUnits.setListData(vlist);

        jListPublicationUnits.clearSelection();
        jButtonDelete.setEnabled(false);
        jButtonSave.setEnabled(false);

        this.pack();

        /*if(vlist!=null && vlist.size()>0)
       	{
        	jButtonDelete.setEnabled(true);
        	jListPublicationUnits.setSelectedIndex(0);
        	//test lock from new publicationUnit
          	PublicationUnit pub = (PublicationUnit)vlist.elementAt(0);
          	boolean idtest = control.getLock(pub);
          	if (!idtest)
          	{
              	//lock new publicationUnit
              	control.lockPublicationUnit(pub);
              	//get new publicationUnit
              	setData(pub);
          	}
          	else
          	{
            	//Show Message
           		panelLocked.changeElement(pub);
            	data=null;
            	panelInfosPub.setVisible(false);
            	panelLocked.setVisible(true);
            	screenIsLocked=true;
          	}
       	} else{
       		notSelect=true;
       		this.clearData();
       		jButtonDelete.setEnabled(false);
       		//this.jbInit();
       	} */

    }

    public PublicationUnit getPublicationUnit() {
        setTree(this.tree);
        return data;

    }

    public void setTree(TOMATree tree) {
        tree.getTree().setVisibleRowCount(10);
        panelTree.setViewportView(tree.getTree());
        Dimension panelTreeMax = new Dimension(400, 200);
        panelTree.setPreferredSize(panelTreeMax);
    }


    public Vector loadPublicationUnits() {
        vPublicationUnits = control.loadPublicationUnits(false);
        return vPublicationUnits;
    }

    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
        String cmd = actionEvent.getActionCommand();
    }
}
