// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import javax.swing.*;
import java.util.*;
import java.awt.Insets;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionListener;

import apostal.toma.data.TOMALabels;
import apostal.toma.data.Location;

import javax.swing.JFrame;

import apostal.toma.data.Training;
import apostal.toma.TOMA;

public class RemoveTrainingView extends TOMACreate {

    private JList jList1 = new JList();
    JScrollPane jScrollPane1 = new JScrollPane();

    public RemoveTrainingView(ActionListener listener, Vector vtrainings, TOMAFrame parent) {
        super(parent);

        this.setTitle(labels.get("apostal.toma.catalogue.training.remove.title"));

        //remplir questions
        questions.setLayout(new GridBagLayout());
        JLabel label = new JLabel(labels.get("apostal.toma.catalogue.training.remove.message"));
        questions.add(label, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        jList1.setListData(vtrainings);
        jScrollPane1.getViewport().add(jList1);
        questions.add(jScrollPane1, new GridBagConstraints(0, 1, 1, 1, 0.1, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));

        ok.setText(labels.get("apostal.toma.catalogue.training.remove.ok"));
        ok.addActionListener(listener);
        cancel.setText(labels.get("apostal.toma.catalogue.training.remove.cancel"));

        this.pack();
    }


    public Object getData() {
        Vector vtrainings = new Vector();
        Object[] t = jList1.getSelectedValues();
        for (int i = 0; i < t.length; i++) {
            vtrainings.addElement(t[i]);
        }
        return vtrainings;
    }
}