// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import java.awt.*;
import javax.swing.*;

/**
 * Title:        TOMA
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      CRP Henri Tudor
 * @author
 * @version 1.0
 */

public class SubPointDealtWithPanel extends JPanel {
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    TOMALabel label_point = new TOMALabel();
    TOMATextArea point = new TOMATextArea();

    Integer columns;

    public SubPointDealtWithPanel(Integer columns) {
        this.columns = columns;

        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        ImageIcon icon = new ImageIcon("Images/point.gif");
        label_point.setIcon(icon);

        this.setLayout(gridBagLayout1);
        point.setColumns(columns.intValue());
        point.setRows(3);

        JScrollPane pane_point = new JScrollPane(point);

        this.add(label_point, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 5), 0, 0));
        this.add(pane_point, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(2, 0, 2, 0), 0, 0));

        this.setBackground(TOMAColors.multipleElementsColor);
    }

    public String getData() {
        return point.getText();
    }

    public void setData(String val) {
        point.setText(val);
    }

    public void setEnabled(boolean enabled) {
        point.setEnabled(enabled);
    }
}