// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import java.awt.Insets;
import javax.swing.JButton;
import javax.swing.SwingConstants;
import javax.swing.border.*;

import apostal.toma.TOMA;

/**
 * Title:        TOMA
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      CRP Henri Tudor
 * @author
 * @version 1.0
 */

public class TOMAButton extends JButton {

    public TOMAButton(boolean withMargin) {
        super();
        this.setDesign(withMargin);
    }

    public TOMAButton(String text, boolean withMargin) {
        super(text);
        this.setDesign(withMargin);
    }

    public TOMAButton() {
        super();
        this.setDesign(true);
    }

    public TOMAButton(String text) {
        super(text);
        this.setDesign(true);
    }

    private void setDesign(boolean withMargin) {
        this.setFont(TOMAFonts.buttonsFont);

        this.setBackground(TOMAColors.buttonsBackgroundColor);
        this.setForeground(TOMAColors.clickableTextColor);

        LineBorder myBorder = new LineBorder(TOMAColors.buttonsBorderColor, 1);
        if (withMargin) {
            EmptyBorder margin = new EmptyBorder(1, 2, 1, 2);
            this.setBorder(new CompoundBorder(myBorder, margin));
        } else
            this.setBorder(myBorder);
    }

    public void setText(String text) {
        if (text != null) {
            //tout en majuscule
            String maj = text.toUpperCase();

            //1ere lettre en majuscule
            /*String maj=text;
            if(text.length()>0)
               maj=text.substring(0, 1).toUpperCase()+text.substring(1);*/

            super.setText(maj);
        } else {
            TOMA.log(TOMA.SEVERE, "TOMAButton: trying to set null text");
            java.lang.Throwable th = new java.lang.Throwable();
            th.printStackTrace();
        }
    }
}