// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

/**
 * Title:        TOMA
 * Description:  Constants that contain all the colors chosen for TOMA
 * Copyright:    Copyright (c) 2001
 * Company:      CRP Henri Tudor
 * @author
 * @version 1.0
 */

import java.awt.Color;

public class TOMAColors {
    /********** listes *********/
    public static final Color multipleElementsColor = new Color(255, 204, 102);
    public static final Color listsLabelBackgroundColor = new Color(255, 204, 102);

    /************ training ***************/
    public static final Color toolbarColor = new Color(255, 204, 102);
    public static final Color trainingTabBackgroundColor = new Color(255, 204, 102);

    public static final Color trainingTabTitleBackgroundColor = Color.lightGray;
    public static final Color trainingTabSelectedTitleBackgroundColor = new Color(255, 204, 102);
    public static final Color trainingTabTitleForegroundColor = new Color(153, 0, 0);

    public static final Color trainingMainBackgroundColor = new Color(153, 153, 51);

    /*************** sessions **************/
    public static final Color sessionsBackgroundColor = new Color(153, 153, 51);
    public static final Color sessionsMainBackgroundColor = new Color(255, 204, 102);

    /*************** catalogues **************/
    public static final Color catalogueColor = new Color(153, 153, 51);

    /*************** autres crans ********************/
    public static final Color auxBackgroundColor = new Color(153, 153, 51);
    public static final Color auxBackgroundColor2 = new Color(255, 204, 102);

    /*************** dition ************************/
    public static final Color editingFieldColor = new Color(255, 255, 153);

    /****************** boutons **********************/
    public static final Color activatedButtonsColor = new Color(153, 0, 0);
    public static final Color unactivatedButtonsColor = new Color(255, 153, 51);
    public static final Color buttonsBorderColor = Color.white;
    public static final Color buttonsBackgroundColor = new Color(204, 51, 0);

    /************ gnral ******************/
    public static final Color tomaBackgroundColor = new Color(153, 153, 51);
    public static final Color treeBackgroundColor = new Color(255, 204, 102);
    public static final Color menuBackgroundColor = new Color(255, 153, 0);

    //scrollBar
    public static final Color scrollBarTrackColor = new Color(255, 204, 102);
    public static final Color scrollBarTrackBackgroundColor = Color.darkGray;
    public static final Color scrollBarBackgroundColor = Color.lightGray;

    //menu
    public static final Color menuSelectionBackground = Color.lightGray;
    public static final Color menuSelectionForeground = Color.black;

    //listes
    public static final Color listSelectionBackground = Color.lightGray;
    public static final Color listSelectionForeground = Color.black;

    //tree
    public static final Color treeTextColor = Color.black;
    public static final Color treeSelectionBackground = Color.lightGray;
    public static final Color treeSelectionForeground = Color.black;

    //texte
    public static final Color unclickableTextColor = Color.black;
    public static final Color clickableTextColor = Color.white;
    public static final Color textSelectionBackground = Color.lightGray;
    public static final Color textSelectionForeground = Color.black;
}
