// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import java.awt.Robot;
import java.awt.event.KeyEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;

import apostal.toma.TOMA;

public class TOMAControlKeySimulator implements MouseListener {
    private Robot robot;
    private TOMAFrame frame;

    public TOMAControlKeySimulator(TOMAFrame frame) {
        this.frame = frame;
        robot = null;
        try {
            robot = new Robot();
        } catch (java.awt.AWTException ex) {
            TOMA.log(TOMA.SEVERE, "Sorry, robots are not allowed on this platform: you'll have to click on the CTRL key manually");
        }
    }

    public void mouseEntered(MouseEvent e) {
        if (frame.isVisible()) {
            if (robot != null)
                robot.keyPress(KeyEvent.VK_CONTROL);
        }
    }

    public void mouseExited(MouseEvent e) {
        if (robot != null)
            robot.keyRelease(KeyEvent.VK_CONTROL);
    }

    public void mouseClicked(MouseEvent e) {
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }
}