// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.view;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Insets;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.*;

import apostal.toma.view.TOMAFrame;

import apostal.toma.TOMA;
import apostal.toma.data.TOMALabels;
import toolbox.swing.MultipleLinesLabel;

abstract public class TOMACreate extends JDialog implements ActionListener {

    protected TOMAButton ok;
    protected TOMAButton cancel;
    protected TOMAMultipleLinesLabel label;
    protected JPanel pane;
    protected JPanel questions;
    protected TOMAFrame parent;
    protected TOMALabels labels = new TOMALabels();
    protected JScrollPane scroll;

    public TOMACreate(TOMAFrame parent) {
        super(apostal.toma.TOMA.getInstance().getTomaView(), "", true);
        this.parent = parent;
        pane = new JPanel();
        pane.setLayout(new GridBagLayout());

        label = new TOMAMultipleLinesLabel(60);
        pane.add(label, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        questions = new JPanel();
        pane.add(questions, new GridBagConstraints(0, 1, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));

        //boutons
        JPanel boutons = new JPanel();

        cancel = new TOMAButton(labels.get("apostal.toma.create.cancel"));
        cancel.setActionCommand("cancel");
        cancel.addActionListener(this);
        boutons.add(cancel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 20, 5, 5), 0, 0));

        ok = new TOMAButton(labels.get("apostal.toma.create.ok"));
        ok.setActionCommand("create_ok");
        // la classe fille de mettre un actionListener
        boutons.add(ok, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 20), 0, 0));

        pane.add(boutons, new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 20), 0, 0));

        label.setBackground(TOMAColors.tomaBackgroundColor);
        questions.setBackground(TOMAColors.tomaBackgroundColor);
        boutons.setBackground(TOMAColors.tomaBackgroundColor);
        this.setBackground(TOMAColors.tomaBackgroundColor);
        pane.setBackground(TOMAColors.tomaBackgroundColor);
        scroll = new JScrollPane();
        scroll.getViewport().add(pane);
        this.getContentPane().add(scroll);
    }

    public void setMessage(String message) {
        label.setTextWithLowerCase(message);
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        if (cmd.equals("cancel")) {
            this.dispose();
            parent.show();
        }
    }

    public void center() {
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = this.getSize();
        this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    }

    abstract public Object getData();
}
