// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.view;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JLabel;

import java.awt.Toolkit;
import java.awt.Dimension;

/**
 * TOMADialog sert  dfinir un format standard pour toutes les fentres de dialogues (bloquantes) de TOMA.
 * */
public class TOMADialog extends JDialog {
    protected String message;

    public TOMADialog(JFrame frame, String message, String title) {
        super(frame, title, true);

        this.message = message;
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = this.getSize();
        this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

        this.setBackground(TOMAColors.tomaBackgroundColor);
        this.setFont(TOMAFonts.labelsFont);
        this.setForeground(TOMAColors.unclickableTextColor);
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public void showMessage() {
        JPanel panelMessage = new JPanel();
        JLabel labelMessage = new JLabel(message);
        panelMessage.add(labelMessage);
        labelMessage.setVisible(true);
        super.setContentPane(panelMessage);

        this.pack();

        apostal.toma.TOMA.log(apostal.toma.TOMA.WARNING, "TOMADialog, showing message=" + this.message);
    }
}
