// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/*
 * TOMAFirstRunServerProblem.java
 *
 * Created on February 26, 2002, 8:30 AM
 */

package apostal.toma.view;

import apostal.toma.TOMA;
import apostal.toma.viewcontrol.TOMAFirstRunEventHandler;

import javax.swing.*;
import java.awt.*;

/**
 *
 * @author  ramel
 */
public class TOMAFirstRunServerProblem extends TOMAFrame {

    private JPanel panel;
    private TOMALabel label;
    private TOMALabel label_server;
    private TOMATextField tf_server;
    private TOMAButton button;

    /** Creates a new instance of TOMAFirstRunServerProblem */
    public TOMAFirstRunServerProblem(TOMAFirstRunEventHandler handler, String serverName) {
        this.init(handler, serverName);
    }

    public void init(TOMAFirstRunEventHandler handler, String serverName) {
        panel = new JPanel();
        panel.setBackground(TOMAColors.auxBackgroundColor);
        panel.setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0);

        label = new TOMALabel();
        label.setTextWithLowerCase(TOMAFonts.htmlBegin + "The server could not be accessed.<BR>Please chek that it is running, and that the server name is correct." + TOMAFonts.htmlEnd);
        panel.add(label, c);

        label_server = new TOMALabel("TOMA's server complete name: ");
        c.gridy = 1;
        panel.add(label_server, c);

        c.gridx = 1;
        tf_server = new TOMATextField();
        tf_server.setText(serverName);
        panel.add(tf_server, c);

        button = new TOMAButton("OK");
        button.setActionCommand("ok_server");
        button.addActionListener(handler);
        c.gridx = 0;
        c.gridy = 2;
        c.gridwidth = 2;
        c.anchor = GridBagConstraints.CENTER;
        c.fill = GridBagConstraints.NONE;
        panel.add(button, c);

        this.setTitle("TOMA First Run: server problem");
        this.setContentPane(panel);
        this.pack();
        this.setVisible(true);
    }

    public String getServer() {
        return tf_server.getText();
    }
}
