// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/*
 * TOMAFirstRunSyrecosProblem.java
 *
 * Created on February 26, 2002, 8:42 AM
 */

package apostal.toma.view;

import apostal.toma.viewcontrol.TOMAFirstRunEventHandler;

import javax.swing.*;
import java.awt.*;

/**
 *
 * @author  ramel
 */
public class TOMAFirstRunSyrecosProblem extends TOMAFrame {

    private JPanel panel;
    private TOMALabel label;
    private TOMALabel label_login;
    private TOMATextField tf_login;
    private TOMALabel label_pwd;
    private JPasswordField tf_pwd;
    private TOMAButton button;
    private TOMAButton button_noImport;

    /** Creates a new instance of TOMAFirstRunSyrecosProblem */
    public TOMAFirstRunSyrecosProblem(TOMAFirstRunEventHandler handler, String login, String pwd) {
        this.init(handler, login, pwd);
    }

    public void init(TOMAFirstRunEventHandler handler, String login, String pwd) {
        panel = new JPanel();
        panel.setBackground(TOMAColors.auxBackgroundColor);
        panel.setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0);

        label = new TOMALabel();
        c.gridwidth = 2;
        label.setTextWithLowerCase(TOMAFonts.htmlBegin + "The extraction of Syrecos' data did not work. <BR>Please check that you entered the correct login and password, <BR>and also that you have an opened Internet connection, before retrying. <BR>If it is the case and the Syrecos extraction still doesn't work, please contact a Syrecos administrator" + TOMAFonts.htmlEnd);
        panel.add(label, c);

        label_login = new TOMALabel("Syrecos login: ");
        c.gridwidth = 1;
        c.gridy = 1;
        panel.add(label_login, c);

        c.gridx = 1;
        tf_login = new TOMATextField();
        tf_login.setText(login);
        panel.add(tf_login, c);

        c.gridy = 2;
        c.gridx = 0;
        label_pwd = new TOMALabel("password: ");
        panel.add(label_pwd, c);
        c.gridx = 1;
        tf_pwd = new JPasswordField(pwd);
        panel.add(tf_pwd, c);


        c.gridy = 3;
        c.gridx = 0;
        c.anchor = GridBagConstraints.CENTER;
        c.fill = GridBagConstraints.NONE;

        button_noImport = new TOMAButton("Do not Import Data from Syrecos");
        button_noImport.setActionCommand("cancel_syrecos");
        button_noImport.addActionListener(handler);
        panel.add(button_noImport, c);

        button = new TOMAButton("OK");
        button.setActionCommand("ok_syrecos");
        button.addActionListener(handler);
        c.gridx = 1;
        panel.add(button, c);

        this.setTitle("TOMA First Run: Syrecos extraction problem");
        this.setContentPane(panel);
        this.pack();
        this.setVisible(true);

    }

    public String getLogin() {
        return tf_login.getText();
    }

    public char[] getPassword() {
        return tf_pwd.getPassword();
    }
}
