// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import javax.swing.JTree;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.util.*;
import javax.swing.event.*;
import javax.swing.plaf.TreeUI;
import javax.swing.tree.*;
import javax.accessibility.*;

public class TOMAJTree extends JTree {

    public TOMAJTree(DefaultTreeModel newModel) {
        super(newModel);
        this.setCellRenderer(new TOMATreeCellRenderer());

    }
/*	public void updateUI() {
            super.updateUI();
            this.setCellRenderer(new TOMATreeCellRenderer());
        }
*/
    public void setCellRenderer(TOMATreeCellRenderer r) {
        super.setCellRenderer(r);
    }

    private TreePath[] getDescendantSelectedPaths(TreePath path, boolean includePath) {
        TreeSelectionModel sm = getSelectionModel();
        TreePath[] selPaths = (sm != null) ? sm.getSelectionPaths() :
                null;

        if (selPaths != null) {
            boolean shouldRemove = false;

            for (int counter = selPaths.length - 1; counter >= 0; counter--) {
                if (selPaths[counter] != null &&
                        path.isDescendant(selPaths[counter]) &&
                        (!path.equals(selPaths[counter]) || includePath))
                    shouldRemove = true;
                else
                    selPaths[counter] = null;
            }
            if (!shouldRemove) {
                selPaths = null;
            }
            return selPaths;
        }
        return null;
    }

    protected boolean removeDescendantSelectedPaths(TreePath path, boolean includePath) {
        TreePath[] toRemove = this.getDescendantSelectedPaths(path, includePath);

        if (toRemove != null) {
            getSelectionModel().removeSelectionPaths(toRemove);
            return false;
        }
        return false;
    }

    /* public void setCellRenderer(TreeCellRenderer x) {
         TreeCellRenderer oldValue = cellRenderer;

         cellRenderer = x;
         firePropertyChange(CELL_RENDERER_PROPERTY, oldValue, cellRenderer);
         invalidate();
     }*/


}