// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import javax.swing.JPanel;

/**
 * Title:        TOMA
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      CRP Henri Tudor
 * @author
 * @version 1.0
 */

import apostal.toma.data.TOMALabels;
//import toolbox.swing.MultipleLinesLabel;
import javax.swing.JLabel;

import apostal.toma.TOMA;
import apostal.toma.data.TOMAParameters;

public class TOMALocked extends JPanel {
    private TOMALabels labels = new TOMALabels();
    //private MultipleLinesLabel message=new MultipleLinesLabel(70);
    private JLabel message = new JLabel();

    public TOMALocked(Object element) {
        this.setText(element);

        this.add(message);
    }

    public void changeElement(Object element) {
        this.setText(element);

        this.removeAll();
        this.add(message);
        this.repaint();
    }

    public void setText(Object element) {
        String msg = null;
        if (element != null)
            msg = TOMAFonts.htmlBegin + "<H3>" + element.toString() + " :</H3> ";

        //vrifier si on est en monoposte ou non
        TOMAParameters params = TOMA.getInstance().getTomaParameters();
        if (params.isClientServer())
            msg = msg + labels.get("apostal.toma.client.locked");
        else
            msg = msg + labels.get("apostal.toma.singlestation.locked");

        msg = msg + TOMAFonts.htmlEnd;

        message.setText(msg);
    }
}