// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/*
 * TOMAPanel.java
 *
 * Created on March 14, 2002, 11:35 AM
 */

package apostal.toma.view;

import javax.swing.*;

//pour imprimer
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.*;
import java.awt.print.*;
import java.awt.geom.*;
/**
 *
 * @author  ramel
 */

import apostal.toma.TOMA;

public class TOMAPrintablePanel extends JPanel implements Printable {

    /** Creates a new instance of TOMAPanel */
    public TOMAPrintablePanel() {
        super();
    }

    public int print(Graphics graphics, PageFormat pageFormat, int pageIndex) throws PrinterException {
        Graphics newGraphics = graphics.create();
        Graphics2D g2d = (Graphics2D) newGraphics;

        //mettre en haut  gauche
        g2d.translate((new Double(pageFormat.getImageableX())).intValue(), (new Double(pageFormat.getImageableY())).intValue());

        //scale en largeur uniquement. En hauteur: garder la proportion
        double sx = (pageFormat.getImageableWidth()) / this.getWidth();
        g2d.scale(sx, sx);

        //taille relle (=ancienne taille * facteur) / taille feuille
        Double nb = new Double(this.getHeight() * sx / pageFormat.getImageableHeight());
        int nbPages = nb.intValue() + 1;
        if (pageIndex < nbPages) {
            //mettre en haut  gauche sur la bonne page
            //double yTranslate=pageIndex*pageFormat.getHeight();
            //calcul: (3H - IH)/2=(H - IH)/2 + H = une marge (haut ou bas) + H
            double yTranslate = pageIndex * (3 * pageFormat.getHeight() - pageFormat.getImageableHeight()) / 2;
            g2d.translate(0.0, -yTranslate);

            //paint
            RepaintManager currentManager = RepaintManager.currentManager(this);
            currentManager.setDoubleBufferingEnabled(false);
            this.paint(g2d);
            currentManager = RepaintManager.currentManager(this);
            currentManager.setDoubleBufferingEnabled(true);

            return Printable.PAGE_EXISTS;
        } else
            return Printable.NO_SUCH_PAGE;
    }
}
