// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */


package apostal.toma.view;


import apostal.toma.data.TOMAConstants;


import javax.swing.*;


/**

 * Contains a text, a "OK" button and a "Cancel" button

 * Used in:

 * Teacher: delete

 * Contact: delete

 * location: delete

 * Publication Unit: delete

 * Catalogue: delete

 * Training: delete

 * Training Programme: delete unit

 */


public class TOMAQuestion {


    private int result;


    public TOMAQuestion(String message, String title) {

        ImageIcon icon = new ImageIcon(TOMAConstants.questionIconPath);


        result = JOptionPane.showConfirmDialog(null, message, title, JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, icon);

    }


    public TOMAQuestion(String message, String title, int optionPaneOptionType) {

        ImageIcon icon = new ImageIcon(TOMAConstants.questionIconPath);


        result = JOptionPane.showConfirmDialog(null, message, title, optionPaneOptionType, JOptionPane.QUESTION_MESSAGE, icon);

    }


    public TOMAQuestion(String message, String title, int optionPaneOptionType, boolean withScrollPane, int width, int height) {

        ImageIcon icon = new ImageIcon(TOMAConstants.questionIconPath);

        if (withScrollPane) {

            JScrollPane scrollPane = new JScrollPane();

            JPanel panel = new JPanel();

            JLabel label = new JLabel(message);

            panel.add(label);

            scrollPane.setViewportView(panel);

            scrollPane.setPreferredSize(new java.awt.Dimension(width, height));



            /*Object[] options=new Object[1];

            options[0]=scrollPane;*/



            result = JOptionPane.showConfirmDialog(null, scrollPane, title, optionPaneOptionType, JOptionPane.QUESTION_MESSAGE, icon);

        } else {

            result = JOptionPane.showConfirmDialog(null, message, title, optionPaneOptionType, JOptionPane.QUESTION_MESSAGE, icon);

        }

    }


    public int getResult() {

        return result;

    }


}

