// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/*
 * (c) Copyright 2001 MyCorporation.
 * All Rights Reserved.
 */
package apostal.toma.view;

import apostal.toma.viewcontrol.TOMAServerEventHandler;
import apostal.toma.data.TOMALabels;

import javax.swing.*;
import javax.swing.border.LineBorder;
import java.awt.BorderLayout;

/**
 * @version 	1.0
 * @author
 */
public class TOMAServerView extends TOMAFrame {
    private TOMALabel label;
    private TOMAButton quit;
    private TOMAButton unlock;
    private JPanel panel;

    public TOMAServerView(TOMAServerEventHandler handler) {
        this.setTitle("TOMA Server");
        this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

        LineBorder border = new LineBorder(TOMAColors.auxBackgroundColor, 10);

        panel = new JPanel();
        panel.setBackground(TOMAColors.auxBackgroundColor);
        panel.setLayout(new BorderLayout());
        panel.setBorder(border);

        label = new TOMALabel();
        label.setTextWithLowerCase(TOMAFonts.htmlBegin + "TOMA server is up and running..." + TOMAFonts.htmlEnd);
        panel.add(label, BorderLayout.NORTH);


        unlock = new TOMAButton("Unlock TOMA Data");
        unlock.addActionListener(handler);
        unlock.setActionCommand("unlock");
        unlock.setBorder(border);
        panel.add(unlock, BorderLayout.WEST);


        quit = new TOMAButton("Stop TOMA Server");
        quit.addActionListener(handler);
        quit.setActionCommand("quit");
        quit.setBorder(border);
        panel.add(quit, BorderLayout.EAST);

        this.setContentPane(panel);
        this.pack();
        this.centerFrame();
        this.setVisible(true);
    }

}
