// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.view;

import javax.swing.tree.*;
import javax.swing.JTree;
import javax.swing.ImageIcon;
import java.awt.Component;

import java.util.Vector;

import apostal.toma.TOMA;
import apostal.toma.data.*;
//import apostal.toma.database.TrainingDB;

import java.lang.Class;
import java.util.Iterator;
import java.util.Vector;

public class TOMATreeCellRenderer extends DefaultTreeCellRenderer {
    private static ImageIcon catalogueOpened;
    private static ImageIcon catalogueClosed;
    private static ImageIcon trainingCourse;
    private static ImageIcon trainingProgramme;

    static {
        catalogueOpened = new ImageIcon(TOMAConstants.catalogueOpenedIconPath);
        catalogueClosed = new ImageIcon(TOMAConstants.catalogueClosedIconPath);
        trainingCourse = new ImageIcon(TOMAConstants.trainingCourseIconPath);
        trainingProgramme = new ImageIcon(TOMAConstants.trainingProgrammeIconPath);
    }

    private int type = -1;

    public TOMATreeCellRenderer(int type) {
        //non: remplac par la proprit "Tree.textBackground" dans TOMAUI
        /*this.setOpaque(true);*/
        this.type = type;

        this.setBackground(TOMAColors.treeBackgroundColor);
        this.setTextNonSelectionColor(TOMAColors.treeTextColor);

        this.setBackgroundSelectionColor(TOMAColors.treeSelectionBackground);
        this.setTextSelectionColor(TOMAColors.treeSelectionForeground);
    }


    public TOMATreeCellRenderer() {
        //non: remplac par la proprit "Tree.textBackground" dans TOMAUI
        /*this.setOpaque(true);*/
        type = -1;
        this.setBackground(TOMAColors.treeBackgroundColor);
        this.setTextNonSelectionColor(TOMAColors.treeTextColor);

        this.setBackgroundSelectionColor(TOMAColors.treeSelectionBackground);
        this.setTextSelectionColor(TOMAColors.treeSelectionForeground);
    }

    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus) {
        super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);

        if (value != null) {
            if (type == -1) {
                Class cl = value.getClass();
                if (cl.getName().equals("apostal.toma.view.CatalogueTreeNode")) {
                    if (expanded)
                        setIcon(catalogueOpened);
                    else
                        setIcon(catalogueClosed);
                } else if (cl.getName().equals("apostal.toma.view.TrainingTreeNode")) {
                    TrainingTreeNode node = (TrainingTreeNode) value;
                    //Training t=TrainingDB.getInstance(TOMA.getInstance().getTomaParameters().getLanguage(), false, node.getIdTraining());
                    //if(t!=null && t.getClass().getName().equals("apostal.toma.data.TrainingProgramme"))
                    if (node.getType() == TrainingTreeNode.TRAININGPROGRAMME)
                        setIcon(trainingProgramme);
                    else
                        setIcon(trainingCourse);
                } else
                    setIcon(trainingCourse);
            } else if (type == TrainingTreeNode.TRAININGPROGRAMME) {
                setIcon(trainingProgramme);
            } else {
                setIcon(trainingCourse);
            }
        }

        /*if(selected)
        {
          this.setBackground(TOMAColors.treeSelectionBackground);
          this.setForeground(TOMAColors.treeSelectionForeground);
        }*/

        return this;
    }
}
