// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import java.awt.Color;
import javax.swing.UIManager;
import javax.swing.ImageIcon;
import javax.swing.border.*;

import apostal.toma.data.TOMAConstants;

/**
 * Title:        TOMA
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      CRP Henri Tudor
 * @author
 * @version 1.0
 */

public class TOMAUI {

    public TOMAUI() {
    }

    public void setUI() {
        /**************** Onglets **************************/
        UIManager.put("TabbedPane.selected", TOMAColors.trainingTabSelectedTitleBackgroundColor);

        /************** Scroll Bar *************************/
        //thumb= partie mobile
        UIManager.put("ScrollBar.background", TOMAColors.editingFieldColor);
        UIManager.put("ScrollBar.thumbHighlight", TOMAColors.scrollBarTrackBackgroundColor);
        UIManager.put("ScrollBar.thumbLightShadow", TOMAColors.scrollBarTrackBackgroundColor);
        UIManager.put("ScrollBar.thumbDarkShadow", TOMAColors.scrollBarTrackBackgroundColor);
        UIManager.put("ScrollBar.thumb", TOMAColors.scrollBarTrackColor);

        //track=?
        /*UIManager.put("ScrollBar.track", Color.gray);
        UIManager.put("ScrollBar.trackHighlight", Color.darkGray);*/

        UIManager.put("ScrollBar.background", TOMAColors.scrollBarBackgroundColor);

        /**************** Menu *****************************/
        UIManager.put("Menu.selectionBackground", TOMAColors.menuSelectionBackground);
        UIManager.put("Menu.selectionForeground", TOMAColors.menuSelectionForeground);

        UIManager.put("MenuItem.selectionBackground", TOMAColors.menuSelectionBackground);
        UIManager.put("MenuItem.selectionForeground", TOMAColors.menuSelectionForeground);

        /***************** boutons ******************/
        UIManager.put("Button.background", TOMAColors.buttonsBackgroundColor);
        UIManager.put("Button.foreground", TOMAColors.clickableTextColor);
        UIManager.put("Button.font", TOMAFonts.buttonsFont);
        LineBorder myBorder = new LineBorder(TOMAColors.buttonsBorderColor, 1);
        EmptyBorder margin = new EmptyBorder(1, 2, 1, 2);
        UIManager.put("Button.border", new CompoundBorder(myBorder, margin));


        /***************** List **********************/
        UIManager.put("List.background", TOMAColors.editingFieldColor);
        UIManager.put("List.foreground", TOMAColors.unclickableTextColor);
        UIManager.put("List.font", TOMAFonts.listsFont);
        UIManager.put("List.selectionBackground", TOMAColors.listSelectionBackground);
        UIManager.put("List.selectionForeground", TOMAColors.listSelectionForeground);

        UIManager.put("ComboBox.background", TOMAColors.editingFieldColor);
        UIManager.put("ComboBox.foreground", TOMAColors.unclickableTextColor);
        UIManager.put("ComboBox.font", TOMAFonts.listsFont);
        UIManager.put("ComboBox.selectionBackground", TOMAColors.listSelectionBackground);
        UIManager.put("ComboBox.selectionForeground", TOMAColors.listSelectionForeground);

        //tests
        /*UIManager.put("ComboBox.buttonBackground",TOMAColors.editingFieldColor);
        UIManager.put("ComboBox.arrowButtonBackground",TOMAColors.editingFieldColor);
        UIManager.put("ComboBox.button",TOMAColors.editingFieldColor);
        UIManager.put("ComboBox.buttonColor",TOMAColors.editingFieldColor);
        UIManager.put("ComboBox.arrowButtonColor",TOMAColors.editingFieldColor);
        UIManager.put("ArrowButton.background", TOMAColors.editingFieldColor);
        UIManager.put("ArrowButton.control", TOMAColors.editingFieldColor);
        UIManager.put("ArrowButton.color", TOMAColors.editingFieldColor);*/

        /***************** textes ********************/
        UIManager.put("TextArea.background", TOMAColors.editingFieldColor);
        UIManager.put("TextArea.foreground", TOMAColors.unclickableTextColor);
        UIManager.put("TextArea.selectionBackground", TOMAColors.textSelectionBackground);
        UIManager.put("TextArea.selectionForeground", TOMAColors.textSelectionForeground);

        UIManager.put("TextField.background", TOMAColors.editingFieldColor);
        UIManager.put("TextField.foreground", TOMAColors.unclickableTextColor);
        UIManager.put("TextField.selectionBackground", TOMAColors.textSelectionBackground);
        UIManager.put("TextField.selectionForeground", TOMAColors.textSelectionForeground);

        /***************** labels ************************/
        UIManager.put("Label.background", TOMAColors.tomaBackgroundColor);
        UIManager.put("Label.foreground", TOMAColors.unclickableTextColor);
        UIManager.put("Label.font", TOMAFonts.labelsFont);

        /***************** tree ************************/
        UIManager.put("Tree.background", TOMAColors.treeBackgroundColor);
        UIManager.put("Tree.foreground", TOMAColors.treeTextColor);
        UIManager.put("Tree.font", TOMAFonts.treeFont);
        UIManager.put("Tree.selectionBackground", TOMAColors.treeSelectionBackground);
        UIManager.put("Tree.selectionForeground", TOMAColors.treeSelectionForeground);
        UIManager.put("Tree.textBackground", TOMAColors.treeBackgroundColor);

        String openPath = TOMAConstants.treeOpenedIconPath;
        ImageIcon open = new ImageIcon(openPath);
        UIManager.put("Tree.expandedIcon", open);

        String closedPath = TOMAConstants.treeClosedIconPath;
        ImageIcon closed = new ImageIcon(closedPath);
        UIManager.put("Tree.collapsedIcon", closed);

        /**************** option pane ******************/
        UIManager.put("OptionPane.background", TOMAColors.tomaBackgroundColor);
        UIManager.put("OptionPane.foreground", TOMAColors.unclickableTextColor);
        UIManager.put("OptionPane.font", TOMAFonts.labelsFont);

        /**************** panel ***************************/
        UIManager.put("Panel.background", TOMAColors.tomaBackgroundColor);
        UIManager.put("Panel.foreground", TOMAColors.unclickableTextColor);
        UIManager.put("Panel.font", TOMAFonts.labelsFont);

    }
}