// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.view;

import apostal.toma.TOMA;

import javax.swing.*;
import java.awt.FlowLayout;
import java.awt.Dimension;
import java.awt.Toolkit;

/**
 * Wait window. It is only composed of a message, and it closes itself when the treatment is finished.
 * Used in:
 * Publication Unit: publication
 * Training: export
 */
public class TOMAWait {

    JDialog dialog;

    JFrame frame;
    String waitTitle;
    String waitMessage;

    public TOMAWait(JFrame frame, String msg, String title) {
        this.frame = frame;
        this.waitMessage = msg;
        this.waitTitle = title;
    }

    public void showWaitScreen() {
        dialog = new JDialog(frame, waitTitle);
        dialog.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);

        JLabel labelMessage = new JLabel(waitMessage);
        labelMessage.setFont(TOMAFonts.labelsFont);
        labelMessage.setOpaque(true);
        JPanel panelMessage = new JPanel();
        panelMessage.setOpaque(true);
        panelMessage.setBackground(TOMAColors.auxBackgroundColor);
        panelMessage.setLayout(new FlowLayout());
        panelMessage.add(labelMessage);
        dialog.setContentPane(panelMessage);

        dialog.pack();
        this.center();
        dialog.setVisible(true);
        dialog.show();

        labelMessage.update(labelMessage.getGraphics());
        dialog.update(dialog.getGraphics());
    }

    public void dispose() {
        if (dialog != null) {
            dialog.dispose();
        }
    }

    public void center() {
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = dialog.getSize();
        dialog.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    }

}
