// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.util.*;

import apostal.toma.data.*;
import apostal.toma.viewcontrol.*;
import apostal.toma.data.TOMALabels;
import apostal.toma.datacontrol.TeachersControl;
import apostal.toma.TOMA;

public class TeachersView extends AuxiliarElementsView implements ListSelectionListener {

    private static int multipleElementsLength = 30;

    private Vector vlist = new Vector();
    private Vector vteachers = new Vector();
    private Teacher data;
    private TeachersControl control = new TeachersControl();

    JScrollPane jScrollPane1 = new JScrollPane();
    JList jList1 = new JList();
    TOMAButton button_new = new TOMAButton();
    JPanel jPanel1 = new JPanel();
    TitledBorder titledBorder1;
    TitledBorder titledBorder2;
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    TOMAButton button_delete = new TOMAButton();
    TOMALabel label_country = new TOMALabel();
    TOMALabel label_tel = new TOMALabel();
    TOMATextField jTFpostcode = new TOMATextField();
    TOMAMultipleElements jAddressLines;
    TOMAMultipleElements jCompetences;
    GridBagLayout gridBagLayout2 = new GridBagLayout();
    TOMATextField jTFcreated = new TOMATextField();
    TOMATextField jTFmodified = new TOMATextField();

    TeachersEventHandler handler = new TeachersEventHandler(this);
    TOMALabel label_postcode = new TOMALabel();
    TOMATextField jTFcity = new TOMATextField();
    TOMATextArea jTAcv = new TOMATextArea();
    TOMALabel label_fax = new TOMALabel();
    TOMALabel label_email = new TOMALabel();
    JComboBox jCBcountry = new JComboBox();
    protected TOMALabels labels;
    GridBagLayout gridBagLayout3 = new GridBagLayout();
    TOMATextField jTFlastname = new TOMATextField();
    TOMATextField jTFtitle = new TOMATextField();
    TOMATextField jTFfirstname = new TOMATextField();
    TOMALabel label_cv = new TOMALabel();
    TOMALabel label_function = new TOMALabel();
    TOMALabel label_lastname = new TOMALabel();
    TOMALabel label_firstname = new TOMALabel();
    JPanel jPanel2 = new JPanel();
    TOMALabel label_title = new TOMALabel();
    TOMATextField jTFfunction = new TOMATextField();
    TOMALabel jLabel1 = new TOMALabel();
    TOMALabel jLabel2 = new TOMALabel();
    TOMATextField jTFtel = new TOMATextField();
    TOMATextField jTFfax = new TOMATextField();
    TOMATextField jTFemail = new TOMATextField();
    //JScrollPane jScrollPane2 = new JScrollPane();
    TOMAButton button_save = new TOMAButton();
    TOMALabel label_city = new TOMALabel();
    TOMALabel labelAddress = new TOMALabel();
    TOMALabel labelCompetences = new TOMALabel();

    JPanel panelInfo = new JPanel();

    //pour le template
    JComponent titleComponent;
    JComponent firstnameComponent;
    JComponent functionComponent;
    JComponent cvComponent;
    private int type=TOMATemplateView.TEACHERSVIEW;
    Vector allowed_competences;
    
    //pour les lments locks
    private TOMALocked panelLocked = new TOMALocked(null);
    private boolean screenIsLocked = false;
    private boolean notSelect = true;
    public boolean alreadyWarned;
    public int selectedIndex;
   

    /**Construct the frame*/
    public TeachersView() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            labels = new TOMALabels();
            jbInit();
            pack();
        } catch (Exception e) {
            e.printStackTrace();
        }

        this.addWindowListener(handler);
    }

    private void jbInit() throws Exception {
        String denomination = "";
        JPanel contentPane = (JPanel) this.getContentPane();

        contentPane.setLayout(gridBagLayout1);
        titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(134, 134, 134)), labels.get("apostal.toma.teacher.notpublished"));
        titledBorder2 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(134, 134, 134)), labels.get("apostal.toma.teacher.teacher"));

        button_new.setText(labels.get("apostal.toma.teacher.new"));
        button_new.addActionListener(handler);
        button_new.setActionCommand(".new");
        jPanel1.setBorder(titledBorder1);
        jPanel1.setLayout(gridBagLayout2);
        jPanel1.setBackground(TOMAColors.auxBackgroundColor2);

        button_delete.setText(labels.get("apostal.toma.teacher.delete"));
        button_delete.addActionListener(handler);
        button_delete.setActionCommand(".delete");
        button_delete.setEnabled(false);

        button_save.setText(labels.get("apostal.toma.teacher.save"));
        button_save.addActionListener(handler);
        button_save.setActionCommand(".save");
        button_save.setEnabled(false);

        labelAddress.setText(labels.get("apostal.toma.teacher.addressLines"));
        labelCompetences.setText(labels.get("apostal.toma.teacher.competences"));
        label_country.setText(labels.get("apostal.toma.teacher.country"));
        label_tel.setText(labels.get("apostal.toma.teacher.tel"));
        label_postcode.setText(labels.get("apostal.toma.teacher.postcode"));
        label_fax.setText(labels.get("apostal.toma.teacher.fax"));
        label_city.setText(labels.get("apostal.toma.teacher.city"));
        label_email.setText(labels.get("apostal.toma.teacher.email"));
        jList1.setBackground(TOMAColors.editingFieldColor);
        /*jList1.addMouseListener(new java.awt.event.MouseAdapter()
        {
          public void mouseClicked(MouseEvent e)
          {
            jList1_mouseClicked(e);
          }
        });*/
        jList1.addListSelectionListener(this);
        jList1.setVisibleRowCount(5);
        jList1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        jList1.setFixedCellWidth(200);
        jList1.setFont(TOMAFonts.listsFont);

        jTFcreated.setBackground(TOMAColors.auxBackgroundColor2);
        jTFcreated.setEditable(false);
        jTFcreated.setBorder(new EmptyBorder(0, 0, 0, 0));
        jTFmodified.setBackground(TOMAColors.auxBackgroundColor2);
        jTFmodified.setEditable(false);
        jTFmodified.setBorder(new EmptyBorder(0, 0, 0, 0));

        // Initialistation de la liste des teachers  partir des donnes de la
        // base de donnes
        vlist = loadteachers();

        jList1.setListData(vlist);

        // Countries
        TOMA t = TOMA.getInstance();
        Vector countries = t.getCountries();

        for (int i = 0; i < countries.size(); i++) {
            jCBcountry.addItem(countries.elementAt(i));
        }

        this.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                this_windowClosing(e);
            }
        });
        jTFtitle.setDisabledTextColor(Color.white);
        jTFtitle.setColumns(20);
        label_cv.setText(labels.get("apostal.toma.teacher.cv"));
        label_function.setText(labels.get("apostal.toma.teacher.function"));
        label_lastname.setText(labels.get("apostal.toma.teacher.lastname"));
        label_firstname.setText(labels.get("apostal.toma.teacher.firstname"));
        jPanel2.setLayout(gridBagLayout3);
        jPanel2.setBorder(titledBorder2);
        jPanel2.setBackground(TOMAColors.auxBackgroundColor2);
        label_title.setText(labels.get("apostal.toma.teacher.title"));

        jLabel1.setTextWithLowerCase(labels.get("apostal.toma.teacher.created"));
        jLabel2.setTextWithLowerCase(labels.get("apostal.toma.teacher.modified"));
        jTFtel.setColumns(20);
        //jCBcountry.setMaximumSize(new Dimension(32767, 20));
        //jCBcountry.setMinimumSize(new Dimension(121, 20));
        jCBcountry.setBackground(TOMAColors.editingFieldColor);
        jTFcity.setColumns(20);
        jTFpostcode.setColumns(20);
        jTFfax.setColumns(20);
        jTFemail.setColumns(20);
        jTFfirstname.setColumns(20);
        jTFlastname.setColumns(20);
        jTFfunction.setColumns(20);
        jTAcv.setColumns(20);

        // definition de l'lment multiple
        //Nombre de colonnes du textfield
        Integer columNb = new Integer(TeachersView.multipleElementsLength);
        Class[] classes = new Class[1];
        classes[0] = Class.forName("java.lang.Integer");
        Object[] values = new Object[1];
        values[0] = columNb;

        jAddressLines = new TOMAMultipleElements("apostal.toma.view.TOMATextField", classes, values, 2, "", labels.get("apostal.toma.teacher.add_address_lines"), labels.get("apostal.toma.teacher.remove"), TOMAColors.multipleElementsColor, 350, 120);
        //jCompetences = new TOMAMultipleElements("apostal.toma.view.TOMATextField", classes, values, 2, "", labels.get("apostal.toma.teacher.add_competence"), labels.get("apostal.toma.teacher.remove"), TOMAColors.multipleElementsColor, 350, 120);

        //////////////// templates /////////////////
        //title
        JScrollPane titlePane = new JScrollPane();
        titlePane.getViewport().add(jTFtitle);
        TOMATemplateResult titleResult = TOMATemplateView.getTemplateResult(type, "title");                
        if (titleResult.isForbidden())
            jTFtitle.setEnabled(false);
        if (titleResult.isMandatory())
            label_title.setText(label_title.getText() + " (*)");
        if (titleResult.getMaximum() > -1)
            label_title.setText(label_title.getText() + " (" + new Integer(titleResult.getMaximum()) + ")");
        if (titleResult.getValues() != null && !titleResult.getValues().isEmpty()) {
            Vector v = titleResult.getValues();
            v.insertElementAt(ElementNotSpecified.getInstance(), 0);
            TOMAComboBox titleCombo = new TOMAComboBox(v);
            titleComponent = titleCombo;
        } else
            titleComponent = titlePane;         
        
        //firstname
        JScrollPane firstnamePane = new JScrollPane();
        firstnamePane.getViewport().add(jTFfirstname);
        TOMATemplateResult firstnameResult = TOMATemplateView.getTemplateResult(type, "firstname");                
        if (firstnameResult.isForbidden())
            jTFfirstname.setEnabled(false);
        if (firstnameResult.isMandatory())
            label_firstname.setText(label_firstname.getText() + " (*)");
        if (firstnameResult.getMaximum() > -1)
            label_firstname.setText(label_firstname.getText() + " (" + new Integer(firstnameResult.getMaximum()) + ")");
        if (firstnameResult.getValues() != null && !firstnameResult.getValues().isEmpty()) {
            Vector v = firstnameResult.getValues();
            v.insertElementAt(ElementNotSpecified.getInstance(), 0);
            TOMAComboBox firstnameCombo = new TOMAComboBox(v);
            firstnameComponent = firstnameCombo;
        } else
            firstnameComponent = firstnamePane;           
        
        //lastname
        TOMATemplateResult lastnameResult = TOMATemplateView.getTemplateResult(type, "lastname");                
        if (lastnameResult.getMaximum() > -1)
            label_lastname.setText(label_lastname.getText() + " (" + new Integer(lastnameResult.getMaximum()) + ")");        
        
        //function
        JScrollPane functionPane = new JScrollPane();
        functionPane.getViewport().add(jTFfunction);
        TOMATemplateResult functionResult = TOMATemplateView.getTemplateResult(type, "function");                
        if (functionResult.isForbidden())
            jTFfunction.setEnabled(false);
        if (functionResult.isMandatory())
            label_function.setText(label_function.getText() + " (*)");
        if (functionResult.getMaximum() > -1)
            label_function.setText(label_function.getText() + " (" + new Integer(functionResult.getMaximum()) + ")");
        if (functionResult.getValues() != null && !functionResult.getValues().isEmpty()) {
            Vector v = functionResult.getValues();
            v.insertElementAt(ElementNotSpecified.getInstance(), 0);
            TOMAComboBox functionCombo = new TOMAComboBox(v);
            functionComponent = functionCombo;
        } else
            functionComponent = functionPane;           
        
        //cv
        JScrollPane cvPane = new JScrollPane();
        cvPane.getViewport().add(jTAcv);
        TOMATemplateResult cvResult = TOMATemplateView.getTemplateResult(type, "cv");                
        if (cvResult.isForbidden())
            jTAcv.setEnabled(false);
        if (cvResult.isMandatory())
            label_cv.setText(label_cv.getText() + " (*)");
        if (cvResult.getMaximum() > -1)
            label_cv.setText(label_cv.getText() + " (" + new Integer(cvResult.getMaximum()) + ")");
        if (cvResult.getValues() != null && !cvResult.getValues().isEmpty()) {
            Vector v = cvResult.getValues();
            v.insertElementAt(ElementNotSpecified.getInstance(), 0);
            TOMAComboBox cvCombo = new TOMAComboBox(v);
            cvComponent = cvCombo;
        } else
            cvComponent = cvPane;             
        
        //competence
        //jCompetences = new TOMAMultipleElements("apostal.toma.view.TOMATextField", classes, values, 2, "", labels.get("apostal.toma.teacher.add_competence"), labels.get("apostal.toma.teacher.remove"), TOMAColors.multipleElementsColor, 350, 120);        
        TOMATemplateResult competenceResult = TOMATemplateView.getTemplateResult(type, "competence");                
        if (competenceResult.isMandatory())
            labelCompetences.setText(labelCompetences.getText() + " (*)");
        if (competenceResult.getMaximum() > -1)
            labelCompetences.setText(labelCompetences.getText() + " (" + new Integer(competenceResult.getMaximum()) + ")");
        if (competenceResult.getValues() != null && !competenceResult.getValues().isEmpty()) {
            allowed_competences = competenceResult.getValues();
            Class[] classes2 = new Class[1];
            classes2[0] = Class.forName("java.util.Vector");
            Object[] values2 = new Object[1];
            values2[0] = allowed_competences;
            jCompetences = new TOMAMultipleElements("apostal.toma.view.TOMAComboBox", classes2, values2, 2, "", labels.get("apostal.toma.teacher.add_competence"), labels.get("apostal.toma.teacher.remove"), TOMAColors.multipleElementsColor, 350, 120);                
        } else
        {
            Class[] classes2 = new Class[1];
            classes2[0] = Class.forName("java.lang.Integer");
            Object[] values2 = new Object[1];
            values2[0] = new Integer(25);
            jCompetences = new TOMAMultipleElements("apostal.toma.view.TOMATextField", classes2, values2, 2, "", labels.get("apostal.toma.teacher.add_competence"), labels.get("apostal.toma.teacher.remove"), TOMAColors.multipleElementsColor, 350, 120);                
        }            
        if (competenceResult.isForbidden())
            jCompetences.setEnabled(false);        
        
        /////////////////////////////////////////

        panelInfo.setLayout(new GridBagLayout());
        panelInfo.setBackground(TOMAColors.auxBackgroundColor2);

        jPanel2.add(label_title, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel2.add(label_firstname, new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel2.add(label_lastname, new GridBagConstraints(0, 3, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel2.add(label_function, new GridBagConstraints(0, 4, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel2.add(firstnameComponent, new GridBagConstraints(2, 2, 1, 1, 1.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel2.add(jTFlastname, new GridBagConstraints(2, 3, 1, 1, 1.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel2.add(functionComponent, new GridBagConstraints(2, 4, 1, 1, 1.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel2.add(titleComponent, new GridBagConstraints(2, 0, 1, 2, 1.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel2.add(jCompetences, new GridBagConstraints(0, 7, 3, 3, 1.0, 1.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel2.add(label_cv, new GridBagConstraints(0, 5, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel2.add(labelCompetences, new GridBagConstraints(0, 6, 3, 1, 1.0, 1.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        //created & modified
        /*
contentPane.add(jTFcreated,new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
contentPane.add(jLabel1,new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
contentPane.add(jLabel2,new GridBagConstraints(2, 3, 1, 1, 0.0, 0.0
,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
contentPane.add(jTFmodified,new GridBagConstraints(3, 3, 1, 1, 0.0, 0.0
,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        */
        panelInfo.add(jLabel1, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfo.add(jTFcreated, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfo.add(jLabel2, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfo.add(jTFmodified, new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        jPanel1.add(labelAddress, new GridBagConstraints(0, 0, 2, 1, 1.0, 1.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(jAddressLines, new GridBagConstraints(0, 1, 2, 1, 1.0, 1.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(label_email, new GridBagConstraints(0, 8, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(label_fax, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(label_tel, new GridBagConstraints(0, 5, 1, 2, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(label_country, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(jTFcity, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(jTFpostcode, new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(label_postcode, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(jCBcountry, new GridBagConstraints(1, 4, 1, 2, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(jTFtel, new GridBagConstraints(1, 6, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(jTFfax, new GridBagConstraints(1, 7, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(label_city, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        jPanel1.add(jTFemail, new GridBagConstraints(1, 8, 1, 2, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        //haut
        contentPane.add(jScrollPane1, new GridBagConstraints(0, 0, 3, 2, 1.1, 0.0
                , GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        contentPane.add(button_new, new GridBagConstraints(3, 0, 1, 1, 1.0, 0.1
                , GridBagConstraints.SOUTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        contentPane.add(button_delete, new GridBagConstraints(3, 1, 1, 1, 1.0, 0.1
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        jScrollPane1.getViewport().add(jList1, null);
        jPanel2.add(cvComponent, new GridBagConstraints(2, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        //content
        /*
        contentPane.add(jPanel1,new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0
                ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        contentPane.add(jPanel2,new GridBagConstraints(2, 2, 2, 1, 0.0, 0.0
                ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0),0, 0));
        contentPane.add(button_save,new GridBagConstraints(0, 4, 4, 1, 0.1, 0.0
                ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
        */

        panelInfo.add(jPanel2, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
        panelInfo.add(jPanel1, new GridBagConstraints(2, 0, 2, 1, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        panelInfo.add(button_save, new GridBagConstraints(1, 2, 2, 1, 0.2, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
        contentPane.add(panelInfo, new GridBagConstraints(0, 2, 4, 2, 0.0, 0.0
                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        panelLocked.setVisible(false);
        contentPane.add(panelLocked, new GridBagConstraints(0, 2, 4, 2, 0.0, 0.0
                , GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));

        //jScrollPane2.getViewport().add(jTAcv);

        jCBcountry.setSelectedIndex(11);

        /******** cran ***********/
        this.setTitle(labels.get("apostal.toma.teacher.teachers"));
        this.getContentPane().setBackground(TOMAColors.auxBackgroundColor);
        //centerFrame();
        this.pack();
        this.setVisible(true);

        this.refresh();
    }


    /**Overridden so we can exit when window is closed*/
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            //System.exit(0);
        }
    }

    // Donnes de la fentre d'affichage vers  l'object teachers
    public Teacher getData() {
        if (screenIsLocked || notSelect) {
            return null;
        } else {

            Address address = getAddress();
            data.setAddress(address);
                        
            data.setTel(jTFtel.getText());
            data.setFax(jTFfax.getText());
            data.setEmail(jTFemail.getText());
            
            if(titleComponent instanceof TOMAComboBox){
                try {
                    data.setTitle((String) ((TOMAComboBox) titleComponent).getSelectedItem());
                } catch (java.lang.ClassCastException ex) {
                    data.setTitle(null);
                }              
            }
            else                  
                data.setTitle(jTFtitle.getText());
            
            if(firstnameComponent instanceof TOMAComboBox){
                try {
                    data.setFirstname((String) ((TOMAComboBox) firstnameComponent).getSelectedItem());
                } catch (java.lang.ClassCastException ex) {
                    data.setFirstname(null);
                }              
            }
            else            
                data.setFirstname(jTFfirstname.getText());
            
            data.setLastname(jTFlastname.getText());

            if(functionComponent instanceof TOMAComboBox){
                try {
                    data.setFunction((String) ((TOMAComboBox) functionComponent).getSelectedItem());
                } catch (java.lang.ClassCastException ex) {
                    data.setFunction(null);
                }              
            }
            else              
                data.setFunction(jTFfunction.getText());
            
            if(cvComponent instanceof TOMAComboBox){
                try {
                    data.setCv((String) ((TOMAComboBox) cvComponent).getSelectedItem());
                } catch (java.lang.ClassCastException ex) {
                    data.setCv(null);
                }              
            }
            else              
                data.setCv(jTAcv.getText());
            
            //competences
            Vector vcompetences = getCompetences();
            //data.setCompetences(competences);     
            Vector comps = new Vector();
            JComponent[] cms = jCompetences.getElements();
            int size = cms.length;
            for (int i = 0; i < size; i++) {
                try {
                    JTextField field = (JTextField) cms[i];
                    String text=field.getText();
                    if (!comps.contains(text))
                        comps.add(text);
                } catch (Exception ex) {
                    TOMAComboBox box = (TOMAComboBox) cms[i];
                    String txt = (String) box.getSelectedItem();

                    if (!comps.contains(txt))
                        comps.add(txt);
                }
            }
           data.setCompetences(comps);                 
            
            //sauver la date de la modification actuelle
            Calendar calendar = new GregorianCalendar();
            Date trialtime = new Date();
            calendar.setTime(trialtime);
            java.sql.Date date = new java.sql.Date(calendar.getTime().getTime());
            data.setDateMaj(date);
            return data;
        }
    }

    //Address des champs du formulaire vers l'object Address
    private Address getAddress() {
        Vector vaddresslines = new Vector();
        JComponent[] components = jAddressLines.getElements();
        for (int i = 0; i < components.length; i++) {
            vaddresslines.addElement(((TOMATextField) components[i]).getText());
        }
        String city = jTFcity.getText();
        String postCode = jTFpostcode.getText();
        Country country = (Country) jCBcountry.getSelectedItem();
        Address addressdata = new Address(vaddresslines, city, postCode, country);
        return addressdata;
    }

    // donnes de l'object vers le formulaire
    public void setData(Teacher data) {
        this.clearData();

        button_save.setEnabled(true);

        this.data = data;
        Address address = data.getAddress();
        setAddress(address);
        String tel = data.getTel();
        String fax = data.getFax();
        String email = data.getEmail();
        String title = data.getTitle();
        String firstname = data.getFirstname();
        String lastname = data.getLastname();
        String cv = data.getCv();
        String function = data.getFunction();
        Vector comptetences = data.getCompetences();
        String created = data.getDateCreation().toString();
        String modified = data.getDateMaj().toString();

        jTFtel.setText(tel);
        jTFfax.setText(fax);
        jTFemail.setText(email);
        
        if(titleComponent instanceof JComboBox)
            TOMATemplateView.setTextCombo(title, (JComboBox) titleComponent);
        else             
            jTFtitle.setText(title);
        
        if(firstnameComponent instanceof JComboBox)
            TOMATemplateView.setTextCombo(firstname, (JComboBox) firstnameComponent);
        else           
            jTFfirstname.setText(firstname);        
        
        jTFlastname.setText(lastname);
        
        if(functionComponent instanceof JComboBox)
            TOMATemplateView.setTextCombo(function, (JComboBox) functionComponent);
        else            
            jTFfunction.setText(function);
        
        if(cvComponent instanceof JComboBox)
            TOMATemplateView.setTextCombo(cv, (JComboBox) cvComponent);
        else            
            jTAcv.setText(cv);

        //competences
        Vector vcompetences = data.getCompetences();
        //setCompetences(vcompetences);        
        if (vcompetences != null) {
            Vector comps = new Vector();

            Iterator iter = vcompetences.iterator();
            while (iter.hasNext()) {
                String comp = (String) iter.next();
                if (comp != null) {
                    if (allowed_competences == null || allowed_competences.isEmpty()) {
                        TOMATextField field = new TOMATextField(new Integer(30));
                        field.setText(comp);
                        comps.add(field);
                    } else {
                        //combo boxes et pas text fields
                        if(!allowed_competences.contains(comp)){
                            allowed_competences.add(comp);
                        }
                        TOMAComboBox box = new TOMAComboBox(allowed_competences);
                        box.setSelectedItem(comp);
                        comps.add(box);
                    }
                }
            }
            jCompetences.setElements(comps);
        }
        TOMATemplateResult competencesResult = TOMATemplateView.getTemplateResult(type, "competence");
        if (competencesResult.isForbidden())
            jCompetences.setEnabled(false);               
        
        jTFcreated.setText(created);
        jTFmodified.setText(modified);
    }


    //Mettre les donnes de l'objet images dans le formulaire
    public void setCompetences(Vector vcompetences) {
        Vector vcomponentlines = new Vector();
        for (int i = 0; i < vcompetences.size(); i++) {
            vcomponentlines.addElement(new TOMATextField(TeachersView.multipleElementsLength, (String) vcompetences.elementAt(i)));
        }
        jCompetences.setElements(vcomponentlines);

    }

    //Mettre les donnes du formulaire dans l'object
    public Vector getCompetences() {
        Vector vcompetences = new Vector();
        JComponent[] components = jCompetences.getElements();
        for (int i = 0; i < components.length; i++) {
            //vcompetences.addElement(((TOMATextField) components[i]).getText());
            JComponent component=components[i];
            if(component instanceof TOMATextField){
                TOMATextField field=(TOMATextField) component;
                vcompetences.addElement(field.getText());
            }
            else if(component instanceof TOMAComboBox){
                TOMAComboBox box=(TOMAComboBox) component;
                Object o=box.getSelectedItem();
                if(o instanceof TOMATextField){
                    TOMATextField field=(TOMATextField) o;
                    vcompetences.addElement(field.getText());
                }
            }            
        }
        return vcompetences;
    }


    //Mettre les donnes de l'object address dans la fentre d'affichage
    public void setAddress(Address address) {
        Vector vstringlines = new Vector();
        Vector vcomponentlines = new Vector();
        //Vecteur avec les donnes des lignes en string
        try {
            vstringlines = address.getAddressLines();
            for (int i = 0; i < vstringlines.size(); i++) {
                vcomponentlines.addElement(new TOMATextField(TeachersView.multipleElementsLength, (String) vstringlines.elementAt(i)));
            }
        } catch (NullPointerException np) {
        }
        jAddressLines.setElements(vcomponentlines);
        try {
            jTFcity.setText(address.getCity());
        } catch (NullPointerException np) {
            jTFcity.setText("");
        }
        try {
            jTFpostcode.setText(address.getPostCode());
        } catch (NullPointerException np) {
            jTFpostcode.setText("");
        }
        try {
            for (int i = 0; i < jCBcountry.getItemCount(); i++) {
                if (jCBcountry.getItemAt(i).toString().compareTo(address.getCountry().toString()) == 0) {
                    jCBcountry.setSelectedIndex(i);
                }
            }
        } catch (NullPointerException np) {
        }

    }

    // affichage des donnes de la base de donnes
    public void refresh() {
        this.clearData();

        // Initialistation de la liste des contacts  partir des donnes de la
        // base de donnes
        vlist = loadteachers();
        jList1.setListData(vlist);

        jList1.clearSelection();
        button_delete.setEnabled(false);
        button_save.setEnabled(false);

        this.pack();
    }

    public void clearData() {
        jTFtitle.setText("");
        jTFtel.setText("");
        jTFcity.setText("");
        jTFpostcode.setText("");
        jTFfax.setText("");
        jTFemail.setText("");
        jTFfirstname.setText("");
        jTFlastname.setText("");
        jTFfunction.setText("");
        jTAcv.setText("");

        jAddressLines.setElements(new Vector());
        jCompetences.setElements(new Vector());

        this.setEnabled(false);
        this.pack();
    }

    public void setEnabled(boolean enabled) {
        if(!enabled){
            jTFtitle.setEnabled(false);
            if(titleComponent!=null)
                titleComponent.setEnabled(false);        
            jTFfirstname.setEnabled(false);
            if(firstnameComponent!=null)
                firstnameComponent.setEnabled(false);            
            jTFlastname.setEnabled(false);
            jTFfunction.setEnabled(false);
            if(functionComponent!=null)
                functionComponent.setEnabled(false);            
            jTAcv.setEnabled(false);
            if(cvComponent!=null)
                cvComponent.setEnabled(false);

            jTFpostcode.setEnabled(false);
            jTFcity.setEnabled(false);
            jTFtel.setEnabled(false);
            jTFfax.setEnabled(false);
            jTFemail.setEnabled(false);
            jCBcountry.setEnabled(false);
            jAddressLines.setEnabled(false);
            jCompetences.setEnabled(false);
        }else{
            TOMATemplateResult result = TOMATemplateView.getTemplateResult(type, "title");
            if (!result.isForbidden()) {                        
                jTFtitle.setEnabled(true);
                if(titleComponent!=null)
                    titleComponent.setEnabled(true);        
            }
            result = TOMATemplateView.getTemplateResult(type, "firstname");
            if (!result.isForbidden()) {                
                jTFfirstname.setEnabled(true);
                if(firstnameComponent!=null)
                    firstnameComponent.setEnabled(true);            
            }
            
            jTFlastname.setEnabled(true);
            result = TOMATemplateView.getTemplateResult(type, "function");
            if (!result.isForbidden()) {                  
                jTFfunction.setEnabled(true);
                if(functionComponent!=null)
                    functionComponent.setEnabled(true);            
            }
            result = TOMATemplateView.getTemplateResult(type, "cv");
            if (!result.isForbidden()) {                  
                jTAcv.setEnabled(true);
                if(cvComponent!=null)
                    cvComponent.setEnabled(true);
            }

            jTFpostcode.setEnabled(true);
            jTFcity.setEnabled(true);
            jTFtel.setEnabled(true);
            jTFfax.setEnabled(true);
            jTFemail.setEnabled(true);
            jCBcountry.setEnabled(true);
            jAddressLines.setEnabled(true);
            result = TOMATemplateView.getTemplateResult(type, "competence");
            if (!result.isForbidden()) {                  
                jCompetences.setEnabled(true);        
            }
        }
    }

    //Sauvegarde les donnes du formulaire dans un object, affichage dans la liste
    public Teacher save() {
        Teacher teacher = getData();
        int index = getIndex(teacher);
        vlist.removeElementAt(index);
        vlist.insertElementAt(teacher, index);
        vteachers.removeElementAt(index);
        vteachers.insertElementAt(teacher, index);
        return teacher;
    }

    public int getIndex(Object object) {
        int index = -1;
        for (int i = 0; i < vlist.size(); i++) {
            if (vlist.elementAt(i).toString().compareTo(object.toString()) == 0) {
                index = i;
            }
        }
        return index;
    }

    public Vector loadteachers() {
        vteachers = control.loadTeachers(true);
        return vteachers;
    }

    public boolean teacherSelected() {
        //check the list!
        return !screenIsLocked && !notSelect && !jList1.isSelectionEmpty();
    }

    public void selectTeacher(int id) {
        alreadyWarned = true;
        if (vlist != null) {
            Iterator it = vlist.iterator();
            boolean found = false;
            while (it.hasNext() && !found) {
                Teacher t = (Teacher) it.next();
                if (t.getIdTeacher() == id) {
                    found = true;
                    jList1.setSelectedValue(t, true);
                    this.changeSelection();
                }
            }
        }
    }

    public void changeSelection() {

        int index = jList1.getSelectedIndex();
        selectedIndex = index;
        if (index > -1) {
            try {
//unlock teacher locked
                if (data != null) {
                    control.unlockTeacher(data);
                }
//test lock from new teacher
                Teacher teacher = (Teacher) vteachers.elementAt(index);
                boolean idtest = control.getLock(teacher);
                if (!idtest) {
                    button_delete.setEnabled(true);
                    notSelect = false;

//lock new teacher
                    control.lockTeacher(teacher);

//si l'cran d'avant tait "locked":
                    if (screenIsLocked) {
                        screenIsLocked = false;
                        panelInfo.setVisible(true);
                        panelLocked.setVisible(false);
                    }

//get new teacher
                    setData(teacher);
                    this.setEnabled(true);
                    this.pack();
                } else {
                    button_delete.setEnabled(false);
//Show Message
                    panelLocked.changeElement(teacher);

                    if (!screenIsLocked) //on n'tait pas dj lock
                    {
                        data = null;
                        panelInfo.setVisible(false);
                        panelLocked.setVisible(true);
                        screenIsLocked = true;
                        notSelect = true;
                    } else {
                        panelLocked.setVisible(false);
                        panelLocked.setVisible(true);
                    }
                }
            } catch (NullPointerException np) {
            }
        }
    }

    public void valueChanged(ListSelectionEvent e) {

        int result = 0;

        if (!alreadyWarned) {
            if (this.teacherSelected() && selectedIndex > -1 && TOMA.getInstance().getTomaParameters().getOpenWarningWindow()) {
                TOMAQuestion tq = new TOMAQuestion(TOMAFonts.htmlBegin + labels.get("apostal.toma.changeSelection.teacher.confirm") + TOMAFonts.htmlEnd, labels.get("apostal.toma.changeSelection.teacher.confirm.title"));
                result = tq.getResult();
                alreadyWarned = true;
            }
            if (result == 0) {
                this.changeSelection();
                //alreadyWarned = false;
                alreadyWarned = true;
            } else {
                alreadyWarned = true;
                //jList1.setSelectedIndex(e.getLastIndex());
                jList1.setSelectedIndex(selectedIndex);
            }

        } else {
            alreadyWarned = false;
        }

    }

    void this_windowClosing(WindowEvent e) {
        //UnLock teacher
        if (data != null) {
            control.unlockTeacher(data);
        }
    }

   public String testTemplateElements() {
        Teacher t=this.getData();
        String msg = "";
                           
        String msg_title=TOMATemplateView.testTemplateElement(type, "title", t.getTitle(), labels.get("apostal.toma.teacher.title"));
        if(msg_title!=null)
            msg =msg +"\n" + msg_title;
        
        String msg_firstname=TOMATemplateView.testTemplateElement(type, "firstname", t.getFirstname(), labels.get("apostal.toma.teacher.firstname"));
        if(msg_firstname!=null)
            msg =msg +"\n" + msg_firstname;
        
        String msg_lastname=TOMATemplateView.testTemplateElement(type, "lastname", t.getLastname(), labels.get("apostal.toma.teacher.lastname"));
        if(msg_lastname!=null)
            msg =msg +"\n" + msg_lastname;
        
        String msg_function=TOMATemplateView.testTemplateElement(type, "function", t.getFunction(), labels.get("apostal.toma.teacher.function"));
        if(msg_function!=null)
            msg =msg +"\n" + msg_function;        
        
        String msg_competence=TOMATemplateView.testTemplateElement(type, "competence", t.getCompetences(), labels.get("apostal.toma.teacher.competences"));
        if(msg_competence!=null)
            msg =msg +"\n" + msg_competence;                    
        
        String msg_cv=TOMATemplateView.testTemplateElement(type, "cv", t.getCv(), labels.get("apostal.toma.teacher.cv"));
        if(msg_cv!=null)
            msg =msg +"\n" + msg_cv;                
        
        if (msg.equals(""))
            return null;
        else
            return msg;
    }            
    
}

