// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */


package apostal.toma.view;


import java.awt.*;

import javax.swing.*;

import apostal.toma.data.TrainingCourse;

import apostal.toma.data.TOMALabels;


public class TrainingCourseView extends TrainingView {


    public TrainingCourseView() {

        try {

            labels = new TOMALabels();

            jbInit();

        } catch (Exception e) {

            e.printStackTrace();

        }

    }


    private void jbInit() throws Exception {

        gridBagLayout6 = new GridBagLayout();

        this.setLayout(gridBagLayout6);


        panel_bottom = new JPanel();

        gridBagLayout7 = new GridBagLayout();

        panel_bottom.setLayout(gridBagLayout7);


        panel_aux = new StandardTrainingViewTabsPanel(TOMATemplateView.TRAININGCOURSEVIEW);


        dates = new JLabel();

        dates.setText("");

        dates.setForeground(TOMAColors.unclickableTextColor);

        panel_bottom.setBackground(TOMAColors.tomaBackgroundColor);



        //mainPanel=new StandardTrainingViewMainPanel(TOMATemplateView.TRAININGCOURSEVIEW);

        mainPanel = new TrainingViewMainPanel(TOMATemplateView.TRAININGCOURSEVIEW);


        panel_toolbar = new TrainingCourseViewButtonsPanel(this);


        this.add(panel_toolbar, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0

                , GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));


        this.add(mainPanel, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0

                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 3, 3, 0), 0, 0));


        this.add(panel_aux, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0

                , GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));


        panel_bottom.add(dates, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0

                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(3, 0, 3, 0), 0, 0));


        this.add(panel_bottom, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0

                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));



        //fill

        this.add(Box.createGlue(), new GridBagConstraints(0, 5, 1, 1, 0.0, 1.0

                , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));

        /*this.add(Box.createGlue(), new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0

                ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));*/



        this.setBackground(TOMAColors.tomaBackgroundColor);

    }


    public void getData(TrainingCourse tc) {

        ((TrainingViewMainPanel) mainPanel).getData(tc);

        ((StandardTrainingViewTabsPanel) panel_aux).getData(tc);

    }

    public void setData(TrainingCourse tc) {

        super.setData(tc);



        //panels

        ((TrainingViewMainPanel) mainPanel).setData(tc);

        //apostal.toma.TOMA.printTime("TrainingCourseView.setData: aprs mainPanel.setData, avant panel_aux.setData");

        ((StandardTrainingViewTabsPanel) panel_aux).setData(tc);

    }


    public String testTemplateElements() {

        int type = TOMATemplateView.TRAININGCOURSEVIEW;


        String msg = "";


        String msg_main = mainPanel.testTemplateElements(type);

        if (msg_main != null)

            msg = msg + msg_main;


        String msg_tab = ((StandardTrainingViewTabsPanel) panel_aux).testTemplateElements(type);

        if (msg_tab != null)

            msg = msg + msg_tab;


        return msg;

    }

    public void updateTeachers() {
        if (panel_aux != null)
            ((StandardTrainingViewTabsPanel) panel_aux).updateTeachers();
    }

    public void updateContacts() {
        if (panel_aux != null)
            ((StandardTrainingViewTabsPanel) panel_aux).updateContacts();
    }

    public void updateLocations() {
        if (panel_aux != null)
            ((StandardTrainingViewTabsPanel) panel_aux).updateLocations();
    }

}

