// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import java.util.Vector;
import java.util.Iterator;

import java.awt.Dimension;
import java.awt.Component;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JLabel;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;

import apostal.toma.view.*;

import apostal.toma.data.TOMATemplate;
import apostal.toma.data.TOMATemplateResult;
import apostal.toma.TOMA;
import apostal.toma.data.TOMALabels;
import apostal.toma.data.Training;
import apostal.toma.data.TOMATemplateResult;

import java.sql.Date;

// remettre  la fin
//public class TrainingView extends ContextualView

public abstract class TrainingView extends JPanel {

    private static TOMATemplate template;

    static {
        template = TOMA.getInstance().getTomaTemplate();
    }

    abstract public void updateTeachers();

    abstract public void updateLocations();

    abstract public void updateContacts();

    public static void refreshTeachers() {
        TrainingViewTeachers.refreshLists();

        JComponent component = TOMA.getInstance().getTomaView().getContextualView();
        if (component != null && component instanceof TrainingView) {
            TrainingView tview = (TrainingView) component;
            tview.updateTeachers();
        } else if (component != null && component instanceof TrainingProgrammeAndUnitsView) {
            TrainingProgrammeAndUnitsView tview = (TrainingProgrammeAndUnitsView) component;
            tview.updateTeachers();
        }
    }

    public static void refreshContacts() {
        Vector contacts=TrainingViewContacts.refreshLists();
        UnitViewContacts.refreshLists(contacts);

        JComponent component = TOMA.getInstance().getTomaView().getContextualView();
        if (component != null && component instanceof TrainingView) {
            TrainingView tview = (TrainingView) component;
            tview.updateContacts();
        } else if (component != null && component instanceof TrainingProgrammeAndUnitsView) {
            TrainingProgrammeAndUnitsView tview = (TrainingProgrammeAndUnitsView) component;
            tview.updateContacts();
        }
    }

    public static void refreshLocations() {
        TrainingViewLocations.refreshLists();

        JComponent component = TOMA.getInstance().getTomaView().getContextualView();
        if (component != null && component instanceof TrainingView) {
            TrainingView tview = (TrainingView) component;
            tview.updateLocations();
        } else if (component != null && component instanceof TrainingProgrammeAndUnitsView) {
            TrainingProgrammeAndUnitsView tview = (TrainingProgrammeAndUnitsView) component;
            tview.updateLocations();
        }
    }


    protected TOMALabels labels;

    TrainingViewButtonsPanel panel_toolbar;

    TrainingViewMainPanel mainPanel;

    JLabel dates;
    GridBagLayout gridBagLayout6;
    GridBagLayout gridBagLayout7;

    JPanel panel_bottom;

    TrainingViewTabsPanel panel_aux;

    public void setData(Training t) {
        //dates
        Date creation = t.getDateCreation();
        Date maj = t.getDateMaj();
        dates.setText(TOMAFonts.htmlBegin + "<font size=-1>" + labels.get("apostal.toma.trainingview.dateCreation") + creation + " " + labels.get("apostal.toma.trainingview.dateMaj") + maj + "</font>" + TOMAFonts.htmlEnd);
    }


    /**
     * additional methods *
     */
    abstract public String testTemplateElements();
}

