// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */
package apostal.toma.view;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.EmptyBorder;

import apostal.toma.TOMA;
import apostal.toma.data.TrainingCourse;
import apostal.toma.data.TOMALabels;

//pour le print
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.*;
import java.awt.print.*;
import java.awt.geom.*;

public class ViewTrainingCourse extends ViewTraining implements ActionListener {

    private TOMAButton print;
    private TOMAPrintablePanel panel;
    private JPanel panel2;
    private JPanel mainPanel;

    public ViewTrainingCourse(TrainingCourse tc) {
        super(tc);

        this.setTitle(labels.get("apostal.toma.viewtrainingcourse.title") + " \"" + tc.toString() + "\"");

        panel = new TOMAPrintablePanel();
        panel.setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(5, 0, 5, 0), 0, 0);

        //sous paneaux
        ViewTrainingMain main = new ViewTrainingMain(tc);
        panel.add(main, c);

        //details
        TOMALabel titleDetails = new TOMALabel(labels.get("apostal.toma.trainingview.details"));
        c.gridy = 1;
        panel.add(titleDetails, c);
        ViewTrainingDetails details = new ViewTrainingDetails(tc);
        c.gridy = 2;
        panel.add(details, c);

        //inscription details
        TOMALabel titleInscriptionDetails = new TOMALabel(labels.get("apostal.toma.trainingview.inscriptionDetails"));
        c.gridy = 3;
        panel.add(titleInscriptionDetails, c);
        ViewTrainingInscriptionDetails inscriptionDetails = new ViewTrainingInscriptionDetails(tc);
        c.gridy = 4;
        panel.add(inscriptionDetails, c);

        //points
        TOMALabel titlePoints = new TOMALabel(labels.get("apostal.toma.viewtraining.points"));
        c.gridy = 5;
        panel.add(titlePoints, c);
        ViewTrainingPoints points = new ViewTrainingPoints(tc);
        c.gridy = 6;
        panel.add(points, c);

        //aux
        TOMALabel titleAux = new TOMALabel(labels.get("apostal.toma.viewtraining.whowhere"));
        c.gridy = 7;
        panel.add(titleAux, c);
        ViewTrainingAux aux = new ViewTrainingAux(tc);
        c.gridy = 8;
        panel.add(aux, c);

        //sessions
        ViewCourseSession sess = new ViewCourseSession(tc);
        c.gridy = 9;
        panel.add(sess, c);

        //mise en page panel
        panel.setBackground(TOMAColors.auxBackgroundColor);
        panel.setBorder(new EmptyBorder(0, 0, 0, 0));

        //print
        panel2 = new JPanel();
        panel2.setBackground(TOMAColors.auxBackgroundColor);
        panel2.setBorder(new EmptyBorder(0, 0, 0, 0));
        panel2.setLayout(new GridBagLayout());
        print = new TOMAButton(labels.get("apostal.toma.print.button"));
        print.addActionListener(this);
        c = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0);
        panel2.add(print, c);
        //coller le bouton  gauche
        panel2.add(Box.createGlue(), new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));

        //mise panel
        mainPanel = new JPanel();
        mainPanel.setBackground(TOMAColors.auxBackgroundColor);
        mainPanel.setBorder(new EmptyBorder(10, 10, 10, 10));
        mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));
        mainPanel.add(panel2);
        mainPanel.add(panel);
        JScrollPane scrollPane = new JScrollPane();
        scrollPane.setViewportView(mainPanel);
        this.setContentPane(scrollPane);

        this.pack();
    }


    public void actionPerformed(ActionEvent e) {
        //PrinterJob
        PrinterJob job = PrinterJob.getPrinterJob();
        job.setCopies(1);
        job.setJobName("TOMA Print");
        job.setPrintable(panel);

        if (job.printDialog()) {
            try {
                TOMA.log(TOMA.INFO, "printing");
                job.print();
            } catch (java.awt.print.PrinterException ex) {
                TOMAError error = new TOMAError(labels.get("apostal.toma.print.error.message"), labels.get("apostal.toma.print.error.title"));
            }
        }
    }


}

