// TOMA, v1.0 - 07/2002
//
// TOMA (Training Offer Management Application) is a Java application
// to manage training offers and all the related data
// (organism data, locations, animators, contacts, ...).
// It also allows to publish the data in different formats:
// 	- XML (in the "TED" format, "Training Exchange Definition",
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
//
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact Information:
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.view;

import apostal.toma.TOMA;
import apostal.toma.data.*;

import apostal.toma.data.TOMALabels;

import java.util.Vector;
import java.util.Iterator;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

/**
 * Title:        TOMA
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      CRP Henri Tudor
 * @author
 * @version 1.0
 */

public class ViewTrainingInscriptionDetails extends JPanel {
    private TOMALabels labels;

    public ViewTrainingInscriptionDetails(StandaloneTraining t) {
        labels = new TOMALabels();

        this.setLayout(new GridBagLayout());
        GridBagConstraints cons = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(2, 2, 2, 2), 0, 0);

        /*String title=labels.get("apostal.toma.trainingview.inscriptionDetails");
        this.setBorder(new TitledBorder(new LineBorder(java.awt.Color.black), title, TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, ViewTraining.titleFont, ViewTraining.titleColor));*/

        //duration
        TOMALabel label_dur = new TOMALabel(labels.get("apostal.toma.trainingview.duration"));
        this.add(label_dur, cons);
        TOMATextArea dur = new TOMATextArea(1, 20);
        dur.setEditable(false);
        dur.setText(t.getDuration());
        cons.gridx = 1;
        this.add(dur, cons);

        //pay
        TOMALabel label_pay = new TOMALabel(labels.get("apostal.toma.trainingview.paymentFacilities"));
        cons.gridx = 2;
        this.add(label_pay, cons);
        TOMATextArea pay = new TOMATextArea(1, 20);
        pay.setEditable(false);
        pay.setText(t.getPaymentFacilities());
        cons.gridx = 3;
        this.add(pay, cons);

        //price
        TOMALabel label_price = new TOMALabel(labels.get("apostal.toma.trainingview.price"));
        cons.gridy = 1;
        cons.gridx = 0;
        this.add(label_price, cons);
        TOMATextArea price = new TOMATextArea(1, 20);
        price.setEditable(false);
        price.setText(t.getPrice());
        cons.gridx = 1;
        this.add(price, cons);

        //inscription conditions
        TOMALabel label_ins = new TOMALabel(labels.get("apostal.toma.trainingview.inscriptionConditions"));
        cons.gridx = 2;
        this.add(label_ins, cons);
        TOMATextArea ins = new TOMATextArea(1, 20);
        ins.setEditable(false);
        ins.setText(t.getInscriptionConditions());
        cons.gridx = 3;
        this.add(ins, cons);

        //pricec
        TOMALabel label_pricec = new TOMALabel(labels.get("apostal.toma.trainingview.priceComment"));
        cons.gridy = 2;
        cons.gridx = 0;
        this.add(label_pricec, cons);
        TOMATextArea pricec = new TOMATextArea(1, 20);
        pricec.setEditable(false);
        pricec.setText(t.getPriceComment());
        cons.gridx = 1;
        this.add(pricec, cons);

        //audience
        TOMALabel label_aud = new TOMALabel(labels.get("apostal.toma.trainingview.audiences"));
        cons.gridy = 3;
        cons.gridx = 0;
        this.add(label_aud, cons);
        TOMATextArea aud = new TOMATextArea(1, 20);
        aud.setEditable(false);
        if (t.getAudiences() != null) {
            String textAud = "";
            Iterator iter = t.getAudiences().iterator();
            while (iter.hasNext()) {
                String a = (String) iter.next();
                textAud = textAud + a + "\n";
            }
            textAud = textAud.trim();
            aud.setText(textAud);
        }
        cons.gridx = 1;
        this.add(aud, cons);

        //prerequis
        TOMALabel label_pre = new TOMALabel(labels.get("apostal.toma.trainingview.prerequisites"));
        cons.gridx = 2;
        this.add(label_pre, cons);
        TOMATextArea pre = new TOMATextArea(1, 20);
        pre.setEditable(false);
        if (t.getPrerequisites() != null) {
            String textPre = "";
            Iterator iter = t.getPrerequisites().iterator();
            while (iter.hasNext()) {
                String p = (String) iter.next();
                textPre = textPre + p + "\n";
            }
            textPre = textPre.trim();
            pre.setText(textPre);
        }
        cons.gridx = 3;
        this.add(pre, cons);


        this.setBackground(TOMAColors.auxBackgroundColor2);
    }
}