// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.viewcontrol;

import apostal.toma.TOMA;
import apostal.toma.view.OrganismView;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;

import apostal.toma.view.*;
import apostal.toma.data.*;
import apostal.toma.database.OrganismDB;
import apostal.toma.datacontrol.*;
import apostal.toma.TOMA;


public class OrganismEventHandler extends WindowAdapter implements ActionListener
{
    protected TOMALabels labels = new TOMALabels();    
    private OrganismView organismView;
    private OrganismControl organismControl = new OrganismControl();

    public OrganismEventHandler(OrganismView organismView)
    {
      this.organismView = organismView;
    }

    public void actionPerformed(ActionEvent e)
    {
      String actioncommand = e.getActionCommand();
      String action = getAction(actioncommand);
      if (action.compareTo("validate")==0)
      {
        organismView.putAddress();
      }
      else if (action.compareTo("removeList")==0)
      {
        //organismControl.removeAddress();
        organismView.removeList();
      }
      else if (action.compareTo("save")==0)
      {
        //Organism org = organismView.getData();
        //organismControl.saveOrganism(org);
          this.saveOrganism();
      }
      else if (action.compareTo("new")==0)
      {
        organismView.emptyAddress();
      }
      //Commande de la liste
      else
      {

      }
    }

    public void windowClosing(WindowEvent e) 
    {
        TOMAEventHandler tomaHandler=TOMA.getInstance().getHandler();
        tomaHandler.closeOrganismView();
    }
    
    public void openOrganism() {
    }

    public void saveOrganism() {
        /*TOMAError error;
        String message1 = labels.get("apostal.toma.organism.error.save.empty");
        String message2 = labels.get("apostal.toma.organism.error.save.exist");
        String title = labels.get("apostal.toma.organism.error.save.title");
        Organism data = organismView.getData();
        String denomination = data.getDenomination();
        
        OrganismDB odb=new OrganismDB(data);
        //Test denomination pas vide
        if (denomination.compareTo("")==0)
        {
          error = new TOMAError(message1, title);
        }
        else if(!odb.testUpdate())
        {
            error = new TOMAError(message2, title);
        }
        // creation
        else
        {*/
            boolean ok=true;

            String template=this.testTemplate();
            if(template!=null)
            {
                //ouvrir la fenetre de demande de confirmation
                String qTitle=labels.get("apostal.toma.organism.templateProblemTitle");
                TOMAQuestion question=new TOMAQuestion(template,qTitle);
                if(question.getResult()!=0)
                    ok=false;
            }
            if(ok){            
                Organism org = organismView.getData();
                organismControl.saveOrganism(org);
            }
        //}        
    }

    /**
     * tests the template:
     * @return: the error message to display if it is incorrect. Otherwise null.
     */
    public String testTemplate()
    {
      //effectuer tous les tests
      String s=organismView.testTemplateElements();
      if(s!=null && !s.equals(""))
      {
	String msg=labels.get("apostal.toma.organism.templateProblem");
        msg=msg+"\n"+s;
        msg=msg+"\n\n"+labels.get("apostal.toma.organism.templateProblemSave");
	return msg;
      }
      else
	return null;
    }    
    
    //Ligne prcise dans le String
    public int getIndex(String action)
    {
       int index = 0;
       int point = action.indexOf(".");
       String substring = action.substring(0,point);
       try
       {
           index = Integer.parseInt(substring);
       }
       catch(NumberFormatException np)
       {
       }
       return index;
    }

    //Action prcise dans le String
    public String getAction (String action)
    {
      int point = action.indexOf(".");
      return action.substring(point+1);
    }
}

