// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.viewcontrol;

import apostal.toma.TOMA;


import apostal.toma.view.*;

import apostal.toma.data.TOMAParameters;
import apostal.toma.data.TOMALabels;
import apostal.toma.data.PublicationUnit;
import apostal.toma.data.TrainingPublished;
import apostal.toma.data.CataloguePublished;
import apostal.toma.data.TOMAConstants;
import apostal.toma.data.SyrecosLogin;
import apostal.toma.data.Training;
import apostal.toma.data.TrainingCourse;
import apostal.toma.data.TrainingProgramme;
import apostal.toma.data.Language;

import apostal.toma.datacontrol.PublicationsControl;

import apostal.toma.database.PublicationUnitDB;
import apostal.toma.database.TrainingDB;

import apostal.toma.external.*;
import apostal.toma.external.tedtoma.*;

import java.util.Vector;
import java.util.Iterator;
import java.util.Enumeration;
import java.util.Date;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.Component;

import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import javax.swing.event.TreeWillExpandListener;


import javax.swing.tree.TreePath;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreeSelectionModel;

import javax.swing.JTree;
import javax.swing.JComponent;
import javax.swing.JFileChooser;

import java.io.File;


    

public class PublicationUnitsEventHandler extends WindowAdapter implements ActionListener, TreeSelectionListener, TreeWillExpandListener, TreeExpansionListener{


    private TOMATree tree;
    private TOMATreeControl control;
    private CreatePublicationUnit create;
    private LoginSyrecos login;
    private LoginSOAP login2;
    private Vector validTrainings;
    private static PublicationUnitsView publicationUnitsView;
    private PublicationsControl pubControl = new PublicationsControl();
	protected TOMALabels labels = new TOMALabels();
	private boolean presCatWithDiffParent;
	private Vector pathSelected;
	private boolean nodeCollapse;
	private boolean firstTime;
	private boolean nodeExpand;
	private boolean parentNotSelected;
	private int nbrValueChange;

    public PublicationUnitsEventHandler(PublicationUnitsView publicationUnitsView){
    	this.publicationUnitsView = publicationUnitsView;
    	nodeCollapse = false;
    	nodeExpand = false;
    	parentNotSelected = false;
    	firstTime=true;
    	nbrValueChange = 0;
    }

	public void setTreeSelection(PublicationUnit publicationUnit,TOMATree tree)
    {
    	Vector trainings = publicationUnit.getTrainings();
    	Vector catalogues = publicationUnit.getCatalogues();
      	Vector treePaths = new Vector();
      	if (trainings==null ||trainings.isEmpty()){
      	} else {      		
      		if (trainings!=null){
      			if (trainings.size()!=0){
      				Iterator it = trainings.iterator();
      				while (it.hasNext()){
      					TrainingPublished t = (TrainingPublished)it.next();
      					int idCat = t.getIdCatalogue();
      					int idTraining = t.getIdTraining();
      					this.selectItem(tree,idCat,idTraining,treePaths);
      				}
       			}
      		}
      		if (catalogues!=null){
      			if (catalogues.size()!=0){
      				Iterator itCat = catalogues.iterator();
      				while(itCat.hasNext()){
      					CataloguePublished catPub = (CataloguePublished)itCat.next();
      					int id = catPub.getIdCatalogue();
      					this.selectCatalogues(tree,id,treePaths);
      				}
      			
      			}
      		}
      		if (treePaths.size()!=0){
      			TreePath[] tabPaths = new TreePath[treePaths.size()];
      			for (int i = 0;i<treePaths.size();i++){
      				tabPaths[i] = (TreePath)treePaths.elementAt(i);
      			}
      			tree.getTree().setSelectionPaths(tabPaths);
     		}
     	}
     	
    }
    
    
    public void selectCatalogues(TOMATree tree,int idCat,Vector v){
    	DefaultTreeModel model = (DefaultTreeModel)tree.getTree().getModel();
    	CatalogueTreeNode root = tree.getRoot();
    	Enumeration e = root.depthFirstEnumeration();
    	while (e.hasMoreElements()){
    		Object o = e.nextElement();
    		String className = o.getClass().getName();
    		if(className.equals("apostal.toma.view.CatalogueTreeNode"))
	  		{
	      		CatalogueTreeNode node=(CatalogueTreeNode) o;
	      		if ( node.getIdCatalogue()==idCat){
	      			TreePath path = new TreePath(model.getPathToRoot(node));
	      			v.add(path);
	      			tree.getTree().makeVisible(path);	      		
	      		}
	      	}
	  	}
    }
	
	public void treeExpanded(TreeExpansionEvent event){
		nodeExpand=false;				
	}
	public void treeCollapsed(TreeExpansionEvent event){}
	
	public void treeWillExpand(TreeExpansionEvent event){
		nodeExpand = true;

		
		publicationUnitsView.getTree().getTree().setExpandsSelectedPaths(false);

		if (pathSelected!=null){
			Iterator it = pathSelected.iterator();
			while(it.hasNext()){
				TreePath pathTemp = (TreePath)it.next();					
				publicationUnitsView.getTree().getTree().addSelectionPath(pathTemp);
			}
			pathSelected=null;			
		}	

	}

	private void deletePath(TreePath path){
		if (pathSelected!=null){
			pathSelected.remove(path);
		}
	}

	private void removeDoublon(Vector trainings){
		if (trainings!=null){
			int i = 0;
			while(i<trainings.size()){
				TrainingPublished trPub = (TrainingPublished)trainings.elementAt(i);
				int j = i+1;
				while(j<trainings.size()){
		    		TrainingPublished tPublishTemp = (TrainingPublished)trainings.elementAt(j);
		    		if (trPub.equals(tPublishTemp)){
						trainings.remove(j);
						j--;
		    		}
		    		j++;
				}
				i++;
			}
		}
	}

	public void treeWillCollapse(TreeExpansionEvent event){
		publicationUnitsView.getTree().getTree().setExpandsSelectedPaths(false);
		nodeCollapse = true;
		if (pathSelected==null)
			pathSelected = new Vector();
		DefaultTreeModel model = (DefaultTreeModel)publicationUnitsView.getTree().getTree().getModel();
		TreePath path = event.getPath();
		Object o= path.getLastPathComponent();
     	if(o!=null){
     		int tailleVecteur= pathSelected.size();
      		String className = o.getClass().getName();
      		if (className.equals("apostal.toma.view.CatalogueTreeNode")){
      			CatalogueTreeNode cat = (CatalogueTreeNode)o;
      			Enumeration enum = cat.depthFirstEnumeration();
      			if (publicationUnitsView.getTree().getTree().isPathSelected(path)){
      				pathSelected.add(path);	      			
      			}
      			while (enum.hasMoreElements()){
      				Object sel = enum.nextElement();
    				String classNameSec = sel.getClass().getName();
    				if(classNameSec.equals("apostal.toma.view.TrainingTreeNode"))
	  				{
	      				TrainingTreeNode node=(TrainingTreeNode) sel;
	      				TreePath pathSec = new TreePath(model.getPathToRoot(node));	      					
	      				if (publicationUnitsView.getTree().getTree().isPathSelected(pathSec)){
	      					pathSelected.add(pathSec);
	      				}
	      			}
	      			if(classNameSec.equals("apostal.toma.view.CatalogueTreeNode"))
	  				{
	      				CatalogueTreeNode node=(CatalogueTreeNode) sel;
	      				TreePath pathSec = new TreePath(model.getPathToRoot(node));
	      				if (publicationUnitsView.getTree().getTree().isPathSelected(pathSec)){
	      					pathSelected.add(pathSec);
	      				}
	      			}
	      		}	
      		
      		}
      		if (pathSelected.size()==tailleVecteur){
      			nodeCollapse = false;
      		}      		
      	}
	}
	
	
    public void selectItem(TOMATree tree,int idCat,int idTraining,Vector v){
    	DefaultTreeModel model = (DefaultTreeModel)tree.getTree().getModel();
    	CatalogueTreeNode root = tree.getRoot();
    	Enumeration e = root.depthFirstEnumeration();
    	while (e.hasMoreElements()){
    		Object o = e.nextElement();
    		String className = o.getClass().getName();
    		if(className.equals("apostal.toma.view.TrainingTreeNode"))
	  		{
	      		TrainingTreeNode node=(TrainingTreeNode) o;
	      		if (node.getIdTraining()==idTraining){
	      			TreePath path = new TreePath(model.getPathToRoot(node));
	      			TreePath parentPath = path.getParentPath();
	      			CatalogueTreeNode catTree= (CatalogueTreeNode)parentPath.getLastPathComponent();
	      			if (catTree.getIdCatalogue()==idCat){
	      				v.add(path);
	      				tree.getTree().makeVisible(path);
	      			}
	      		}
	      	}	      	
    	}
    }

   	public void valueChanged(TreeSelectionEvent e)
   	{           	
     	DefaultTreeModel model = (DefaultTreeModel)publicationUnitsView.getTree().getTree().getModel();
     	TreePath path=e.getPath();
       	if (!nodeCollapse && !nodeExpand){
     		Object o= path.getLastPathComponent();
       		if(o!=null){
     			String className = o.getClass().getName();
      			if (className.equals("apostal.toma.view.CatalogueTreeNode")){
      				CatalogueTreeNode cat = (CatalogueTreeNode)o;
      				Enumeration enum = cat.depthFirstEnumeration();
      				if (publicationUnitsView.getTree().getTree().isPathSelected(path)){
      					while (enum.hasMoreElements()){
      						Object sel = enum.nextElement();
    						String classNameSec = sel.getClass().getName();
    						if(classNameSec.equals("apostal.toma.view.TrainingTreeNode"))
	  						{
	      						TrainingTreeNode node=(TrainingTreeNode) sel;
	      						TreePath pathSec = new TreePath(model.getPathToRoot(node));
	      						publicationUnitsView.getTree().getTree().addSelectionPath(pathSec);
	      						if (!nodeCollapse && !nodeExpand){
	      							publicationUnitsView.getTree().getTree().makeVisible(pathSec);
	      						}
	      					}
	      					if(classNameSec.equals("apostal.toma.view.CatalogueTreeNode"))
	  						{
	      						CatalogueTreeNode node=(CatalogueTreeNode) sel;
	      						TreePath pathSec = new TreePath(model.getPathToRoot(node));
	      						publicationUnitsView.getTree().getTree().addSelectionPath(pathSec); 	      					      			
	      						if (!nodeCollapse && !nodeExpand){
	      							publicationUnitsView.getTree().getTree().makeVisible(pathSec);
	      						}
	      					}
      					}
      				}  else {
      					if (!nodeCollapse && !nodeExpand){
      						deletePath(path);
      						while (enum.hasMoreElements()){
      							Object sel = enum.nextElement();
    							String classNameSec = sel.getClass().getName();
    							if(classNameSec.equals("apostal.toma.view.TrainingTreeNode"))
	  							{
	      							TrainingTreeNode node=(TrainingTreeNode) sel;
	      							TreePath pathSec = new TreePath(model.getPathToRoot(node));
	      							publicationUnitsView.getTree().getTree().removeSelectionPath(pathSec);  
	      							if (!nodeCollapse && !nodeExpand){
	      								publicationUnitsView.getTree().getTree().makeVisible(pathSec);
	      							}
	      							deletePath(pathSec); 
								}
	      						if(classNameSec.equals("apostal.toma.view.CatalogueTreeNode"))
	  							{
	      							CatalogueTreeNode node=(CatalogueTreeNode) sel;
	      							TreePath pathSec = new TreePath(model.getPathToRoot(node));
									publicationUnitsView.getTree().getTree().removeSelectionPath(pathSec);  
									if (!nodeCollapse && !nodeExpand){
	      								publicationUnitsView.getTree().getTree().makeVisible(pathSec);
	      							}
									deletePath(pathSec);
		    					}
      						}
      					}
      					firstTime=false;
      				}    	
      			}
      			else {
      				if (className.equals("apostal.toma.view.TrainingTreeNode")){
      					TrainingTreeNode tr = (TrainingTreeNode)o;      			
      				}
      			}
   			}
   		}
   		nodeCollapse=false;
   	}

   
    
   	public void createPublicationUnit() {
        Vector temp= new Vector();
        TOMAError error;
        String message1 = labels.get("apostal.toma.publication.error.creation.empty");
        String message2 = labels.get("apostal.toma.publication.error.creation.exist");
        String message3 = labels.get("apostal.toma.publication.error.creation.missing_type");
        String title = labels.get("apostal.toma.publication.error.creation.title");
        temp= (Vector)create.getData();
        String denomination = (String)temp.elementAt(0);
        String type = (String)temp.elementAt(1);
        // Try to unlock locked data
        PublicationUnit l = new PublicationUnit();
        TOMAParameters param = TOMA.getInstance().getTomaParameters();
        l.setName(denomination);
        l.setType(Integer.parseInt(type));
        l.setLanguage(param.getExportationLanguage());
        int typeInt= Integer.parseInt(type);
        if (typeInt==PublicationUnit.PUBLICATION_HTML){
        	File f = new File(TOMAConstants.defaultHTMLStylesheet);
        	String path = f.getAbsolutePath();
        	l.setTemplateFile(path);
            File fProperties = new File(TOMAConstants.propertiesFileHTML);
            String pathProperties = fProperties.getAbsolutePath();
            l.setPropertiesFile(pathProperties);
        }
        else if (typeInt==PublicationUnit.PUBLICATION_PDF){
        	File f = new File(TOMAConstants.defaultPDFStylesheet);
        	String path = f.getAbsolutePath();
        	l.setTemplateFile(path);
            File fProperties = new File(TOMAConstants.propertiesFilePDF);
            String pathProperties = fProperties.getAbsolutePath();
            l.setPropertiesFile(pathProperties);
        }
        else if (typeInt==PublicationUnit.PUBLICATION_RTF){
        	File f = new File(TOMAConstants.defaultRTFStylesheet);
        	String path = f.getAbsolutePath();
        	l.setTemplateFile(path);
            File fProperties = new File(TOMAConstants.propertiesFileRTF);
            String pathProperties = fProperties.getAbsolutePath();
            l.setPropertiesFile(pathProperties);
        }
        else if (typeInt==PublicationUnit.PUBLICATION_SOAP){
        	l.setConsiderValidityDates(false);
        	l.setDestinationPath(null);
        	l.setTemplateFile(null);
        	l.setPublishOrganismData(true);
        	l.setLanguage(new Language("fra"));
        	l.setFirstCatalogueTitle(null);
        	l.setPropertiesFile(TOMAConstants.propertiesFileSOAP);
        }
		else if (typeInt==PublicationUnit.PUBLICATION_SOAP_DELETE){
        	l.setConsiderValidityDates(false);
        	l.setDestinationPath(null);
        	l.setTemplateFile(null);
        	l.setPublishOrganismData(false);
        	l.setLanguage(new Language("fra"));
        	l.setFirstCatalogueTitle(null);
        	l.setPropertiesFile(TOMAConstants.propertiesFileSOAP);
        }		
        else if (typeInt==PublicationUnit.PUBLICATION_XSL){
            l.setConsiderValidityDates(false);            
            l.setTemplateFile(null);
            l.setPublishOrganismData(true);
            l.setLanguage(new Language("fra"));
            l.setFirstCatalogueTitle(null);
            l.setPropertiesFile(TOMAConstants.propertiesFileXSL);
        }        

        l.setDefaultDestinationPath();
        try
        {
          PublicationUnit data = (PublicationUnit)publicationUnitsView.getData().elementAt(0);
          pubControl.unlockPublicationUnit(data);
        }
        catch(NullPointerException np){}
        boolean valid = true;

        //Test denomination pas vide
        if (denomination.compareTo("")==0)
        {
          error = new TOMAError(message1, title);
          valid = false;
        } else if (type.compareTo("")==0)
        	{
          		error = new TOMAError(message3, title);
          		valid = false;
        	}
        //test si le nom n'esiste pas encore
        else if (publicationexists(l))
        {
          error = new TOMAError(message2, title);
          valid=false;
        } else if (valid)
        {
          pubControl.createPublicationUnit(l);
          create.hide();
          
          publicationUnitsView.show();         
          publicationUnitsView.refresh();
          publicationUnitsView.selectPublicationUnit(l.getIdPublicationUnit());
        }
        
    }

    public void savePublicationUnit() {
        TOMAError error;
        String message1 = labels.get("apostal.toma.publication.error.save.empty");
        String message2 = labels.get("apostal.toma.publication.error.save.exist");
        String title = labels.get("apostal.toma.publication.error.save.title");
        PublicationUnit data = (PublicationUnit)publicationUnitsView.getData().elementAt(0);
        String name = data.getName();

        if (data.getType()==PublicationUnit.PUBLICATION_SOAP
		|| data.getType()==PublicationUnit.PUBLICATION_SOAP_DELETE){
        	//data.setConsiderValidityDates(true);
			//should this not be set to false !?!
			data.setConsiderValidityDates(false);
        }

        PublicationUnitDB ldb=new PublicationUnitDB(data);
        //Test denomination pas vide
        if (name.compareTo("")==0)
        {
          error = new TOMAError(message1, title);
          
           //recharger l'id sec
            pubControl.loadPublicationUnit(data, false);            
            publicationUnitsView.setData(data);
            publicationUnitsView.repaint();                     
        }
        else if(!ldb.testUpdate())
        {
            error = new TOMAError(message2, title);
            
           //recharger l'id sec
            pubControl.loadPublicationUnit(data, false);            
            publicationUnitsView.setData(data);
            publicationUnitsView.repaint();                                 
        }
        // creation
        else
        {
          pubControl.savePublicationUnit(data);
          
        }
    }

    public void deletePublicationUnit() {
        TOMAQuestion question;
        int result = 0;
        String question1 = labels.get("apostal.toma.publication.question.delete.exist");
        String title = labels.get("apostal.toma.publication.question.delete.title");
        PublicationUnit data = (PublicationUnit)publicationUnitsView.getData().elementAt(0);
        String denomination = data.getName();
        if (publicationexists(data))
        {
          question = new TOMAQuestion(question1,title);
          result = question.getResult();
        }
        if (result==0)
        {
          pubControl.deletePublicationUnit(data);
          publicationUnitsView.refresh();
        }
    }

 	public void setTrainingToPublish(PublicationUnit publicUnit,TOMATree tree){
 		java.util.Date toDay = new java.util.Date();
 		presCatWithDiffParent = false;
 		Vector trainings = new Vector();
 		Vector catalogues = new Vector();
 		TOMAJTree jTree = tree.getTree();
 		if (pathSelected!=null){
 			Iterator it = pathSelected.iterator();
 			while (it.hasNext()){
 				TreePath treePath = (TreePath)it.next();					
				publicationUnitsView.getTree().getTree().addSelectionPath(treePath);
			}
			pathSelected=null;
			
		}
 		if (jTree.getSelectionPaths()!=null){
 			TreePath[] paths = jTree.getSelectionPaths();
 			if (paths.length!=0){
 				TreePath treePath;
 				for (int i=0;i<paths.length;i++){
 					treePath = paths[i];
 					Object o=treePath.getLastPathComponent();
        			if(o!=null)
					{
	  					String className=o.getClass().getName();
	  					if(className.equals("apostal.toma.view.CatalogueTreeNode"))
	  					{
	      					CatalogueTreeNode node=(CatalogueTreeNode) o;
	      					CataloguePublished catPub = new CataloguePublished(node.getIdCatalogue(),publicUnit.getIdPublicationUnit());
	      					catalogues.add(catPub);
	      					
	     				}
	  					else if(className.equals("apostal.toma.view.TrainingTreeNode"))
	  					{
	      					TrainingTreeNode node=(TrainingTreeNode) o;
	  	    				TreePath catParent = treePath.getParentPath();
	  	    				CatalogueTreeNode parentNode = (CatalogueTreeNode)catParent.getLastPathComponent();
	  	    				TrainingPublished t;
	  	    				if (jTree.isPathSelected(catParent)){
	      						t = new TrainingPublished(publicUnit.getIdPublicationUnit(),parentNode.getIdCatalogue(),node.getIdTraining(),1,false);
	      					} else {
	      						t = new TrainingPublished(publicUnit.getIdPublicationUnit(),parentNode.getIdCatalogue(),node.getIdTraining(),1,true);
	      					}
	      					trainings.add(t);
	      	  			}
	  					else
	    					TOMA.log(TOMA.SEVERE, "TOMATreeControl.getSelection, className="+className);
					}
 				}				
 			}
 		}
 		
 		this.removeDoublon(trainings);
 		publicUnit.setTrainings(trainings);
 		publicUnit.setCatalogues(catalogues);
 	}
 	
 	
	private boolean getPublishFirstCatName(){	
		boolean publish = false;
		if (validTrainings!=null){
			Iterator it = validTrainings.iterator();
			while (it.hasNext() && publish==false){
				TrainingPublished tr = (TrainingPublished)it.next();
				if (tr.getPublishWithoutCatalogue() && validTrainings.size()>1){
					publish = true;
				}			
			}
			if (!publish){
				publish = this.presCatWithDiffParent;
			}
		}
		return publish;
	}
	
	private boolean testCatalogueValidity(CatalogueTreeNode catNode,TOMAJTree tree){
		boolean valid  = false;
		DefaultTreeModel model = (DefaultTreeModel)tree.getModel();
		int nbrChild = catNode.getChildCount();
		if (nbrChild>0){
			int i = 0;
			while (i<nbrChild && valid==false){
				TreeNode node = catNode.getChildAt(i);
				if (node instanceof TrainingTreeNode){
					TrainingTreeNode trNode = (TrainingTreeNode)node;					
					if (isValidTraining(trNode.getIdTraining())){
						TreePath path = new TreePath(model.getPathToRoot(node));
						if (tree.isPathSelected(path)){
							valid = true;
						}
					}		
				} else {
					if (node instanceof CatalogueTreeNode){
						TreePath path = new TreePath(model.getPathToRoot(node));
						if (tree.isPathSelected(path)){
							CatalogueTreeNode catNodeTemp = (CatalogueTreeNode)node;
							valid = testCatalogueValidity(catNodeTemp,tree);
						}		
					}
				}
				i++;
			}
		}
		return valid;
	}
	
	private boolean isValidTraining(int idTraining){
		boolean found = false;
		Iterator it = validTrainings.iterator();
		while (it.hasNext() && !found){
			TrainingPublished t = (TrainingPublished)it.next();
			if (idTraining==t.getIdTraining()){
				found = true;
			}
		}
		return found;
	}
	
	private int getNbrSelectPath(TreePath path,TOMAJTree tree){
		int nbrSelectPath = 1;
		TreePath parent = path.getParentPath();
		if (parent!=null){	
			if (tree.isPathSelected(parent)){
				nbrSelectPath = nbrSelectPath + getNbrSelectPath(parent,tree);	
			}
		}
		return nbrSelectPath;
	}
	
	private boolean getPathWithDiffParent(TOMAJTree tree){
		boolean dif = false;	
		TreePath[] paths = tree.getSelectionPaths();
		int nbrMinValue = 0;
		if (paths!=null){ 
			int i = 0;
			while(i<paths.length){
				TreePath path = paths[i];
				Object o = path.getLastPathComponent();
				String className = o.getClass().getName();
				if (className.equals("apostal.toma.view.CatalogueTreeNode")){
					CatalogueTreeNode catNode = (CatalogueTreeNode)o;
					if (testCatalogueValidity(catNode,tree)){
						int nbrSelectPath = getNbrSelectPath(path,tree);
						if (nbrSelectPath==1){
							nbrMinValue++; 
						}
					}
				}
				i++;
			}
		}
		if (nbrMinValue>1){
			dif = true;
		}
		return dif;
	}
	private boolean getValidTrainingToPublish(Vector trainings,Language lang,boolean consider,Date beginInterval,Date endInterval){
		validTrainings = new Vector();
		java.util.Date toDay = new java.util.Date();
		boolean valid = false;
		if (consider){
			if (trainings!=null){
				if (trainings.size()!=0){
					Iterator it = trainings.iterator();
					while(it.hasNext()){
						TrainingPublished t = (TrainingPublished)it.next();
						Training training = TrainingDB.getInstance(lang,true,t.getIdTraining());
	      				java.sql.Date beginDate = training.getBeginValidityDate();
	    	  			java.sql.Date endDate = training.getEndValidityDate();
	      				if (toDay.before(endDate) && toDay.after(beginDate)){
	      					valid = true;
	      					validTrainings.add(t);
	      				}	      			
					}
				} 
			}
		} else {
			validTrainings = trainings;			
			if (trainings.size()!=0){
				valid = true;
			}
		}
		/* publish trainings that have at least one session in the date interval  */

		if (beginInterval!=null && endInterval!=null){
            TOMA.log(TOMA.WARNING,"************************************\nTaille de valid trainings : " + validTrainings.size());
            int cpt=0;
			while (cpt<validTrainings.size()){
				TrainingPublished t = (TrainingPublished)validTrainings.elementAt(cpt);
				Object training = TrainingDB.getInstance(lang,true,t.getIdTraining());
				String strClass = training.getClass().getName();
				if (strClass.equals("apostal.toma.data.TrainingCourse")){
					TrainingCourse trCourse = (TrainingCourse)training;
					java.sql.Date dateBeginSession = trCourse.getFirstSeanceDate();
					java.sql.Date dateEndSession = trCourse.getEndSeanceDate();
					if (dateEndSession!=null && dateBeginSession!=null){
						if (!(dateBeginSession.before(endInterval) && dateBeginSession.after(beginInterval)) && !(dateEndSession.before(endInterval) && dateEndSession.after(beginInterval))){
							validTrainings.remove(t);
							cpt--;						
						}
					} else {
						validTrainings.remove(t);
						cpt--;	
					}
				}
				if (strClass.equals("apostal.toma.data.TrainingProgramme")){
					TrainingProgramme trProg = (TrainingProgramme)training;
					java.sql.Date dateBeginSession = trProg.getFirstSeanceDate();
					java.sql.Date dateEndSession = trProg.getEndSeanceDate();
					if (dateEndSession!=null && dateBeginSession!=null){
						if (!(dateBeginSession.before(endInterval) && dateBeginSession.after(beginInterval)) && !(dateEndSession.before(endInterval) && dateEndSession.after(beginInterval))){
							validTrainings.remove(t);
							cpt--;
						}
					} else {
						validTrainings.remove(t);
						cpt--;	
					}
				}
				cpt++;
			}
		}
		if (validTrainings.size()==0){
			valid = false;
		}
		return valid;
	}
	public boolean publicationexists(PublicationUnit pub)
    {
        PublicationUnitDB ldb=new PublicationUnitDB(pub);
        return !ldb.testCreate();
    }


    public void publish() {
    	TOMAError error;
    	TOMAOk info;
    	String message1 = new String(labels.get("apostal.toma.publication.error.publish.missing_firstCatName"));
    	String message2 = new String(labels.get("apostal.toma.publication.error.publish.missing_destination"));
    	String message3 = new String(labels.get("apostal.toma.publication.error.publish.missing_template"));
    	String message4 = new String(labels.get("apostal.toma.publication.error.publish.missing_properties"));
    	String title = new String(labels.get("apostal.toma.publication.error.publish.title"));
       	PublicationUnit pub = (PublicationUnit)publicationUnitsView.getData().elementAt(0);
    	Date beginInterval = (Date)publicationUnitsView.getData().elementAt(1);
    	Date endInterval = (Date)publicationUnitsView.getData().elementAt(2);
    	Vector trainings = pub.getTrainings();
    	int type = pub.getType();
    	String firstCatTitle = pub.getFirstCatalogueTitle();
    	String destPath = pub.getDestinationPath();
    	String propFile = pub.getPropertiesFile();
    	String templateFile = pub.getTemplateFile();
    	Date dateToday = new Date();
    	java.sql.Date date = new java.sql.Date(dateToday.getTime());    	
    	if (this.getValidTrainingToPublish(trainings,pub.getLanguage(),pub.getConsiderValidityDates(),beginInterval,endInterval)){
    		presCatWithDiffParent = getPathWithDiffParent(publicationUnitsView.getTree().getTree());
    		if (type==PublicationUnit.PUBLICATION_HTML){
	   			if (firstCatTitle.compareTo("")==0){
    				firstCatTitle = pub.getName();
    				pub.setFirstCatalogueTitle(firstCatTitle);
    			}
    			if (destPath.compareTo("")==0){
    				error = new TOMAError(message2,title);
    			}
    			else if (propFile.compareTo("")==0){
    				error = new TOMAError(message4,title);
    			}
    			else if (templateFile.compareTo("")==0){
    				error = new TOMAError(message3,title);
    			} else {
            		HTMLPublication pubHTML = new HTMLPublication(pub);
                    TOMAWaitThread waitCheck=new TOMAWaitThread(labels.get("apostal.toma.publication.publish.checkCompliance.message"), labels.get("apostal.toma.publication.publish.checkCompliance.title"));
                    waitCheck.start();
                    try{
                    	waitCheck.join();
                    }
                    catch(Exception ex){}
                    pubHTML.checkCompliance();
                    waitCheck.close();
                    Vector warnings=TedTomaConversion.getErrors();
                    boolean continuer=true;
                    if(warnings!=null && !warnings.isEmpty())
                    {
                    	TOMA.log(TOMA.WARNING, "il y a eu des probl�mes XML");
                        //demander si on veut continuer
                        XMLPublicationEventHandler xmlpub=new XMLPublicationEventHandler();
                        continuer=xmlpub.interpretInternalXMLPublication(warnings);
                   	}
                    if(continuer){
                    	TOMAWaitThread wait=new TOMAWaitThread(labels.get("apostal.toma.publication.publish.message"), labels.get("apostal.toma.publication.publish.title"));
                        wait.start();
                        try{
                        	wait.join();
                        }
                        catch(Exception ex){}
                        pubHTML.publish(this.getPublishFirstCatName());                                                
                		wait.close();
    					if (pubHTML.getResult()==1){
    						String errorMessage = pubHTML.getErrorMessage();
    						if (errorMessage==null){
    							errorMessage = TOMAFonts.htmlBegin;
    							errorMessage = errorMessage + "<P>" +labels.get("apostal.toma.publication.publish.unKnowError.messageTitle") + "</P>";
    							errorMessage = errorMessage + "<P>" + labels.get("apostal.toma.publication.publish.unKnowError.message") + "</P>";
    							errorMessage = errorMessage + TOMAFonts.htmlEnd;
    						} else {
    							if (errorMessage.compareTo("")==0){
    								errorMessage = TOMAFonts.htmlBegin;
    								errorMessage = errorMessage + "<P>" + labels.get("apostal.toma.publication.publish.unKnowError.messageTitle") + "<P>";
    								errorMessage = errorMessage + "<P>" + labels.get("apostal.toma.publication.publish.unKnowError.message") + "</P>";
    								errorMessage = errorMessage + TOMAFonts.htmlEnd;
    							}
    						}
    						error = new TOMAError(errorMessage,title);
    					} else {
    						pub.setDateLastPublished(date);
    						info = new TOMAOk(labels.get("apostal.toma.publication.publish.ok.message"),labels.get("apostal.toma.publication.publish.ok.title"));
    					}
    				}
   				}
    		}
    		else if (type==PublicationUnit.PUBLICATION_PDF){
    			if (firstCatTitle.compareTo("")==0){
    				firstCatTitle = pub.getName();
    				pub.setFirstCatalogueTitle(firstCatTitle);
    			}
    			if (destPath.compareTo("")==0){
    				error = new TOMAError(message2,title);
    			}
    			else if (propFile.compareTo("")==0){
    				error = new TOMAError(message4,title);
    			}
    			else if (templateFile.compareTo("")==0){
    				error = new TOMAError(message3,title);
    			} else {
    				PDFPublication pubPDF = new PDFPublication(pub);
    				TOMAWaitThread waitCheck=new TOMAWaitThread(labels.get("apostal.toma.publication.publish.checkCompliance.message"), labels.get("apostal.toma.publication.publish.checkCompliance.title"));
                    waitCheck.start();
                    try{
                    	waitCheck.join();
                    }catch(Exception ex){}
                    pubPDF.checkCompliance();
    				waitCheck.close();
    				Vector warnings=TedTomaConversion.getErrors();
                    boolean continuer=true;
                    if(warnings!=null && !warnings.isEmpty())
                    {
                    	TOMA.log(TOMA.WARNING, "il y a eu des probl�mes XML");
                        //demander si on veut continuer
                        XMLPublicationEventHandler xmlpub=new XMLPublicationEventHandler();
                        continuer=xmlpub.interpretInternalXMLPublication(warnings);
                   	}
                    if(continuer){
                       	TOMAWaitThread wait=new TOMAWaitThread(labels.get("apostal.toma.publication.publish.message"), labels.get("apostal.toma.publication.publish.title"));
                       	wait.start();
                        try{
                        	wait.join();
                        }catch(Exception ex){}
    					pubPDF.publish(this.getPublishFirstCatName());
    					wait.close();
    					if (pubPDF.getResult()==1){
    						error = new TOMAError(pubPDF.getErrorMessage(),title);
    					} else {
    						pub.setDateLastPublished(date);
    						info = new TOMAOk(labels.get("apostal.toma.publication.publish.ok.message"),labels.get("apostal.toma.publication.publish.ok.title"));
    					}
    				}
                }
    		}
    		else if (type==PublicationUnit.PUBLICATION_RTF){
    			if (firstCatTitle.compareTo("")==0){
    				firstCatTitle = pub.getName();
    				pub.setFirstCatalogueTitle(firstCatTitle);
    			}
    			if (destPath.compareTo("")==0){
    				error = new TOMAError(message2,title);
    			}
    			else if (propFile.compareTo("")==0){
    				error = new TOMAError(message4,title);
    			}
    			else if (templateFile.compareTo("")==0){
    				error = new TOMAError(message3,title);
    			} else {
    				RTFPublication pubRTF = new RTFPublication(pub);
    				TOMAWaitThread waitCheck=new TOMAWaitThread(labels.get("apostal.toma.publication.publish.checkCompliance.message"), labels.get("apostal.toma.publication.publish.checkCompliance.title"));
                   	waitCheck.start();
                    try{
                    	waitCheck.join();
                    }catch(Exception ex){}
    				//pubPDF.checkCompliance(pub);
                    pubRTF.checkCompliance();
    				waitCheck.close();
    				Vector warnings=TedTomaConversion.getErrors();
                    boolean continuer=true;
                    if(warnings!=null && !warnings.isEmpty())
                    {
                       	TOMA.log(TOMA.WARNING, "il y a eu des probl�mes XML");
                        //demander si on veut continuer
                        XMLPublicationEventHandler xmlpub=new XMLPublicationEventHandler();
                        continuer=xmlpub.interpretInternalXMLPublication(warnings);
                    }
                    if(continuer){
                       	TOMAWaitThread wait=new TOMAWaitThread(labels.get("apostal.toma.publication.publish.message"), labels.get("apostal.toma.publication.publish.title"));
                       	wait.start();
                        try{
                        	wait.join();
                        }catch(Exception ex){}
    					pubRTF.publish(this.getPublishFirstCatName());
    					wait.close();
    					if (pubRTF.getResult()==1){
    						error = new TOMAError(pubRTF.getErrorMessage(),title);
    					} else {
    						pub.setDateLastPublished(date);
    						info = new TOMAOk(labels.get("apostal.toma.publication.publish.ok.message"),labels.get("apostal.toma.publication.publish.ok.title"));
    					}
    				}                        
    			}
    		}
    		else if (type==PublicationUnit.PUBLICATION_SOAP || type==PublicationUnit.PUBLICATION_SOAP_DELETE){
    			login2 = new LoginSOAP(this,this.publicationUnitsView);
    			login2.pack();
    			login2.center();
    			login2.show();
    		}    		
    		else if (type==PublicationUnit.PUBLICATION_XML){
    			if (firstCatTitle.compareTo("")==0){
    				firstCatTitle = pub.getName();
    				pub.setFirstCatalogueTitle(firstCatTitle);
    			}
    			if (destPath.compareTo("")==0){
    				error = new TOMAError(message2,title);
    			}
    			else {
    				XMLPublication pubXML = new XMLPublication(pub);
	                TOMAWaitThread waitCheck=new TOMAWaitThread(labels.get("apostal.toma.publication.publish.checkCompliance.message"), labels.get("apostal.toma.publication.publish.checkCompliance.title"));
                    waitCheck.start();
                    try{
                    	waitCheck.join();
                    }catch(Exception ex){}
	                //pubPDF.checkCompliance(pub);
                    pubXML.checkCompliance();
                    waitCheck.close();
                    Vector warnings=TedTomaConversion.getErrors();
                    boolean continuer=true;
                    if(warnings!=null && !warnings.isEmpty())
                    {
                       	TOMA.log(TOMA.WARNING, "il y a eu des probl�mes XML");
                        XMLPublicationEventHandler xmlpub=new XMLPublicationEventHandler();
                        continuer=xmlpub.interpretInternalXMLPublication(warnings);
                    }
                    if(continuer){
                       	TOMAWaitThread wait=new TOMAWaitThread(labels.get("apostal.toma.publication.publish.message"), labels.get("apostal.toma.publication.publish.title"));
                       	wait.start();
                        try{
                        	wait.join();
                        }catch(Exception ex){}
    					pubXML.publish(this.getPublishFirstCatName());
    					wait.close();
    					if (pubXML.getResult()==1){
    						error = new TOMAError(pubXML.getErrorMessage(),title);
    					} else {
    						pub.setDateLastPublished(date);
    						info = new TOMAOk(labels.get("apostal.toma.publication.publish.ok.message"),labels.get("apostal.toma.publication.publish.ok.title"));
    					}
    				}
             	}
    		}
            else if (type==PublicationUnit.PUBLICATION_XSL){
                if (firstCatTitle.compareTo("")==0){
                    firstCatTitle = pub.getName();
                    pub.setFirstCatalogueTitle(firstCatTitle);
                }
                if (destPath.compareTo("")==0){
                    error = new TOMAError(message2,title);
                }
                else if (propFile.compareTo("")==0){
                    error = new TOMAError(message4,title);
                }
                else {
                    GenericXSLPublication pubXSL = new GenericXSLPublication(pub);
                    TOMAWaitThread waitCheck=new TOMAWaitThread(labels.get("apostal.toma.publication.publish.checkCompliance.message"), labels.get("apostal.toma.publication.publish.checkCompliance.title"));
                    waitCheck.start();
                    try{
                        waitCheck.join();
                    }catch(Exception ex){}
                    pubXSL.checkCompliance();
                    waitCheck.close();
                    Vector warnings=TedTomaConversion.getErrors();
                    boolean continuer=true;
                    if(warnings!=null && !warnings.isEmpty())
                    {
                        TOMA.log(TOMA.WARNING, "il y a eu des probl�mes XML");
                        //demander si on veut continuer
                        XMLPublicationEventHandler xmlpub=new XMLPublicationEventHandler();
                        continuer=xmlpub.interpretInternalXMLPublication(warnings);
                    }
                    if(continuer){
                        TOMAWaitThread wait=new TOMAWaitThread(labels.get("apostal.toma.publication.publish.message"), labels.get("apostal.toma.publication.publish.title"));
                        wait.start();
                        try{
                            wait.join();
                        }catch(Exception ex){}
                        pubXSL.publish(this.getPublishFirstCatName());
                        wait.close();
                        if (pubXSL.getResult()==1){
                            error = new TOMAError(pubXSL.getErrorMessage(),title);
                        } else {
                            pub.setDateLastPublished(date);
                            info = new TOMAOk(labels.get("apostal.toma.publication.publish.ok.message"),labels.get("apostal.toma.publication.publish.ok.title"));
                        }
                    }
                }
            }            
            
    		//publicationUnitsView.setData(pub);  
    		PublicationUnitDB pdb=new PublicationUnitDB(pub);
        	if(pdb.testUpdate())
            	pdb.update();
        	else
            	TOMA.log(TOMA.SEVERE, "PublicationUnitDB.publish, could not update publication unit");
    	} else {
   			error = new TOMAError(labels.get("apostal.toma.publication.publish.no_training"),title);
    	
    	}
        publicationUnitsView.refresh();
        publicationUnitsView.repaint(); 
        
    }
	
	public void publishToSOAP(){
		SyrecosLogin log = login2.getLogin();
		
		TOMA.log(TOMA.WARNING, ">>>>publishToSOAP, login="+log.getLogin());
		
		login2.dispose();
		PublicationUnit pub = (PublicationUnit)publicationUnitsView.getData().elementAt(0);
		SOAPPublication pubSOAP=new SOAPPublication(log, pub);	
		SOAPPublicationEventHandler soap = new SOAPPublicationEventHandler(pubSOAP);
		
		boolean change = soap.publish(this.getPublishFirstCatName());	
		if (change){
			Date dateToday = new Date();
    		java.sql.Date date = new java.sql.Date(dateToday.getTime());
			pub.setDateLastPublished(date);
			PublicationUnitDB pdb=new PublicationUnitDB(pub);
        	if(pdb.testUpdate())
            	pdb.update();
        	else{
            	TOMA.log(TOMA.SEVERE, "PublicationUnitDB.publish, could not update publication unit");
        	}
        	
		}
		publicationUnitsView.refresh();  
		publicationUnitsView.show();
	}	
	public void publishToSOAPDelete(){
		SyrecosLogin log = login2.getLogin();
		
		TOMA.log(TOMA.WARNING, ">>>>publishToSOAPDelete, login="+log.getLogin());
		
		login2.dispose();
		PublicationUnit pub = (PublicationUnit)publicationUnitsView.getData().elementAt(0);
		SOAPDeletePublication pubSOAP=new SOAPDeletePublication(log, pub);	
		SOAPDeletePublicationEventHandler soap = new SOAPDeletePublicationEventHandler(pubSOAP);
		
		boolean change = soap.publish(this.getPublishFirstCatName());	
		if (change){
			Date dateToday = new Date();
    		java.sql.Date date = new java.sql.Date(dateToday.getTime());
			pub.setDateLastPublished(date);
			PublicationUnitDB pdb=new PublicationUnitDB(pub);
        	if(pdb.testUpdate())
            	pdb.update();
        	else{
            	TOMA.log(TOMA.SEVERE, "PublicationUnitDB.publish, could not update publication unit");
        	}
        	
		}
		publicationUnitsView.refresh();  
		publicationUnitsView.show();
	}	

  	public void viewTrainingsCatalogues() {
  	
    	PublicationUnit pub = (PublicationUnit)publicationUnitsView.getData().elementAt(0);
    	Date beginInterval = (Date)publicationUnitsView.getData().elementAt(1);
    	Date endInterval = (Date)publicationUnitsView.getData().elementAt(2);
    	if (pub.getFirstCatalogueTitle()==null || pub.getFirstCatalogueTitle().compareTo("")==0){
    		pub.setFirstCatalogueTitle(pub.getName());
    	}
    	if (this.getValidTrainingToPublish(pub.getTrainings(),pub.getLanguage(),pub.getConsiderValidityDates(),beginInterval,endInterval)){
  			presCatWithDiffParent = getPathWithDiffParent(publicationUnitsView.getTree().getTree());
    		Publication publication = new Publication(pub);
    		TOMATree tree =  publication.generateTreeForView(pub,this.getPublishFirstCatName());
    		if (tree!=null){
    			TrainingToPublishView tr = new TrainingToPublishView(tree,pub.getName());
    			tr.pack();
    			tr.center();
 				tr.show();
 			}
 			publicationUnitsView.show();
 				
 		} else {
 				TOMAError error = new TOMAError(labels.get("apostal.toma.publication.publish.no_training"),labels.get("apostal.toma.publication.publish.view_error"));
 		}
    }
    
    public void removeChild(CatalogueTreeNode root,TOMATree tree){
    	DefaultTreeModel model = (DefaultTreeModel)tree.getTree().getModel();
    	int cptChild = root.getChildCount();
    	int x=0;
    	while (x<cptChild){
    		DefaultMutableTreeNode node = (DefaultMutableTreeNode)root.getChildAt(x);
    		if(node!=null){
    			TreePath pathTemp = new TreePath(model.getPathToRoot(node));
    			if (!tree.getTree().isPathSelected(pathTemp)){
    				Object o = pathTemp.getLastPathComponent();
    				String className = o.getClass().getName();
    				if (className.equals("apostal.toma.view.CatalogueTreeNode")){
    					root.removeNode((CatalogueTreeNode)o);
    					cptChild--;
    					x--;
    				}
    				if (className.equals("apostal.toma.view.TrainingTreeNode")){
    					root.removeNode((TrainingTreeNode)o);
    					cptChild--;
    					x--;
    				}
    			}
    		}
    		x++;
    	}
    	for (int i=0;i<root.getChildCount();i++){
    		DefaultMutableTreeNode node = (DefaultMutableTreeNode)root.getChildAt(i);
    		String className = node.getClass().getName();
    		if (className.equals("apostal.toma.view.CatalogueTreeNode")){
    			CatalogueTreeNode tempCat = (CatalogueTreeNode)node;
    			removeChild(tempCat,tree);
    		}
    	}
    	
    }

    public void chooseTemplate() {
        publicationUnitsView.hide();
    	PublicationUnit pub = (PublicationUnit)publicationUnitsView.getData().elementAt(0);
    	int type = pub.getType();
    	TOMAFileChooser fileChooser=new TOMAFileChooser(publicationUnitsView, labels.get("apostal.toma.publication.template_filechoosertitle"), labels.get("apostal.toma.parameters.filechooseracceptbutton"), labels.get("apostal.toma.parameters.filechoosercancelbutton"));
		if (type==PublicationUnit.PUBLICATION_HTML){
			XSLFileFilter filter = new XSLFileFilter(XSLFileFilter.xsl);
			fileChooser.addXSLFileFilter(filter);
		} else if (type==PublicationUnit.PUBLICATION_RTF || type==PublicationUnit.PUBLICATION_PDF){
			FOFileFilter filter=new FOFileFilter(FOFileFilter.fo);
			fileChooser.addFOFileFilter(filter);
		} else {
			TOMAFileFilter filter=new TOMAFileFilter(TOMAFileFilter.xml);
			fileChooser.addTOMAFileFilter(filter);
		}
		int ret=fileChooser.showOpenDialog();
	 	if (ret == TOMAFileChooser.APPROVE)
	 	{
	        String path=fileChooser.getSelectedPath();
			publicationUnitsView.setTemplateFile(path);
	  	}
        publicationUnitsView.show();
    }

    public void chooseDestinationOrFile() {
    	publicationUnitsView.hide();
        PublicationUnit pub = (PublicationUnit)publicationUnitsView.getData().elementAt(0);
    	int type = pub.getType();
    	TOMAFileChooser fileChooser=new TOMAFileChooser(publicationUnitsView, labels.get("apostal.toma.publication.destination_filechoosertitle"), labels.get("apostal.toma.parameters.filechooseracceptbutton"), labels.get("apostal.toma.parameters.filechoosercancelbutton"));
		if (type==PublicationUnit.PUBLICATION_HTML){
			fileChooser.setSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		}else if (type==PublicationUnit.PUBLICATION_PDF){
			PDFFileFilter filter=new PDFFileFilter(PDFFileFilter.pdf);
			fileChooser.addPDFFileFilter(filter);
        } else if (type==PublicationUnit.PUBLICATION_RTF){
			RTFFileFilter filter=new RTFFileFilter(RTFFileFilter.rtf);
			fileChooser.addRTFFileFilter(filter);
        } else {
			TOMAFileFilter filter=new TOMAFileFilter(TOMAFileFilter.xml);
			fileChooser.addTOMAFileFilter(filter);
		}
		int ret=fileChooser.showOpenDialog();
	 	if (ret == TOMAFileChooser.APPROVE)
	 	{
	        String path=fileChooser.getSelectedPath();
			publicationUnitsView.setDestinationPath(path);
	  	}
        publicationUnitsView.show();
    }


    public void chooseProperties() {
        publicationUnitsView.hide();
    	TOMAFileChooser fileChooser=new TOMAFileChooser(publicationUnitsView, labels.get("apostal.toma.publication.properties_filechoosertitle"), labels.get("apostal.toma.parameters.filechooseracceptbutton"), labels.get("apostal.toma.parameters.filechoosercancelbutton"));
		TOMAFileFilter filter=new TOMAFileFilter(TOMAFileFilter.xml);
		fileChooser.addTOMAFileFilter(filter);
		int ret=fileChooser.showOpenDialog();
	 	if (ret == TOMAFileChooser.APPROVE)
	 	{
	        String path=fileChooser.getSelectedPath();
			publicationUnitsView.setPropertiesFile(path);
	  	}
        publicationUnitsView.show();
    }

    public void actionPerformed(ActionEvent e)
    {
      String denomination;
      String action = e.getActionCommand();
      if (action.compareTo("new")==0)
      {
      	int result = 0;
        if (TOMA.getInstance().getTomaParameters().getOpenWarningWindow() && publicationUnitsView.publicationUnitSelected()){
            TOMAQuestion tq = new TOMAQuestion(TOMAFonts.htmlBegin+labels.get("apostal.toma.changeSelection.publicationUnit.confirm")+TOMAFonts.htmlEnd,labels.get("apostal.toma.changeSelection.publicationUnit.confirm.title"));
            result = tq.getResult();
        }
        if (result==0){
      	
        publicationUnitsView.hide();
        create = new CreatePublicationUnit(this,this.publicationUnitsView);
        create.pack();
        create.center();
        create.show();
        }
      }
      else if (action.compareTo("delete")==0)
      {
      	  deletePublicationUnit();

      }
      else if (action.compareTo("save")==0)
      {
        savePublicationUnit();
      }
      else if (action.compareTo("save_publish")==0)
      {
        savePublicationUnit();
        publish();       
      }
      else if (action.compareTo("create_ok")==0)
      {
        //Create new
        createPublicationUnit();
      }
      else if (action.compareTo("choose_properties")==0)
      {

        chooseProperties();
      }
      else if (action.compareTo("choose_template")==0)
      {

        chooseTemplate();
      }
      else if (action.compareTo("choose_destination")==0)
      {

        chooseDestinationOrFile();
      }
      else if (action.compareTo("view")==0)
      {

        viewTrainingsCatalogues();
      }
      /*else if (action.compareTo("login_ok")==0)
      {
			publishToSyrecos();
      }*/
      else if (action.compareTo("soap_login_ok")==0)
      {
		  //test if SOAP publication unit or SOAPDelete
		  if(publicationUnitsView.getPublicationUnit().getType()==PublicationUnit.PUBLICATION_SOAP)
			  publishToSOAP();
		  else if(publicationUnitsView.getPublicationUnit().getType()==PublicationUnit.PUBLICATION_SOAP_DELETE)
			  publishToSOAPDelete();
      }      
      
    }

    public void windowClosing(WindowEvent e) {
    	PublicationsControl control = new PublicationsControl();
    	PublicationUnit data = null;
        Vector datas = publicationUnitsView.getData();
        if (datas!=null){
            if (datas.elementAt(0)!=null){
                data = (PublicationUnit)datas.elementAt(0);
            }
        }
    	if (data!=null){
    		control.unlockPublicationUnit(data);
    	}
    	TOMAEventHandler tomaHandler = TOMA.getInstance().getHandler();
    	tomaHandler.closePublicationUnitsView();
    }

    public void openPublicationUnits() {
    }

    public void openPublicationUnit() {
    }
    
}
