// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

package apostal.toma.viewcontrol;

/**
 * Title:        TOMA
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      CRP Henri Tudor
 * @author
 * @version 1.0
 */
import java.util.Vector;
import java.util.Iterator;
import java.lang.Thread;

import apostal.toma.TOMA;
import apostal.toma.data.TOMALabels;
import apostal.toma.external.SOAPDeletePublication;

import apostal.toma.view.TOMAQuestion;
import apostal.toma.view.TOMAError;
import apostal.toma.view.TOMAWait;
import apostal.toma.view.TOMAOk;
import apostal.toma.view.TOMAFonts;


public class SOAPDeletePublicationEventHandler
{
  private TOMALabels labels;
  private SOAPDeletePublication soapPublication;

  public SOAPDeletePublicationEventHandler(SOAPDeletePublication soapPublication)
  {
    labels=new TOMALabels();
    this.soapPublication=soapPublication;
  }

  public boolean publish(boolean addFirstCat)
  {
    boolean publishOk = false;
    
    //faire la publication

        //ouvrir la fen�tre d'attente
	  TOMAWaitThread wait=new TOMAWaitThread(labels.get("apostal.toma.publication.publish.message"), labels.get("apostal.toma.publication.publish.title"));
		wait.start();
        try{wait.join();}catch(Exception ex){}
	  TOMA.log(TOMA.WARNING, "SOAP publishing");
    
    //preparer la transfo: lecture param�tres
    soapPublication.preparePublication();	
    	
	//faire la transfo XML
	soapPublication.publishXML(addFirstCat);
	
	//faire la publication
	  soapPublication.publish();
	  	  
	  //fermer le wait
	  wait.close();

	 String msg=soapPublication.getMessages();
	if(soapPublication.getResult())
	{
		publishOk=true;
        TOMAOk info = new TOMAOk(msg, labels.get("apostal.toma.publication.publish.ok.title"),true,800,400);
	}
	else
	{
        TOMAError error=new TOMAError(msg, labels.get("apostal.toma.external.soap.error.title"),true,800,400);
	}
	
	
	return publishOk;
  }
}
