// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.viewcontrol;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Vector;

import apostal.toma.TOMA;
import apostal.toma.data.TOMALabels;
import apostal.toma.data.Training;
import apostal.toma.data.Session;

import apostal.toma.view.SessionView;
import apostal.toma.view.CreateSession;

abstract public class SessionEventHandler implements ActionListener, WindowListener {

    protected TOMALabels labels;
    //protected static Training training;
    protected static SessionView view;

    protected int idTraining;
    protected CreateSession create;


    public SessionEventHandler()
    {
      labels=new TOMALabels();
    }

    public void actionPerformed(ActionEvent e) {

    String cmd=e.getActionCommand();
    if(cmd.equals("save"))
    {
      this.save();
    }
    else if(cmd.equals("delete"))
    {
      this.delete();
    }
    else if(cmd.equals("create"))
    {
      this.create();
    }
    else if(cmd.equals("create_ok"))
    {
      this.doCreate();
    }
    else if(cmd.equals("addSeance"))
    {
      this.addSeancesConsec();
    }
    else if(cmd.equals("session_ok"))
    {
      this.doAddSeancesConsec();
    }
    }

    abstract public void save();
    abstract public void delete();
    abstract public void create();
    abstract public void doCreate();
	abstract public void addSeancesConsec();
	abstract public void doAddSeancesConsec();
    
    /**
     * tests the template:
     * @return: the error message to display if it is incorrect. Otherwise null.
     */
    public String testTemplate()
    {
      //effectuer tous les tests
      String s=view.testTemplateElements();
      if(s!=null && !s.equals(""))
      {
	String msg=labels.get("apostal.toma.sessionview.templateProblem");

        msg=msg+"\n"+s;

        msg=msg+"\n\n"+labels.get("apostal.toma.sessionview.templateProblemSave");

	return msg;
      }
      else
	return null;
    }

    public void windowActivated(WindowEvent e)
    {}
    public void windowClosed(WindowEvent e)
    {
    }
    public void windowDeactivated(WindowEvent e)
    {
    }
    public void windowDeiconified(WindowEvent e)
    {}
    public void windowIconified(WindowEvent e)
    {}
    public void windowOpened(WindowEvent e)
    {}
}
