// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */

package apostal.toma.viewcontrol;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import apostal.toma.view.TeachersView;
import apostal.toma.view.TOMAParametersView;
import apostal.toma.data.TOMAParameters;
import apostal.toma.TOMA;
import apostal.toma.datacontrol.TOMAParametersControl;
import apostal.toma.view.TOMAFileChooser;
import apostal.toma.view.TOMAFileFilter;
import apostal.toma.data.TOMALabels;

public class TOMAParametersEventHandler extends WindowAdapter implements ActionListener {
    private TOMAParametersView parametersView;
    private TOMAParameters params;

    public TOMAParametersEventHandler(TOMAParametersView param)
    {
	super();
	this.parametersView=param;
    }


    public TOMAParametersEventHandler() {
    //chargerles paramtres sauvs (pas ceux en mmoire)
    params=new TOMAParameters();
    params.load();
    }

    public void openTOMAParameters()
    {
      parametersView=new TOMAParametersView();
      parametersView.setData(params);
    }

    public void actionPerformed(ActionEvent e) {

    String cmd=e.getActionCommand();
    if(cmd!=null)
    {
      if(cmd.equals("ok"))
      {
	this.saveParameters();
      }
      else if(cmd.equals("browse"))
      {
	this.browse();
      }
      else if(cmd.equals("browseBrowser"))
      {
        this.browseBrowser();
      }
    }

    }

    public void windowClosing(WindowEvent e) {
    }


    public void saveParameters() {
	TOMAParameters params=parametersView.getData();
        TOMAParametersControl.saveParameters(params);

	//fermer la fenetre
	parametersView.dispose();
    }

    public void browse()
    {
        TOMALabels labels=new TOMALabels();

	TOMAFileChooser fileChooser=new TOMAFileChooser(parametersView, labels.get("apostal.toma.parameters.filechoosertitle"), labels.get("apostal.toma.parameters.filechooseracceptbutton"), labels.get("apostal.toma.parameters.filechoosercancelbutton"));
	TOMAFileFilter filter=new TOMAFileFilter(TOMAFileFilter.xml);
	fileChooser.addTOMAFileFilter(filter);
	//fileChooser.setVisible(true);

	int ret=fileChooser.showOpenDialog();
	 if (ret == TOMAFileChooser.APPROVE)
	 {
	        String path=fileChooser.getSelectedPath();

		//mettre le template dans le properties
		TOMAParameters params=parametersView.getData();
		params.setTemplateFile(path);
		parametersView.setData(params);
	  } else {
		//rien
          }
    }
    
    public void browseBrowser()
    {
        TOMALabels labels=new TOMALabels();

	TOMAFileChooser fileChooser=new TOMAFileChooser(parametersView, labels.get("apostal.toma.parameters.browser.filechoosertitle"), labels.get("apostal.toma.parameters.filechooseracceptbutton"), labels.get("apostal.toma.parameters.filechoosercancelbutton"));
	TOMAFileFilter filter=new TOMAFileFilter(TOMAFileFilter.xml);

	int ret=fileChooser.showOpenDialog();
	 if (ret == TOMAFileChooser.APPROVE)
	 {
	        String path=fileChooser.getSelectedPath();

		//mettre le template dans le properties
		TOMAParameters params=parametersView.getData();
		params.setBrowser(path);
		parametersView.setData(params);
	  } else {
		//rien
          }
    }    
}
