// TOMA, v1.0 - 07/2002
// 
// TOMA (Training Offer Management Application) is a Java application 
// to manage training offers and all the related data 
// (organism data, locations, animators, contacts, ...). 
// It also allows to publish the data in different formats: 
// 	- XML (in the "TED" format, "Training Exchange Definition", 
// 			http://binux.tudor.lu:8080/XML/ted.xsd)
// 	- PDF
// 	- RTF
// 	- HTML
// 
// Copyright (C) 2002 CRP Henri Tudor, Luxembourg
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program (file gpl.txt); if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact Information: 
// 	Address:    CRP Henri Tudor
// 			6 rue Coudenhove-Kalergi
// 			L - 1359 Luxembourg
// 	Email: 		toma@tudor.lu

/* Generated by Together */



package apostal.toma.viewcontrol;



import java.awt.event.ActionEvent;

import java.awt.event.ActionListener;

import java.awt.event.ActionEvent;

import java.awt.event.WindowEvent;

import java.awt.event.WindowAdapter;



import java.util.HashSet;

import java.util.Vector;

import java.util.Iterator;

import java.lang.String;



import apostal.toma.TOMA;


import apostal.toma.view.*;


import apostal.toma.data.Training;

import apostal.toma.data.TrainingProgramme;

import apostal.toma.data.TrainingCourse;

import apostal.toma.data.Unit;

import apostal.toma.data.Language;

import apostal.toma.data.TOMALabels;

import apostal.toma.data.ProgrammeSession;

import apostal.toma.data.Catalogue;



import apostal.toma.datacontrol.PublicationsControl;

import apostal.toma.datacontrol.TrainingProgrammeControl;

import apostal.toma.datacontrol.TrainingCourseControl;

import javax.swing.tree.TreePath;



public class TrainingProgrammeEventHandler extends TrainingEventHandler {



  private TrainingProgrammeControl control;



  private TrainingProgrammeDuplication duplication;

  private TrainingProgrammeAndUnitsView view;

  private CreateUnit createUnit;



  //private TrainingChooser copyChooser;

  private TrainingInCatalogueChooser copyChooser;

  private CopyTrainingIntoUnit copy;



  public TrainingProgrammeEventHandler(TrainingProgrammeAndUnitsView view)

    {

      this.view=view;

      control=new TrainingProgrammeControl();

    }



    public TrainingProgrammeEventHandler()

    {

      control=new TrainingProgrammeControl();

    }



    public TrainingProgrammeAndUnitsView getView()

    {

      return view;

    }



    public void actionPerformed(ActionEvent e) {

    String cmd=e.getActionCommand();

    if(cmd!=null)

    {

      if(cmd.equals("save"))

      {

	this.save();

      }

      else if(cmd.equals("delete"))

      {

	this.delete();

      }

      else if(cmd.equals("duplicate"))

      {

	this.duplicate();

      }

      else if(cmd.equals("duplicate_ok"))

      {

	this.doDuplication();

      }

      else if(cmd.equals("export"))

      {

	this.export();

      }

      else if(cmd.equals("sessions"))

      {

	this.openSessions();

      }

      else if(cmd.equals("createUnit"))

      {

        this.createUnit();

      }

      else if(cmd.equals("create_ok"))

      {

        this.createUnitChoiceMade();

      }

      else if(cmd.equals("copy"))

      {

        this.copyTrainingIntoUnit();

      }

      else if(cmd.equals("choose_ok"))

      {

        this.doAskCodeForCopy();

      }

      else if(cmd.equals("copy_code_ok"))

      {

        this.doCopy();

      }



    }

    }



    public void windowClosing(WindowEvent e) {

    }



/************* Actions ***********************/



    public TrainingProgrammeAndUnitsView openTraining(int idTraining) {

    //charger la formation

    TrainingProgramme t=control.loadTraining(idTraining);



    return this.openTraining(t);

    }



    public TrainingProgrammeAndUnitsView openTraining(TrainingProgramme t)

    {

      //la mettre ds l'attribut

      this.training=t;



      //mettre les donnes

      view=new TrainingProgrammeAndUnitsView(this);

      view.setData(t);



      return ((TrainingProgrammeAndUnitsView) view);

    }



    /*public void export()

    {

      TOMAFileChooser chooser=new TOMAFileChooser(TOMA.getInstance().getTomaView(), labels.get("apostal.toma.trainingview.export.title"), labels.get("apostal.toma.trainingview.export.ok"), labels.get("apostal.toma.trainingview.export.cancel"));

      TOMAFileFilter filter=new TOMAFileFilter(TOMAFileFilter.xml);

      chooser.addTOMAFileFilter(filter);

      int ret=chooser.showSaveDialog();

      if (ret == TOMAFileChooser.APPROVE)

	 {

	    PublicationsControl pubControl=new PublicationsControl();

	    Vector errors=pubControl.export(training, chooser.getSelectedFile());

	    if(errors!=null && !errors.isEmpty())

	    {

	      String message=labels.get("apostal.toma.export.errors.message");

	      Iterator iter = errors.iterator();

	      while (iter.hasNext())

	      {

		String error= (String) iter.next();

		message=message+error+"\n";

	      }

	      TOMAError error=new TOMAError(message, labels.get("apostal.toma.export.errors.title"));

	    }

	 }

    }*/



    public void duplicate() {

      duplication=new TrainingProgrammeDuplication(this, (TrainingProgramme) training,TOMA.getInstance().getTomaView());

      duplication.pack();

      duplication.show();

    }

    public void doDuplication() {
        TrainingProgramme t = this.doOnlyDuplication();
        updateTree(t);
    }
    private void updateTree(TrainingProgramme t) {
       // System.gc();
        TOMATreeControl control=new TOMATreeControl();
        control.addTrainingNodeToDesktop(t);
    }
    private TrainingProgramme doOnlyDuplication(){
        Vector v = new Vector();
      v= (Vector)duplication.getData();
      TrainingProgramme  t=(TrainingProgramme)v.elementAt(0);

      boolean withSession= ((Boolean)v.elementAt(1)).booleanValue();

      Training value=control.duplicate(t,withSession);



      if(value==null)

      {
       	duplication.dispose();



	//maj arbre



      }

      else if(value.getClass().getName().equals("apostal.toma.data.Unit"))

      //pb  cause d'un unit

      {

        Unit unit=(Unit) value;

        String msg=labels.get("apostal.toma.trainingview.duplicate.unitCodeproblem")+" \""+unit.getTitle()+"\".\n"+labels.get("apostal.toma.trainingview.duplicate.unitCodeproblem2");

        TOMAError error=new TOMAError(msg, labels.get("apostal.toma.trainingview.duplicate.codeproblemtitle"));

      }

      else

      //pb  cause du training

      {

	  //message d'erreur

	  TOMAError error=new TOMAError(labels.get("apostal.toma.trainingview.duplicate.codeproblem"), labels.get("apostal.toma.trainingview.duplicate.codeproblemtitle"));

      }
        return t;
    }

     /*
    public void doDuplication()

    {

      Vector v = new Vector();
      v= (Vector)duplication.getData();
      TrainingProgramme  t=(TrainingProgramme)v.elementAt(0);

      boolean withSession= ((Boolean)v.elementAt(1)).booleanValue();

      Training value=control.duplicate(t,withSession);



      if(value==null)

      {

	duplication.dispose();



	//maj arbre

	TOMATreeControl control=new TOMATreeControl();	

     control.addTrainingNodeToDesktop(t);

      }

      else if(value.getClass().getName().equals("apostal.toma.data.Unit"))

      //pb  cause d'un unit

      {

        Unit unit=(Unit) value;

        String msg=labels.get("apostal.toma.trainingview.duplicate.unitCodeproblem")+" \""+unit.getTitle()+"\".\n"+labels.get("apostal.toma.trainingview.duplicate.unitCodeproblem2");

        TOMAError error=new TOMAError(msg, labels.get("apostal.toma.trainingview.duplicate.codeproblemtitle"));

      }

      else

      //pb  cause du training

      {

	  //message d'erreur

	  TOMAError error=new TOMAError(labels.get("apostal.toma.trainingview.duplicate.codeproblem"), labels.get("apostal.toma.trainingview.duplicate.codeproblemtitle"));

      }

    }

     */

    public void openSessions()

    {

      TrainingProgramme t=(TrainingProgramme) this.training;

      //recharger les sessions?

      //pour les sessions -> oui

      //pour les autres donnes -> ne pas perdre les info rentres. Prendre en compte les dernires valeurs

      TrainingProgramme t2=control.loadTraining(t.getIdTraining());



      ProgrammeSessionEventHandler handler=new ProgrammeSessionEventHandler();

      handler.openSessions(t2);

    }



    public void delete() {

	//cran de confirmation

	TOMALabels labels=new TOMALabels();

	TOMAQuestion question=new TOMAQuestion(labels.get("apostal.toma.trainingprogrammeview.delete"), labels.get("apostal.toma.trainingprogrammeview.delete.title"));

	int result=question.getResult();



	//delete

	if(result==0)

	{

	  TrainingProgramme t=(TrainingProgramme) this.training;

	  view.getTrainingProgrammeView().getData(t);

	  control.delete(t);



	//todo: changer l'cran en cours

	view.setVisible(false);



	  //maj arbre
	  /*TOMATreeControl control=new TOMATreeControl();	 
	  control.deleteNode();*/
          TOMA.getInstance().getHandler().updateTree();        
	}

    }



    public void save() {

      //rcuprer les donnes

      TrainingProgramme t=(TrainingProgramme) this.training;

      view.getTrainingProgrammeView().getData(t);



      boolean ok=control.testSave(t);

      if(!ok)

      {

	TOMAError tomaerror=new TOMAError(labels.get("apostal.toma.trainingview.saveproblem"), labels.get("apostal.toma.trainingview.saveproblemTitle"));

      }

      else

      {

	//vrifier le template avant & mettre le warning si ncessaire

	String template=this.testTemplate();

	if(template!=null)

	{

	   //ouvrir la fenetre de demande de confirmation

	   String title=labels.get("apostal.toma.trainingview.templateProblemTitle");



	   TOMAQuestion question=new TOMAQuestion(template,title);

	   if(question.getResult()!=0)

	   {

	    ok=false;

	   }

	}



	if(ok)

	{

	  control.save(t);

	  //maj arbre

	  TOMATreeControl control=new TOMATreeControl();

	  control.updateTrainingNodeView(t);

	}

      }

    }





    public void refreshTeachers() {

    }



    public void refreshContacts() {

    }



    public void refreshLocations() {

    }



    /********************** create unit ********************/

    public void createUnit() {

      //cran de cration de unit

      createUnit=new CreateUnit(this,TOMA.getInstance().getTomaView());

      createUnit.pack();
      createUnit.center();

      createUnit.show();

    }



    public void createUnitChoiceMade()

    {

      Unit u=(Unit) createUnit.getData();

      TrainingProgramme tp=(TrainingProgramme) training;



      boolean ok=control.createUnit(tp, u);



      if(ok)

	{

	  createUnit.dispose();

	  view.addUnit(u);

	}

	else

	{

	  //message d'erreur

	  TOMAError error=new TOMAError(labels.get("apostal.toma.trainingview.createunit.codeproblem"), labels.get("apostal.toma.trainingview.createunit.codeproblemtitle"));

	  //createUnit.dispose();

	  //this.createUnit();

	}

    }



    /**

     * tests the template:

     * @return: the error message to display if it is incorrect. Otherwise null.

     */

    public String testTemplate()

    {

      //effectuer tous les tests

      String s=view.getTrainingProgrammeView().testTemplateElements();

      if(s!=null && !s.equals(""))

      {

	String msg=labels.get("apostal.toma.trainingview.templateProblem");

        msg=msg+"\n"+s;

        msg=msg+"\n\n"+labels.get("apostal.toma.trainingview.templateProblemSave");



	return msg;

      }

      else

	return null;

    }



    /*************** Copy training into unit ***************/



    public void copyTrainingIntoUnit()

    {

      copyChooser=new TrainingInCatalogueChooser(labels.get("apostal.toma.trainingview.copyintounit.message"), labels.get("apostal.toma.trainingview.copyintounit.title"),labels.get("apostal.toma.trainingview.copyintounit.ok"),labels.get("apostal.toma.trainingview.copyintounit.cancel"), true, false,true, false, this);

      //copyChooser=new TrainingChooser(labels.get("apostal.toma.trainingview.copyintounit.message"), labels.get("apostal.toma.trainingview.copyintounit.title"),labels.get("apostal.toma.trainingview.copyintounit.ok"),labels.get("apostal.toma.trainingview.copyintounit.cancel"), true, false, false, this);

      copyChooser.pack();

      copyChooser.show();

    }



    public void doAskCodeForCopy()

    {

      int id=copyChooser.getIdTraining();

      if(id>-1)

      {

	//TrainingCourse t=(TrainingCourse) copyChooser.getData();

        TrainingCourseControl courseControl=new TrainingCourseControl();

        //t=courseControl.loadTraining(t.getIdTraining());

	TrainingCourse t=courseControl.loadTraining(id);



        if(t!=null)

        {

	  copyChooser.dispose();

	  copy=new CopyTrainingIntoUnit(this, t,TOMA.getInstance().getTomaView());

	  copy.pack();

	  copy.show();

        }



      }

    }



    public void doCopy()

    {

      TrainingCourse t=(TrainingCourse) copy.getData();

      Unit u=control.createUnitWithTrainingCourse((TrainingProgramme) training, t);



      if(u!=null)

	{

	  copy.dispose();

	  view.addUnit(u);

	}

	else

	{

	  TOMAError error=new TOMAError(labels.get("apostal.toma.trainingview.createunit.codeproblem"), labels.get("apostal.toma.trainingview.createunit.codeproblemtitle"));

	}

    }

}

